"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getDtMetadataForEvent = exports.generateEventsMetadata = void 0;
const ts = __importStar(require("typescript"));
const MetaTypes = __importStar(require("./MetadataTypes"));
const TypeUtils = __importStar(require("./MetadataTypeUtils"));
const MetaUtils = __importStar(require("./MetadataUtils"));
const DecoratorUtils = __importStar(require("./DecoratorUtils"));
function generateEventsMetadata(memberKey, propDeclaration, decorators, typeName, metaUtilObj) {
    if (!typeName)
        return false;
    const rtEventMeta = {};
    const eventDecorator = decorators[metaUtilObj.namedExportToAlias.event];
    if (eventDecorator) {
        rtEventMeta.bubbles =
            DecoratorUtils.getDecoratorParamValue(eventDecorator, "bubbles") === true;
    }
    switch (typeName) {
        case `${metaUtilObj.namedExportToAlias.ElementVComponent}.${MetaTypes.CANCELABLE_ACTION}`:
            rtEventMeta.cancelable = true;
        case `${metaUtilObj.namedExportToAlias.ElementVComponent}.${MetaTypes.ACTION}`:
            const eventProp = `${memberKey[2].toLowerCase()}${memberKey.substring(3)}`;
            if (!metaUtilObj.rtMetadata.events) {
                metaUtilObj.rtMetadata.events = {};
                metaUtilObj.fullMetadata.events = {};
            }
            metaUtilObj.rtMetadata.events[eventProp] = rtEventMeta;
            metaUtilObj.fullMetadata.events[eventProp] = Object.assign({}, rtEventMeta, getDtMetadataForEvent(propDeclaration, metaUtilObj));
            return true;
        default:
            return false;
    }
}
exports.generateEventsMetadata = generateEventsMetadata;
function getDtMetadataForEvent(propDeclaration, metaUtilObj) {
    var _a, _b;
    const dt = MetaUtils.getDtMetadata(propDeclaration, metaUtilObj);
    const typeName = TypeUtils.getPropertyType(propDeclaration);
    const typeRefNode = propDeclaration.type;
    let cancelableDetail = null;
    let detailObj = null;
    if (typeName ===
        `${metaUtilObj.namedExportToAlias.ElementVComponent}.${MetaTypes.CANCELABLE_ACTION}`) {
        cancelableDetail = {
            accept: {
                description: "This method can be called with an application-created Promise to cancel this event asynchronously.  The Promise should be resolved or rejected to accept or cancel the event, respectively.",
                reftype: "(param: Promise<void>) => void",
                type: "function",
            },
        };
    }
    if (typeRefNode.typeArguments && typeRefNode.typeArguments.length) {
        const detailNode = typeRefNode.typeArguments[0];
        if (detailNode.kind == ts.SyntaxKind.TypeReference) {
            const typeObject = metaUtilObj.typeChecker.getTypeAtLocation(detailNode);
            const declaration = ((_a = typeObject.aliasSymbol) === null || _a === void 0 ? void 0 : _a.getDeclarations()[0]) || ((_b = typeObject.symbol) === null || _b === void 0 ? void 0 : _b.getDeclarations()[0]);
            if (ts.isTypeAliasDeclaration(declaration) ||
                ts.isClassDeclaration(declaration)) {
                const eventDetailType = declaration;
                let eventDetailName = eventDetailType.name.getText();
                const genericsInfo = TypeUtils.getGenericsAndTypeParameters(eventDetailType);
                if (genericsInfo) {
                    dt["evnDetailTypeParamsDeclaration"] =
                        genericsInfo.genericsDeclaration;
                    dt["evnDetailNameTypeParams"] = `${eventDetailName}${genericsInfo.genericsTypeParams}`;
                }
                else {
                    dt["evnDetailNameTypeParams"] = eventDetailName;
                }
            }
        }
        detailObj = getEventDetails(detailNode, metaUtilObj);
    }
    if (detailObj || cancelableDetail) {
        dt["detail"] = Object.assign({}, cancelableDetail, detailObj);
    }
    return dt;
}
exports.getDtMetadataForEvent = getDtMetadataForEvent;
function getEventDetails(detailNode, metaUtilObj) {
    let detailMetadata;
    if ((detailNode === null || detailNode === void 0 ? void 0 : detailNode.kind) !== ts.SyntaxKind.NullKeyword) {
        const detailSymbol = metaUtilObj.typeChecker
            .getTypeAtLocation(detailNode)
            .getSymbol();
        detailMetadata = processEventDetailMembers(detailSymbol, metaUtilObj);
    }
    return detailMetadata;
}
function processEventDetailMembers(detailType, metaUtilObj) {
    var _a;
    let details;
    const members = detailType["members"] || ((_a = detailType["symbol"]) === null || _a === void 0 ? void 0 : _a.members);
    members.forEach((value, key) => {
        const propSignature = value.valueDeclaration;
        if (!propSignature) {
            return;
        }
        const symbolType = metaUtilObj.typeChecker.getTypeOfSymbolAtLocation(value, propSignature);
        if (ts.isPropertySignature(propSignature) ||
            ts.isPropertyDeclaration(propSignature)) {
            const property = key.toString();
            const eventDetailMetadata = TypeUtils.getAllMetadataForDeclaration(propSignature, true, metaUtilObj);
            details = details || {};
            details[property] = eventDetailMetadata;
            if (TypeUtils.possibleComplexProperty(symbolType, eventDetailMetadata.type, true)) {
                let stack = [];
                if (eventDetailMetadata.type === "Array<object>") {
                    stack.push(key);
                }
                const subprops = TypeUtils.getComplexPropertyMetadata(value, eventDetailMetadata.type, true, stack, metaUtilObj);
                if (subprops) {
                    if (eventDetailMetadata.type === "Array<object>") {
                        details[property].extension = {};
                        details[property].extension.vbdt = {};
                        details[property].extension.vbdt.itemProperties = subprops;
                    }
                    else {
                        details[property].type = "object";
                        details[property].properties = subprops;
                    }
                }
            }
        }
    });
    return details;
}
