/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["exports"],function(e){"use strict";var t,r;function n(e){return e.type===t.literal}function a(e){return e.type===t.argument}function o(e){return e.type===t.number}function u(e){return e.type===t.date}function i(e){return e.type===t.time}function c(e){return e.type===t.select}function s(e){return e.type===t.plural}function l(e){return e.type===t.pound}function f(e){return e.type===t.tag}function p(e){return!(!e||"object"!=typeof e||0!==e.type)}function h(e){return!(!e||"object"!=typeof e||1!==e.type)}!function(e){e[e.literal=0]="literal",e[e.argument=1]="argument",e[e.number=2]="number",e[e.date=3]="date",e[e.time=4]="time",e[e.select=5]="select",e[e.plural=6]="plural",e[e.pound=7]="pound",e[e.tag=8]="tag"}(t||(t={})),function(e){e[e.number=0]="number",e[e.dateTime=1]="dateTime"}(r||(r={}));var g,m=(g=function(e,t){return(g=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r])})(e,t)},function(e,t){function r(){this.constructor=e}g(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}),d=function(){return(d=Object.assign||function(e){for(var t,r=1,n=arguments.length;r<n;r++)for(var a in t=arguments[r])Object.prototype.hasOwnProperty.call(t,a)&&(e[a]=t[a]);return e}).apply(this,arguments)},v=function(e){function t(r,n,a,o){var u=e.call(this)||this;return u.message=r,u.expected=n,u.found=a,u.location=o,u.name="SyntaxError","function"==typeof Error.captureStackTrace&&Error.captureStackTrace(u,t),u}return m(t,e),t.buildMessage=function(e,t){function r(e){return e.charCodeAt(0).toString(16).toUpperCase()}function n(e){return e.replace(/\\/g,"\\\\").replace(/"/g,'\\"').replace(/\0/g,"\\0").replace(/\t/g,"\\t").replace(/\n/g,"\\n").replace(/\r/g,"\\r").replace(/[\x00-\x0F]/g,function(e){return"\\x0"+r(e)}).replace(/[\x10-\x1F\x7F-\x9F]/g,function(e){return"\\x"+r(e)})}function a(e){return e.replace(/\\/g,"\\\\").replace(/\]/g,"\\]").replace(/\^/g,"\\^").replace(/-/g,"\\-").replace(/\0/g,"\\0").replace(/\t/g,"\\t").replace(/\n/g,"\\n").replace(/\r/g,"\\r").replace(/[\x00-\x0F]/g,function(e){return"\\x0"+r(e)}).replace(/[\x10-\x1F\x7F-\x9F]/g,function(e){return"\\x"+r(e)})}function o(e){switch(e.type){case"literal":return'"'+n(e.text)+'"';case"class":var t=e.parts.map(function(e){return Array.isArray(e)?a(e[0])+"-"+a(e[1]):a(e)});return"["+(e.inverted?"^":"")+t+"]";case"any":return"any character";case"end":return"end of input";case"other":return e.description}}return"Expected "+function(e){var t,r,n=e.map(o);if(n.sort(),n.length>0){for(t=1,r=1;t<n.length;t++)n[t-1]!==n[t]&&(n[r]=n[t],r++);n.length=r}switch(n.length){case 1:return n[0];case 2:return n[0]+" or "+n[1];default:return n.slice(0,-1).join(", ")+", or "+n[n.length-1]}}(e)+" but "+(((u=t)?'"'+n(u)+'"':"end of input")+" found.");var u},t}(Error);var y=function(e,r){r=void 0!==r?r:{};var n,a={},o={start:_e},u=_e,i=xe("#",!1),c=De("tagElement"),s=xe("<",!1),l=xe("/>",!1),f=xe(">",!1),p=function(e){return Qe.pop(),!0},h=xe("</",!1),g=De("argumentElement"),m=xe("{",!1),y=xe("}",!1),A=De("numberSkeletonId"),b=/^['\/{}]/,w=Ce(["'","/","{","}"],!1,!1),x={type:"any"},C=De("numberSkeletonTokenOption"),D=xe("/",!1),k=De("numberSkeletonToken"),F=xe("::",!1),E=function(e){return Qe.pop(),e.replace(/\s*$/,"")},I=xe(",",!1),_=xe("number",!1),O=function(e,r,n){return d({type:"number"===r?t.number:"date"===r?t.date:t.time,style:n&&n[2],value:e},et())},S=xe("'",!1),j=/^[^']/,T=Ce(["'"],!0,!1),N=/^[^a-zA-Z'{}]/,L=Ce([["a","z"],["A","Z"],"'","{","}"],!0,!1),R=/^[a-zA-Z]/,P=Ce([["a","z"],["A","Z"]],!1,!1),z=xe("date",!1),V=xe("time",!1),M=xe("plural",!1),Z=xe("selectordinal",!1),B=xe("offset:",!1),U=xe("select",!1),G=xe("=",!1),H=De("whitespace"),$=/^[\t-\r \x85\xA0\u1680\u2000-\u200A\u2028\u2029\u202F\u205F\u3000]/,q=Ce([["\t","\r"]," ",""," "," ",[" "," "],"\u2028","\u2029"," "," ","　"],!1,!1),W=De("syntax pattern"),J=/^[!-\/:-@[-\^`{-~\xA1-\xA7\xA9\xAB\xAC\xAE\xB0\xB1\xB6\xBB\xBF\xD7\xF7\u2010-\u2027\u2030-\u203E\u2041-\u2053\u2055-\u205E\u2190-\u245F\u2500-\u2775\u2794-\u2BFF\u2E00-\u2E7F\u3001-\u3003\u3008-\u3020\u3030\uFD3E\uFD3F\uFE45\uFE46]/,K=Ce([["!","/"],[":","@"],["[","^"],"`",["{","~"],["¡","§"],"©","«","¬","®","°","±","¶","»","¿","×","÷",["‐","‧"],["‰","‾"],["⁁","⁓"],["⁕","⁞"],["←","⑟"],["─","❵"],["➔","⯿"],["⸀","⹿"],["、","〃"],["〈","〠"],"〰","﴾","﴿","﹅","﹆"],!1,!1),Q=De("optional whitespace"),X=De("number"),Y=xe("-",!1),ee=(De("apostrophe"),De("double apostrophes")),te=xe("''",!1),re=xe("\n",!1),ne=De("argNameOrNumber"),ae=De("validTag"),oe=De("argNumber"),ue=xe("0",!1),ie=/^[1-9]/,ce=Ce([["1","9"]],!1,!1),se=/^[0-9]/,le=Ce([["0","9"]],!1,!1),fe=De("argName"),pe=De("tagName"),he=0,ge=0,me=[{line:1,column:1}],de=0,ve=[],ye=0;if(void 0!==r.startRule){if(!(r.startRule in o))throw new Error("Can't start parsing from rule \""+r.startRule+'".');u=o[r.startRule]}function Ae(){return e.substring(ge,he)}function be(){return Fe(ge,he)}function we(e,t){throw function(e,t){return new v(e,[],"",t)}(e,t=void 0!==t?t:Fe(ge,he))}function xe(e,t){return{type:"literal",text:e,ignoreCase:t}}function Ce(e,t,r){return{type:"class",parts:e,inverted:t,ignoreCase:r}}function De(e){return{type:"other",description:e}}function ke(t){var r,n=me[t];if(n)return n;for(r=t-1;!me[r];)r--;for(n={line:(n=me[r]).line,column:n.column};r<t;)10===e.charCodeAt(r)?(n.line++,n.column=1):n.column++,r++;return me[t]=n,n}function Fe(e,t){var r=ke(e),n=ke(t);return{start:{offset:e,line:r.line,column:r.column},end:{offset:t,line:n.line,column:n.column}}}function Ee(e){he<de||(he>de&&(de=he,ve=[]),ve.push(e))}function Ie(e,t,r){return new v(v.buildMessage(e,t),e,t,r)}function _e(){return Oe()}function Oe(){var e,t;for(e=[],t=Se();t!==a;)e.push(t),t=Se();return e}function Se(){var r;return(r=function(){var e,r;e=he,(r=je())!==a&&(ge=e,n=r,r=d({type:t.literal,value:n},et()));var n;return e=r}())===a&&(r=function(){var r,n,o,u;ye++,r=he,123===e.charCodeAt(he)?(n="{",he++):(n=a,0===ye&&Ee(m));n!==a&&Be()!==a&&(o=qe())!==a&&Be()!==a?(125===e.charCodeAt(he)?(u="}",he++):(u=a,0===ye&&Ee(y)),u!==a?(ge=r,i=o,n=d({type:t.argument,value:i},et()),r=n):(he=r,r=a)):(he=r,r=a);var i;ye--,r===a&&(n=a,0===ye&&Ee(g));return r}())===a&&(r=function(){var t;(t=function(){var t,r,n,o,u,i,c,s,l;t=he,123===e.charCodeAt(he)?(r="{",he++):(r=a,0===ye&&Ee(m));r!==a&&Be()!==a&&(n=qe())!==a&&Be()!==a?(44===e.charCodeAt(he)?(o=",",he++):(o=a,0===ye&&Ee(I)),o!==a&&Be()!==a?("number"===e.substr(he,6)?(u="number",he+=6):(u=a,0===ye&&Ee(_)),u!==a&&Be()!==a?(i=he,44===e.charCodeAt(he)?(c=",",he++):(c=a,0===ye&&Ee(I)),c!==a&&(s=Be())!==a&&(l=function(){var t,r,n;t=he,"::"===e.substr(he,2)?(r="::",he+=2):(r=a,0===ye&&Ee(F));r!==a&&(n=function(){var e,t,r;if(e=he,t=[],(r=Le())!==a)for(;r!==a;)t.push(r),r=Le();else t=a;t!==a&&(ge=e,t=d({type:0,tokens:t},et()));return e=t}())!==a?(ge=t,t=r=n):(he=t,t=a);t===a&&(t=he,ge=he,Qe.push("numberArgStyle"),(r=(r=!0)?void 0:a)!==a&&(n=je())!==a?(ge=t,r=E(n),t=r):(he=t,t=a));return t}())!==a?i=c=[c,s,l]:(he=i,i=a),i===a&&(i=null),i!==a&&(c=Be())!==a?(125===e.charCodeAt(he)?(s="}",he++):(s=a,0===ye&&Ee(y)),s!==a?(ge=t,r=O(n,u,i),t=r):(he=t,t=a)):(he=t,t=a)):(he=t,t=a)):(he=t,t=a)):(he=t,t=a);return t}())===a&&(t=function(){var t,r,n,o,u,i,c,s,l;t=he,123===e.charCodeAt(he)?(r="{",he++):(r=a,0===ye&&Ee(m));r!==a&&Be()!==a&&(n=qe())!==a&&Be()!==a?(44===e.charCodeAt(he)?(o=",",he++):(o=a,0===ye&&Ee(I)),o!==a&&Be()!==a?("date"===e.substr(he,4)?(u="date",he+=4):(u=a,0===ye&&Ee(z)),u===a&&("time"===e.substr(he,4)?(u="time",he+=4):(u=a,0===ye&&Ee(V))),u!==a&&Be()!==a?(i=he,44===e.charCodeAt(he)?(c=",",he++):(c=a,0===ye&&Ee(I)),c!==a&&(s=Be())!==a&&(l=function(){var t,r,n;t=he,"::"===e.substr(he,2)?(r="::",he+=2):(r=a,0===ye&&Ee(F));r!==a&&(n=function(){var t,r,n,o;t=he,r=he,n=[],(o=Re())===a&&(o=Pe());if(o!==a)for(;o!==a;)n.push(o),(o=Re())===a&&(o=Pe());else n=a;r=n!==a?e.substring(r,he):n;r!==a&&(ge=t,r=d({type:1,pattern:r},et()));return t=r}())!==a?(ge=t,t=r=n):(he=t,t=a);t===a&&(t=he,ge=he,Qe.push("dateOrTimeArgStyle"),(r=(r=!0)?void 0:a)!==a&&(n=je())!==a?(ge=t,r=E(n),t=r):(he=t,t=a));return t}())!==a?i=c=[c,s,l]:(he=i,i=a),i===a&&(i=null),i!==a&&(c=Be())!==a?(125===e.charCodeAt(he)?(s="}",he++):(s=a,0===ye&&Ee(y)),s!==a?(ge=t,r=O(n,u,i),t=r):(he=t,t=a)):(he=t,t=a)):(he=t,t=a)):(he=t,t=a)):(he=t,t=a);return t}());return t}())===a&&(r=function(){var r,n,o,u,i,c,s,l,f,p,h;r=he,123===e.charCodeAt(he)?(n="{",he++):(n=a,0===ye&&Ee(m));if(n!==a)if(Be()!==a)if((o=qe())!==a)if(Be()!==a)if(44===e.charCodeAt(he)?(u=",",he++):(u=a,0===ye&&Ee(I)),u!==a)if(Be()!==a)if("plural"===e.substr(he,6)?(i="plural",he+=6):(i=a,0===ye&&Ee(M)),i===a&&("selectordinal"===e.substr(he,13)?(i="selectordinal",he+=13):(i=a,0===ye&&Ee(Z))),i!==a)if(Be()!==a)if(44===e.charCodeAt(he)?(c=",",he++):(c=a,0===ye&&Ee(I)),c!==a)if(Be()!==a)if(s=he,"offset:"===e.substr(he,7)?(l="offset:",he+=7):(l=a,0===ye&&Ee(B)),l!==a&&(f=Be())!==a&&(p=Ue())!==a?s=l=[l,f,p]:(he=s,s=a),s===a&&(s=null),s!==a)if((l=Be())!==a){if(f=[],(p=Ve())!==a)for(;p!==a;)f.push(p),p=Ve();else f=a;f!==a&&(p=Be())!==a?(125===e.charCodeAt(he)?(h="}",he++):(h=a,0===ye&&Ee(y)),h!==a?(ge=r,n=function(e,r,n,a){return d({type:t.plural,pluralType:"plural"===r?"cardinal":"ordinal",value:e,offset:n?n[2]:0,options:a.reduce(function(e,t){var r=t.id,n=t.value,a=t.location;return r in e&&we('Duplicate option "'+r+'" in plural element: "'+Ae()+'"',be()),e[r]={value:n,location:a},e},{})},et())}(o,i,s,f),r=n):(he=r,r=a)):(he=r,r=a)}else he=r,r=a;else he=r,r=a;else he=r,r=a;else he=r,r=a;else he=r,r=a;else he=r,r=a;else he=r,r=a;else he=r,r=a;else he=r,r=a;else he=r,r=a;else he=r,r=a;else he=r,r=a;return r}())===a&&(r=function(){var r,n,o,u,i,c,s,l,f;r=he,123===e.charCodeAt(he)?(n="{",he++):(n=a,0===ye&&Ee(m));if(n!==a)if(Be()!==a)if((o=qe())!==a)if(Be()!==a)if(44===e.charCodeAt(he)?(u=",",he++):(u=a,0===ye&&Ee(I)),u!==a)if(Be()!==a)if("select"===e.substr(he,6)?(i="select",he+=6):(i=a,0===ye&&Ee(U)),i!==a)if(Be()!==a)if(44===e.charCodeAt(he)?(c=",",he++):(c=a,0===ye&&Ee(I)),c!==a)if(Be()!==a){if(s=[],(l=ze())!==a)for(;l!==a;)s.push(l),l=ze();else s=a;s!==a&&(l=Be())!==a?(125===e.charCodeAt(he)?(f="}",he++):(f=a,0===ye&&Ee(y)),f!==a?(ge=r,n=function(e,r){return d({type:t.select,value:e,options:r.reduce(function(e,t){var r=t.id,n=t.value,a=t.location;return r in e&&we('Duplicate option "'+r+'" in select element: "'+Ae()+'"',be()),e[r]={value:n,location:a},e},{})},et())}(o,s),r=n):(he=r,r=a)):(he=r,r=a)}else he=r,r=a;else he=r,r=a;else he=r,r=a;else he=r,r=a;else he=r,r=a;else he=r,r=a;else he=r,r=a;else he=r,r=a;else he=r,r=a;else he=r,r=a;return r}())===a&&(r=function(){var r,n,o,u,i,g;ye++,r=he,n=he,60===e.charCodeAt(he)?(o="<",he++):(o=a,0===ye&&Ee(s));o!==a&&(u=We())!==a&&(i=Be())!==a?("/>"===e.substr(he,2)?(g="/>",he+=2):(g=a,0===ye&&Ee(l)),g!==a?n=o=[o,u,i,g]:(he=n,n=a)):(he=n,n=a);n!==a&&(ge=r,m=n,n=d({type:t.literal,value:m.join("")},et()));var m;(r=n)===a&&(r=he,(n=function(){var t,r,n,o;t=he,60===e.charCodeAt(he)?(r="<",he++):(r=a,0===ye&&Ee(s));r!==a?(ge=he,Qe.push("openingTag"),(!0?void 0:a)!==a&&(n=We())!==a?(62===e.charCodeAt(he)?(o=">",he++):(o=a,0===ye&&Ee(f)),o!==a?(ge=he,(p()?void 0:a)!==a?(ge=t,t=r=n):(he=t,t=a)):(he=t,t=a)):(he=t,t=a)):(he=t,t=a);return t}())!==a&&(o=Oe())!==a&&(u=function(){var t,r,n,o;t=he,"</"===e.substr(he,2)?(r="</",he+=2):(r=a,0===ye&&Ee(h));r!==a?(ge=he,Qe.push("closingTag"),(!0?void 0:a)!==a&&(n=We())!==a?(62===e.charCodeAt(he)?(o=">",he++):(o=a,0===ye&&Ee(f)),o!==a?(ge=he,(p()?void 0:a)!==a?(ge=t,t=r=n):(he=t,t=a)):(he=t,t=a)):(he=t,t=a)):(he=t,t=a);return t}())!==a?(ge=r,y=o,(v=n)!==(A=u)&&we('Mismatch tag "'+v+'" !== "'+A+'"',be()),n=d({type:t.tag,value:v,children:y},et()),r=n):(he=r,r=a));var v,y,A;ye--,r===a&&(n=a,0===ye&&Ee(c));return r}())===a&&(r=function(){var r,n;r=he,35===e.charCodeAt(he)?(n="#",he++):(n=a,0===ye&&Ee(i));n!==a&&(ge=r,n=d({type:t.pound},et()));return r=n}()),r}function je(){var e,t,r;if(e=he,t=[],(r=Ge())===a&&(r=He())===a&&(r=$e()),r!==a)for(;r!==a;)t.push(r),(r=Ge())===a&&(r=He())===a&&(r=$e());else t=a;return t!==a&&(ge=e,t=t.join("")),e=t}function Te(){var t,r,n,o,u;if(ye++,t=he,r=[],n=he,o=he,ye++,(u=Me())===a&&(b.test(e.charAt(he))?(u=e.charAt(he),he++):(u=a,0===ye&&Ee(w))),ye--,u===a?o=void 0:(he=o,o=a),o!==a?(e.length>he?(u=e.charAt(he),he++):(u=a,0===ye&&Ee(x)),u!==a?n=o=[o,u]:(he=n,n=a)):(he=n,n=a),n!==a)for(;n!==a;)r.push(n),n=he,o=he,ye++,(u=Me())===a&&(b.test(e.charAt(he))?(u=e.charAt(he),he++):(u=a,0===ye&&Ee(w))),ye--,u===a?o=void 0:(he=o,o=a),o!==a?(e.length>he?(u=e.charAt(he),he++):(u=a,0===ye&&Ee(x)),u!==a?n=o=[o,u]:(he=n,n=a)):(he=n,n=a);else r=a;return t=r!==a?e.substring(t,he):r,ye--,t===a&&(r=a,0===ye&&Ee(A)),t}function Ne(){var t,r,n;return ye++,t=he,47===e.charCodeAt(he)?(r="/",he++):(r=a,0===ye&&Ee(D)),r!==a&&(n=Te())!==a?(ge=t,t=r=n):(he=t,t=a),ye--,t===a&&(r=a,0===ye&&Ee(C)),t}function Le(){var e,t,r,n;if(ye++,e=he,Be()!==a)if((t=Te())!==a){for(r=[],n=Ne();n!==a;)r.push(n),n=Ne();r!==a?(ge=e,e=function(e,t){return{stem:e,options:t}}(t,r)):(he=e,e=a)}else he=e,e=a;else he=e,e=a;return ye--,e===a&&(a,0===ye&&Ee(k)),e}function Re(){var t,r,n,o;if(t=he,39===e.charCodeAt(he)?(r="'",he++):(r=a,0===ye&&Ee(S)),r!==a){if(n=[],(o=Ge())===a&&(j.test(e.charAt(he))?(o=e.charAt(he),he++):(o=a,0===ye&&Ee(T))),o!==a)for(;o!==a;)n.push(o),(o=Ge())===a&&(j.test(e.charAt(he))?(o=e.charAt(he),he++):(o=a,0===ye&&Ee(T)));else n=a;n!==a?(39===e.charCodeAt(he)?(o="'",he++):(o=a,0===ye&&Ee(S)),o!==a?t=r=[r,n,o]:(he=t,t=a)):(he=t,t=a)}else he=t,t=a;if(t===a)if(t=[],(r=Ge())===a&&(N.test(e.charAt(he))?(r=e.charAt(he),he++):(r=a,0===ye&&Ee(L))),r!==a)for(;r!==a;)t.push(r),(r=Ge())===a&&(N.test(e.charAt(he))?(r=e.charAt(he),he++):(r=a,0===ye&&Ee(L)));else t=a;return t}function Pe(){var t,r;if(t=[],R.test(e.charAt(he))?(r=e.charAt(he),he++):(r=a,0===ye&&Ee(P)),r!==a)for(;r!==a;)t.push(r),R.test(e.charAt(he))?(r=e.charAt(he),he++):(r=a,0===ye&&Ee(P));else t=a;return t}function ze(){var t,r,n,o,u,i,c;return t=he,Be()!==a&&(r=Ke())!==a&&Be()!==a?(123===e.charCodeAt(he)?(n="{",he++):(n=a,0===ye&&Ee(m)),n!==a?(ge=he,Qe.push("select"),(!0?void 0:a)!==a&&(o=Oe())!==a?(125===e.charCodeAt(he)?(u="}",he++):(u=a,0===ye&&Ee(y)),u!==a?(ge=t,i=r,c=o,Qe.pop(),t=d({id:i,value:c},et())):(he=t,t=a)):(he=t,t=a)):(he=t,t=a)):(he=t,t=a),t}function Ve(){var t,r,n,o,u,i,c;return t=he,Be()!==a&&(r=function(){var t,r,n,o;return t=he,r=he,61===e.charCodeAt(he)?(n="=",he++):(n=a,0===ye&&Ee(G)),n!==a&&(o=Ue())!==a?r=n=[n,o]:(he=r,r=a),(t=r!==a?e.substring(t,he):r)===a&&(t=Ke()),t}())!==a&&Be()!==a?(123===e.charCodeAt(he)?(n="{",he++):(n=a,0===ye&&Ee(m)),n!==a?(ge=he,Qe.push("plural"),(!0?void 0:a)!==a&&(o=Oe())!==a?(125===e.charCodeAt(he)?(u="}",he++):(u=a,0===ye&&Ee(y)),u!==a?(ge=t,i=r,c=o,Qe.pop(),t=d({id:i,value:c},et())):(he=t,t=a)):(he=t,t=a)):(he=t,t=a)):(he=t,t=a),t}function Me(){var t;return ye++,$.test(e.charAt(he))?(t=e.charAt(he),he++):(t=a,0===ye&&Ee(q)),ye--,t===a&&(a,0===ye&&Ee(H)),t}function Ze(){var t;return ye++,J.test(e.charAt(he))?(t=e.charAt(he),he++):(t=a,0===ye&&Ee(K)),ye--,t===a&&(a,0===ye&&Ee(W)),t}function Be(){var t,r,n;for(ye++,t=he,r=[],n=Me();n!==a;)r.push(n),n=Me();return t=r!==a?e.substring(t,he):r,ye--,t===a&&(r=a,0===ye&&Ee(Q)),t}function Ue(){var t,r,n,o,u;return ye++,t=he,45===e.charCodeAt(he)?(r="-",he++):(r=a,0===ye&&Ee(Y)),r===a&&(r=null),r!==a&&(n=Je())!==a?(ge=t,o=r,t=r=(u=n)?o?-u:u:0):(he=t,t=a),ye--,t===a&&(r=a,0===ye&&Ee(X)),t}function Ge(){var t,r;return ye++,t=he,"''"===e.substr(he,2)?(r="''",he+=2):(r=a,0===ye&&Ee(te)),r!==a&&(ge=t,r="'"),ye--,(t=r)===a&&(r=a,0===ye&&Ee(ee)),t}function He(){var t,r,n,o,u,i;if(t=he,39===e.charCodeAt(he)?(r="'",he++):(r=a,0===ye&&Ee(S)),r!==a)if((n=function(){var t,r,n,o;t=he,r=he,e.length>he?(n=e.charAt(he),he++):(n=a,0===ye&&Ee(x));n!==a?(ge=he,(o=(o="<"===(u=n)||">"===u||"{"===u||"}"===u||Ye()&&"#"===u)?void 0:a)!==a?r=n=[n,o]:(he=r,r=a)):(he=r,r=a);var u;t=r!==a?e.substring(t,he):r;return t}())!==a){for(o=he,u=[],"''"===e.substr(he,2)?(i="''",he+=2):(i=a,0===ye&&Ee(te)),i===a&&(j.test(e.charAt(he))?(i=e.charAt(he),he++):(i=a,0===ye&&Ee(T)));i!==a;)u.push(i),"''"===e.substr(he,2)?(i="''",he+=2):(i=a,0===ye&&Ee(te)),i===a&&(j.test(e.charAt(he))?(i=e.charAt(he),he++):(i=a,0===ye&&Ee(T)));(o=u!==a?e.substring(o,he):u)!==a?(39===e.charCodeAt(he)?(u="'",he++):(u=a,0===ye&&Ee(S)),u===a&&(u=null),u!==a?(ge=t,t=r=n+o.replace("''","'")):(he=t,t=a)):(he=t,t=a)}else he=t,t=a;else he=t,t=a;return t}function $e(){var t,r,n,o,u;return t=he,r=he,e.length>he?(n=e.charAt(he),he++):(n=a,0===ye&&Ee(x)),n!==a?(ge=he,u=n,(o=(o=(tt()||"<"!==u)&&"{"!==u&&!(Ye()&&"#"===u)&&!(Xe()&&"}"===u)&&!(!tt()&&Xe()&&">"===u))?void 0:a)!==a?r=n=[n,o]:(he=r,r=a)):(he=r,r=a),r===a&&(10===e.charCodeAt(he)?(r="\n",he++):(r=a,0===ye&&Ee(re))),t=r!==a?e.substring(t,he):r}function qe(){var t,r;return ye++,t=he,(r=Je())===a&&(r=Ke()),t=r!==a?e.substring(t,he):r,ye--,t===a&&(r=a,0===ye&&Ee(ne)),t}function We(){var t,r;return ye++,t=he,(r=Je())===a&&(r=function(){var t,r,n,o,u;ye++,t=he,r=[],45===e.charCodeAt(he)?(n="-",he++):(n=a,0===ye&&Ee(Y));n===a&&(n=he,o=he,ye++,(u=Me())===a&&(u=Ze()),ye--,u===a?o=void 0:(he=o,o=a),o!==a?(e.length>he?(u=e.charAt(he),he++):(u=a,0===ye&&Ee(x)),u!==a?n=o=[o,u]:(he=n,n=a)):(he=n,n=a));if(n!==a)for(;n!==a;)r.push(n),45===e.charCodeAt(he)?(n="-",he++):(n=a,0===ye&&Ee(Y)),n===a&&(n=he,o=he,ye++,(u=Me())===a&&(u=Ze()),ye--,u===a?o=void 0:(he=o,o=a),o!==a?(e.length>he?(u=e.charAt(he),he++):(u=a,0===ye&&Ee(x)),u!==a?n=o=[o,u]:(he=n,n=a)):(he=n,n=a));else r=a;t=r!==a?e.substring(t,he):r;ye--,t===a&&(r=a,0===ye&&Ee(pe));return t}()),t=r!==a?e.substring(t,he):r,ye--,t===a&&(r=a,0===ye&&Ee(ae)),t}function Je(){var t,r,n,o,u;if(ye++,t=he,48===e.charCodeAt(he)?(r="0",he++):(r=a,0===ye&&Ee(ue)),r!==a&&(ge=t,r=0),(t=r)===a){if(t=he,r=he,ie.test(e.charAt(he))?(n=e.charAt(he),he++):(n=a,0===ye&&Ee(ce)),n!==a){for(o=[],se.test(e.charAt(he))?(u=e.charAt(he),he++):(u=a,0===ye&&Ee(le));u!==a;)o.push(u),se.test(e.charAt(he))?(u=e.charAt(he),he++):(u=a,0===ye&&Ee(le));o!==a?r=n=[n,o]:(he=r,r=a)}else he=r,r=a;r!==a&&(ge=t,r=parseInt(r.join(""),10)),t=r}return ye--,t===a&&(r=a,0===ye&&Ee(oe)),t}function Ke(){var t,r,n,o,u;if(ye++,t=he,r=[],n=he,o=he,ye++,(u=Me())===a&&(u=Ze()),ye--,u===a?o=void 0:(he=o,o=a),o!==a?(e.length>he?(u=e.charAt(he),he++):(u=a,0===ye&&Ee(x)),u!==a?n=o=[o,u]:(he=n,n=a)):(he=n,n=a),n!==a)for(;n!==a;)r.push(n),n=he,o=he,ye++,(u=Me())===a&&(u=Ze()),ye--,u===a?o=void 0:(he=o,o=a),o!==a?(e.length>he?(u=e.charAt(he),he++):(u=a,0===ye&&Ee(x)),u!==a?n=o=[o,u]:(he=n,n=a)):(he=n,n=a);else r=a;return t=r!==a?e.substring(t,he):r,ye--,t===a&&(r=a,0===ye&&Ee(fe)),t}var Qe=["root"];function Xe(){return Qe.length>1}function Ye(){return"plural"===Qe[Qe.length-1]}function et(){return r&&r.captureLocation?{location:be()}:{}}function tt(){return r&&r.ignoreTag}if((n=u())!==a&&he===e.length)return n;throw n!==a&&he<e.length&&Ee({type:"end"}),Ie(ve,de<e.length?e.charAt(de):null,de<e.length?Fe(de,de+1):Fe(de,de))},A=function(){for(var e=0,t=0,r=arguments.length;t<r;t++)e+=arguments[t].length;var n=Array(e),a=0;for(t=0;t<r;t++)for(var o=arguments[t],u=0,i=o.length;u<i;u++,a++)n[a]=o[u];return n},b=/(^|[^\\])#/g;var w=function(){return(w=Object.assign||function(e){for(var t,r=1,n=arguments.length;r<n;r++)for(var a in t=arguments[r])Object.prototype.hasOwnProperty.call(t,a)&&(e[a]=t[a]);return e}).apply(this,arguments)},x=/(?:[Eec]{1,6}|G{1,5}|[Qq]{1,5}|(?:[yYur]+|U{1,5})|[ML]{1,5}|d{1,2}|D{1,3}|F{1}|[abB]{1,5}|[hkHK]{1,2}|w{1,2}|W{1}|m{1,2}|s{1,2}|[zZOvVxX]{1,4})(?=([^']*'[^']*')*[^']*$)/g;function C(e){var t={};return e.replace(x,function(e){var r=e.length;switch(e[0]){case"G":t.era=4===r?"long":5===r?"narrow":"short";break;case"y":t.year=2===r?"2-digit":"numeric";break;case"Y":case"u":case"U":case"r":throw new RangeError("`Y/u/U/r` (year) patterns are not supported, use `y` instead");case"q":case"Q":throw new RangeError("`q/Q` (quarter) patterns are not supported");case"M":case"L":t.month=["numeric","2-digit","short","long","narrow"][r-1];break;case"w":case"W":throw new RangeError("`w/W` (week) patterns are not supported");case"d":t.day=["numeric","2-digit"][r-1];break;case"D":case"F":case"g":throw new RangeError("`D/F/g` (day) patterns are not supported, use `d` instead");case"E":t.weekday=4===r?"short":5===r?"narrow":"short";break;case"e":if(r<4)throw new RangeError("`e..eee` (weekday) patterns are not supported");t.weekday=["short","long","narrow","short"][r-4];break;case"c":if(r<4)throw new RangeError("`c..ccc` (weekday) patterns are not supported");t.weekday=["short","long","narrow","short"][r-4];break;case"a":t.hour12=!0;break;case"b":case"B":throw new RangeError("`b/B` (period) patterns are not supported, use `a` instead");case"h":t.hourCycle="h12",t.hour=["numeric","2-digit"][r-1];break;case"H":t.hourCycle="h23",t.hour=["numeric","2-digit"][r-1];break;case"K":t.hourCycle="h11",t.hour=["numeric","2-digit"][r-1];break;case"k":t.hourCycle="h24",t.hour=["numeric","2-digit"][r-1];break;case"j":case"J":case"C":throw new RangeError("`j/J/C` (hour) patterns are not supported, use `h/H/K/k` instead");case"m":t.minute=["numeric","2-digit"][r-1];break;case"s":t.second=["numeric","2-digit"][r-1];break;case"S":case"A":throw new RangeError("`S/A` (second) pattenrs are not supported, use `s` instead");case"z":t.timeZoneName=r<4?"short":"long";break;case"Z":case"O":case"v":case"V":case"X":case"x":throw new RangeError("`Z/O/v/V/X/x` (timeZone) pattenrs are not supported, use `z` instead")}return""}),t}var D=/^\.(?:(0+)(\*)?|(#+)|(0+)(#+))$/g,k=/^(@+)?(\+|#+)?$/g;function F(e){var t={};return e.replace(k,function(e,r,n){return"string"!=typeof n?(t.minimumSignificantDigits=r.length,t.maximumSignificantDigits=r.length):"+"===n?t.minimumSignificantDigits=r.length:"#"===r[0]?t.maximumSignificantDigits=r.length:(t.minimumSignificantDigits=r.length,t.maximumSignificantDigits=r.length+("string"==typeof n?n.length:0)),""}),t}function E(e){switch(e){case"sign-auto":return{signDisplay:"auto"};case"sign-accounting":return{currencySign:"accounting"};case"sign-always":return{signDisplay:"always"};case"sign-accounting-always":return{signDisplay:"always",currencySign:"accounting"};case"sign-except-zero":return{signDisplay:"exceptZero"};case"sign-accounting-except-zero":return{signDisplay:"exceptZero",currencySign:"accounting"};case"sign-never":return{signDisplay:"never"}}}function I(e){var t=E(e);return t||{}}function _(e){for(var t={},r=0,n=e;r<n.length;r++){var a=n[r];switch(a.stem){case"percent":t.style="percent";continue;case"currency":t.style="currency",t.currency=a.options[0];continue;case"group-off":t.useGrouping=!1;continue;case"precision-integer":case".":t.maximumFractionDigits=0;continue;case"measure-unit":t.style="unit",t.unit=a.options[0].replace(/^(.*?)-/,"");continue;case"compact-short":t.notation="compact",t.compactDisplay="short";continue;case"compact-long":t.notation="compact",t.compactDisplay="long";continue;case"scientific":t=w(w(w({},t),{notation:"scientific"}),a.options.reduce(function(e,t){return w(w({},e),I(t))},{}));continue;case"engineering":t=w(w(w({},t),{notation:"engineering"}),a.options.reduce(function(e,t){return w(w({},e),I(t))},{}));continue;case"notation-simple":t.notation="standard";continue;case"unit-width-narrow":t.currencyDisplay="narrowSymbol",t.unitDisplay="narrow";continue;case"unit-width-short":t.currencyDisplay="code",t.unitDisplay="short";continue;case"unit-width-full-name":t.currencyDisplay="name",t.unitDisplay="long";continue;case"unit-width-iso-code":t.currencyDisplay="symbol";continue}if(D.test(a.stem)){if(a.options.length>1)throw new RangeError("Fraction-precision stems only accept a single optional option");a.stem.replace(D,function(e,r,n,a,o,u){return"*"===n?t.minimumFractionDigits=r.length:a&&"#"===a[0]?t.maximumFractionDigits=a.length:o&&u?(t.minimumFractionDigits=o.length,t.maximumFractionDigits=o.length+u.length):(t.minimumFractionDigits=r.length,t.maximumFractionDigits=r.length),""}),a.options.length&&(t=w(w({},t),F(a.options[0])))}else if(k.test(a.stem))t=w(w({},t),F(a.stem));else{var o=E(a.stem);o&&(t=w(w({},t),o))}}return t}function O(e,t){var r=y(e,t);return t&&!1===t.normalizeHashtagInPlural||function e(t){t.forEach(function(t){(s(t)||c(t))&&Object.keys(t.options).forEach(function(r){for(var a,o=t.options[r],u=-1,i=void 0,c=0;c<o.value.length;c++){var s=o.value[c];if(n(s)&&b.test(s.value)){u=c,i=s;break}}if(i){var l=i.value.replace(b,"$1{"+t.value+", number}"),f=y(l);(a=o.value).splice.apply(a,A([u,1],f))}e(o.value)})})}(r),r}var S=function(){for(var e=0,t=0,r=arguments.length;t<r;t++)e+=arguments[t].length;var n=Array(e),a=0;for(t=0;t<r;t++)for(var o=arguments[t],u=0,i=o.length;u<i;u++,a++)n[a]=o[u];return n};function j(e){return JSON.stringify(e.map(function(e){return e&&"object"==typeof e?(t=e,Object.keys(t).sort().map(function(e){var r;return(r={})[e]=t[e],r})):e;var t}))}var T,N=function(e,t){return void 0===t&&(t={}),function(){for(var r,n=[],a=0;a<arguments.length;a++)n[a]=arguments[a];var o=j(n),u=o&&t[o];return u||(u=new((r=e).bind.apply(r,S([void 0],n))),o&&(t[o]=u)),u}},L=function(){var e=function(t,r){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r])})(t,r)};return function(t,r){function n(){this.constructor=t}e(t,r),t.prototype=null===r?Object.create(r):(n.prototype=r.prototype,new n)}}();!function(e){e.MISSING_VALUE="MISSING_VALUE",e.INVALID_VALUE="INVALID_VALUE",e.MISSING_INTL_API="MISSING_INTL_API"}(T||(T={}));var R,P=function(e){function t(t,r,n){var a=e.call(this,t)||this;return a.code=r,a.originalMessage=n,a}return L(t,e),t.prototype.toString=function(){return"[formatjs Error: "+this.code+"] "+this.message},t}(Error),z=function(e){function t(t,r,n,a){return e.call(this,'Invalid values for "'+t+'": "'+r+'". Options are "'+Object.keys(n).join('", "')+'"',"INVALID_VALUE",a)||this}return L(t,e),t}(P),V=function(e){function t(t,r,n){return e.call(this,'Value for "'+t+'" must be of type '+r,"INVALID_VALUE",n)||this}return L(t,e),t}(P),M=function(e){function t(t,r){return e.call(this,'The intl string context variable "'+t+'" was not provided to the string "'+r+'"',"MISSING_VALUE",r)||this}return L(t,e),t}(P);function Z(e){return"function"==typeof e}!function(e){e[e.literal=0]="literal",e[e.object=1]="object"}(R||(R={}));var B=function(){return(B=Object.assign||function(e){for(var t,r=1,n=arguments.length;r<n;r++)for(var a in t=arguments[r])Object.prototype.hasOwnProperty.call(t,a)&&(e[a]=t[a]);return e}).apply(this,arguments)};function U(e,t){return t?Object.keys(e).reduce(function(r,n){var a,o;return r[n]=(a=e[n],(o=t[n])?B(B(B({},a||{}),o||{}),Object.keys(a).reduce(function(e,t){return e[t]=B(B({},a[t]),o[t]||{}),e},{})):a),r},B({},e)):e}var G=function(){function e(t,r,g,m){var d,v=this;if(void 0===r&&(r=e.defaultLocale),this.formatterCache={number:{},dateTime:{},pluralRules:{}},this.format=function(e){var t=v.formatToParts(e);if(1===t.length)return t[0].value;var r=t.reduce(function(e,t){return e.length&&0===t.type&&"string"==typeof e[e.length-1]?e[e.length-1]+=t.value:e.push(t.value),e},[]);return r.length<=1?r[0]||"":r},this.formatToParts=function(e){return function e(t,r,g,m,d,v,y){if(1===t.length&&n(t[0]))return[{type:0,value:t[0].value}];for(var A=[],b=0,w=t;b<w.length;b++){var x=w[b];if(n(x))A.push({type:0,value:x.value});else if(l(x))"number"==typeof v&&A.push({type:0,value:g.getNumberFormat(r).format(v)});else{var D=x.value;if(!d||!(D in d))throw new M(D,y);var k=d[D];if(a(x))k&&"string"!=typeof k&&"number"!=typeof k||(k="string"==typeof k||"number"==typeof k?String(k):""),A.push({type:"string"==typeof k?0:1,value:k});else if(u(x)){var F="string"==typeof x.style?m.date[x.style]:h(x.style)?C(x.style.pattern):void 0;A.push({type:0,value:g.getDateTimeFormat(r,F).format(k)})}else if(i(x)){F="string"==typeof x.style?m.time[x.style]:h(x.style)?C(x.style.pattern):void 0;A.push({type:0,value:g.getDateTimeFormat(r,F).format(k)})}else if(o(x)){F="string"==typeof x.style?m.number[x.style]:p(x.style)?_(x.style.tokens):void 0;A.push({type:0,value:g.getNumberFormat(r,F).format(k)})}else{if(f(x)){var E=x.children,I=x.value,O=d[I];if(!Z(O))throw new V(I,"function",y);var S=e(E,r,g,m,d,v),j=O.apply(void 0,S.map(function(e){return e.value}));Array.isArray(j)||(j=[j]),A.push.apply(A,j.map(function(e){return{type:"string"==typeof e?0:1,value:e}}))}if(c(x)){if(!(T=x.options[k]||x.options.other))throw new z(x.value,k,Object.keys(x.options),y);A.push.apply(A,e(T.value,r,g,m,d))}else if(s(x)){var T;if(!(T=x.options["="+k])){if(!Intl.PluralRules)throw new P('Intl.PluralRules is not available in this environment.\nTry polyfilling it using "@formatjs/intl-pluralrules"\n',"MISSING_INTL_API",y);var N=g.getPluralRules(r,{type:x.pluralType}).select(k-(x.offset||0));T=x.options[N]||x.options.other}if(!T)throw new z(x.value,k,Object.keys(x.options),y);A.push.apply(A,e(T.value,r,g,m,d,k-(x.offset||0)))}else;}}}return function(e){return e.length<2?e:e.reduce(function(e,t){var r=e[e.length-1];return r&&0===r.type&&0===t.type?r.value+=t.value:e.push(t),e},[])}(A)}(v.ast,v.locales,v.formatters,v.formats,e,void 0,v.message)},this.resolvedOptions=function(){return{locale:Intl.NumberFormat.supportedLocalesOf(v.locales)[0]}},this.getAst=function(){return v.ast},"string"==typeof t){if(this.message=t,!e.__parse)throw new TypeError("IntlMessageFormat.__parse must be set to process `message` of type `string`");this.ast=e.__parse(t,{normalizeHashtagInPlural:!1})}else this.ast=t;if(!Array.isArray(this.ast))throw new TypeError("A message must be provided as a String or AST.");this.formats=U(e.formats,g),this.locales=r,this.formatters=m&&m.formatters||(void 0===(d=this.formatterCache)&&(d={number:{},dateTime:{},pluralRules:{}}),{getNumberFormat:N(Intl.NumberFormat,d.number),getDateTimeFormat:N(Intl.DateTimeFormat,d.dateTime),getPluralRules:N(Intl.PluralRules,d.pluralRules)})}return Object.defineProperty(e,"defaultLocale",{get:function(){return e.memoizedDefaultLocale||(e.memoizedDefaultLocale=(new Intl.NumberFormat).resolvedOptions().locale),e.memoizedDefaultLocale},enumerable:!0,configurable:!0}),e.memoizedDefaultLocale=null,e.__parse=O,e.formats={number:{currency:{style:"currency"},percent:{style:"percent"}},date:{short:{month:"numeric",day:"numeric",year:"2-digit"},medium:{month:"short",day:"numeric",year:"numeric"},long:{month:"long",day:"numeric",year:"numeric"},full:{weekday:"long",month:"long",day:"numeric",year:"numeric"}},time:{short:{hour:"numeric",minute:"numeric"},medium:{hour:"numeric",minute:"numeric",second:"numeric"},long:{hour:"numeric",minute:"numeric",second:"numeric",timeZoneName:"short"},full:{hour:"numeric",minute:"numeric",second:"numeric",timeZoneName:"short"}}},e}();function H(e,t){return r=>new G(function(e){return O(e,{ignoreTag:!0})}(e),t).format(r)}e.convertBundle=function(e,t){return Object.keys(e).reduce((r,n)=>(n.startsWith("@")||(r[n]=H(e[n],t)),r),{})},Object.defineProperty(e,"__esModule",{value:!0})});
//# sourceMappingURL=ojbundletransform.js.map