/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["exports","ojs/ojdvt-toolkit","ojs/ojdvt-axis","ojs/ojlegend-toolkit","ojs/ojdvt-overview"],function(t,e,i,r,a){"use strict";
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */const s=function(t,e){return t+"; "+e},n=function(t,i,r){return null!=t&&null!=i&&e.Obj.compareValues(r,t,i)};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */var o=function(t,e,i,r){this.id=t,this.series=e,this.group=i,this.context=r};e.Obj.createSubclass(o,e.Obj),o.prototype.equals=function(t){return t instanceof o&&(null!=this.id||null!=t.id?n(this.id,t.id,this.context):n(this.series,t.series,this.context)&&n(this.group,t.group,this.context))},o.prototype.toString=function(){return null!=this.id&&"object"!=typeof this.id?this.id.toString():s(this.series,this.group)},o.prototype.valueOf=function(){return this.toString()};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var l=new Object;e.Obj.createSubclass(l,e.Obj),l._SUPPORTED_TYPES=["bar","line","area","lineWithArea","combo","pie","bubble","scatter","funnel","pyramid","stock","boxPlot"],l.isValidType=function(t){return l._SUPPORTED_TYPES.indexOf(t.getType())>=0},l.isSpark=function(t){return t.getOptions().__spark},l.isOverview=function(t){return t.getOptions()._isOverview},l.isVertical=function(t){return!l.isHorizontal(t)&&!l.isPolar(t)},l.isHorizontal=function(t){return"horizontal"==t.getOptions().orientation&&!l.isPolar(t)&&!l.isStock(t)&&(l.isBLAC(t)||l.isFunnel(t))},l.isPolar=function(t){return"polar"==t.getOptions().coordinateSystem&&!l.isStock(t)&&!l.isBoxPlot(t)},l.isCombo=function(t){return"combo"==t.getType()},l.isBar=function(t){return"bar"==t.getType()},l.isLine=function(t){return"line"==t.getType()},l.isLineWithArea=function(t){return"lineWithArea"==t.getType()},l.isArea=function(t){return"area"==t.getType()},l.isStock=function(t){return"stock"==t.getType()},l.isBoxPlot=function(t){return"boxPlot"==t.getType()},l.isScatter=function(t){return"scatter"==t.getType()},l.isBubble=function(t){return"bubble"==t.getType()},l.isPie=function(t){return"pie"==t.getType()},l.isFunnel=function(t){return"funnel"==t.getType()},l.isPyramid=function(t){return"pyramid"==t.getType()},l.isDualY=function(t){return!(!l.hasAxes(t)||l.isScatterBubble(t)||l.isPolar(t))},l.isBLAC=function(t){var e=t.getType();return"bar"==e||"line"==e||"area"==e||"lineWithArea"==e||"combo"==e||"stock"==e||"boxPlot"==e},l.isScatterBubble=function(t){var e=t.getType();return"scatter"==e||"bubble"==e},l.isLineArea=function(t){var e=t.getType();return"line"==e||"area"==e||"lineWithArea"==e},l.isScrollSupported=function(t){return!(l.isPie(t)||l.isFunnel(t)||l.isPolar(t)||l.isPyramid(t))},l.isOverviewSupported=function(t){return l.isBLAC(t)&&l.isVertical(t)},l.hasAxes=function(t){return!("pie"==t.getType()||"funnel"==t.getType()||"pyramid"==t.getType())},l.isLegendRendered=function(t){var e=t.getOptions(),i=t.getOptionsCache().getFromCache("hasLargeSeriesCount"),r=e.legend;if("off"===r.rendered)return!1;if("auto"===r.rendered&&i)return!1;var a=t.getOptionsCache().getFromCache("hasSeriesDisplayedInLegend"),s=r.sections&&0!==r.sections.length,n=l.isStock(t),o=l.isFunnel(t),h=l.isPyramid(t);return!((n||o||h)&&!a&&!s)},l.hasTimeAxis=function(t){return l.isBLAC(t)&&"disabled"!=l.getTimeAxisType(t)},l.hasGroupAxis=function(t){return l.isBLAC(t)&&"disabled"==l.getTimeAxisType(t)},l.getTimeAxisType=function(t){var e=t.getOptions().timeAxisType;return e&&"auto"!=e&&l.isBLAC(t)&&!l.isPolar(t)?e:l.isStock(t)?"skipGaps":"disabled"},l.isMixedFrequency=function(t){return"mixedFrequency"==l.getTimeAxisType(t)};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
const h={polarToCartesian:function(t,i,r){var a=r.x+r.w/2+t*Math.sin(i),s=r.y+r.h/2-t*Math.cos(i);return new e.Point(a,s)},convertAxisCoord:function(t,i,r){if(l.isPolar(t)){var a=h.polarToCartesian(i.y,i.x,r);return new e.Point(a.x,a.y)}return l.isHorizontal(t)?new e.Point(i.y,i.x):new e.Point(i.x,i.y)}},u={getValueFormat:function(t,e){var i=t.getOptions().valueFormats;return i?i[e]?i[e]:"group"==e&&l.hasTimeAxis(t)?u.getValueFormat(t,"x"):"y"!=e&&"y2"!=e&&"min"!=e&&"max"!=e||!l.isBLAC(t)?{}:u.getValueFormat(t,"value"):{}},formatValue:function(t,e,r,a,s,n){var o,l="auto",h="on";e.scaling&&(l=e.scaling),e.autoPrecision&&(h=e.autoPrecision),e.converter&&(o=e.converter),a=null!=a?a:r,s=null!=s?s:r,n=null!=n?n:0;var u=new i.LinearScaleAxisValueFormatter(t.getCtx(),a,s,n,l,h,t.getOptions().translations);return o&&o.format?u.format(r,o):u.format(r)},formatDateValue:function(t,e){var i=t.converter;return i&&i.format?i.format(e):null}};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var g=new Object;e.Obj.createSubclass(g,e.Obj),g.hasData=function(t){var e=t.getOptions();if(!e||!e.series||e.series.length<1)return!1;for(var i=g.getSeriesCount(t),r=0;r<i;r++){var a=g.getSeriesItem(t,r);if(a&&a.items&&a.items.length>=1)return!0}return!1},g.hasInvalidData=function(t){return!g.hasData(t)||g.hasInvalidTimeData(t)},g.hasInvalidTimeData=function(t){if(l.isFunnel(t)||l.isPie(t)||l.isPyramid(t))return!1;var e,i,r=t.getOptions(),a=g.getGroupCount(t);if(!r||!r.series||r.series.length<1)return!0;if(a<1)return!0;var s=g.getSeriesCount(t);if(l.isMixedFrequency(t))for(e=0;e<s;e++)for(i=0;i<a;i++){var n=g.getDataItem(t,e,i);if(n&&(null==n.x||isNaN(n.x)))return!0}else if(l.hasTimeAxis(t))for(i=0;i<a;i++){var o=g.getGroup(t,i);if(null==o||isNaN(o))return!0}return!1},g.hasSeriesData=function(t,e){var i=g.getSeriesItem(t,e).items;if(i)for(var r=0;r<i.length;r++)if(null!=i[r])return!0;return!1},g.getSeriesCount=function(t){var e=t.getOptions().series;return e?e.length:0},g.getY2SeriesCount=function(t,e,i){for(var r=0,a=g.getSeriesCount(t),s=0;s<a;s++)e&&g.getSeriesType(t,s)!=e||(i||g.isSeriesRendered(t,s))&&g.isAssignedToY2(t,s)&&r++;return r},g.getSeries=function(t,e){var i=g.getSeriesItem(t,e);return i?i.id?i.id:i.name||""===i.name?i.name:String(e):null},g.getSeriesLabel=function(t,e){var i=g.getSeriesItem(t,e);return i&&(i.name||""===i.name)?i.name:null},g.getSeriesIndex=function(t,e){for(var i=g.getSeriesCount(t),r=0;r<i;r++){if(g.getSeries(t,r)==e)return r}return-1},g.getSeriesStyleIndex=function(t,e){if(t.getOptionsCache().getFromCache("hasLargeSeriesCount"))return e;var i=g.getSeries(t,e);return null==i?e:t.getSeriesStyleArray().indexOf(i)},g.getSeriesItem=function(t,e){if(isNaN(e)||null==e||e<0)return null;var i=t.getOptions();return i.series&&i.series.length>e?i.series[e]:void 0},g.getDataItem=function(t,e,i){if(isNaN(i)||null==i||i<0)return null;var r=g.getSeriesItem(t,e);return r&&r.items&&r.items.length>i?r.items[i]:null},g.getRawDataItem=function(t,e,i){if(isNaN(i)||null==i||i<0)return null;var r=t.getRawOptions().series[e].items[i];if("number"==typeof r)return r;var a=Object.assign({},r);return a.itemData=r._itemData,delete a._itemData,a},g.getDataItemId=function(t,e,i){var r=g.getDataItem(t,e,i);return r?null!=r.id?r.id:s(g.getSeries(t,e),g.getGroup(t,i)):null},g.getNestedDataItem=function(t,e,i,r){if(isNaN(r)||null==r||r<0)return null;var a=g.getDataItem(t,e,i);return a&&a.items&&a.items.length>r?a.items[r]:null},g.getNestedDataItemCount=function(t,e,i){var r=g.getDataItem(t,e,i);return r&&r.items?r.items.length:0},g.getNestedDataItemId=function(t,e,i,r){var a=g.getNestedDataItem(t,e,i,r);return a?null!=a.id?a.id:g.getDataItemId(t,e,i)+"; "+String(r):null},g.getNestedDataItemIndex=function(t,e,i,r){for(var a=g.getNestedDataItemCount(t,e,i),s=0;s<a;s++){var o=g.getNestedDataItemId(t,e,i,s);if(n(o,r,t.getCtx()))return s}return-1},g.getGroupCount=function(t){return g._getGroupsArray(t).length},g.getGroup=function(t,e){if(null!=e&&e>=0&&e<g.getGroupCount(t)){var i=g._getGroupsArray(t)[e];if(i)return null!=i.id?i.id:null!=i.name?i.name:String(e)}return null},g.getGroupIndex=function(t,i){for(var r=g.getGroups(t),a=0;a<r.length;a++)if(i instanceof Array&&r[a]instanceof Array?e.ArrayUtils.equals(i,r[a]):i===r[a])return a;return-1},g.getGroupLabel=function(t,e){if(e>=0&&e<g.getGroupCount(t)){var i=g._getGroupsArray(t)[e];if(i)return null!=i.name?i.name:null!=i.id||"string"!=typeof i?"":i}return null},g.getGroups=function(t){var e=t.getOptionsCache().getFromCache("groups");if(!e){var i=g.getGroupCount(t);e=[];for(var r=0;r<i;r++)e.push(g.getGroup(t,r));t.getOptionsCache().putToCache("groups",e)}return e},g._getGroupsArray=function(t){var e=t.getOptions(),i=t.getOptionsCache().getFromCache("groupsArray");if(!i){i=[],e.groups&&(i=g._getNestedGroups(e.groups,i));for(var r=0;r<i.length;r++)1==i[r].id.length&&(i[r].id=i[r].id[0],i[r].name=i[r].name[0]);t.getOptionsCache().putToCache("groupsArray",i)}return i},g._getNestedGroups=function(t,e){if(!t||t&&0==t.length)return[];for(var i=0;i<t.length;i++){var r=t[i],a=null,s=null;if(null!=r&&(a=r.id?r.id:r.name?r.name:r,s=r.name?r.name:r),"object"==typeof a&&(a=null),"object"==typeof s&&(s=null),r&&r.groups){var n=g._getNestedGroups(r.groups,[]);0==n.length&&n.push({id:[],name:[]});for(var o=0;o<n.length;o++)n[o].id.unshift(a),n[o].name.unshift(s);e=e.concat(n)}else e.push({id:[a],name:[s]})}return e},g.getNumLevels=function(t){var e=t.getOptionsCache().getFromCache("groupsNumLevels");if(null!=e)return e;e=0;for(var i=g._getGroupsArray(t),r=0;r<i.length;r++){var a=i[r];if(a&&a.id){var s=Array.isArray(a.id)?a.id.length:1;e=Math.max(e,s)}}return t.getOptionsCache().putToCache("groupsNumLevels",e),e},g.getValue=function(t,e,i,r){var a,s="number"==typeof r&&r>=0;if(!s&&void 0!==(a=t.getOptionsCache().getFromCachedMap2D("value",e,i)))return a;var n=s?g.getNestedDataItem(t,e,i,r):g.getDataItem(t,e,i);return a=null,null!=n&&("object"!=typeof n?a=n:l.isStock(t)&&null!=n.close?a=n.close:null!=n.value?a=n.value:null!=n.y&&(a=n.y)),a=a||(0===a?0:null),s||t.getOptionsCache().putToCachedMap2D("value",e,i,a),a},g.getCumulativeValue=function(t,e,i,r){if(!g.isStacked(t))return g.getValue(t,e,i);var a=r?"cumValueH":"cumValue",s=t.getCache().getFromCachedMap2D(a,e,i);if(void 0!==s)return s;var n=g.getSeriesType(t,e),o=g.isAssignedToY2(t,e),l=g.getValue(t,e,i),h=g.getStackCategory(t,e),u="bar"==n?l<0:g.isSeriesNegative(t,e);s=0;for(var d=e;d>=0;d--)if((r||g.isDataItemRendered(t,d,i))&&n==g.getSeriesType(t,d)&&o==g.isAssignedToY2(t,d)&&g.getStackCategory(t,d)==h){var c=g.getValue(t,d,i),p="bar"==n?c<0:g.isSeriesNegative(t,d);if(u&&p||!u&&!p){var _=t.getCache().getFromCachedMap2D(a,d,i);if(void 0!==_){s=l+(_||0);break}s+=null==c||isNaN(c)?0:c}}return t.getCache().putToCachedMap2D(a,e,i,s),s},g.getLowValue=function(t,e,i){var r=g.getDataItem(t,e,i);return null==r?null:"candlestick"==g.getSeriesType(t,e)?null==r.low&&null!=r.close?null!=r.open?Math.min(r.close,r.open):r.close:r.low:null!=r.low&&null==r.close?r.low:null},g.getHighValue=function(t,e,i){var r=g.getDataItem(t,e,i);return null==r?null:"candlestick"==g.getSeriesType(t,e)?null==r.high?null!=r.open?Math.max(r.close,r.open):r.close:r.high:null!=r.high&&null==r.close?r.high:null},g.getXValue=function(t,e,i){var r=g.getDataItem(t,e,i);return g.getXValueFromItem(t,r,i)},g.getXValueFromItem=function(t,e,i){return null!=e&&null!=e.x?e.x:l.hasGroupAxis(t)?i:l.hasTimeAxis(t)&&!l.isMixedFrequency(t)?g.getGroupLabel(t,i):null},g.getTargetValue=function(t,e){var i=g.getDataItem(t,e,0);return null==i||"object"!=typeof i?null:i.targetValue},g.getZValue=function(t,e,i,r){var a=g.getDataItem(t,e,i);return null==a||"object"!=typeof a?r:null!=a.z?Math.max(0,a.z):r},g.isStockValueRising=function(t,e,i){var r=g.getDataItem(t,e,i);return!r||r.open<=r.close},g.getCategories=function(t,e,i,r){var a=g.getNestedDataItem(t,e,i,r);if(a&&a.categories)return a.categories;var s=g.getDataItem(t,e,i);if(s&&s.categories)return s.categories;var n=g.getSeriesItem(t,e);if(n&&n.categories)return n.categories;var o=g.getSeries(t,e);return null!=o?[o]:[]},g.isAssignedToY2=function(t,e){if(!t.getOptionsCache().getFromCache("hasY2Assignment"))return!1;var i=g.getSeriesItem(t,e);return!(!i||"on"!=i.assignedToY2||!l.isDualY(t))},g.getInitialSelection=function(t){var e=t.getOptions().selection,i=null!=t.getOptions().data;e||(e=[]);for(var r=t.getChartObjPeers(),a=0;a<e.length;a++){var s=null==e[a].id||i?e[a]:e[a].id;if(null!=e[a].id||e[a].series||e[a].group||(e[a]={id:s}),!(null==s||e[a].series&&e[a].group))for(var o=0;o<r.length;o++){var l=r[o];if(n(s,l.getDataItemId(),t.getCtx())){e[a].series=l.getSeries(),e[a].group=l.getGroup();break}}}return e},g.getCurrentSelection=function(t){var e=[],i=t.getSelectionHandler();if(i)for(var r=i.getSelectedIds(),a=0;a<r.length;a++){var s=r[a];e.push({series:s.series,group:s.group,id:s.id})}return e},g.hasVolumeSeries=function(t){var e=t.getOptionsCache().getFromCache("hasVolume");return e||!1},g.isDataSelected=function(t,e,i,r){var a=!isNaN(r)&&null!=r&&r>=0?g.getNestedDataItemId(t,e,i,r):g.getDataItemId(t,e,i),s=g.getSeries(t,e),o=g.getGroup(t,i),l=t.getOptions().selection;l||(l=[]);for(var h=0;h<l.length;h++){if(n(a,l[h],t.getCtx())||n(a,l[h].id,t.getCtx()))return!0;if(null==l[h].id&&n(s,l[h].series,t.getCtx())&&n(o,l[h].group,t.getCtx()))return!0}return!1},g.getDefaultDataLabel=function(t,e,i,r,a,s){var n;if(s)n=g.getCumulativeValue(t,e,i);else{var o=!isNaN(r)&&null!=r&&r>=0?g.getNestedDataItem(t,e,i,r):g.getDataItem(t,e,i);if(!o)return null;n=o.label,"low"==a?n=n instanceof Array?n[0]:n:"high"==a&&(n=n instanceof Array?n[1]:null)}if(null!=n){if("number"==typeof n){var l,h,d,c=g.isAssignedToY2(t,e)&&t.y2Axis?t.y2Axis:t.yAxis;if(c){var p=c.getInfo();l=p.getGlobalMin(),h=p.getGlobalMax(),d=p.getMajorIncrement()}var _=u.getValueFormat(t,"label");return u.formatValue(t,_,n,l,h,d)}return n}return null},g.getStackCategory=function(t,e){var i=t.getCache().getFromCachedMap("stackCategory",e);return void 0!==i||(i=g.isStacked(t)?g.getSeriesItem(t,e).stackCategory||null:g.getSeries(t,e)||null,t.getCache().putToCachedMap("stackCategory",e,i)),i},g.getStackCategories=function(t,e,i){var r=[],a=[],s={},n={},o=t.getCache().getFromCachedMap2D("stackCategories",e,i);if(o)return o;for(var l=g.getSeriesCount(t),h=0;h<l;h++)if(g.isSeriesRendered(t,h)||i){if(e){var u=g.getSeriesType(t,h);if("candlestick"!=u&&"boxPlot"!=u||(u="bar"),e!=u)continue}var d=g.getStackCategory(t,h);g.isAssignedToY2(t,h)?n[d]||(a.push(d),n[d]=!0):s[d]||(r.push(d),s[d]=!0)}return o={y:r,y2:a},t.getCache().putToCachedMap2D("stackCategories",e,i,o),o},g.getBarCategoryZ=function(t,e,i,r){for(var a=0,s=g.getSeriesCount(t),n=0;n<s;n++){var o=g.getSeriesType(t,n);if(("bar"==o||"candlestick"==o||"boxPlot"==o)&&g.getStackCategory(t,n)==e&&g.isSeriesRendered(t,n)){var l=g.isAssignedToY2(t,n);(r&&l||!r&&!l)&&(a=Math.max(a,g.getZValue(t,n,i,1)))}}return a},g.getMarkerPosition=function(t,i,r,a,s){var n,o,u=t.xAxis,d=g.isAssignedToY2(t,i)?t.y2Axis:t.yAxis,c=l.isPolar(t),p=g.isRangeSeries(t,i),_=!isNaN(a)&&null!=a&&a>=0,f=g.getXValue(t,i,r),v=_?g.getValue(t,i,r,a):g.getCumulativeValue(t,i,r);if(l.isBubble(t)){if(c&&v<d.getInfo().getViewportMin())return null;n=c?u.getCoordAt(f):u.getUnboundedCoordAt(f),o=d.getUnboundedCoordAt(v)}else if(p){var m=d.getCoordAt(g.getLowValue(t,i,r)),S=d.getCoordAt(g.getHighValue(t,i,r));n=u.getCoordAt(g.getXValue(t,i,r)),o=(m+S)/2}else n=u.getCoordAt(f),o=d.getCoordAt(v);return null==n||null==o?null:h.convertAxisCoord(t,new e.Point(n,o),s)},g.getScatterBubbleMarkerPosition=function(t,i,r){var a=t.xAxis,s=t.yAxis,n=g.getXValue(t,i,r),o=g.getValue(t,i,r),l=a.getCoordAt(n),h=s.getCoordAt(o);return null==l||null==h?null:new e.Point(l,h)},g.isSeriesNegative=function(t,e){if(!t.getOptionsCache().getFromCache("hasNegativeValues"))return!1;var i=t.getOptionsCache().getFromCachedMap("isSeriesNegative",e);if(null!=i)return i;var r=g.getGroupCount(t);i=!0;for(var a=0;a<r;a++){if(g.getValue(t,e,a)>0){i=!1;break}}return t.getOptionsCache().putToCachedMap("isSeriesNegative",e,i),i},g.getGroupsDataForContext=function(t){var e=t.getOptionsCache().getFromCache("groupsDataArray");if(!e){var i=t.getRawOptions();e=g._getNestedGroupsData(i.groups),t.getOptionsCache().putToCache("groupsDataArray",e)}return e},g.getSeriesDataForContext=function(t,e){var i=t.getRawOptions().series[e],r=Object.assign({},i);r.items=[];for(var a=0;a<i.items.length;a++){var s,n=i.items[a];(s="object"==typeof n?Object.assign({},i.items[a]):n)&&"object"==typeof s&&delete s._itemData,r.items.push(s)}return r},g._getNestedGroupsData=function(t){if(!t)return[];for(var e=[],i=0;i<t.length;i++){var r=t[i];if(r.groups){for(var a=g._getNestedGroupsData(r.groups),s=0;s<a.length;s++)a[s].unshift(r);e=e.concat(a)}else e.push([r])}return e},g._computeOutermostBarMap=function(t){if(!t.getOptionsCache().getFromCache("outermostBar")){for(var e={},i=g.getSeriesCount(t),r=t.getOptionsCache().getFromCache("hasNegativeValues"),a=i-1;a>=0;a--)if(g.isSeriesRendered(t,a)&&"bar"==g.getSeriesType(t,a)){var s=(g.getStackCategory(t,a)||"")+g.isAssignedToY2(t,a);e[s]?e[s].push(a):e[s]=[a]}var n=g.getGroupCount(t);for(var o in e)for(var l=e[o],h=0;h<n;h++)for(var u=!1,d=!1,c=0;c<l.length&&!(!r&&u||u&&d);c++)if(a=l[c],g.isDataItemRendered(t,a,h)){var p=g.getValue(t,a,h);null==p?t.getOptionsCache().putToCachedMap2D("outermostBar",a,h,!1):!u&&p>=0?(u=!0,t.getOptionsCache().putToCachedMap2D("outermostBar",a,h,!0)):!d&&p<0&&(d=!0,t.getOptionsCache().putToCachedMap2D("outermostBar",a,h,!0))}}},g.isOutermostBar=function(t,e,i){return g._computeOutermostBarMap(t),t.getOptionsCache().getFromCachedMap2D("outermostBar",e,i)||!1},g.isDataItemFiltered=function(t,e,i){var r=g.getDataItem(t,e,i);return!(!r||!r._filtered)},g.isStacked=function(t){return!("on"!=t.getOptions().stack||l.isMixedFrequency(t)||g.getSeriesCount(t)<2)&&l.isBLAC(t)},g.isSplitDualY=function(t){return!(!l.isStock(t)||!g.hasVolumeSeries(t)||l.isOverview(t))||"on"==t.getOptions().splitDualY&&g.hasY2Data(t)&&!g.hasY2DataOnly(t)},g.hasY2DataOnly=function(t){return!!l.isDualY(t)&&g.getY2SeriesCount(t,null,!0)==g.getSeriesCount(t)},g.hasY2Data=function(t,e){return!!l.isDualY(t)&&g.getY2SeriesCount(t,null,!0)>0},g.hasY2BarData=function(t){return g.hasY2Data(t,"bar")},g.hasBarSeries=function(t){return g._hasSeriesType(t,"bar")},g.hasLineSeries=function(t){return g._hasSeriesType(t,"line")},g.hasAreaSeries=function(t){return g._hasSeriesType(t,"area")},g.hasLineWithAreaSeries=function(t){return g._hasSeriesType(t,"lineWithArea")},g.hasCandlestickSeries=function(t){return g._hasSeriesType(t,"candlestick")},g.hasBoxPlotSeries=function(t){return g._hasSeriesType(t,"boxPlot")},g._hasSeriesType=function(t,e){if(l.isBLAC(t))for(var i=g.getSeriesCount(t),r=0;r<i;r++)if(g.isSeriesRendered(t,r)&&g.getSeriesType(t,r)==e)return!0;return!1},g.getRefObjs=function(t){var e=g.getAxisRefObjs(t,"x"),i=g.getAxisRefObjs(t,"y"),r=g.getAxisRefObjs(t,"y2");return e.concat(i,r)},g.getAxisRefObjs=function(t,e){var i=t.getOptions();return i&&i[e+"Axis"]&&i[e+"Axis"].referenceObjects?i[e+"Axis"].referenceObjects:[]},g._SERIES_TYPE_RAMP=["bar","line","area"],g.getSeriesType=function(t,e){var i=t.getOptionsCache().getFromCachedMap("seriesType",e);if(i)return i;if(!l.isBLAC(t))return t.getOptionsCache().putToCachedMap("seriesType",e,"auto"),"auto";var r=g.getSeriesItem(t,e);if(i=r?r.type:null,l.isStock(t)||"candlestick"!=i||(i="auto"),!i||"auto"==i)if(l.isBar(t))i="bar";else if(l.isLine(t))i="line";else if(l.isArea(t))i="area";else if(l.isLineWithArea(t))i="lineWithArea";else if(l.isStock(t))i="candlestick";else if(l.isBoxPlot(t))i="boxPlot";else if(l.isCombo(t)){var a=g.getSeriesStyleIndex(t,e)%g._SERIES_TYPE_RAMP.length;i=g._SERIES_TYPE_RAMP[a]}return t.getOptionsCache().putToCachedMap("seriesType",e,i),i},g.getHiddenCategories=function(t){var e=t.getOptions();return e.hiddenCategories||(e.hiddenCategories=[]),e.hiddenCategories},g.getHighlightedCategories=function(t){var e=t.getOptions();return e.highlightedCategories||(e.highlightedCategories=[]),e.highlightedCategories},g.isSeriesRendered=function(t,i){var r=g.getHiddenCategories(t);return!(r.length>0&&e.ArrayUtils.hasAnyItem(r,g.getCategories(t,i)))},g.isDataItemRendered=function(t,i,r,a){var s,n=!isNaN(a)&&null!=a&&a>=0;if(!n&&void 0!==(s=t.getOptionsCache().getFromCachedMap2D("isDataItemRendered",i,r)))return s;if(s=!0,g.isSeriesRendered(t,i)){var o=g.getHiddenCategories(t);o.length>0&&((l.isPie(t)||l.isFunnel(t)||l.isPyramid(t))&&(r=0),e.ArrayUtils.hasAnyItem(o,g.getCategories(t,i,r))&&(s=!1),e.ArrayUtils.hasAnyItem(o,g.getCategories(t,i,r,a))&&(s=!1))}else s=!1;return n||t.getOptionsCache().putToCachedMap2D("isDataItemRendered",i,r,s),s},g.isRangeSeries=function(t,e){var i=t.getOptionsCache();if(!i.getFromCache("hasLowHighSeries"))return!1;var r=i.getFromCachedMap("isRange",e);if(null!=r)return r;r=!1;var a=g.getSeriesType(t,e);if("bar"==a||"area"==a)for(var s=0;s<g.getGroupCount(t);s++)if(null!=g.getLowValue(t,e,s)||null!=g.getHighValue(t,e,s)){r=!0;break}return t.getOptionsCache().putToCachedMap("isRange",e,r),r},g.isSeriesDrillable=function(t,e){var i=g.getSeriesItem(t,e),r=null!=i?i.drilling:"inherit";return"on"==r||"off"!=r&&("on"==(r=t.getOptions().drilling)||"seriesOnly"==r)},g.isDataItemDrillable=function(t,e,i,r){var a=g.getNestedDataItem(t,e,i,r);a||(a=g.getDataItem(t,e,i));var s=null!=a?a.drilling:"inherit";return"on"==s||"off"!=s&&"on"==(s=t.getOptions().drilling)},g.isMultiSeriesDrillEnabled=function(t){return"on"===t.getOptions().multiSeriesDrilling};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var d=function(t){this.Init({alta:d.SKIN_ALTA},t)};e.Obj.createSubclass(d,e.BaseComponentDefaults),d.SKIN_ALTA={skin:e.CSSStyle.SKIN_ALTA,emptyText:null,type:"bar",stack:"off",stackLabel:"off",orientation:"vertical",polarGridShape:"circle",selectionMode:"none",hideAndShowBehavior:"none",hoverBehavior:"none",zoomAndScroll:"off",zoomDirection:"auto",initialZooming:"none",dragMode:"user",sorting:"off",otherThreshold:0,animationOnDataChange:"none",animationOnDisplay:"none",__sparkBarSpacing:"subpixel",__spark:!1,dataCursor:"auto",dataCursorBehavior:"auto",drilling:"off",highlightMatch:"all",series:[],groups:[],title:{style:new e.CSSStyle(e.BaseComponentDefaults.FONT_FAMILY_ALTA_BOLD_13+"color: #252525;"),halign:"start"},subtitle:{style:new e.CSSStyle(e.BaseComponentDefaults.FONT_FAMILY_ALTA_12+"color: #252525;")},footnote:{style:new e.CSSStyle(e.BaseComponentDefaults.FONT_FAMILY_ALTA_11+"color: #333333;"),halign:"start"},titleSeparator:{upperColor:"#74779A",lowerColor:"#FFFFFF",rendered:"off"},touchResponse:"auto",_statusMessageStyle:new e.CSSStyle(e.BaseComponentDefaults.FONT_FAMILY_ALTA_13+"color: #252525;"),_dropColor:"#D9F4FA",xAxis:{tickLabel:{rendered:"on"},majorTick:{rendered:"auto"},minorTick:{rendered:"auto"},axisLine:{rendered:"on"},scale:"linear"},yAxis:{tickLabel:{rendered:"on"},majorTick:{rendered:"auto"},minorTick:{rendered:"auto"},axisLine:{rendered:"auto"},scale:"linear"},y2Axis:{tickLabel:{rendered:"on"},majorTick:{rendered:"auto"},minorTick:{rendered:"auto"},axisLine:{rendered:"auto"},scale:"linear",alignTickMarks:"on"},pieCenter:{labelStyle:new e.CSSStyle("")},zAxis:{},plotArea:{backgroundColor:null},legend:{position:"auto",rendered:"auto",layout:{gapRatio:1},seriesSection:{},referenceObjectSection:{},sections:[]},overview:{rendered:"off"},dnd:{drag:{items:{},series:{},groups:{}},drop:{plotArea:{},xAxis:{},yAxis:{},y2Axis:{},legend:{}}},styleDefaults:{colors:e.CSSStyle.COLORS_ALTA,borderColor:"auto",borderWidth:"auto",patterns:["smallDiagonalRight","smallChecker","smallDiagonalLeft","smallTriangle","smallCrosshatch","smallDiamond","largeDiagonalRight","largeChecker","largeDiagonalLeft","largeTriangle","largeCrosshatch","largeDiamond"],shapes:["square","circle","diamond","plus","triangleDown","triangleUp"],seriesEffect:"color",threeDEffect:"off",selectionEffect:"highlight",animationDuration:1e3,animationIndicators:"all",animationUpColor:"",animationDownColor:"",lineStyle:"solid",lineType:"auto",markerDisplayed:"auto",markerColor:null,markerShape:"auto",markerSize:10,marqueeColor:"",marqueeBorderColor:"",pieFeelerColor:"#BAC5D6",pieInnerRadius:0,selectedInnerColor:"#ffffff",selectedOuterColor:"#5a5a5a",sliceLabelType:"percent",otherColor:"#4b4b4b",dataItemGaps:"auto",dataLabelStyle:new e.CSSStyle(""),_dataLabelStyle:new e.CSSStyle(""),dataLabelPosition:"auto",funnelBackgroundColor:"#EDEDED",x1Format:{},y1Format:{},y2Format:{},zFormat:{},_defaultSliceLabelColor:"#333333",_scrollbarHeight:3,_scrollbarTrackColor:"#F0F0F0",_scrollbarHandleColor:"#9E9E9E",hoverBehaviorDelay:200,dataCursor:{markerSize:8,markerDisplayed:"on",lineStyle:"solid"},groupSeparators:{rendered:"on",color:"rgba(138,141,172,0.4)"},tooltipLabelStyle:new e.CSSStyle(""),tooltipValueStyle:new e.CSSStyle(""),stackLabelStyle:new e.CSSStyle(""),boxPlot:{whiskerSvgStyle:{},whiskerEndSvgStyle:{strokeWidth:2},whiskerEndLength:"9px",medianSvgStyle:{strokeWidth:3}}},layout:{gapWidthRatio:null,gapHeightRatio:null,outerGapWidth:10,outerGapHeight:8,titleSubtitleGapWidth:14,titleSubtitleGapHeight:4,titleSeparatorGap:6,titlePlotAreaGap:16,footnoteGap:10,verticalAxisGap:6,legendGapWidth:15,legendGapHeight:10,tickLabelGapHeight:8,tickLabelGapWidth:9},_locale:"en-us",_resources:{}},d.getGapWidth=function(t,e){return Math.ceil(e*t.getGapWidthRatio())},d.getGapHeight=function(t,e){return Math.ceil(e*t.getGapHeightRatio())},d.prototype.getNoCloneObject=function(t){return{series:{items:{_itemData:!0}},data:!0}};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var c=new Object;e.Obj.createSubclass(c,e.Obj),c.OTHER_SLICE_SERIES_ID="_dvtOther",c.getSliceId=function(t,e){var i=g.getDataItem(t,e,0),r=i?i.id:null,a=g.getSeries(t,e),s=g.getGroup(t,0);return new o(r,a,s,t.getCtx())},c.getOtherSliceId=function(t){var e=g.getGroup(t,0);return new o(null,c.OTHER_SLICE_SERIES_ID,e,t.getCtx())},c.getRenderedSeriesIndices=function(t){return c._getSeriesIndicesArrays(t).rendered},c.hasOtherSeries=function(t){return c._getSeriesIndicesArrays(t).other.length>0},c.getOtherValue=function(t){for(var e=c._getSeriesIndicesArrays(t).other,i=0,r=0;r<e.length;r++){var a=e[r];if(g.isSeriesRendered(t,a)){var s=g.getValue(t,a,0);s>0&&(i+=s)}}return i},c.getOtherSliceIds=function(t){for(var e=c._getSeriesIndicesArrays(t).other,i=[],r=0;r<e.length;r++){var a=e[r];i.push(c.getSliceId(t,a))}return i},c.isOtherSliceSelected=function(t,e){for(var i=c.getOtherSliceIds(t),r=0;r<i.length;r++){for(var a=i[r],s=!1,n=0;n<e.length;n++)if(null!=e[n].id&&a.id===e[n].id||a.series===e[n].series&&a.group===e[n].group){s=!0;break}if(!s)return!1}return!0},c._getSeriesIndicesArrays=function(t){for(var e=[],i=[],r=g.getSeriesCount(t),a=t.getOptions(),s=a.otherThreshold*c.getTotalValue(t),n=0;n<r;n++){var o=g.getValue(t,n,0);s>0&&o<s?i.push(n):e.push(n)}return"ascending"==a.sorting?e.sort(function(e,i){return g.getValue(t,e,0)-g.getValue(t,i,0)}):"on"!=a.sorting&&"descending"!=a.sorting||e.sort(function(e,i){return g.getValue(t,i,0)-g.getValue(t,e,0)}),{rendered:e,other:i}},c.getTotalValue=function(t){for(var e=g.getSeriesCount(t),i=0,r=0;r<e;r++){var a=g.getValue(t,r,0);a>0&&(i+=a)}return i},c.getSliceExplode=function(t,e){var i=g.getSeriesItem(t,e);return i&&i.pieSliceExplode?i.pieSliceExplode:0},c.getSliceBySeriesIndex=function(t,e){for(var i=t.pieChart.__getSlices(),r=0;r<i.length;r++)if(i[r].getSeriesIndex()==e)return i[r];return null};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var p=new Object;e.Obj.createSubclass(p,e.Obj),p.MARKER_DATA_LABEL_GAP=4,p.getSeriesEffect=function(t){return t.getOptions().styleDefaults.seriesEffect},p.getColor=function(t,e,i){var r=g.getDataItem(t,e,i);if(r&&r.color)return r.color;var a=g.getSeriesItem(t,e);if(a&&a.color)return a.color;if("candlestick"==g.getSeriesType(t,e))return p.getStockItemColor(t,e,i);var s=t.getOptions().styleDefaults.colors;return s[g.getSeriesStyleIndex(t,e)%s.length]},p.getStockItemColor=function(t,e,i){var r=t.getOptions();return g.isStockValueRising(t,e,i)?r.styleDefaults.stockRisingColor:r.styleDefaults.stockFallingColor},p.getStockVolumeColor=function(t,e,i){var r=g.getDataItem(t,e,i);if(r&&r.color)return r.color;var a=t.getOptions();return a.styleDefaults.stockVolumeColor?a.styleDefaults.stockVolumeColor:p.getStockItemColor(t,e,i)},p.getSplitterPosition=function(t){var e=t.getOptions().splitterPosition;return null!=e?e:l.isStock(t)?.8:.5},p.getPattern=function(t,i,r,a){var s=g.getNestedDataItem(t,i,r,a);if(s&&s.pattern&&"auto"!=s.pattern)return s.pattern;var n=g.getDataItem(t,i,r);if(n&&n.pattern&&"auto"!=n.pattern)return n.pattern;var o=g.getSeriesType(t,i);if(("line"==o||"area"==o)&&null!=r)return null;var h=g.getSeriesItem(t,i);if(h&&h.pattern&&"auto"!=h.pattern)return h.pattern;if("pattern"==p.getSeriesEffect(t)){if(l.isStock&&"candlestick"==g.getSeriesType(t,i)){var u=g.isStockValueRising(t,i,r),d=e.Agent.isRightToLeft(t.getCtx());return u?d?"smallDiagonalLeft":"smallDiagonalRight":d?"smallDiagonalRight":"smallDiagonalLeft"}var c=t.getOptions().styleDefaults.patterns;return c[g.getSeriesStyleIndex(t,i)%c.length]}return null},p.getMarkerBorderColor=function(t,e,i,r){var a=p.getBorderColor(t,e,i,r);return a||p.getDefaultMarkerBorderColor(t,e,i,r)},p.getDefaultMarkerBorderColor=function(t,i,r,a){if("redwood"===t.getCtx().getThemeBehavior()&&!g.isRangeSeries(t,i))return p.getMarkerColor(t,i,r,a);if(p.getDataItemGaps(t)>0&&"lineWithArea"!=g.getSeriesType(t,i))return p.getBackgroundColor(t,!0);if(l.isBubble(t)&&"gradient"!=p.getSeriesEffect(t)){var s=p.getMarkerColor(t,i,r);if(s)return e.ColorUtils.adjustHSL(s,0,.15,-.25)}return null},p.getBorderColor=function(t,e,i,r){var a=g.getNestedDataItem(t,e,i,r);if(a&&a.borderColor)return a.borderColor;var s=g.getDataItem(t,e,i);if(s&&s.borderColor)return s.borderColor;var n=g.getSeriesItem(t,e);if(n&&n.borderColor)return n.borderColor;var o=t.getOptions().styleDefaults;return"auto"!=o.borderColor?o.borderColor:null},p.getUserBorderWidth=function(t,e,i,r){var a=g.getNestedDataItem(t,e,i,r);if(a&&null!=a.borderWidth)return a.borderWidth;var s=g.getDataItem(t,e,i);if(s&&null!=s.borderWidth)return s.borderWidth;var n=g.getSeriesItem(t,e);if(n&&null!=n.borderWidth)return n.borderWidth;var o=t.getOptions().styleDefaults;return"auto"!=o.borderWidth?o.borderWidth:null},p.getDefaultBorderWidth=function(t){return l.isScatterBubble(t)||l.isLineArea(t)?1.25:1},p.getDefaultMarkerBorderWidth=function(t){return"redwood"===t.getCtx().getThemeBehavior()?0:p.getDefaultBorderWidth(t)},p.getBorderWidth=function(t,e,i,r){var a=p.getUserBorderWidth(t,e,i,r);return null!=a?a:p.getDefaultBorderWidth(t)},p.getMarkerColor=function(t,e,i,r){if(!p.isMarkerDisplayed(t,e,i,r))return p.getColor(t,e,i);var a=g.getNestedDataItem(t,e,i,r);if(a&&a.color)return a.color;var s=g.getDataItem(t,e,i);if(s&&s.color)return s.color;var n=g.getSeriesItem(t,e);if(n&&n.markerColor)return n.markerColor;var o=t.getOptions().styleDefaults.markerColor;return o||p.getColor(t,e,i)},p.getMarkerShape=function(t,e,i,r){var a=t.getOptions(),s=a.styleDefaults.markerShape,n=g.getSeriesItem(t,e);n&&n.markerShape&&(s=n.markerShape);var o=g.getDataItem(t,e,i);o&&o.markerShape&&(s=o.markerShape);var h=g.getNestedDataItem(t,e,i,r);if(h&&h.markerShape&&(s=h.markerShape),"auto"==s)if(l.isBubble(t)||"boxPlot"==g.getSeriesType(t,e)||g.isRangeSeries(t,e))s="circle";else{var u=g.getSeriesStyleIndex(t,e),d=a.styleDefaults.shapes;s=d[u%d.length]}return s},p.getMarkerSize=function(t,e,i,r){var a;if(l.isBubble(t)&&(a=t.getOptionsCache().getFromCachedMap2D("bubbleSizeCache",e,i)))return a;var s=g.getNestedDataItem(t,e,i,r);if(s&&null!=s.markerSize)a=Number(s.markerSize);else{var n=g.getDataItem(t,e,i);if(n&&null!=n.markerSize)a=Number(n.markerSize);else{var o=g.getSeriesItem(t,e);a=o&&null!=o.markerSize?Number(o.markerSize):Number(t.getOptions().styleDefaults.markerSize)}}return l.isOverview(t)&&(a=Math.ceil(.6*a)),a},p.isMarkerDisplayed=function(t,e,i,r){var a,s=g.getNestedDataItem(t,e,i,r);if(s&&null!=s.markerDisplayed)a=s.markerDisplayed;else{var n=g.getDataItem(t,e,i);if(n&&null!=n.markerDisplayed)a=n.markerDisplayed;else{var o=g.getSeriesItem(t,e);a=o&&null!=o.markerDisplayed?o.markerDisplayed:t.getOptions().styleDefaults.markerDisplayed}}return"on"==a||"off"!=a&&(l.isScatterBubble(t)||"boxPlot"==g.getSeriesType(t,e)||"none"==p.getLineType(t,e))},p.getImageSource=function(t,e,i,r,a){var s=g.getNestedDataItem(t,e,i,r);if(s&&s[a])return s[a];var n=g.getDataItem(t,e,i);if(n&&n[a])return n[a];var o=g.getSeriesItem(t,e);return o&&o[a]?o[a]:void 0},p.getLineWidth=function(t,e){var i,r=g.getSeriesItem(t,e),a=t.getOptions();return i=r&&r.lineWidth?r.lineWidth:a.styleDefaults.lineWidth?a.styleDefaults.lineWidth:"lineWithArea"==g.getSeriesType(t,e)?2:3,l.isOverview(t)&&(i=Math.ceil(.6*i)),i},p.getLineStyle=function(t,e){var i=g.getSeriesItem(t,e);return i&&i.lineStyle?i.lineStyle:t.getOptions().styleDefaults.lineStyle},p.getLineType=function(t,e){var i,r=g.getSeriesItem(t,e);return"auto"==(i=r&&r.lineType?r.lineType:t.getOptions().styleDefaults.lineType)&&(i=l.isScatterBubble(t)?"none":"straight"),(l.isPolar(t)||l.isScatterBubble(t))&&("centeredSegmented"==i&&(i="segmented"),"centeredStepped"==i&&(i="stepped")),i},p.getBarSpacing=function(t){return t.getOptions().__sparkBarSpacing},p.getMaxBarWidth=function(t){var e=t.getOptions().styleDefaults.maxBarWidth;return null==e||l.isPolar(t)?1/0:e},p.getBarWidth=function(t,e,i){t.getOptionsCache().getFromCache("hasConstantZValue")&&(e=0,i=0);var r=t.getCache().getFromCachedMap2D("barWidth",e,i);if(null!=r)return r;var a=g.getZValue(t,e,i,1)/t.getOptions()._averageGroupZ;return r=Math.min(a*p.getGroupWidth(t),p.getMaxBarWidth(t)),t.getCache().putToCachedMap2D("barWidth",e,i,r),r},p.getBarStackWidth=function(t,e,i,r){t.getOptionsCache().getFromCache("hasConstantZValue")&&(i=0);var a=r?"y2BarStackWidth":"yBarStackWidth",s=t.getCache().getFromCachedMap2D(a,e,i);if(null!=s)return s;var n=g.getBarCategoryZ(t,e,i,r)/t.getOptions()._averageGroupZ;return s=Math.min(n*p.getGroupWidth(t),p.getMaxBarWidth(t)),t.getCache().putToCachedMap2D(a,e,i,s),s},p.getBarCategoryOffsetMap=function(t,e){t.getOptionsCache().getFromCache("hasConstantZValue")&&(e=0);var i=t.getCache().getFromCachedMap("barCategoryOffsetMap",e);if(i)return i;var r,a=g.isStacked(t),s=g.getStackCategories(t,"bar"),n=l.isMixedFrequency(t),o=g.isSplitDualY(t),h={},u={},d=0,c=0;if(a){for(f=0;f<s.y.length;f++)r=p.getBarStackWidth(t,s.y[f],e,!1),n?h[s.y[f]]=-.5*r:(h[s.y[f]]=d,d+=r);for(o||(c=d),f=0;f<s.y2.length;f++)r=p.getBarStackWidth(t,s.y2[f],e,!0),n?u[s.y2[f]]=-.5*r:(u[s.y2[f]]=c,c+=r);o||(d=c)}else for(var _=g.getSeriesCount(t),f=0;f<_;f++){var v=g.getSeriesType(t,f);if(("bar"==v||"candlestick"==v||"boxPlot"==v)&&g.isSeriesRendered(t,f)){var m=g.isAssignedToY2(t,f),S=g.getStackCategory(t,f);r=p.getBarWidth(t,f,e),m?n?u[S]=-.5*r:(u[S]=c,c+=r):n?h[S]=-.5*r:(h[S]=d,d+=r)}}for(var S in h)h[S]-=o||a?d/2:(d+c)/2;for(var S in u)u[S]-=o||a?c/2:(d+c)/2-d;return i={y:h,y2:u},t.getCache().putToCachedMap("barCategoryOffsetMap",e,i),i},p.getDataItemGaps=function(t){var e=t.getOptionsCache().getFromCache("dataItemGaps");if(null!=e)return e;var i=t.getOptions();if(null!=i.styleDefaults.sliceGaps)e=i.styleDefaults.sliceGaps;else{var r=i.styleDefaults.dataItemGaps;"auto"==r&&(r="on"==i.styleDefaults.threeDEffect?"0%":"50%");var a=r&&r.indexOf?r.indexOf("%"):-1;e=a>=0?(r=r.substring(0,a))/100:0}return t.getOptionsCache().putToCache("dataItemGaps",e),e},p.isSelectable=function(t,e,i){var r=g.getSeriesItem(t,e);return(!r||"off"!=r._selectable)&&(t.isSelectionSupported()&&null!=e&&e>=0&&null!=i&&i>=0)},p.getAnimationOnDisplay=function(t){return t.getOptions().animationOnDisplay},p.getAnimationOnDataChange=function(t){return t.getOptions().animationOnDataChange},p.getAnimationDuration=function(t){return e.CSSStyle.getTimeMilliseconds(t.getOptions().styleDefaults.animationDuration)/1e3},p.getAnimationIndicators=function(t){return t.getOptions().styleDefaults.animationIndicators},p.getAnimationUpColor=function(t){return t.getOptions().styleDefaults.animationUpColor},p.getAnimationDownColor=function(t){return t.getOptions().styleDefaults.animationDownColor},p.getSelectedInnerColor=function(t){return t.getOptions().styleDefaults.selectedInnerColor},p.getSelectedOuterColor=function(t){return t.getOptions().styleDefaults.selectedOuterColor},p.isSelectionHighlighted=function(t){var e=t.getOptions().styleDefaults.selectionEffect;return"highlight"==e||"highlightAndExplode"==e},p.isSelectionExploded=function(t){var e=t.getOptions().styleDefaults.selectionEffect;return"explode"==e||"highlightAndExplode"==e},p.getDataLabelStyle=function(t,i,r,a,s,n,o){var h,u=t.getOptions().styleDefaults,d=[u._dataLabelStyle,u.dataLabelStyle];!s||"bar"!=g.getSeriesType(t,i)&&!l.isBubble(t)||"center"!=n&&"inBottom"!=n&&"inTop"!=n&&"inRight"!=n&&"inLeft"!=n||(h=null!=p.getPattern(t,i,r,a)?"#000000":e.ColorUtils.getContrastingTextColor(s),d.push(new e.CSSStyle("color: "+h+";"))),d.push(p._parseLowHighArray(t.getOptions().styleDefaults.dataLabelStyle,o));var c=g.getDataItem(t,i,r);c&&d.push(new e.CSSStyle(p._parseLowHighArray(c.labelStyle,o)));var _=g.getNestedDataItem(t,i,r,a);return _&&d.push(new e.CSSStyle(p._parseLowHighArray(_.labelStyle,o))),h&&e.Agent.isHighContrast()&&d.push(new e.CSSStyle("color: "+h+";")),e.CSSStyle.mergeStyles(d)},p.getDataLabelCollisions=function(t,e,i,r,a){var s=e&&e.x&&e.x-i.w/2||i.x,n=e&&e.y&&e.y-i.h/2||i.y,o=p.MARKER_DATA_LABEL_GAP/2,l=t.getOptions(),h=a?d.getGapHeight(t,l.layout.legendGapHeight):d.getGapWidth(t,l.layout.legendGapWidth);return{xAxis:n+i.h+o>r.y+r.h,yAxis:s+o<r.x,y2Axis:s+i.w+o>r.x+r.w,legend:s+i.w+o>r.x+r.w+h,top:n<t.getDimensions().y}},p.adjustDataLabelPosition=function(t,e,i){var r=t;return"left"!=t&&"center"!=t||!e.yAxis?"right"!=t&&"center"!=t||!(i&&e.y2Axis||e.legend)?"top"!=t&&"center"!=t||!e.top?"bottom"!=t&&"center"!=t||!e.xAxis||(r="top"):r="bottom":r="left":r="right",r},p._parseLowHighArray=function(t,e){return t instanceof Array?"high"==e?t[1]:t[0]:t},p.isOverviewRendered=function(t){var e=t.getOptions();return l.isOverviewSupported(t)&&"off"!=e.overview.rendered},p.getOverviewHeight=function(t){var e=t.getOptions().overview.height;return null==e&&(e=l.hasTimeAxis(t)?.25:.2),p.getSizeInPixels(e,t.getHeight())},p.getSizeInPixels=function(t,e){if("string"==typeof t){if("%"==t.slice(-1))return e*Number(t.slice(0,-1))/100;if("px"==t.slice(-2))return Number(t.slice(0,-2));t=Number(t)}return"number"==typeof t?t<=1?e*t:t:0},p.getBackgroundColor=function(t,e){var i=t.getOptions();return i.plotArea.backgroundColor?i.plotArea.backgroundColor:e?"#FFFFFF":null},p.getHoverBehaviorDelay=function(t){var i=t.getOptions().styleDefaults.hoverBehaviorDelay;return i?(i=e.CSSStyle.getTimeMilliseconds(i),l.isScatterBubble(t)||l.isLine(t)?.75*i:1.25*i):0},p.optimizeMarkerStroke=function(t){return l.isScatterBubble(t)||l.isBoxPlot(t)},p.getGroupWidth=function(t){var e=t.getCache().getFromCache("groupWidth");return null==e&&(e=t.xAxis.getInfo().getGroupWidth(),t.getCache().putToCache("groupWidth",e)),e},p.isStackLabelRendered=function(t){var e=t.getOptions();return"on"==e.stack&&!l.isMixedFrequency(t)&&("on"===e.stackLabel&&l.isBLAC(t))},p.optimizeMarkerFill=function(t){return l.isLineArea(t)},p.getClassName=function(t,e,i){var r=g.getDataItem(t,e,i);if(r&&(r.className||r.svgClassName))return r.className||r.svgClassName;var a=g.getSeriesItem(t,e);return a&&(a.className||a.svgClassName)?a.className||a.svgClassName:null},p.getAreaClassName=function(t,e){var i=g.getSeriesItem(t,e);return i&&(i.areaClassName||i.areaSvgClassName)?i.areaClassName||i.areaSvgClassName:i&&(i.className||i.svgClassName)?i.className||i.svgClassName:null},p.getMarkerClassName=function(t,e,i,r){var a=g.getNestedDataItem(t,e,i,r);if(a&&(a.className||a.svgClassName))return a.className||a.svgClassName;var s=g.getDataItem(t,e,i);if(s&&(s.className||s.svgClassName))return s.className||s.svgClassName;var n=g.getSeriesItem(t,e);return n&&(n.markerClassName||n.markerSvgClassName)?n.markerClassName||n.markerSvgClassName:l.isScatterBubble(t)&&n&&(n.className||n.svgClassName)?n.className||n.svgClassName:null},p.getStyle=function(t,e,i){var r=g.getDataItem(t,e,i);if(r&&(r.style||r.svgStyle))return r.style||r.svgStyle;var a=g.getSeriesItem(t,e);return a&&(a.style||a.svgStyle)?a.style||a.svgStyle:null},p.getAreaStyle=function(t,e){var i=g.getSeriesItem(t,e);return i&&(i.areaStyle||i.areaSvgStyle)?i.areaStyle||i.areaSvgStyle:i&&(i.style||i.svgStyle)?i.style||i.svgStyle:null},p.getMarkerStyle=function(t,e,i,r){var a=g.getNestedDataItem(t,e,i,r);if(a&&(a.style||a.svgStyle))return a.style||a.svgStyle;var s=g.getDataItem(t,e,i);if(s&&(s.style||s.svgStyle))return s.style||s.svgStyle;var n=g.getSeriesItem(t,e);return n&&(n.markerStyle||n.markerSvgStyle)?n.markerStyle||n.markerSvgStyle:l.isScatterBubble(t)&&n&&(n.style||n.svgStyle)?n.style||n.svgStyle:null},p.getBoxPlotStyleOptions=function(t,i,r){var a=g.getDataItem(t,i,r),s=a&&a.boxPlot?a.boxPlot:{},n=g.getSeriesItem(t,i),o=n&&n.boxPlot?n.boxPlot:{},l=t.getOptions().styleDefaults.boxPlot,h=e.JsonUtils.merge(s,e.JsonUtils.merge(o,l)),u=p.getColor(t,i,r);h._color=u;var d=e.ColorUtils.getBrighter(u,.8);if(h.q2Color||(h.q2Color=d),h.q3Color||(h.q3Color=d),"pattern"==p.getSeriesEffect(t)){var c=p.getPattern(t,i,r);h._q2Pattern=c,h._q3Pattern=c}var _=p.getBorderColor(t,i,r);h.borderColor=_||u,h.borderWidth=p.getBorderWidth(t,i,r);var f=e.ColorUtils.getDarker(u,.1);return p._setBoxPlotDefaultLineColor(h,"whisker",f),p._setBoxPlotDefaultLineColor(h,"whiskerEnd",f),p._setBoxPlotDefaultLineColor(h,"median",f),h},p._setBoxPlotDefaultLineColor=function(t,i,r){var a=e.JsonUtils.merge(t[i+"Style"],t[i+"SvgStyle"]);t[i+"SvgStyle"]=a,t[i+"Style"]=null,!a||a.stroke||t[i+"ClassName"]||t[i+"SvgClassName"]||(t[i+"SvgStyle"].stroke=r)},p.getDataContext=function(t,e,i,r){var a,s=g.getSeriesItem(t,e),n=g.getDataItem(t,e,i),o=g.getNestedDataItem(t,e,i,r),h=t.getRawOptions(),u=l.isPie(t)&&(null==e||e<0),d=t.getOptions();if(u){var _=d.translations.labelOther;a={id:_,series:_,value:c.getOtherValue(t),color:d.styleDefaults.otherColor}}else if(o){(f=h.series[e].items[i])._noTemplate?f=f._itemData:f&&"object"==typeof f&&delete(f=Object.assign({},f))._itemData,a={id:g.getNestedDataItemId(t,e,i,r),data:[f,f.items[r]],value:g.getValue(t,e,i,r),y:g.getValue(t,e,i,r),color:p.getMarkerColor(t,e,i,r),itemData:d.series[e].items[i]._itemData}}else if(n){var f;(f=h.series[e].items[i])._noTemplate?f=f._itemData:f&&"object"==typeof f&&delete(f=Object.assign({},f))._itemData,a={id:g.getDataItemId(t,e,i),data:f,value:g.getValue(t,e,i),targetValue:g.getTargetValue(t,e,i),x:g.getXValue(t,e,i),y:g.getValue(t,e,i),z:g.getZValue(t,e,i),low:g.getLowValue(t,e,i),high:g.getHighValue(t,e,i),open:n.open,close:n.close,volume:n.volume,color:p.getColor(t,e,i),itemData:d.series[e].items[i]._itemData}}else s&&(a={id:g.getSeries(t,e),color:p.getColor(t,e)});if(a){a.component=d._widgetConstructor,(u||o||n)&&(a.group=g.getGroup(t,i),a.groupData=g.getGroupsDataForContext(t)[i]),!u&&(o||n||s)&&(a.series=g.getSeries(t,e),a.seriesData=g.getSeriesDataForContext(t,e)),l.isPie(t)&&t.pieChart&&(a.totalValue=t.pieChart.getTotalValue());var v=t.getOptionsCache().getFromCachedMap2D("barDims",e,i);v&&(a.dimensions=v),a=t.getCtx().fixRendererContext(a)}return a||{}},p.getDataLabel=function(t,e,i,r,a,s){var n,o=g.getDefaultDataLabel(t,e,i,r,a,s),l=t.getOptions().dataLabel;if(l&&!s){var h=p.getDataContext(t,e,i,r);if(h.label=o,"number"==typeof(n=l(h))){var u=DvtChartFormatUtils.getValueFormat(t,"label");n=DvtChartFormatUtils.formatValue(t,u,n)}}return n||o},p.hasCenteredSeries=function(t){if(!l.isBLAC(t))return!1;for(var e=g.getSeriesCount(t),i=0;i<e;i++)if(g.isSeriesRendered(t,i)&&"bar"!=g.getSeriesType(t,i)){var r=p.getLineType(t,i);if("centeredSegmented"==r||"centeredStepped"==r)return!0}return!1},p.hasUncenteredSeries=function(t){if(!l.isBLAC(t))return!1;for(var e=g.getSeriesCount(t),i=0;i<e;i++)if(g.isSeriesRendered(t,i)&&"bar"!=g.getSeriesType(t,i)){var r=p.getLineType(t,i);if("segmented"==r||"stepped"==r)return!0}return!1};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var _=function(t,e,i){this.Init(t,e,i)};e.Obj.createSubclass(_,e.Container),_.BEHAVIOR_SNAP="SNAP",_.BEHAVIOR_SMOOTH="SMOOTH",_.BEHAVIOR_AUTO="AUTO",_.TOOLTIP_ID="_dvtDataCursor",_.prototype.Init=function(t,i,r){_.superclass.Init.call(this,t),this._bHoriz=r,this._options=i,this.setMouseEnabled(!1),this.setVisible(!1);var a=i.lineWidth,s=i.lineColor,n=new e.Stroke(s,1,a,!1,e.Stroke.getDefaultDashProps(i.lineStyle,a));if(this._cursorLine=new e.Line(this.getCtx(),0,0,0,0,"dcLine"),this._cursorLine.setStroke(n),this.addChild(this._cursorLine),this._cursorOuterLine=new e.Line(this.getCtx(),0,0,0,0,"dcLine"),this._cursorOuterLine.setClassName("oj-chart-data-cursor-outer-line"),this.addChild(this._cursorOuterLine),"off"!=i.markerDisplayed){this._marker=new e.Container(this._context),this._marker.setMouseEnabled(!1),this.addChild(this._marker);var o=i.markerSize,l=new e.SimpleMarker(this._context,e.SimpleMarker.CIRCLE,0,0,o+4*a,o+4*a);l.setSolidFill(s),this._marker.addChild(l);var h=new e.SimpleMarker(this._context,e.SimpleMarker.CIRCLE,0,0,o+2*a,o+2*a);h.setSolidFill("white"),this._marker.addChild(h),this._markerInnerCircle=new e.SimpleMarker(this._context,e.SimpleMarker.CIRCLE,0,0,o,o),this._marker.addChild(this._markerInnerCircle)}},_.prototype.render=function(t,i,r,a,s,n){var o,l=this.isHorizontal(),h=e.Agent.isRightToLeft(this.getCtx());if(null!=s&&""!=s){var u=this.getCtx().getStageAbsolutePosition(),g=this.getCtx().getTooltipManager(_.TOOLTIP_ID);g.showDatatip(i+u.x,r+u.y,s,n,!1),o=g.getTooltipBounds();var d,c,p=this._options.markerSize+4*this._options.lineWidth;l?(d=h?t.x-.75*o.w:t.x+t.w-o.w/4,c=a-o.h/2,!h&&d-i<p?d=i+p:h&&i-(d+o.w)<p&&(d=i-p-o.w)):(d=a-o.w/2,r-((c=t.y-.75*o.h)+o.h)<p&&(c=r-p-o.h)),g.positionTip(d+u.x,c+u.y),(o=g.getTooltipBounds()).x-=u.x,o.y-=u.y}var f=this._cursorLine.getStroke().getWidth(),v=a+Math.ceil(f/2);if(l){var m,S;this._cursorLine.setTranslateY(a),this._cursorOuterLine.setTranslateY(v),h?(m=o?o.x+o.w-1:t.x,S=t.x+t.w):(m=t.x,S=o?o.x+1:t.x+t.w),this._cursorLine.setX1(m),this._cursorLine.setX2(S),this._cursorOuterLine.setX1(m),this._cursorOuterLine.setX2(S)}else{this._cursorLine.setTranslateX(a),this._cursorOuterLine.setTranslateX(v);var C=o?o.y+o.h-1:t.y,y=t.y+t.h;this._cursorLine.setY1(C),this._cursorLine.setY2(y),this._cursorOuterLine.setY1(C),this._cursorOuterLine.setY2(y)}if(this._marker){this._marker.setTranslate(i,r);var x=this._options.markerColor;this._markerInnerCircle.setSolidFill(x||n),e.Agent.workaroundFirefoxRepaint(this._marker)}},_.prototype.isHorizontal=function(){return this._bHoriz},_.prototype.getBehavior=function(){return this._behavior?this._behavior:_.BEHAVIOR_AUTO},_.prototype.setBehavior=function(t){this._behavior=t};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var f=new Object;e.Obj.createSubclass(f,e.Obj),f.getType=function(t){return"area"==t.type?"area":"line"},f.getLocation=function(t){return"front"==t.location?"front":"back"},f.getColor=function(t,e){return e.color?e.color:"line"===f.getType(e)?t.getOptions()._defaultReferenceObjectLineColor:t.getOptions()._defaultReferenceObjectAreaColor},f.getLineWidth=function(t,e){return e.lineWidth?e.lineWidth:parseFloat(t.getOptions()._defaultReferenceObjectLineWidth)},f.getLineType=function(t){return t.lineType?t.lineType:"straight"},f.isObjectRendered=function(t,i){var r=g.getHiddenCategories(t);if(r.length>0){var a=f.getRefObjCategories(i);if(a&&e.ArrayUtils.hasAnyItem(r,a))return!1}return!("hidden"==i.visibility)},f.getId=function(t){return null!=t.id?t.id:t.text},f.getRefObjCategories=function(t){return t.categories?t.categories:[f.getId(t)]},f.getRefObj=function(t,e){for(var i=g.getRefObjs(t),r=0;r<i.length;r++)if(f.getId(i[r])==e)return i[r]},f.getLowValue=function(t){return null==t?null:t.low},f.getHighValue=function(t){return null==t?null:t.high},f.getXValue=function(t,e,i){return g.getXValueFromItem(t,e[i],i)};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var v=new Object;e.Obj.createSubclass(v,e.Obj),v.getDatatipColor=function(t,e,i,r){return l.isStock(t)?p.getColor(t,0,i):null!=r&&r>=0?p.getMarkerColor(t,e,i,r):p.getColor(t,e,i)},v.getDatatip=function(t,e,i,r,a){if(l.isSpark(t)||l.isOverview(t))return null;if(e<0||i<0)return null;var s=t.getOptions().tooltip,n=s?s.renderer:null;if(a&&n){var o=t.getCtx().getTooltipManager(v.isDataCursorEnabled(t)?_.TOOLTIP_ID:null),h=p.getDataContext(t,e,i,r);if(l.isPie(t)){var u=c.getSliceBySeriesIndex(t,e);h.label=u.getSliceLabelString()}else h.label=p.getDataLabel(t,e,i,r);return o.getCustomTooltip(n,h)}var d=g.getNestedDataItem(t,e,i,r);if(d&&null!=d.shortDesc)return d.shortDesc;var f,m=g.getDataItem(t,e,i);return m&&null!=m.shortDesc?m.shortDesc:(l.isStock(t)?f=v._getStockDatatip(t,0,i,a):(f=[],v._addSeriesDatatip(f,t,e,i,a),v._addGroupDatatip(f,t,e,i,a),v._addValueDatatip(f,t,e,i,r,a)),v._processDatatip(f,t,a))},v.getOtherSliceDatatip=function(t,e,i){var r=t.getOptions().translations.labelOther,a=t.getOptions().tooltip,s=a?a.renderer:null;if(i&&s){var n=c.getSliceBySeriesIndex(t,null),o=p.getDataContext(t,null,0);return o.label=n.getSliceLabelString(),t.getCtx().getTooltipManager().getCustomTooltip(s,o)}var l=[];return v._addDatatipRow(l,t,"series","labelSeries",r,i),v._addGroupDatatip(l,t,0,0,i),v._addDatatipRow(l,t,"value","labelValue",e,i),v._processDatatip(l,t,i)},v._processDatatip=function(t,i,r){return 0===t.length?null:r?e.HtmlTooltipManager.createElement("table",null,t,["oj-dvt-datatip-table"]):t.join("")},v.getRefObjTooltip=function(t,e,i,r){var a=t.getOptions().tooltip,s=a?a.renderer:null;if(s&&null!=e.id){var n=t.getCtx().getTooltipManager(v.isDataCursorEnabled(t)?_.TOOLTIP_ID:null),o={id:f.getId(e),label:e.text,data:t.getRawOptions()[i].referenceObjects[r],value:e.value,low:f.getLowValue(e),high:f.getHighValue(e),color:f.getColor(t,e)};return n.getCustomTooltip(s,o)}return e.shortDesc},v._getStockDatatip=function(t,e,i,r){var a=g.getDataItem(t,e,i),s=[];return v._addGroupDatatip(s,t,e,i,r),a&&(v._addDatatipRow(s,t,"open","labelOpen",a.open,r),v._addDatatipRow(s,t,"close","labelClose",a.close,r),v._addDatatipRow(s,t,"high","labelHigh",a.high,r),v._addDatatipRow(s,t,"low","labelLow",a.low,r),v._addDatatipRow(s,t,"volume","labelVolume",a.volume,r)),s},v._addSeriesDatatip=function(t,e,i,r,a){var s=g.getSeriesLabel(e,i);v._addDatatipRow(t,e,"series","labelSeries",s,a)},v._addGroupDatatip=function(t,e,i,r,a){var s;if(l.hasTimeAxis(e)){var n=u.getValueFormat(e,"group"),o=g.getXValue(e,i,r);null==(s=u.formatDateValue(n,new Date(o)))&&(s=e.xAxis.getInfo().formatLabel(o))}else s=g.getGroupLabel(e,r);var h=g.getNumLevels(e),d="labelGroup";if(1!=h&&Array.isArray(s))for(var c=h-1;c>=0;c--)v._addDatatipRow(t,e,"group",d,s[c],a,c),s[c]&&(d=null);else v._addDatatipRow(t,e,"group",d,s,a)},v._addValueDatatip=function(t,e,i,r,a,s){var n=g.getValue(e,i,r,a),o=g.getXValue(e,i,r),h=g.getZValue(e,i,r),u=g.getLowValue(e,i,r),d=g.getHighValue(e,i,r),c=null!=a&&a>=0;if(l.isScatterBubble(e))v._addDatatipRow(t,e,"x","labelX",o,s),v._addDatatipRow(t,e,"y","labelY",n,s),l.isBubble(e)&&v._addDatatipRow(t,e,"z","labelZ",h,s);else if(l.isPie(e)||l.isPyramid(e))v._addDatatipRow(t,e,"value","labelValue",n,s);else if(l.isFunnel(e)){v._addDatatipRow(t,e,"value","labelValue",n,s);var p=g.getTargetValue(e,i);null!=p&&v._addDatatipRow(t,e,"targetValue","labelTargetValue",p,s)}else if("boxPlot"!=g.getSeriesType(e,i)||c){if(l.isBLAC(e)){var _=g.isAssignedToY2(e,i)?"y2":"y";null==u&&null==d||c?null==h||c?v._addDatatipRow(t,e,_,"labelValue",n,s):(v._addDatatipRow(t,e,_,"labelY",n,s),v._addDatatipRow(t,e,"z","labelZ",h,s)):(v._addDatatipRow(t,e,"high","labelHigh",d,s),v._addDatatipRow(t,e,"low","labelLow",u,s),null!=h&&v._addDatatipRow(t,e,"z","labelZ",h,s))}}else{var f=g.getDataItem(e,i,r);v._addDatatipRow(t,e,"high","labelHigh",d,s),v._addDatatipRow(t,e,"q3","labelQ3",f.q3,s),v._addDatatipRow(t,e,"q2","labelQ2",f.q2,s),v._addDatatipRow(t,e,"q1","labelQ1",f.q1,s),v._addDatatipRow(t,e,"low","labelLow",u,s),null!=h&&v._addDatatipRow(t,e,"z","labelZ",h,s)}},v._addDatatipRow=function(t,i,r,a,s,n,o){if(null!=s&&""!==s){var h,g=i.getOptions().styleDefaults,d=u.getValueFormat(i,r),c=d.tooltipDisplay,p=i.getOptions().translations;if(c&&"auto"!=c||"group"==r&&(l.isPie(i)||l.isFunnel(i))&&(c="off"),"off"!=c)if("string"==typeof d.tooltipLabel?h=d.tooltipLabel:Array.isArray(d.tooltipLabel)&&(h=d.tooltipLabel[o||0]),null==h&&(h=null==a?"":"labelGroup"==a&&l.hasTimeAxis(i)?p.labelDate:p[a]),"series"!=r&&"group"!=r&&(s=u.formatValue(i,d,s)),n){var _=[e.HtmlTooltipManager.createElement("td",g.tooltipLabelStyle,h,["oj-dvt-datatip-label"]),e.HtmlTooltipManager.createElement("td",g.tooltipValueStyle,s,["oj-dvt-datatip-value"])];t.push(e.HtmlTooltipManager.createElement("tr",null,_))}else t.push((t.length>0?"<br>":"")+e.ResourceUtils.format(p.labelAndValue,[h,s]))}},v.isDataCursorEnabled=function(t){if(l.isPie(t)||l.isFunnel(t)||l.isPolar(t)||l.isPyramid(t))return!1;var i=t.getOptions();return"on"==i.dataCursor||"off"!=i.dataCursor&&(e.Agent.isTouchDevice()&&l.isLineArea(t))},v.getDataCursorBehavior=function(t){var e=t.getOptions().dataCursorBehavior;return"snap"==e?_.BEHAVIOR_SNAP:"smooth"==e||l.isLineArea(t)?_.BEHAVIOR_SMOOTH:_.BEHAVIOR_SNAP};
/**
   * @license
   * Copyright (c) 2008 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var m=function(t,e,i,r,a,s){this.Init(t,e,i,r,a,s)};e.Obj.createSubclass(m,e.Obj),m.prototype.Init=function(t,i,r,a,s,n){if(this._chart=t,this._displayables=i,this._seriesIndex=null!=r&&r>=0?r:-1,this._groupIndex=null!=a&&a>=0?a:-1,this._itemIndex=null!=s&&s>=0?s:-1,this._dataPos=n,this._isSelected=!1,this._isShowingKeyboardFocusEffect=!1,this._series=g.getSeries(t,r),this._group=g.getGroup(t,a),this._categories=g.getCategories(t,r,a,s),-1!=this._itemIndex)this._dataItemId=g.getNestedDataItemId(t,r,a,s),this._drillable=g.isDataItemDrillable(t,r,a,s);else if(-1!=this._groupIndex){g.getDataItem(t,r,a)&&(this._dataItemId=g.getDataItemId(t,r,a),this._drillable=g.isDataItemDrillable(t,r,a))}else{g.getSeriesItem(t,r)&&(this._drillable=g.isSeriesDrillable(t,r))}if(this._drillable)for(var o=0;o<this._displayables.length;o++)this._displayables[o].setCursor(e.SelectionEffectUtils.getSelectingCursor());for(var l=0;l<i.length;l++){var h=i[l];"lineArea"!==h.chartShapeType&&h.setAriaRole("img"),this._updateAriaLabel(h)}},m.associate=function(t,e,i,r,a,s){if(t&&!e.getOptions()._duringZoomAndScroll){var n=new m(e,[t],i,r,a,s);e.registerObject(n),e.getEventManager().associate(t,n)}},m.prototype.getId=function(){return this._seriesIndex>=0&&this._groupIndex>=0?new o(this._dataItemId,this.getSeries(),this.getGroup(),this._chart.getCtx()):this._seriesIndex>=0?this.getSeries():null},m.prototype.getDataItemId=function(){return this._dataItemId},m.prototype.getNestedDataItemIndex=function(){return this._itemIndex},m.prototype.getSeries=function(){return this._series},m.prototype.getSeriesIndex=function(){return this._seriesIndex},m.prototype.getGroup=function(){return this._group},m.prototype.getGroupIndex=function(){return this._groupIndex},m.prototype.isDrillable=function(){return this._drillable},m.prototype.isDoubleClickable=function(){return this.isSelectable()&&this.isDrillable()},m.prototype.getChart=function(){return this._chart},m.prototype.getDatatip=function(t){return v.getDatatip(this._chart,this._seriesIndex,this._groupIndex,this._itemIndex,!0)},m.prototype.getDatatipColor=function(){return v.getDatatipColor(this._chart,this._seriesIndex,this._groupIndex,this._itemIndex)},m.prototype.isSelectable=function(){return p.isSelectable(this.getChart(),this.getSeriesIndex(),this.getGroupIndex())},m.prototype.isSelected=function(){return this._isSelected},m.prototype.setSelected=function(t){this._isSelected=t;for(var e=0;e<this._displayables.length;e++)this._displayables[e].setSelected&&(this._displayables[e].setSelected(t),this._updateAriaLabel(this._displayables[e]))},m.prototype.showHoverEffect=function(){for(var t=0;t<this._displayables.length;t++)this._displayables[t].showHoverEffect&&this._displayables[t].showHoverEffect()},m.prototype.hideHoverEffect=function(){for(var t=0;t<this._displayables.length;t++)this._displayables[t].hideHoverEffect&&this._displayables[t].hideHoverEffect()},m.prototype.getDisplayables=function(){return this._displayables},m.prototype.getAriaLabel=function(){var t=[],i=this.getChart().getOptions().translations;this.isSelectable()&&t.push(i[this.isSelected()?"stateSelected":"stateUnselected"]),this.isDrillable()&&t.push(i.stateDrillable);var r=v.getDatatip(this._chart,this._seriesIndex,this._groupIndex,this._itemIndex,!1);return null==r&&this._groupIndex<0&&t.length>0&&(r=g.getSeriesLabel(this._chart,this._seriesIndex)),e.Displayable.generateAriaLabel(r,t)},m.prototype._updateAriaLabel=function(t){e.Agent.deferAriaCreation()||t.setAriaProperty("label",this.getAriaLabel())},m.prototype.getCategories=function(t){return this._categories},m.prototype.getDataPosition=function(){return this._dataPos},m.prototype.getNextNavigable=function(t){var i,r;if(i=t.keyCode,t.type==e.MouseEvent.CLICK)return this;if(i==e.KeyboardEvent.SPACE&&t.ctrlKey)return this;for(var a=this._chart,s=a.getChartObjPeers(),n=[],o=0;o<s.length;o++)s[o].isNavigable()&&n.push(s[o]);var h=t.keyCode==e.KeyboardEvent.UP_ARROW||t.keyCode==e.KeyboardEvent.DOWN_ARROW,u=l.isHorizontal(a),d=e.Agent.isRightToLeft(a.getCtx());return l.isScatterBubble(a)||l.isBoxPlot(a)&&(h&&!u||!h&&u)?r=e.KeyboardHandler.getNextAdjacentNavigable(this,t,n):l.isLineArea(a)||g.isStacked(a)||l.isPolar(a)?r=this._findNextNavigable(t):l.isFunnel(a)&&h?(t.keyCode=d?t.keyCode==e.KeyboardEvent.UP_ARROW?e.KeyboardEvent.RIGHT_ARROW:e.KeyboardEvent.LEFT_ARROW:t.keyCode-1,r=e.KeyboardHandler.getNextNavigable(this,t,n)):l.isPyramid(a)&&!h?(t.keyCode=d?t.keyCode==e.KeyboardEvent.RIGHT_ARROW?e.KeyboardEvent.DOWN_ARROW:e.KeyboardEvent.UP_ARROW:t.keyCode==e.KeyboardEvent.RIGHT_ARROW?e.KeyboardEvent.UP_ARROW:e.KeyboardEvent.DOWN_ARROW,r=e.KeyboardHandler.getNextNavigable(this,t,n)):r=e.KeyboardHandler.getNextNavigable(this,t,n,!0),r},m.prototype.getKeyboardBoundingBox=function(t){return this._displayables[0]?this._displayables[0].getDimensions(t):new e.Rectangle(0,0,0,0)},m.prototype.getTargetElem=function(){return this._displayables[0]?this._displayables[0].getElem():null},m.prototype.showKeyboardFocusEffect=function(){this.isNavigable()&&(this._isShowingKeyboardFocusEffect=!0,this.showHoverEffect())},m.prototype.hideKeyboardFocusEffect=function(){this.isNavigable()&&(this._isShowingKeyboardFocusEffect=!1,this.hideHoverEffect())},m.prototype.isShowingKeyboardFocusEffect=function(){return this._isShowingKeyboardFocusEffect},m.prototype.isNavigable=function(){return-1!=this.getGroupIndex()&&-1!=this.getSeriesIndex()},m.prototype._findNextNavigable=function(t){var i,r,a=t.keyCode,s=this._chart,n=s.getCtx(),o=this.getSeriesIndex(),h=this.getGroupIndex(),u=g.getGroupCount(s),d=l.isHorizontal(s),c=l.isPolar(s),p=e.Agent.isRightToLeft(n),_=d?p?a==e.KeyboardEvent.LEFT_ARROW:a==e.KeyboardEvent.RIGHT_ARROW:a==e.KeyboardEvent.UP_ARROW,f=d?p?a==e.KeyboardEvent.RIGHT_ARROW:a==e.KeyboardEvent.LEFT_ARROW:a==e.KeyboardEvent.DOWN_ARROW,v=d?a==e.KeyboardEvent.UP_ARROW:p?a==e.KeyboardEvent.RIGHT_ARROW:a==e.KeyboardEvent.LEFT_ARROW,m=d?a==e.KeyboardEvent.DOWN_ARROW:p?a==e.KeyboardEvent.LEFT_ARROW:a==e.KeyboardEvent.RIGHT_ARROW;if(_)r=h,i=this._findNextUpSeries(s,o,h);else if(f)r=h,i=this._findNextDownSeries(s,o,h);else if(m){i=o,r=h;do{r++,c&&r>=u&&(r=0)}while(null==s.getObject(i,r)&&r<u)}else if(v){i=o,r=h;do{r--,c&&r<0&&(r=u-1)}while(null==s.getObject(i,r)&&r>-1)}var S=s.getObject(i,r);return S&&S.isNavigable()?S:this},m.prototype._findNextUpSeries=function(t,e,i){for(var r=g.isStacked(t),a=g.getSeriesCount(t),s=g.getCumulativeValue(t,e,i),n=null,o=null,l=0;l<a;l++)if(g.isSeriesRendered(t,l)&&null!=g.getValue(t,l,i)&&(!r||null!=t.getObject(l,i))){var h=g.getCumulativeValue(t,l,i);(h>s||h==s&&l>e)&&(null!==n&&h<n||null==n)&&(n=h,o=l)}return o},m.prototype._findNextDownSeries=function(t,e,i){for(var r=g.isStacked(t),a=g.getSeriesCount(t),s=g.getCumulativeValue(t,e,i),n=null,o=null,l=a-1;l>=0;l--)if(g.isSeriesRendered(t,l)&&null!=g.getValue(t,l,i)&&(!r||null!=t.getObject(l,i))){var h=g.getCumulativeValue(t,l,i);(h<s||h==s&&l<e)&&(null!==n&&h>n||null==n)&&(n=h,o=l)}return o},m.prototype.isDragAvailable=function(t){return!0},m.prototype.getDragTransferable=function(t,e){return[this.getId()]},m.prototype.getDragFeedback=function(t,e){if(this._chart.isSelectionSupported()&&this._chart.getSelectionHandler().getSelectedCount()>1){for(var i=this._chart.getSelectionHandler().getSelection(),r=[],a=0;a<i.length;a++)r=r.concat(i[a].getDisplayables());return r}return this._displayables};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var S=function(t,e,i,r,a){this.Init(t,e,i,r,a)};e.Obj.createSubclass(S,e.Obj),S.prototype.Init=function(t,e,i,r,a){this._chart=t,this._displayables=e,this._refObj=i,this._categories=f.getRefObjCategories(this._refObj),this._index=r,this._axisType=a;for(var s=0;s<e.length;s++){var n=e[s];n.setAriaRole("img"),n.setAriaProperty("label",i.shortDesc)}},S.prototype.getCategories=function(){return this._categories},S.prototype.getDisplayables=function(){return this._displayables},S.prototype.getIndex=function(){return this._index},S.prototype.getAxisType=function(){return this._axisType},S.prototype.getDatatip=function(t){return v.getRefObjTooltip(this._chart,this._refObj,this._axisType,this._index)},S.prototype.getDatatipColor=function(){return f.getColor(this._chart,this._refObj)};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var C={};e.Obj.createSubclass(C,e.Obj),C.TICK_LABEL="tickLabel",C.TITLE="title";
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var y=function(t){this.Init({alta:y.SKIN_ALTA},t)};e.Obj.createSubclass(y,e.BaseComponentDefaults),y.SKIN_ALTA={position:null,baselineScaling:"zero",axisLine:{lineColor:"#9E9E9E",lineWidth:1,rendered:"on"},majorTick:{lineColor:"rgba(196,206,215,0.4)",baselineColor:"auto",lineWidth:1,rendered:"auto",lineStyle:"solid"},minorTick:{lineColor:"rgba(196,206,215,0.2)",lineWidth:1,rendered:"off",lineStyle:"solid"},tickLabel:{scaling:"auto",style:new e.CSSStyle(e.BaseComponentDefaults.FONT_FAMILY_ALTA_11+"color: #333333;"),rotation:"auto",rendered:"on"},titleStyle:new e.CSSStyle(e.BaseComponentDefaults.FONT_FAMILY_ALTA_12+"color: #737373;"),startGroupOffset:0,endGroupOffset:0,layout:{titleGap:6,radialLabelGap:5,insideLabelGapWidth:4,insideLabelGapHeight:2,hierarchicalLabelGapHeight:8,hierarchicalLabelGapWidth:15},_locale:"en-us"},y.getGapSize=function(t,i,r){var a=Math.min(e.TextUtils.getTextStringHeight(t,i.tickLabel.style)/14,1);return Math.ceil(r*a)};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var x=function(){};e.Obj.createSubclass(x,i.BaseAxisInfo),x._constructors=[],x.registerConstructor=function(t,e){x._constructors[t]=e},x.getConstructor=function(t){return x._constructors[t]},x.newInstance=function(t,e,i){return e.timeAxisType&&"disabled"!=e.timeAxisType?new x._constructors.time(t,e,i):e._isGroupAxis?new x._constructors.group(t,e,i):new x._constructors.data(t,e,i)},x.prototype.Init=function(t,e,i){x.superclass.Init.call(this,t,e,i),this._title=null},x.prototype.getLabels=function(t,e){return null},x.prototype.getTitle=function(){return this._title},x.prototype.setTitle=function(t){this._title=t},x.prototype.getMajorTickCoords=function(){return[]},x.prototype.getMinorTickCoords=function(){return[]},x.prototype.getBaselineCoord=function(){return null},x.prototype.getDatatip=function(t,e){return null},x.prototype.getLabelBackground=function(t,e){return null},x.prototype.isDrillable=function(t){return null},x.prototype.isLabelRotated=function(){return!1},x.prototype.CreateLabel=function(t,i,r,a,s){var n;if("tangential"==this.Position){var o=16/180*Math.PI,l=1/180*Math.PI,h=.5*this.getTickLabelHeight(),u=this._radius+h;(r<l||r>2*Math.PI-l)&&(u+=h);var g=Math.round(u*Math.sin(r)),d=Math.round(-u*Math.cos(r));n=a?new e.BackgroundOutputText(t,i,g,d,a):new e.OutputText(t,i,g,d),r<l||Math.abs(r-Math.PI)<l||r>2*Math.PI-l?n.alignCenter():r<Math.PI?n.alignLeft():n.alignRight(),Math.abs(r-Math.PI/2)<o||Math.abs(r-3*Math.PI/2)<o?n.alignMiddle():r<Math.PI/2||r>3*Math.PI/2?n.alignBottom():n.alignTop()}else s?n=a?new e.BackgroundMultilineText(t,i,r,r,a):new e.MultilineText(t,i,r,r):(n=a?new e.BackgroundOutputText(t,i,r,r,a):new e.OutputText(t,i,r,r)).alignMiddle(),n.alignCenter();return(n instanceof e.OutputText||n instanceof e.MultilineText)&&n.setCSSStyle(this.Options.tickLabel.style),n},x.prototype.IsOverlapping=function(t,i,r){if(!t||t.length<=0)return!1;for(var a,s,n,o,l="left"==this.Position||"right"==this.Position||"radial"==this.Position,h=e.Agent.isRightToLeft(this.getCtx()),u=this.GetTickLabelGapSize(),g=0;g<t.length;g+=i+1)if(null!=t[g]){if(null!=r&&t[g].w>r[g])return!0;if(null!=a&&null!=s){if(l){if(n=t[g].y,o=t[g].y+t[g].h,n>=a&&n-u<s)return!0;if(n<a&&o+u>a)return!0}else{if(n=t[g].x,o=t[g].x+t[g].w,!h&&n-u<s)return!0;if(h&&o+u>a)return!0}a=n,s=o}else l?(a=t[g].y,s=t[g].y+t[g].h):(a=t[g].x,s=t[g].x+t[g].w)}return!1},x.prototype.IsOverlappingDims=function(t,e){if(!t||!e)return!1;var i=t.y,r=t.y+t.h,a=t.x,s=t.x+t.w,n=e.y,o=e.y+e.h,l=e.x,h=e.x+e.w;return(a<=l&&l<=s||a<=h&&h<=s||l<=a&&a<=h||l<=s&&s<=h)&&(n>=i&&n<r||n<=i&&o>=i)},x.prototype.GetTickLabelGapSize=function(){var t=this.getTickLabelHeight(),e=this instanceof x._constructors.group?.24*t:.79*t,i=this instanceof x._constructors.group?.08*t:.28*t;return"left"==this.Position||"right"==this.Position||"radial"==this.Position||this.isLabelRotated()?i:e},x.prototype.getTickLabelHeight=function(){return e.TextUtils.getTextStringHeight(this.getCtx(),this.Options.tickLabel.style)},x.prototype.SkipLabels=function(t,e){for(var i=0,r=this.IsOverlapping(e,i);r;)i++,r=this.IsOverlapping(e,i);if(i>0){for(var a=[],s=0;s<t.length;s+=i+1)a.push(t[s]);return a}return t},x.prototype.SkipTangentialLabels=function(t,e){var i=[],r=t.length,a=null;if(r>1){for(var s,n=0;n<r;n++)e[n]&&(!s||s&&!this.IsOverlappingDims(s,e[n]))&&(a||(a=e[n]),i.push(t[n]),s=e[n]);return this.IsOverlappingDims(s,a)&&i.pop(),i}return t},x.prototype.GetLabelDims=function(t,e,i){for(var r=[],a=this.isLabelRotated(i),s=0;s<t.length;s++){var n=t[s];if(null!=n){var o=n.getDimensions(e);null!=i&&(o.x=(a?n.getTranslateX():n.getX())-o.w/2,o.y=(a?n.getTranslateY():n.getY())-o.h/2),o.w&&o.h?r.push(o):r.push(null)}else r.push(null)}return r},x.prototype.getMajorTickCount=function(){return null},x.prototype.getMinorTickCount=function(){return null},x.prototype.getMajorIncrement=function(){return null},x.prototype.getMinorIncrement=function(){return null},x.prototype.getGlobalMin=function(){return this.GlobalMin},x.prototype.getGlobalMax=function(){return this.GlobalMax},x.prototype.getViewportMin=function(){return this.MinValue},x.prototype.getViewportMax=function(){return this.MaxValue},x.prototype.getDataMin=function(){return this.DataMin},x.prototype.getDataMax=function(){return this.DataMax},x.prototype.getMinimumExtent=function(){return 0},x.prototype.getStartCoord=function(){return this.StartCoord},x.prototype.getEndCoord=function(){return this.EndCoord},x.prototype.getStartOverflow=function(){return this.StartOverflow},x.prototype.getEndOverflow=function(){return this.EndOverflow},x.prototype.getGroupWidth=function(){return 0},x.prototype.getGroup=function(t,e){return null},x.prototype.linearToActual=function(t){return t},x.prototype.actualToLinear=function(t){return t},x.prototype.alignLogScaleToTickCount=function(t,e){return t},x.prototype.getLogScaleUnit=function(){return null};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var A=function(t,e,i,r,a,s,n){this.Init(t,e,i,r,a,s,n)};e.Obj.createSubclass(A,e.SimpleObjPeer),A.prototype.Init=function(t,i,r,a,s,n,o){A.superclass.Init.call(this,s,n,null,o),this._axis=t,this._label=i,this._group=r,this._drillable=a,this._drillable&&i.setCursor(e.SelectionEffectUtils.getSelectingCursor()),t.__registerObject(this)},A.prototype.getLabel=function(){return this._label},A.prototype.getId=function(){return this._group},A.prototype.isDrillable=function(){return this._drillable},A.prototype.getGroup=function(){return this._group},A.prototype.getNextNavigable=function(t){if(t.type==e.MouseEvent.CLICK)return this;var i=this._axis.__getKeyboardObjects();return e.KeyboardHandler.getNextNavigable(this,t,i,!1,this._axis.getCtx().getStage())},A.prototype.getKeyboardBoundingBox=function(t){return this._label?this._label.getDimensions(t):new e.Rectangle(0,0,0,0)},A.prototype.getDisplayable=function(){return this._label},A.prototype.getTargetElem=function(){return this._label?this._label.getElem():null},A.prototype.showKeyboardFocusEffect=function(){if(this._isShowingKeyboardFocusEffect=!0,this._label){var t=this.getKeyboardBoundingBox();this._overlayRect=new e.Rect(this._axis.getCtx(),t.x,t.y,t.w,t.h),this._overlayRect.setSolidStroke(e.Agent.getFocusColor()),this._overlayRect.setInvisibleFill(),this._overlayRect.setMatrix(this._label.getMatrix()),this._axis.addChild(this._overlayRect)}},A.prototype.hideKeyboardFocusEffect=function(){this._isShowingKeyboardFocusEffect=!1,this._label&&(this._axis.removeChild(this._overlayRect),this._overlayRect=null)},A.prototype.isShowingKeyboardFocusEffect=function(){return this._isShowingKeyboardFocusEffect},A.prototype.getAriaLabel=function(){var t;return this.isDrillable()&&(t=[this._axis.getOptions().translations.stateDrillable]),null!=this.getDatatip()?e.Displayable.generateAriaLabel(this.getDatatip(),t):null!=t?e.Displayable.generateAriaLabel(this.getLabel().getTextString(),t):void 0},A.prototype.isDragAvailable=function(t){return!0},A.prototype.getDragTransferable=function(t,e){return[this.getId()]},A.prototype.getDragFeedback=function(t,e){return[this.getDisplayable()]};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var b=function(t){this.Init(t.getCtx(),t.processEvent,t,t),this._axis=t};e.Obj.createSubclass(b,e.EventManager),b.getUIParams=function(t,e,i,r){return{type:t,id:e,index:i,level:r}},b.prototype.OnClick=function(t){b.superclass.OnClick.call(this,t);var e=this.GetLogicalObject(t.target);e&&(this.processDrillEvent(e)&&t.stopPropagation())},b.prototype.HandleTouchClickInternal=function(t){var e=this.GetLogicalObject(t.target);if(e){var i=t.touchEvent;this.processDrillEvent(e)&&i&&i.preventDefault()}},b.prototype.processDrillEvent=function(t){return!!(t instanceof A&&t.isDrillable())&&(this.FireEvent(e.EventFactory.newChartDrillEvent(t.getId(),null,t.getGroup(),"group"),this._axis),!0)},b.prototype.isDndSupported=function(){return!0},b.prototype.GetDragSourceType=function(t){var e=this.DragSource.getDragObject();return e instanceof A&&null!=e.getGroup()?"groups":null},b.prototype.GetDragDataContexts=function(t){var i=this.DragSource.getDragObject();if(i instanceof A){var r={id:i.getId(),group:i.getGroup(),label:i.getLabel().getTextString()};return t&&e.ToolkitUtils.cleanDragDataContext(r),[r]}return[]};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var M=new Object;e.Obj.createSubclass(M,e.Obj),M._MAX_TITLE_LINE_WRAP=3,M.getPreferredSize=function(t,i,r,a){var s=M._createAxisInfo(t,new e.Rectangle(0,0,i,r)),n=t.getCtx(),o=t.getOptions(),l="top"==o.position||"bottom"==o.position;if(("off"==o.rendered||i<=0||r<=0)&&!a)return l?new e.Dimension(i,0):new e.Dimension(0,r);var h=M.getTitleHeight(n,o,.8*(l?i:r),.8*(l?r:i)),u=0!=h?h+M._getTitleGap(t):0;if("on"==o.tickLabel.rendered&&"inside"!=o.tickLabel.position)if(l){var g=e.TextUtils.getTextStringHeight(n,o.tickLabel.style);s instanceof x.getConstructor("data")?u+=g:s instanceof x.getConstructor("time")?u+=null!=s.getLabels(n,1)?2*g:g:s instanceof x.getConstructor("group")&&(u=M._getGroupAxisPreferredSize(t,s,u,r,l))}else if(s instanceof x.getConstructor("data"))u+=e.TextUtils.getMaxTextStringWidth(n,s.getAllLabels(n,!0),s.Options.tickLabel.style);else if(s instanceof x.getConstructor("time")){var d=s.getLabels(n),c=e.TextUtils.getMaxTextDimensions(d).w,p=s.getLabels(n,1),_=null!=p?e.TextUtils.getMaxTextDimensions(p).w:0;u+=Math.max(c,_)}else s instanceof x.getConstructor("group")&&(u=M._getGroupAxisPreferredSize(t,s,u,i,l));return l?new e.Dimension(i,Math.min(u,r)):new e.Dimension(Math.min(u,i),r)},M.render=function(t,e){var i=M._createAxisInfo(t,e);"off"!=t.getOptions().rendered&&(t.__setBounds(e.clone()),M._renderBackground(t,e),M._renderTitle(t,i,e),M._renderLabels(t,i,e))},M._createAxisInfo=function(t,e){var i=x.newInstance(t.getCtx(),t.getOptions(),e);return t.__setInfo(i),i},M._getTitleGap=function(t){var e=t.getOptions();return y.getGapSize(t.getCtx(),e,e.layout.titleGap)},M._renderBackground=function(t,i){var r=t.getOptions();if(r.dnd){var a=r.dnd.drop,s=Object.keys(a.xAxis).length>0||Object.keys(a.yAxis).length>0||Object.keys(a.y2Axis).length>0,n=r.dnd.drag,o=Object.keys(n.groups).length>0&&t.getInfo()instanceof x.getConstructor("group");if(s||o){var l=r.position,h="top"==l||"bottom"==l,u=h?4:10,g=h?10:4,d=new e.Rect(t.getCtx(),i.x-g,i.y-u,i.w+2*g,i.h+2*u);o&&d.setClassName("oj-draggable"),d.setInvisibleFill(),t.getCache().putToCache("background",d),t.addChild(d)}}},M._renderTitle=function(t,i,r){var a=t.getOptions();if(a.title){var s=a.position;if("radial"!=s&&"tangential"!=s){var n="top"==a.position||"bottom"==a.position,o=n?r.w:r.h,l=n?r.h:r.w,h=a.titleStyle,u=M.isWrapEnabled(h),g=M._createText(t.getEventManager(),t,a.title,h,0,0,o,l,b.getUIParams(C.TITLE),u);if(g){var d=M._getTitleGap(t),c=(i.getStartOverflow()-i.getEndOverflow())/2,p=e.Agent.isRightToLeft(t.getCtx()),_=g.getDimensions().h;g.alignCenter(),"top"==s?(g.setX(r.x+c+r.w/2),g.setY(r.y),r.y+=_+d,r.h-=_+d):"bottom"==s?(g.setX(r.x+c+r.w/2),g.setY(r.y+r.h-_),r.h-=_+d):"left"==s?(g.alignMiddle(),g.setRotation(p?Math.PI/2:3*Math.PI/2),g.setTranslate(r.x+_/2,r.y+r.h/2),r.x+=_+d,r.w-=_+d):"right"==s&&(g.alignMiddle(),g.setRotation(p?Math.PI/2:3*Math.PI/2),g.setTranslate(r.x+r.w-_/2,r.y+r.h/2),r.w-=_+d),i.setTitle(g)}}}},M._renderLabels=function(t,e,i){var r=t.getOptions();if("on"==r.tickLabel.rendered){var a=r.position;"top"==a||"bottom"==a?M._renderLabelsHoriz(t,e,i):"tangential"==a?M._renderLabelsTangent(t,e,i):M._renderLabelsVert(t,e,i),M._renderGroupSeparators(t,e,i)}},M._renderLabelsHoriz=function(t,i,r){var a=t.getCtx(),s=t.getOptions(),n=s.position,o="inside"==s.tickLabel.position,l=e.Agent.isRightToLeft(a),h=i instanceof x.getConstructor("group"),u=h&&i.getNumLevels()>1,g=u?0:null,d=i.getLabels(a,g);for(m=u?y.getGapSize(a,s,s.layout.hierarchicalLabelGapHeight):0;d;){for(var c=0,p=0,_=0;_<d.length;_++){var f=d[_];if(null!=f){var v=f instanceof e.MultilineText||f instanceof e.BackgroundMultilineText;if(i.isLabelRotated(g)){if((!v||v&&!f.isWrapEnabled())&&!e.TextUtils.fitText(f,r.h,r.w,t))continue;l?f.alignLeft():f.alignRight(),u?(c=f.getDimensions().w,f.setTranslateY(r.h-c),p=Math.max(p,c)):f.setTranslateY(r.y)}else{if(!o&&f.getDimensions().h-1>r.h)continue;if(u&&"bottom"==n?f.setY(r.h):"bottom"==n?f.setY(r.y):f.setY(r.y+r.h),!u&&("bottom"==n&&!o||"top"==n&&o)||u&&"top"==n?f.alignTop():f.alignBottom(),u)p=Math.max(p,f.getDimensions().h);else if(o){var m=y.getGapSize(a,s,s.layout.insideLabelGapWidth);l?f.alignRight():f.alignLeft(),f.setX(f.getX()+m*(l?-1:1))}}var S=h?i.getLabelIndex(f):_,M=i.getDatatip(S,g),T=f.getUntruncatedTextString(),I=i.isDrillable(S,g),D=i.getGroup(S,g),O=b.getUIParams(C.TICK_LABEL,f.getTextString(),S,g);t.getEventManager().associate(f,new A(t,f,D,I,T,M,O)),u?i.setLastRenderedLevel(g):p=Math.max(p,f.getDimensions().h),t.addChild(f)}}if(u){for(_=0;_<d.length;_++)if(null!=(f=d[_])){var E=i.isLabelRotated(g),P=g<i.getNumLevels()-1;!E&&P?(f.setY(r.h-p/2),f.alignMiddle()):f.setTranslateY(r.h-p)}r.y+=p+m,r.h-=p+m,g++,d=i.getLabels(t.getCtx(),g)}else r.y+=p,r.h-=p,d=null}if(i instanceof x.getConstructor("time")){d=i.getLabels(t.getCtx());var L=i.getLabels(t.getCtx(),1),w=0;if(null!=L)for(_=0;_<L.length;_++)if(null!=(f=L[_])&&!(f.getDimensions().h-1>r.h)){t.getEventManager().associate(f,new e.SimpleObjPeer(null,null,null,b.getUIParams(C.TICK_LABEL,f.getTextString())));var R=0,B=0,k=i.getOptions()._maxOverflowCoord,F=i.getOptions()._minOverflowCoord;if(null!=d[_]&&(w=d[_].getDimensions().w/2,R=i._level1Overflow[_],B=i._level2Overflow[_]),0==R&&0==B){var N,H=f.getX();l?(N=H+w<=k?H+w:k,f.setX(N)):(N=H-w>=F?H-w:F,f.setX(N))}else R<0?f.setX(F):R>0&&f.setX(k);f.alignTop(),f.setY(r.y),t.addChild(f)}}},M._renderLabelsVert=function(t,i,r){var a,s,n,o=t.getOptions(),l=o.position,h=t.getCtx(),u=e.Agent.isRightToLeft(h),g=i instanceof x.getConstructor("data"),d="inside"==o.tickLabel.position,c=i instanceof x.getConstructor("group"),p=c&&i.getNumLevels()>1,_=p?0:null;a=i.getLabels(t.getCtx(),_);var f=0;p?(s=y.getGapSize(h,o,o.layout.hierarchicalLabelGapWidth),n=e.TextUtils.getMaxTextDimensions(a).w):"radial"==l?(s=y.getGapSize(h,o,o.layout.radialLabelGap),f=r.x+r.w/2,u?f+=s+e.TextUtils.getMaxTextDimensions(a).w:f-=s):"left"==l?(f=r.x+r.w,g&&d&&(f+=e.TextUtils.getMaxTextDimensions(a).w)):(f=r.x,g&&!d&&(f+=e.TextUtils.getMaxTextDimensions(a).w));for(var v=function(s,v){var m=s instanceof e.MultilineText||s instanceof e.BackgroundMultilineText,S=!m||m&&!s.isWrapEnabled();if(!(p&&e.TextUtils.getMaxTextDimensions(a).w-1>r.w)&&(p||d||!S||e.TextUtils.fitText(s,r.w,r.h,t))){v=c?i.getLabelIndex(s):v;var x=i.getDatatip(v,_),M=s.getUntruncatedTextString(),T=i.isDrillable(v,_),I=i.getGroup(v,_),D=b.getUIParams(C.TICK_LABEL,s.getTextString(),v,_);if(t.getEventManager().associate(s,new A(t,s,I,T,M,x,D)),p)s.alignRight(),s.setX(u?r.w:r.x+n),i.setLastRenderedLevel(_);else if(s.setX(f),g||"right"!=l?s.alignRight():s.alignLeft(),d&&(s.alignBottom(),s.setY(s.getY()-y.getGapSize(h,o,o.layout.insideLabelGapHeight))),"radial"==l){var O=s.getY();s.setY(r.y+r.h/2-O);var E=s.getDimensions(),P=.15*E.h,L=e.PathUtils.roundedRectangle(E.x-P,E.y,E.w+2*P,E.h,2,2,2,2),w=new e.Path(t.getCtx(),L),R=s.getCSSStyle().getStyle(e.CSSStyle.BACKGROUND_COLOR),B=O+E.h/2>i.getEndCoord()&&"circle"==t.getOptions().polarGridShape?"outside":"inside";R?w.setSolidFill(R):w.setClassName("oj-chart-polar-axis-tick-label-"+B),t.addChild(w)}t.addChild(s)}};a;){for(var m=0;m<a.length;m++){var S=a[m];null!=S&&v(S,m)}if(!p)break;r.x+=n+s,r.w-=n+s,_++,a=i.getLabels(t.getCtx(),_),n=a?e.TextUtils.getMaxTextDimensions(a).w:null}if(i instanceof x.getConstructor("time")){var M=i.getLabels(t.getCtx(),1);if(null!=M)for(m=0;m<M.length;m++)null!=(S=M[m])&&v(S,m)}},M._renderLabelsTangent=function(t,i,r){for(var a=i.getLabels(t.getCtx()),s=0;s<a.length;s++){var n=a[s];if(null!=n){var o=r.w/2-Math.abs(n.getX()),l=r.h/2-Math.abs(n.getY());if(e.TextUtils.fitText(n,o,l,t)){var h=i instanceof x.getConstructor("group")?i.getLabelIndex(n):s,u=i.getDatatip(h),g=n.getUntruncatedTextString(),d=i.isDrillable(h),c=i.getGroup(h),p=b.getUIParams(C.TICK_LABEL,n.getTextString(),h);t.getEventManager().associate(n,new A(t,n,c,d,g,u,p)),n.setTranslateX(r.x+r.w/2),n.setTranslateY(r.y+r.h/2),t.addChild(n)}}}},M._createText=function(t,i,r,a,s,n,o,l,h,u){var g;return u?((g=new e.MultilineText(i.getCtx(),r,s,n)).setMaxLines(M._MAX_TITLE_LINE_WRAP),g.setCSSStyle(a),g.wrapText(o,l,1)):(g=new e.OutputText(i.getCtx(),r,s,n)).setCSSStyle(a),e.TextUtils.fitText(g,o,l,i)?(t.associate(g,new e.SimpleObjPeer(g.getUntruncatedTextString(),null,null,h)),g):null},M._renderGroupSeparators=function(t,i,r){if(i instanceof x.getConstructor("group")&&i.areSeparatorsRendered()){var a=i.getNumLevels(),s=i.getSeparatorStartLevel();if(a<=1||s<=0)return;for(var n,o,l,h,u,g,d=t.getOptions(),c=d.position,p="top"==c||"bottom"==c,_=t.getCtx(),f=e.Agent.isRightToLeft(_),v=i.getSeparatorColor(),m=new e.Stroke(v,1,1),S=0,C=p?y.getGapSize(_,d,d.layout.hierarchicalLabelGapHeight):y.getGapSize(_,d,d.layout.hierarchicalLabelGapWidth),A=d.startGroupOffset,b=d.endGroupOffset,T=s;T>=0;T--){var I=i.getLabels(t.getCtx(),T),D=e.TextUtils.getMaxTextDimensions(I),O=i.isLabelRotated(T),E=O||!p?D.w:D.h;if(0!=E){var P=!1,L=null;if(T<s)for(var w=0;w<I.length;w++){var R=I[w];if(null!=R){var B=i.getLabelIndex(R),k=0==i.getLabelAt(B,T).length;if(!k){var F=k&&0==T&&(0==B||B==I.length-1),N=R&&null==I[B-1],H=R&&null==I[B+1],G=i.getStartIndex(B,T),U=i.getEndIndex(B,T);if(p){var j;if(R)j=R instanceof e.MultilineText||R instanceof e.BackgroundMultilineText?R.getYAlignCoord():R.getY(),n=i.getCoordAt(G-A),o=O?j+.5*S:j-E/2-.5*S-C,l=i.getCoordAt(U+b),h=O?j+E+S+2*C:j,k&&F||0!=P||null==n||M._addSeparatorLine(t,m,n,h,n,o),null==l||F||M._addSeparatorLine(t,m,l,h,l,o);if(!k){if(R)var V=O?R.getDimensions().h:R.getDimensions().w;n=N&&0==L?i.getStartCoord():i.getBoundedCoordAt(G-A),N&&(N=!1);var Y=i.getLabelAt(B+1,T);if(l=H&&Y&&Y.length>0?i.getEndCoord():i.getBoundedCoordAt(U+b),u=R?f?R.getX()+.5*V:R.getX()-.5*V:i.getBoundedCoordAt(U+b),g=R?f?R.getX()-.5*V:R.getX()+.5*V:i.getBoundedCoordAt(G-A),R)if(O)M._addSeparatorLine(t,m,n,h,l,h);else{var W=f?.5*-R.getDimensions().h:.5*R.getDimensions().h,z=f?g+W>l:g+W<l;(f?n>u-W:n<u-W)&&M._addSeparatorLine(t,m,n,h,u-W,h),z&&M._addSeparatorLine(t,m,g+W,h,l,h)}}}else R&&(n=f?R.getX()-E-.5*C:R.getX()+.5*C,o=i.getCoordAt(G-A),l=f?R.getX()+.5*C:R.getX()-E-.5*C,h=i.getCoordAt(U+b),(!k&&0==P||0==B&&k&&0!=T)&&null!=o&&M._addSeparatorLine(t,m,n,o,l,o),null==h||F||M._addSeparatorLine(t,m,l,h,n,h)),k||(o=N&&0==L?0:i.getBoundedCoordAt(G-A),N&&(N=!1),Y=i.getLabelAt(B+1,T),h=H&&Y&&Y.length>0?i.getEndCoord():i.getBoundedCoordAt(U+b),R&&M._addSeparatorLine(t,m,l,o,l,h));P=!k&&null!=R,L=null!=R||null==R&&k}}}S=E}else S=E}}},M._addSeparatorLine=function(t,i,r,a,s,n){var o=new e.Line(t.getCtx(),r,a,s,n);o.setStroke(i),o.setPixelHinting(!0),t.addChild(o)},M._getGroupAxisPreferredSize=function(t,i,r,a,s){for(var n=t.getCtx(),o=t.getOptions(),l=i.getNumLevels(),h=s?"hierarchicalLabelGapHeight":"hierarchicalLabelGapWidth",u=l>1?y.getGapSize(n,o,o.layout[h]):0,g=0;g<l;g++){var d;if(i.isAutoRotate()){for(var c=[],p=[],_=i.getSkipIncrement(),f=0;f<i.getGroupCount();f+=_){c.push(i.getLabelAt(f,0));var v=i.getLabelStyleAt(f,0);v||(v=i.Options.tickLabel.style),p.push(v)}d=e.TextUtils.getMaxTextStringWidth(n,c,p)}else{var m=i.getLabels(n,g);if(s){var S=e.TextUtils.getMaxTextDimensions(m);d=i.isLabelRotated(g)?S.w:S.h}else d=e.TextUtils.getMaxTextDimensions(m).w}if(!(r+d<=a)){0==g&&(r=a);break}r+=d+u}return 0!=g&&(r-=u),r},M.getTitleHeight=function(t,i,r,a){var s=0;if(i.title)if(M.isWrapEnabled(i.titleStyle)){var n=new e.MultilineText(t,i.title,0,0);n.setMaxLines(M._MAX_TITLE_LINE_WRAP),n.setCSSStyle(i.titleStyle),n.wrapText(r,a,1),s=e.TextUtils.getTextStringHeight(t,i.titleStyle)*n.getLineCount()}else s=e.TextUtils.getTextStringHeight(t,i.titleStyle);return s},M.isWrapEnabled=function(t){var i=t.getStyle(e.CSSStyle.WHITE_SPACE);return"nowrap"!=i&&"noWrap"!=i};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var T=function(t,e,i){this.Init(t,e,i)};e.Obj.createSubclass(T,x),x.registerConstructor("group",T),T._MAX_LINE_WRAP=3,T._ROTATE_THRESHOLD=12,T.prototype.Init=function(t,i,r){T.superclass.Init.call(this,t,i,r);var a=e.Agent.isRightToLeft(t),s="top"==this.Position||"bottom"==this.Position;if(s&&a){var n=this.StartCoord;this.StartCoord=this.EndCoord,this.EndCoord=n}this._levelsArray=[],this._groupCount=this._generateLevelsArray(i.groups,0,this._levelsArray,0),this._numLevels=this._levelsArray.length,this._areSeparatorsRendered="off"!=i.groupSeparators.rendered,this._separatorColor=i.groupSeparators.color,this._lastRenderedLevel=null,this._drilling=i.drilling;var o=i.endGroupOffset>0?Number(i.endGroupOffset):0,l=i.startGroupOffset>0?Number(i.startGroupOffset):0;this.DataMin=0,this.DataMax=this._groupCount-1,this.GlobalMin=null==i.min?this.DataMin-l:i.min,this.GlobalMax=null==i.max?this.DataMax+o:i.max;var h=this.getGroupIndex(i.viewportStartGroup),u=this.getGroupIndex(i.viewportEndGroup);-1!=h&&(this.MinValue=h-l),-1!=u&&(this.MaxValue=u+o),null!=i.viewportMin&&(this.MinValue=i.viewportMin),null!=i.viewportMax&&(this.MaxValue=i.viewportMax),null==this.MinValue&&(this.MinValue=this.GlobalMin),null==this.MaxValue&&(this.MaxValue=this.GlobalMax),this.GlobalMin>this.MinValue&&(this.GlobalMin=this.MinValue),this.GlobalMax<this.MaxValue&&(this.GlobalMax=this.MaxValue),this._groupWidthRatios=i._groupWidthRatios,this._processGroupWidthRatios(),this._startBuffer=a?i.rightBuffer:i.leftBuffer,this._endBuffer=a?i.leftBuffer:i.rightBuffer,this._isLabelRotated=[];for(var g=0;g<this._numLevels;g++)this._isLabelRotated.push(!1);if(this._renderGridAtLabels=i._renderGridAtLabels,this._labels=null,this._maxSpace=s?r.h:r.w,"off"!=i.rendered){var d=M.getTitleHeight(t,i,s?r.w:r.h,s?r.h:r.w);this._maxSpace-=0!=d?d+y.getGapSize(t,i,i.layout.titleGap):0}this._maxLineWrap=T._MAX_LINE_WRAP},T.prototype._processGroupWidthRatios=function(){if(!this._groupWidthRatios||this._groupWidthRatios.length<2)this._groupWidthRatios=null;else{for(var t,e,i=0,r=0;r<this._groupCount;r++)t=0==r?this.MinValue:Math.max(r-.5,this.MinValue),(e=r==this._groupCount-1?this.MaxValue:Math.min(r+.5,this.MaxValue))>t&&(i+=(e-t)*this._groupWidthRatios[r]);var a=this.EndCoord-this.StartCoord;this._groupWidths=this._groupWidthRatios.map(function(t){return t*a/i}),this._borderValues=[];for(r=0;r<this._groupWidthRatios.length-1;r++)this._borderValues.push(r+.5);this._borderCoords=[];var s=Math.min(Math.max(Math.round(this.MinValue),0),this._borderValues.length-1);this._borderCoords[s]=this.StartCoord+(this._borderValues[s]-this.MinValue)*this._groupWidths[s];for(r=s+1;r<this._borderValues.length;r++)this._borderCoords[r]=this._borderCoords[r-1]+this._groupWidths[r];for(r=s-1;r>=0;r--)this._borderCoords[r]=this._borderCoords[r+1]-this._groupWidths[r+1]}},T.prototype._rotateLabels=function(t,i,r,a){var s,n,o=this.getCtx(),l=e.Agent.isRightToLeft(o),h=this._numLevels>1;null==a&&(a=this._numLevels-1),this._isLabelRotated[a]=!0,h||this._setOverflow(r,r,t);for(var u=0;u<t.length;u++)if(null!=(s=t[u])){if(n=s.getX(),s instanceof e.MultilineText||s instanceof e.BackgroundMultilineText){var g=this.getGroupWidth()*(this.getEndIndex(u,a)-this.getStartIndex(u,a)+1);2*s.getLineHeight()<g&&this._maxSpace>0?s.wrapText(this._maxSpace,s.getLineHeight()*T._MAX_LINE_WRAP,1):s.setWrapEnabled(!1)}s.setX(0),s.setY(0),l?s.setRotation(Math.PI/2):s.setRotation(3*Math.PI/2),s.setTranslateX(n)}var d=this.GetLabelDims(t,i,a);M.isWrapEnabled(this.Options.tickLabel.style)&&this._maxSpace>0&&(this._sanitizeWrappedText(o,d,t,!0,h)&&(d=this.GetLabelDims(t,i,a)));return this.SkipLabels(t,d)},T.prototype._sanitizeWrappedText=function(t,i,r,a,s){for(var n=this._calculateMaxWrap(i,r,a),o=0,l=0;l<r.length;l++){var h=r[l];if(h){var u=h instanceof e.MultilineText||h instanceof e.BackgroundMultilineText;n&&u&&h.isWrapEnabled()&&h.wrapText(this._maxSpace,h.getLineHeight()*this._maxLineWrap,1),s&&(o=Math.max(o,h.getDimensions().w)),h.alignMiddle()}}if(s){var g=a?this.Options.layout.hierarchicalLabelGapHeight:this.Options.layout.hierarchicalLabelGapWidth;this._maxSpace-=o+y.getGapSize(t,this.Options,g)}return n},T.prototype._calculateMaxWrap=function(t,i,r){for(var a=!1;this.IsOverlapping(t,0)&&this._maxLineWrap>1;){a=!0;for(var s=0;s<i.length;s++){var n=i[s];if((n instanceof e.MultilineText||n instanceof e.BackgroundMultilineText)&&n.getLineCount()==this._maxLineWrap){var o=n.getLineHeight();r?t[s].w-=o:(t[s].y+=.5*o,t[s].h-=o)}}this._maxLineWrap--}return a},T.prototype.isLabelRotated=function(t){return null==t&&(t=this._numLevels-1),this._isLabelRotated[t]},T.prototype._setOverflow=function(t,i,r){t=Math.max(t-this._startBuffer,0),i=Math.max(i-this._endBuffer,0);var a=e.Agent.isRightToLeft(this.getCtx());this.StartCoord+=(t-this.StartOverflow)*(a?-1:1),this.EndCoord-=(i-this.EndOverflow)*(a?-1:1),this._processGroupWidthRatios();for(var s=0;s<this._numLevels;s++){r=this._labels[s];for(var n=0;n<r.length;n++){var o=r[n];if(o){var l=this._getLabelCoord(s,this.getLabelIndex(o));o.setX(l)}}}this.StartOverflow=t,this.EndOverflow=i},T.prototype.getLabels=function(t,e){return null==e&&(e=this._numLevels-1),this._labels||this._generateLabels(t),this._labels[e]},T.prototype._getLabelCoord=function(t,e){var i=this.getStartIndex(e,t),r=this.getEndIndex(e,t);if(null==i||null==r)return null;i<this.MinValue&&r>this.MinValue&&(i=this.MinValue),r>this.MaxValue&&i<this.MaxValue&&(r=this.MaxValue);var a=r?i+(r-i)/2:i;return this.getCoordAt(a)},T.prototype._generateLabels=function(t){var i=[];this._labels=[];for(var r,a,s,n,o,l=t.getStage(),h="top"==this.Position||"bottom"==this.Position,u=e.Agent.isRightToLeft(t),g=this._numLevels>1,d=this.getGroupWidth(),c=this._maxSpace,p=h?"hierarchicalLabelGapHeight":"hierarchicalLabelGapWidth",_=g?y.getGapSize(t,this.Options,this.Options.layout[p]):0,f="auto"==this.Options.tickLabel.rotation&&h,v={},m=this.isAutoRotate(),S=this.Options.tickLabel.style,C=M.isWrapEnabled(this.Options.tickLabel.style)&&"tangential"!=this.Position&&d>e.TextUtils.getTextStringHeight(t,S),x=0;x<this._numLevels;x++){var A=this._levelsArray[x],b=m?this.getSkipIncrement():1;v[x]=[];for(var T=0;T<A.length;T+=b)if(A[T]){if(""===(r=this.getLabelAt(T,x))||!r&&0!=r){i.push(null);continue}var I=this._getLabelCoord(x,T);if(null!=I){n=this.getLabelStyleAt(T,x);var D=!m&&C&&"number"!=typeof r&&r.indexOf(" ")>=0;o=this.CreateLabel(t,r,I,n,D);var O=d*(this.getEndIndex(T,x)-this.getStartIndex(T,x)+1);v[x].push(O),D&&this._isTextWrapNeeded(t,r,n,f,h?O:c)&&c>0?h?o.wrapText(O,c,1,!0):o.wrapText(c,o.getLineHeight()*this._maxLineWrap,1,!1):D&&(!h||c<0)&&o.setWrapEnabled(!1),o._index=T,i.push(o),a||0!=x||(a=o),0==x&&(s=o)}else i.push(null)}else i.push(null);if(C&&g){for(var E=0,P=0;P<i.length;P++)if(i[P]){var L=i[P].getDimensions();E=Math.max(E,h?L.h:L.w)}c-=E+_}this._labels.push(i),i=[]}i=this._labels[this._numLevels-1];var w=[];if(a){if("tangential"==this.Position)return w=this.GetLabelDims(i,l),void(this._labels[0]=this.SkipTangentialLabels(i,w));var R=a.getDimensions(),B=!1;if(h){var k,F;if(null!=this.Options._startOverflow&&null!=this.Options._endOverflow)k=this.Options._startOverflow,F=this.Options._endOverflow;else{var N=s.getDimensions();k=u?R.w+R.x-this.StartCoord:this.StartCoord-R.x,F=u?this.EndCoord-N.x:N.w+N.x-this.EndCoord}B=k>this._startBuffer||F>this._endBuffer}for(x=0;x<this._numLevels;x++)if(i=this._labels[x],m)this._labels[x]=this._rotateLabels(i,l,R.h/2,x);else{w=this.GetLabelDims(i,l,x);var H=this.IsOverlapping(w,0,v[x]);if(H||(this._labels[x]=i),h)if(f){if(H)this._labels[x]=this._rotateLabels(i,l,R.h/2,x);else if(B&&this._setOverflow(k,F,i),this._labels[x]=i,g){var G=0;for(P=0;P<w.length;P++)w[P]&&(G=Math.max(G,w[P].h));this._maxSpace-=G+_}}else B&&this._setOverflow(k,F,i),w=this.GetLabelDims(i,l),this._labels[x]=this.SkipLabels(i,w);else{if(C)this._sanitizeWrappedText(t,w,i,!1,g)&&(w=this.GetLabelDims(i,l,x));this._labels[x]=this.SkipLabels(i,w)}}}},T.prototype.getMajorTickCoords=function(){for(var t,e=[],i="tangential"==this.Position?this.getGroupCount():this.getGroupCount()-1,r=0;r<this._levelsArray[0].length;r++)if(this._levelsArray[0][r]){var a=this.getStartIndex(r,0),s=this.getEndIndex(r,0);null!=(t=this._renderGridAtLabels?this.getCoordAt(a+.5*(s-a)):s+.5<i?this.getCoordAt(s+.5):null)&&e.push(t)}return e},T.prototype.getMinorTickCoords=function(){var t,e=[];if(!this._levelsArray[1])return e;for(var i=0;i<this._levelsArray[1].length;i++)if(this._levelsArray[1][i]){var r=this.getStartIndex(i,1),a=this.getEndIndex(i,1);null!=(t=this._renderGridAtLabels?this.getCoordAt(r+.5*(a-r)):a+.5<this.getGroupCount()-1?this.getCoordAt(a+.5):null)&&e.push(t)}return e},T.prototype.getUnboundedValueAt=function(t){if(null==t)return null;if(this._groupWidthRatios){for(var e=this._borderCoords.length,i=0;i<this._borderCoords.length;i++)if(t<=this._borderCoords[i]){e=i;break}return 0==e?this._borderValues[0]-(this._borderCoords[0]-t)/this._groupWidths[0]:this._borderValues[e-1]+(t-this._borderCoords[e-1])/this._groupWidths[e]}var r=(this.EndCoord-this.StartCoord)/(this.MaxValue-this.MinValue);return this.MinValue+(t-this.StartCoord)/r},T.prototype.getUnboundedCoordAt=function(t){if(null==t)return null;if(this._groupWidthRatios){for(var e=this._borderValues.length,i=0;i<this._borderValues.length;i++)if(t<=this._borderValues[i]){e=i;break}return 0==e?this._borderCoords[0]-this._groupWidths[0]*(this._borderValues[0]-t):this._borderCoords[e-1]+this._groupWidths[e]*(t-this._borderValues[e-1])}var r=(this.EndCoord-this.StartCoord)/(this.MaxValue-this.MinValue);return this.StartCoord+(t-this.MinValue)*r},T.prototype.getLabelAt=function(t,e){if(null==e&&(e=this._numLevels-1),(t=Math.round(t))<0)return null;var i=this._levelsArray[e]&&this._levelsArray[e][t]?this._levelsArray[e][t].item:null;return i&&(i.name?i=i.name:null!=i.id&&(i="")),i},T.prototype.getGroupAt=function(t,e){if(null==e&&(e=this._numLevels-1),(t=Math.round(t))<0)return null;var i=this._levelsArray[e]&&this._levelsArray[e][t]?this._levelsArray[e][t].item:null;if(i){if(i.id)return i.id;if(i.name||""===i.name)return i.name}return i},T.prototype.getLabelStyleAt=function(t,i){var r=this._getGroupAttribute(t,i,"labelStyle");if(r){var a=new e.CSSStyle(r);return a.getStyle("font-size")||a.setStyle("font-size",this.Options.tickLabel.style.getStyle("font-size")),a}return null},T.prototype.getDatatip=function(t,e){return this._getGroupAttribute(t,e,"shortDesc")},T.prototype.isDrillable=function(t,e){var i=this._getGroupAttribute(t,e,"drilling");return"on"==i||"off"!=i&&("on"==this._drilling||"groupsOnly"==this._drilling)},T.prototype.getGroup=function(t,e){if(t<0||t>this.getGroupCount()-1)return null;if(1==this._numLevels)return this.getGroupAt(t);var i=[];null==e&&(e=this._numLevels-1);for(var r=this.getStartIndex(t,e),a=0;a<=e;a++)for(var s=this._levelsArray[a],n=0;n<s.length;n++)this.getStartIndex(n,a)<=r&&this.getEndIndex(n,a)>=r&&i.push(this.getGroupAt(n,a));return i.length>0?1===i.length&&1===this._numLevels?i[0]:i:null},T.prototype.getLabelBackground=function(t,i,r){null==r&&(r=this._numLevels-1);var a=t.getCSSStyle();if(a){var s=a.getStyle(e.CSSStyle.BACKGROUND_COLOR),n=a.getStyle(e.CSSStyle.BORDER_COLOR),o=a.getStyle(e.CSSStyle.BORDER_WIDTH),l=a.getStyle(e.CSSStyle.BORDER_RADIUS);if(null!=s||null!=n||null!=o||null!=l){var h=t.getDimensions(),u=.15*h.h;"blink"!==e.Agent.engine&&"ie"!==e.Agent.browser&&"edge"!==e.Agent.browser||t.getVertAlignment()!==e.OutputText.V_ALIGN_BOTTOM||(h.y+=h.h/2);var g=new e.Rect(i,h.x-u,h.y,h.w+2*u,h.h),d=new e.CSSStyle;return null!=s?d.setStyle(e.CSSStyle.BACKGROUND_COLOR,s):g.setInvisibleFill(),d.setStyle(e.CSSStyle.BORDER_COLOR,n),d.setStyle(e.CSSStyle.BORDER_WIDTH,o),d.setStyle(e.CSSStyle.BORDER_RADIUS,l),g.setCSSStyle(d),this._isLabelRotated[r]&&g.setMatrix(t.getMatrix()),g.setMouseEnabled(!1),g}return null}return null},T.prototype.getGroupIndex=function(t){if(null==t)return-1;for(var i=-1,r=0;r<this._groupCount;r++){var a=this.getGroup(r);if(t instanceof Array&&a instanceof Array?e.ArrayUtils.equals(t,a):t==a){i=r;break}}return i},T.prototype.getMinimumExtent=function(){return 1},T.prototype.getGroupWidth=function(){return Math.abs(this.EndCoord-this.StartCoord)/Math.abs(this.MaxValue-this.MinValue)},T.prototype.getGroupCount=function(){return this._groupCount},T.prototype.getNumLevels=function(){return this._numLevels},T.prototype._generateLevelsArray=function(t,e,i,r){for(var a=0;a<t.length;a++)if(i[e]||(i[e]=[]),i[e].push({item:t[a],start:r,end:r,position:a}),t[a]&&t[a].groups){var s=i[e].length-1,n=this._generateLevelsArray(t[a].groups,e+1,i,i[e][s].start);r!=n?(i[e][s].end=n-1,r=n):r++}else r++;return r},T.prototype._getGroupAttribute=function(t,e,i){null==e&&(e=this._numLevels-1);var r=this._levelsArray[e]&&this._levelsArray[e][t]?this._levelsArray[e][t].item:null;return r?r[i]:null},T.prototype.areSeparatorsRendered=function(){return this._areSeparatorsRendered},T.prototype.getSeparatorColor=function(){return this._separatorColor},T.prototype.getStartIndex=function(t,e){return null==e&&(e=this._numLevels-1),this._levelsArray[e]&&this._levelsArray[e][t]?this._levelsArray[e][t].start:null},T.prototype.getEndIndex=function(t,e){return null==e&&(e=this._numLevels-1),this._levelsArray[e]&&this._levelsArray[e][t]?this._levelsArray[e][t].end:null},T.prototype.getPosition=function(t,e){return null==e&&(e=this._numLevels-1),this._levelsArray[e]&&this._levelsArray[e][t]?this._levelsArray[e][t].position:null},T.prototype.getItemsRange=function(t){t instanceof Array||(t=[t]);for(var e=0,i=this._groupCount,r=[],a=0;a<t.length;a++)for(var s=this._levelsArray[a],n=t[a],o=0;o<s.length;o++){if((s[o].item.id?s[o].item.id:s[o].item.name)===n){var l=s[o].start,h=s[o].end;e<=l&&i>=h&&(e=l,i=h,r.push(s[o].item))}}return{startIndex:e,endIndex:i,groupData:r}},T.prototype.isRenderGridAtLabels=function(){return this._renderGridAtLabels},T.prototype.setLastRenderedLevel=function(t){this._lastRenderedLevel=t},T.prototype.getLastRenderedLevel=function(){return this._lastRenderedLevel},T.prototype.getSeparatorStartLevel=function(){for(var t=this._lastRenderedLevel,e=this._lastRenderedLevel-1;e>=0;e--)this._labels[e].length!=this._levelsArray[e].length&&(t=e);return t},T.prototype.getLabelIndex=function(t){return t._index>=0?t._index:null},T.prototype.getMaxLineWrap=function(){return this._maxLineWrap},T.prototype._isTextWrapNeeded=function(t,i,r,a,s){var n=e.TextUtils.getTextStringWidth(t,i,r);return n>=s&&(n/this._maxLineWrap<s||!a)},T.prototype.isAutoRotate=function(){var t="top"==this.Position||"bottom"==this.Position,e=this._numLevels>1,i=this.getGroupWidth(),r="auto"==this.Options.tickLabel.rotation&&t;return!e&&r&&i<T._ROTATE_THRESHOLD},T.prototype.getSkipIncrement=function(){var t=1;return t=T._ROTATE_THRESHOLD/(2*this.getGroupWidth()),this.Options._duringZoomAndScroll&&(t*=4),Math.max(1,Math.floor(t))};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var I=function(t){this._axis=t,this._options=this._axis.getOptions(),this._axisInfo=this._axis.getInfo()};e.Obj.createSubclass(I,e.Automation),I.prototype.GetSubIdForDomElement=function(t){var i=this._axis.getEventManager().GetLogicalObject(t);if(i&&i instanceof e.SimpleObjPeer){if(i.getParams().type==C.TITLE)return"title";if(this._options.groups){for(var r=i.getParams().level,a=this._axisInfo.getStartIndex(i.getParams().index,r),s="",n=0;n<=r;n++)for(var o=this._axisInfo.getLabels(this._axis.getCtx(),n),l=0;l<o.length;l++){var h=this._axisInfo.getLabelIndex(o[l]);this._axisInfo.getStartIndex(h,n)<=a&&this._axisInfo.getEndIndex(h,n)>=a&&(s+="["+this._axisInfo.getPosition(h,n)+"]")}if(s.length>0)return"item"+s}}return null},I.prototype.getDomElementForSubId=function(t){if("title"==t){var e=this._axisInfo.getTitle();if(e)return e.getElem()}else if(this._axisInfo instanceof T)for(var i=t.split("[").length-1-1,r=0,a=0,s=0;s<=i;s++){var n=t.indexOf("["),o=t.indexOf("]"),l=t.substring(n+1,o);t=t.substring(o+1);for(var h,u=this._axisInfo.getLabels(this._axis.getCtx(),s),g=0;g<u.length;g++)if(h=this._axisInfo.getLabelIndex(u[g]),this._axisInfo.getStartIndex(h,s)==a){r=h;break}for(var d=r;d<u.length;d++)if(h=this._axisInfo.getLabelIndex(u[d]),this._axisInfo.getPosition(h,s)==l){if(0==t.length)return u[d].getElem();a=this._axisInfo.getStartIndex(h,s);break}}return null};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var D=function(t,e){this.Init(t,e)};e.Obj.createSubclass(D,e.KeyboardHandler),D.prototype.Init=function(t,e){D.superclass.Init.call(this,t),this._axis=e},D.prototype.processKeyDown=function(t){var i=t.keyCode,r=this._eventManager.getFocus(),a=null;if(i==e.KeyboardEvent.TAB){r&&(e.EventManager.consumeEvent(t),a=r);var s=this._axis.__getKeyboardObjects();s.length>0&&(e.EventManager.consumeEvent(t),a=this.getDefaultNavigable(s))}else i==e.KeyboardEvent.ENTER?r&&(this._eventManager.processDrillEvent(r),e.EventManager.consumeEvent(t)):a=D.superclass.processKeyDown.call(this,t);return a};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var O=function(){};e.Obj.createSubclass(O,e.BaseComponent),O.newInstance=function(t,e,i){var r=new O;return r.Init(t,e,i),r},O.getDefaults=function(t){return(new y).getDefaults(t)},O.prototype.Init=function(t,i,r){O.superclass.Init.call(this,t,i,r),this.Defaults=new y(t),this.EventManager=new b(this),this.EventManager.addListeners(this),e.Agent.isTouchDevice()||this.EventManager.setKeyboardHandler(new D(this.EventManager,this)),this._bounds=null},O.prototype.SetOptions=function(t){t?"off"!==t.rendered?this.Options=this.Defaults.calcOptions(t):(t.tickLabel.style=new e.CSSStyle(t.tickLabel.style),t.titleStyle=new e.CSSStyle(t.titleStyle),this.Options=t):this.Options||(this.Options=this.GetDefaults())},O.prototype.getPreferredSize=function(t,e,i,r){return this.SetOptions(t),M.getPreferredSize(this,e,i,r)},O.prototype.render=function(t,i,r,a,s){this.getCache().clearCache(),this.SetOptions(t),this._navigablePeers=[],this.Width=i,this.Height=r,this.removeChildren(),a||(a=0),s||(s=0);var n=new e.Rectangle(a,s,i,r);M.render(this,n)},O.prototype.__registerObject=function(t){(null!=t.getDatatip()||t.isDrillable())&&this._navigablePeers.push(t)},O.prototype.__getKeyboardObjects=function(){return this._navigablePeers},O.prototype.isNavigable=function(){return this._navigablePeers.length>0},O.prototype.getKeyboardFocus=function(){return null!=this.EventManager?this.EventManager.getFocus():null},O.prototype.setKeyboardFocus=function(t,i){if(null!=this.EventManager){for(var r=this.__getKeyboardObjects(),a=t.getId(),s=!1,n=0;n<r.length;n++){var o=r[n].getId();if(a instanceof Array&&o instanceof Array&&e.ArrayUtils.equals(a,o)||a===o){this.EventManager.setFocusObj(r[n]),s=!0,i&&r[n].showKeyboardFocusEffect();break}}s||this.EventManager.setFocusObj(this.EventManager.getKeyboardHandler().getDefaultNavigable(r));var l=this.getKeyboardFocus();if(l){var h=l.getDisplayable();h.setAriaProperty("label",l.getAriaLabel()),this.getCtx().setActiveElement(h)}}},O.prototype.processEvent=function(t,e){this===e&&this.dispatchEvent(t)},O.prototype.getInfo=function(){return this.Info},O.prototype.__setInfo=function(t){this.Info=t},O.prototype.getWidth=function(){return this.Width},O.prototype.getHeight=function(){return this.Height},O.prototype.__setBounds=function(t){this._bounds=t},O.prototype.__getBounds=function(){return this._bounds},O.prototype.getAutomation=function(){return new I(this)};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
const E={getHideAndShowBehavior:function(t){return t.getOptions().hideAndShowBehavior},getHoverBehavior:function(t){return t.getOptions().hoverBehavior},isScrollable:function(t){return!!l.isScrollSupported(t)&&"off"!=t.getOptions().zoomAndScroll},isZoomable:function(t){if(!l.isScrollSupported(t))return!1;var e=t.getOptions().zoomAndScroll;return"live"==e||"delayed"==e},getZoomDirection:function(t){return l.isScatterBubble(t)?t.getOptions().zoomDirection:"auto"},isLiveScroll:function(t){if(!l.isScrollSupported(t))return!1;var e=t.getOptions().zoomAndScroll;return"live"==e||"liveScrollOnly"==e},isDelayedScroll:function(t){if(!l.isScrollSupported(t))return!1;var e=t.getOptions().zoomAndScroll;return"delayed"==e||"delayedScrollOnly"==e},isPlotAreaDraggable:function(t){var e=t.getOptions(),i=e.dnd?e.dnd.drag.items:{};return Object.keys(i).length>0},isPlotAreaDropTarget:function(t){var e=t.getOptions(),i=e.dnd?e.dnd.drop.plotArea:{};return Object.keys(i).length>0},isHorizScrollbarSupported:function(t){var e=E.getZoomDirection(t);return!l.isPolar(t)&&(l.isBLAC(t)&&l.isVertical(t)||l.isScatterBubble(t)&&"y"!=e)},isVertScrollbarSupported:function(t){var e=E.getZoomDirection(t);return!l.isPolar(t)&&(l.isBLAC(t)&&l.isHorizontal(t)||l.isScatterBubble(t)&&"x"!=e)}};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */var P=new Object;e.Obj.createSubclass(P,e.Obj),P.createText=function(t,i,r,a,s,n,o,l){var h=new e.OutputText(i.getCtx(),r,s,n);return h.setCSSStyle(a),e.TextUtils.fitText(h,o,l,i)?(t.associate(h,new e.SimpleObjPeer(h.getUntruncatedTextString())),h):null},P.areTitlesRendered=function(t){var e=t.getOptions();return e.title.text||e.subtitle.text||e.footnote.text},P.renderEmptyText=function(t,i,r){var a=t.getOptions();if(g.hasInvalidTimeData(t)&&g.hasData(t))var s=a.translations.labelInvalidData;else(s=a.emptyText)||(s=a.translations.labelNoData);t.renderEmptyText(i,s,new e.Rectangle(r.x,r.y,r.w,r.h),t.getEventManager(),a._statusMessageStyle)};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var L=new Object;e.Obj.createSubclass(L,e.Obj),L.getXAxisPosition=function(t){return l.isPolar(t)?"tangential":l.isHorizontal(t)?e.Agent.isRightToLeft(t.getCtx())?"right":"left":"bottom"},L.getBaselineScaling=function(t,e){var i=e+"Axis",r=t.getOptions()[i].baselineScaling;return!r||"zero"!=r&&"min"!=r?l.isStock(t)?"min":"zero":r},L.getYAxisPosition=function(t){var i=t.getOptions().yAxis.position;return l.isPolar(t)?"radial":l.isHorizontal(t)?!i||"top"!=i&&"bottom"!=i?"bottom":i:(l.isStock(t)&&(i=i||"end"),e.Agent.isRightToLeft(t.getCtx())?i&&"end"==i?"left":"right":i&&"end"==i?"right":"left")},L.getY2AxisPosition=function(t){var i=t.getOptions().y2Axis.position;return l.isHorizontal(t)?!i||"top"!=i&&"bottom"!=i?"top":i:e.Agent.isRightToLeft(t.getCtx())?i&&"start"==i?"right":"left":i&&"start"==i?"left":"right"},L.getAxisOffset=function(t){var e=t.getCache().getFromCache("axisOffset");if(null!=e)return e;var i=t.getOptions().styleDefaults.groupSeparators;if(l.hasGroupAxis(t)&&g.getNumLevels(t)>1&&"on"==i.rendered)e=.5;else if(g.hasBarSeries(t)||p.hasCenteredSeries(t)||g.hasCandlestickSeries(t)||g.hasBoxPlotSeries(t)||l.isBLAC(t)&&1==g.getGroupCount(t))e=.5;else if(l.isSpark(t)||E.isScrollable(t)||l.isOverview(t))e=0;else{var r=l.isHorizontal(t)?.2:.5;e=r-r/Math.sqrt(g.getGroupCount(t))}return t.getCache().putToCache("axisOffset",e),e},L.isGridShifted=function(t){if(!l.isBLAC(t))return!1;if(g.getNumLevels(t)>1)return!0;for(var e=g.getSeriesCount(t),i=0;i<e;i++)if(g.isSeriesRendered(t,i)){var r=g.getSeriesType(t,i),a=p.getLineType(t,i);if("bar"!=r&&"centeredSegmented"!=a&&"centeredStepped"!=a)return!1}return!0},L.isGridPolygonal=function(t){return!(!l.isBLAC(t)||g.hasBarSeries(t))&&"polygon"==t.getOptions().polarGridShape},L.isAxisRendered=function(t,e){if(!l.hasAxes(t))return!1;var i=t.getOptions(),r=i.overview.content&&i.overview.content[e+"Axis"],a=r&&"on"==r.rendered;if("y"==e&&g.hasY2DataOnly(t)&&!a)return!1;if("y2"==e&&!g.hasY2Data(t)&&!a)return!1;var s=i[e+"Axis"];return!("off"==s.rendered&&!a)&&!("off"==s.tickLabel.rendered&&!s.title&&!a)},L.isAxisLineRendered=function(t,e){var i=t.getOptions()[e+"Axis"];return"off"!=i.rendered&&"off"!=i.axisLine.rendered&&!("auto"==i.axisLine.rendered&&"x"!=e&&l.isBLAC(t)&&!l.isPolar(t))},L.isMajorTickRendered=function(t,e){var i=t.getOptions()[e+"Axis"];return"off"!=i.rendered&&"off"!=i.majorTick.rendered&&!("auto"==i.majorTick.rendered&&"x"==e&&l.isBLAC(t)&&!l.isPolar(t))},L.isMinorTickRendered=function(t,e){var i=t.getOptions()[e+"Axis"];return"off"!=i.rendered&&"off"!=i.minorTick.rendered&&("on"==i.minorTick.rendered||L.isLog(t,e))},L.isLog=function(t,e){return"log"==t.getOptions()[e+"Axis"].scale},L.getTickLabelHeight=function(t,i){var r=t.getOptions(),a=r[i+"Axis"].tickLabel.style;return a instanceof e.CSSStyle||(a=new e.CSSStyle(a)),a.mergeUnder(O.getDefaults(r.skin).tickLabel.style),e.TextUtils.getTextStringHeight(t.getCtx(),a)},L.getTickLabelGapSize=function(t,e){if(L.isTickLabelInside(t,e))return 0;var i=t.getOptions(),r=l.isHorizontal(t),a=L.getGapScalingFactor(t,e),s=Math.ceil(i.layout.tickLabelGapWidth*a),n=Math.ceil(i.layout.tickLabelGapHeight*a);return"x"==e?r?s:n:r?n:s},L.getGapScalingFactor=function(t,e){return L.isAxisRendered(t,e)?L.getTickLabelHeight(t,e)/14:0},L.isTickLabelInside=function(t,e){return!(l.isPolar(t)||l.isScatterBubble(t)||l.isBLAC(t)&&"x"==e)&&"inside"==t.getOptions()[e+"Axis"].tickLabel.position},L.getXAxisViewportMinMax=function(t,e){var i=e?"xAxisViewportMinMaxUG":"xAxisViewportMinMax",r=t.getCache().getFromCache(i);if(r)return r;var a=t.getOptions().xAxis,s=l.hasGroupAxis(t),n=L.getAxisOffset(t);if(e)var o=L.getXAxisGlobalMinMax(t);var h=null;null!=a.viewportMin?h=a.viewportMin:null!=a.viewportStartGroup?h=s?g.getGroupIndex(t,a.viewportStartGroup)-n:a.viewportStartGroup:e&&(h=o.min);var u=null;return null!=a.viewportMax?u=a.viewportMax:null!=a.viewportEndGroup?u=s?g.getGroupIndex(t,a.viewportEndGroup)+n:a.viewportEndGroup:e&&(u=o.max),r={min:h,max:u},t.getCache().putToCache(i,r),r},L.getXAxisGlobalMinMax=function(t){var e=t.getOptions().xAxis,i=l.hasGroupAxis(t),r=L.getAxisOffset(t);if(!i)var a=L.getMinMaxValue(t,"x");return{min:null!=e.min?e.min:i?0-r:a.min,max:null!=e.max?e.max:i?g.getGroupCount(t)-1+r:a.max}},L.applyInitialZooming=function(t,e){var i=t.getOptions(),r=i.xAxis,a=i.initialZooming;if(l.isBLAC(t)&&"off"!=i.zoomAndScroll&&"none"!=a){i._initialZoomed&&("last"==a?r.viewportMin=null:r.viewportMax=null);var s=L.getXAxisViewportMinMax(t,!1),n=s.min,o=s.max;if(!("last"==a&&null!=n||"first"==a&&null!=o)){var h=l.isHorizontal(t)?e.h:e.w,u=Math.floor(h/(2*L.getTickLabelHeight(t,"x")))+L.getAxisOffset(t),d=g.getGroupCount(t)-1;if(!(d<=u)){var c,p;if(l.hasGroupAxis(t))c=0,p=d;else{var _=L.getMinMaxValue(t,"x");c=_.min,p=_.max}var f=u/d*(p-c);"last"==i.initialZooming?(null==o&&(o=p),r.viewportMin=Math.max(o-f,c)):(null==n&&(n=c),r.viewportMax=Math.min(n+f,p)),i._initialZoomed=!0}}}},L.isYAdjustmentNeeded=function(t){var e=t.getOptions().styleDefaults.dataLabelPosition,i=t.getOptionsCache().getFromCache("hasDataOutsideBarEdge"),r="outsideBarEdge"==e||i,a=p.isStackLabelRendered(t);return!(!g.hasBarSeries(t)||!r&&!a)},L.axisContainsPoint=function(t,e){if(!t)return!1;var i=t.getOptions().position,r="top"==i||"bottom"==i,a=r?4:10,s=r?10:4,n=t.__getBounds().clone();n.x-=s,n.y-=a,n.w+=2*s,n.h+=2*a;var o=t.stageToLocal(e);return n.containsPoint(o.x,o.y)},L.isStandalonePlotArea=function(t){t.getOptions();return!P.areTitlesRendered(t)&&(!l.isLegendRendered(t)&&(!L.isAxisRendered(t,"x")&&(!L.isAxisRendered(t,"y")&&!L.isAxisRendered(t,"y2"))))},L.isStandaloneXAxis=function(t){var e=t.getOptions();return!P.areTitlesRendered(t)&&("off"==e.legend.rendered&&("off"==e.plotArea.rendered&&(!L.isAxisRendered(t,"y")&&!L.isAxisRendered(t,"y2"))))},L.isStandaloneYAxis=function(t){var e=t.getOptions();return!P.areTitlesRendered(t)&&("off"==e.legend.rendered&&(!L.isAxisRendered(t,"x")&&("off"==e.plotArea.rendered&&!L.isAxisRendered(t,"y2"))))},L.isStandaloneY2Axis=function(t){var e=t.getOptions();return!P.areTitlesRendered(t)&&("off"==e.legend.rendered&&(!L.isAxisRendered(t,"x")&&(!L.isAxisRendered(t,"y")&&"off"==e.plotArea.rendered)))},L.getViewportMinMaxGroupIndex=function(t,e){var i=L.getXAxisViewportMinMax(t,!0),r=l.hasGroupAxis(t),a=g.getGroupCount(t),s=i.min,n=0;if(null!=s)if(r)n=Math.ceil(s);else for(var o=0;o<a;o++){if(g.getXValue(t,e,o)>=s){n=o;break}}var h=i.max,u=a-1;if(null!=u)if(r)u=Math.floor(h);else for(o=a-1;o>=n;o--){if(g.getXValue(t,e,o)<=h){u=o;break}}return{min:n,max:u}},L.getViewportGroupCount=function(t){var e=L.getXAxisViewportMinMax(t,!0),i=L.getXAxisGlobalMinMax(t),r=(e.max-e.min)/(i.max-i.min);return isNaN(r)?1:r*g.getGroupCount(t)},L._computeYAlongLine=function(t,i,r,a,s,n){t&&(r=e.Math.log10(r),s=e.Math.log10(s));var o=r+(s-r)*(n-i)/(a-i);return t?Math.pow(10,o):o},L.getMinMaxValue=function(t,e,i){var r=e+(i?"MinMaxDO":"MinMax"),a=t.getCache().getFromCache(r);if(a)return a;var s=t.getOptions()[e+"Axis"];if(null!=s.dataMax&&null!=s.dataMin&&i)return a={min:s.dataMin,max:s.dataMax},t.getCache().putToCache(r,a),a;var n=l.hasTimeAxis(t);if(null!=s.max&&null!=s.min&&!i&&!n)return a={min:s.min,max:s.max},t.getCache().putToCache(r,a),a;var o="z"!=e&&L.isLog(t,e),h="y2"==e;h&&(e="y");for(var u="y"==e,d=!i&&u&&l.isBLAC(t),c="withoutRescale"==E.getHideAndShowBehavior(t)||"x"==e&&l.hasTimeAxis(t),_=-1/0,v=1/0,m=g.getSeriesCount(t),S=0;S<m;S++){var C=g.getSeriesItem(t,S),y=g.getSeriesType(t,S),x=u&&(g.isRangeSeries(t,S)||"candlestick"==y||"boxPlot"==y);if(c||g.isSeriesRendered(t,S)){var A=g.isAssignedToY2(t,S);if(!u||h==A){var b=C.items;if(b){var M=0,T=b.length-1;if(d){var I=L.getViewportMinMaxGroupIndex(t,S);M=I.min,T=I.max}for(var D=M;D<=T;D++)if(c||g.isDataItemRendered(t,S,D)){var O=b[D],P=null;if(u?x||(P=g.getCumulativeValue(t,S,D,c)):"x"==e&&n&&!l.isMixedFrequency(t)?(P=g.getGroupLabel(t,D),null!=O&&(O.x=P)):null!=O&&(P=O[e]),!("z"==e&&P<=0)){if(!(x||null==P||"number"!=typeof P||o&&P<=0)){var w=0;if(l.isBubble(t)&&!i&&"z"!=e){var R=p.getMarkerSize(t,S,D);w=L.getBubbleAxisRadius(t,e,R)}_=Math.max(_,o?P*Math.pow(10,w):P+w),v=Math.min(v,o?P/Math.pow(10,w):P-w)}if(x){var B=g.getHighValue(t,S,D),k=g.getLowValue(t,S,D);o&&(B<=0||k<=0)||(_=Math.max(_,B,k),v=Math.min(v,B,k))}if(d&&!x){var F=null,N=null;if(M>0&&D==M?(F=D-1,N=L.getXAxisViewportMinMax(t,!0).min):T<b.length-1&&D==T&&(F=D+1,N=L.getXAxisViewportMinMax(t,!0).max),null!=F){var H=g.getXValue(t,S,D),G=g.getXValue(t,S,F),U=g.getCumulativeValue(t,S,F),j=L._computeYAlongLine(o,H,P||0,G,U||0,N);_=Math.max(_,j),v=Math.min(v,j)}}var V=g.getNestedDataItemCount(t,S,D);if(V>0)for(var Y=0;Y<V;Y++){var W=g.getNestedDataItem(t,S,D,Y),z="number"==typeof W;_=z?Math.max(_,W):Math.max(_,W.value),v=z?Math.min(v,W):Math.min(v,W.value)}}}}}}}var X=null;if("x"==e?X=g.getAxisRefObjs(t,"x"):h?X=g.getAxisRefObjs(t,"y2"):u&&(X=g.getAxisRefObjs(t,"y")),null!=X)for(var K=0;K<X.length;K++){var Z=X[K],q=Z.items,Q="withRescale"==E.getHideAndShowBehavior(t)&&!f.isObjectRendered(t,Z);if(!Q)if(q&&!Q){var J=0,$=q.length-1;if(d){var tt=L.getViewportMinMaxIndex(t,q);J=tt.min,$=tt.max}for(var et=J;et<=$;et++)if(null!=q[et]){k=f.getLowValue(q[et]),B=f.getHighValue(q[et]);var it=isNaN(q[et])?q[et].value:q[et];null!=k&&isFinite(k)&&(v=Math.min(v,k),_=Math.max(_,k)),null!=B&&isFinite(B)&&(v=Math.min(v,B),_=Math.max(_,B)),null!=it&&isFinite(it)&&(v=Math.min(v,it),_=Math.max(_,it))}}else{k=f.getLowValue(Z),B=f.getHighValue(Z),it=Z.value;null!=k&&isFinite(k)&&(v=Math.min(v,k),_=Math.max(_,k)),null!=B&&isFinite(B)&&(v=Math.min(v,B),_=Math.max(_,B)),null!=it&&isFinite(it)&&(v=Math.min(v,it),_=Math.max(_,it))}}return a={min:v,max:_},t.getCache().putToCache(r,a),a},L.getBubbleAxisRadius=function(t,e,i){if(!i)return 0;var r="x"==e?"_xAxisBubbleRatio":"_yAxisBubbleRatio";return i/2*t.getCache().getFromCache(r)},L.getViewportMinMaxIndex=function(t,e){var i=L.getXAxisViewportMinMax(t,!0),r=l.hasGroupAxis(t),a=i.min,s=0;if(null!=a)if(r)s=Math.ceil(a);else for(var n=0;n<e.length;n++){if(f.getXValue(t,e,n)>=a){s=n;break}}var o=i.max,h=e.length-1;if(null!=h)if(r)h=Math.floor(o);else for(n=e.length-1;n>=s;n--){if(g.getXValue(t,e,n)<=o){h=n;break}}return{min:s,max:h}};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
const w={getGroupWidthRatios:function(t){if(!g.hasBarSeries(t)&&!g.hasCandlestickSeries(t)&&!g.hasBoxPlotSeries(t))return null;var e=t.getOptions(),i=w.getBarGapRatio(t);if(i>=1)return e._averageGroupZ=1/0,null;e._averageGroupZ=0;var r,a,s,n,o,l,h=g.getGroupCount(t),u=g.isSplitDualY(t),d=g.getStackCategories(t,"bar"),c=d.y.length,p=d.y2.length;if(t.getOptionsCache().getFromCache("hasConstantZValue")){var _=t.getOptionsCache().getFromCache("constantZValue")*(u?Math.max(c,p):c+p);l=(o=_*h)*i/(1-i),r=null}else{for(var f=[],v=0;v<h;v++){for(a=0,n=0;n<c;n++)a+=g.getBarCategoryZ(t,d.y[n],v,!1);for(s=0,n=0;n<p;n++)s+=g.getBarCategoryZ(t,d.y2[n],v,!0);f.push(u?Math.max(a,s):a+s)}o=f.reduce(function(t,e){return t+e}),l=o*i/(1-i),r=f.map(function(t){return t+l/h})}return e._averageGroupZ=(o+l)/h,r},getBarGapRatio:function(t){var e=t.getCache().getFromCache("barGapRatio");if(e)return e;if("string"==typeof(e=t.getOptions().styleDefaults.barGapRatio)&&"%"==e.slice(-1)&&(e=Number(e.slice(0,-1))/100),null!=e&&!isNaN(e))return e;var i=g.getStackCategories(t,"bar"),r=i.y.length,a=i.y2.length,s=g.isSplitDualY(t)?Math.max(r,a):r+a;return e=l.isPolar(t)?1==s?0:.25:1==s?.37+.26/L.getViewportGroupCount(t):.25,t.getCache().putToCache("barGapRatio",e),e},getBarInfo:function(t,i,r,a){var s,n,o=l.isHorizontal(t),u=g.isStacked(t),d=e.Agent.isRightToLeft(t.getCtx()),c=t.xAxis,_=g.isRangeSeries(t,i),f=p.getBarCategoryOffsetMap(t,r),v=g.getXValue(t,i,r),m=c.getUnboundedCoordAt(v),S=g.isAssignedToY2(t,i),C=S?t.y2Axis:t.yAxis,y=C.getBaselineCoord();if(_){var x=g.getLowValue(t,i,r),A=g.getHighValue(t,i,r);if(null==x||isNaN(x)||null==A||isNaN(A))return null;if((s=C.getBoundedCoordAt(x))==(n=C.getBoundedCoordAt(A))&&null==C.getCoordAt(x))return null}else{var b=g.getValue(t,i,r),M=g.getCumulativeValue(t,i,r);if(null==b||isNaN(b))return null;if((s=C.getBoundedCoordAt(M))==(n=u?C.getBoundedCoordAt(M-b):y)&&null==C.getCoordAt(M))return null}var T=g.getStackCategory(t,i),I=p.getBarWidth(t,i,r),D=u?p.getBarStackWidth(t,T,r,S):I;if("pixel"==p.getBarSpacing(t)&&"firefox"===e.Agent.browser){var O=I/(1-w.getBarGapRatio(t));I>1&&O-I<2&&(D=--I)}var E=f[S?"y2":"y"][T]+.5*(D-I),P=d&&!o?m-E-I:m+E,L=P+I,R=(P+L)/2,B=_?(s+n)/2:s;return{x1:P,x2:L,axisCoord:y,baseCoord:n,yCoord:s,dataPos:h.convertAxisCoord(t,new e.Point(R,B),a),barWidth:I}},getDataLabelPosition:function(t,i,r,a,s,n){var o,h=g.getNestedDataItem(t,i,r,a),u=g.getDataItem(t,i,r);if(n)o="outsideBarEdge";else if((o=h&&h.labelPosition?h.labelPosition:u.labelPosition)||(o=t.getOptions().styleDefaults.dataLabelPosition),"none"==(o=p._parseLowHighArray(o,s)))return"none";var d=e.Agent.isRightToLeft(t.getCtx()),c=l.isHorizontal(t),_=l.isPolar(t);if(l.isFunnel(t)||l.isPyramid(t))return"center";if("bar"==g.getSeriesType(t,i)){if("center"==o||_)return"center";var f,v=g.isStacked(t);if("insideBarEdge"!=o){if(v&&!n)return"center";"outsideBarEdge"!=o&&(o="insideBarEdge")}if("insideBarEdge"==o&&!v){var m,S=t.getOptions().styleDefaults.dataLabelStyle,C=u.labelStyle?e.CSSStyle.mergeStyles([S,new e.CSSStyle(u.labelStyle)]):S;if(c){var y=p.getDataLabel(t,i,r,a,s);m=e.TextUtils.getTextStringWidth(t.getCtx(),y,C)}else m=e.TextUtils.getTextStringHeight(t.getCtx(),C);var x=w.getBarInfo(t,i,r);(x?Math.abs(x.baseCoord-x.yCoord):0)<=m&&(o="outsideBarEdge")}return f="low"==s?u.low<=u.high:"high"==s?u.high<u.low:g.getValue(t,i,r,a)<0,"outsideBarEdge"==o?c?!f&&!d||f&&d?"right":"left":f?"bottom":"top":c?!f&&!d||f&&d?"inRight":"inLeft":f?"inBottom":"inTop"}if("center"==o)return"center";if("belowMarker"==o)return"bottom";if("aboveMarker"==o)return"top";if("afterMarker"!=o&&"beforeMarker"!=o){if(l.isBubble(t))return"center";if("low"!=s||_)if("high"!=s||_)o="afterMarker";else{if(!c)return"top";o="afterMarker"}else{if(!c)return"bottom";o="beforeMarker"}}return!d&&"afterMarker"==o||d&&"beforeMarker"==o?"right":"left"}};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */var R=new Object;e.Obj.createSubclass(R,e.Obj),R.getBarFill=function(t,e,i,r){var a=p.getColor(t,e,i),s=p.getPattern(t,e,i);return R.getRectangleFill(t,a,s,r)},R.getRectangleFill=function(t,i,r,a){var s=p.getSeriesEffect(t);if(r)return new e.PatternFill(r,i);if("gradient"==s&&a>3){var n,o,h=l.isHorizontal(t)?270:0;return n=[e.ColorUtils.adjustHSL(i,0,-.09,.04),e.ColorUtils.adjustHSL(i,0,-.04,-.05)],o=[0,1],new e.LinearGradientFill(h,n,null,o)}return new e.SolidFill(i)},R.getAreaFill=function(t,i){var r,a="lineWithArea"==g.getSeriesType(t,i),s=g.getSeriesItem(t,i);s&&s.areaColor?r=s.areaColor:(r=p.getColor(t,i),a&&(r=e.ColorUtils.setAlpha(r,.2)));var n=p.getPattern(t,i),o=p.getSeriesEffect(t);if(n)return new e.PatternFill(n,r);if("gradient"==o){var h,u,d=l.isHorizontal(t)?180:270;if(a){var c=e.ColorUtils.getAlpha(r);h=[e.ColorUtils.setAlpha(r,Math.min(c+.2,1)),e.ColorUtils.setAlpha(r,Math.max(c-.15,0))],u=[0,1]}else h=[e.ColorUtils.adjustHSL(r,0,-.09,.04),e.ColorUtils.adjustHSL(r,0,-.04,-.05)],u=[0,1];return new e.LinearGradientFill(d,h,null,u)}return new e.SolidFill(r)},R.getMarkerFill=function(t,i,r,a){var s=p.getMarkerColor(t,i,r,a),n=p.getPattern(t,i,r,a);if(n)return new e.PatternFill(n,s);if(l.isBubble(t)&&"gradient"==p.getSeriesEffect(t)){var o=[e.ColorUtils.adjustHSL(s,0,-.09,.04),e.ColorUtils.adjustHSL(s,0,-.04,-.05)];return new e.LinearGradientFill(270,o,null,[0,1])}return new e.SolidFill(s)},R.getFunnelPyramidSliceFill=function(t,i,r,a,s){var n,o=p.getPattern(t,i,0),h=p.getSeriesEffect(t);if(o&&!s)return("vertical"==t.getOptions().orientation||l.isPyramid(t))&&(n=e.Agent.isRightToLeft(t.getCtx())?new e.Matrix(0,-1,1,0):new e.Matrix(0,1,-1,0)),new e.PatternFill(o,r,null,n);if("gradient"==h){var u,g,d=l.isPyramid(t)?180:90;return"on"==t.getOptions().styleDefaults.threeDEffect?(u=[e.ColorUtils.adjustHSL(r,0,0,-.1),e.ColorUtils.adjustHSL(r,0,0,.12),r],g=[0,.65,1]):(u=[e.ColorUtils.adjustHSL(r,0,-.09,.04),e.ColorUtils.adjustHSL(r,0,-.04,-.05)],g=[0,1]),new e.LinearGradientFill(d,u,null,g,[a.x,a.y,a.w,a.h])}return new e.SolidFill(r)};
/**
   * @license
   * Copyright (c) 2013 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var B=function(t,e,i,r,a,s,n,o,l){this.Init(t,e,i,r,a,s,n,o,l)};e.Obj.createSubclass(B,e.Path),B.prototype.Init=function(t,i,r,a,s,n,o,l,h){B.superclass.Init.call(this,t.getCtx()),this._chart=t;var u=t.getOptions().styleDefaults;this._seriesIndex=i,this._numDrawnSeries=r,this._funnelWidth=a,this._funnelHeight=s,this._startPercent=n,this._valuePercent=o,this._fillPercent=l,this._3dRatio="on"==u.threeDEffect?1:0,this._gap=h;var g=this._getPath();this._dataColor=p.getColor(this._chart,this._seriesIndex,0),this._backgroundColor=u.backgroundColor?u.backgroundColor:u.funnelBackgroundColor,this.setCmds(g.slice),g.bar&&(this._bar=new e.Path(this.getCtx(),g.bar),this.addChild(this._bar),this._bar.setMouseEnabled(!1)),this._setColorProperties(g.sliceBounds),this._label=this._getSliceLabel(g.sliceBounds,g.barBounds),null!=this._label&&(this._label.setMouseEnabled(!1),this.addChild(this._label))},B._FUNNEL_3D_WIDTH_RATIO=.08,B._FUNNEL_ANGLE_2D=36,B._FUNNEL_RATIO=1/3,B._BORDER_COLOR="#FFFFFF",B._MIN_CHARS_DATA_LABEL=3,B._LINE_FRACTION=2/3,B._AREA_FRACTION=.41,B._HEIGHT_FRACTION=.28,B._LINE_FRACTION_2=.4,B._AREA_FRACTION_2=.8,B._HEIGHT_FRACTION_2=.7,B.prototype._getPath=function(){var t=e.Agent.isRightToLeft(this.getCtx()),i=g.getSeriesCount(this._chart),r=(this._numDrawnSeries+1)*this._gap,a=e.Math.degreesToRads(B._FUNNEL_ANGLE_2D-2*this._3dRatio),s=this._funnelWidth-i*this._gap,n=s/Math.sin(e.Math.degreesToRads(B._FUNNEL_ANGLE_2D)),o=this._funnelHeight/Math.sin(a),l=this._3dRatio*this._funnelWidth/this._funnelHeight*B._FUNNEL_3D_WIDTH_RATIO;l<1e-5&&(l=0);var h,u,d,c,p,_,f,v,m,S,C,y,x=this._funnelHeight,A=this._funnelHeight*B._FUNNEL_RATIO;this._startPercent<B._AREA_FRACTION?(h=this._startPercent,d=x,p=this._funnelHeight*B._LINE_FRACTION,f=B._AREA_FRACTION,m=s*B._HEIGHT_FRACTION,C=s*(1-B._HEIGHT_FRACTION)):this._startPercent<B._AREA_FRACTION_2?(h=this._startPercent-B._AREA_FRACTION,d=this._funnelHeight*B._LINE_FRACTION,p=this._funnelHeight*B._LINE_FRACTION_2,f=B._AREA_FRACTION_2-B._AREA_FRACTION,m=s*(B._HEIGHT_FRACTION_2-B._HEIGHT_FRACTION),C=s*(1-B._HEIGHT_FRACTION_2)):(h=this._startPercent-B._AREA_FRACTION_2,d=this._funnelHeight*B._LINE_FRACTION_2,p=A,f=1-B._AREA_FRACTION_2,m=s*(1-B._HEIGHT_FRACTION_2),C=0),this._startPercent+this._valuePercent<B._AREA_FRACTION?(c=x,_=this._funnelHeight*B._LINE_FRACTION,u=this._startPercent+this._valuePercent,v=B._AREA_FRACTION,S=s*B._HEIGHT_FRACTION,y=s*(1-B._HEIGHT_FRACTION)):this._startPercent+this._valuePercent<B._AREA_FRACTION_2?(c=this._funnelHeight*B._LINE_FRACTION,_=this._funnelHeight*B._LINE_FRACTION_2,u=this._startPercent+this._valuePercent-B._AREA_FRACTION,v=B._AREA_FRACTION_2-B._AREA_FRACTION,S=s*(B._HEIGHT_FRACTION_2-B._HEIGHT_FRACTION),y=s*(1-B._HEIGHT_FRACTION_2)):(c=this._funnelHeight*B._LINE_FRACTION_2,_=A,u=this._startPercent+this._valuePercent-B._AREA_FRACTION_2,v=1-B._AREA_FRACTION_2,S=s*(1-B._HEIGHT_FRACTION_2),y=0);var b,M,T,I=Math.sqrt((f-h)/f*d*d+h/f*p*p),D=Math.sqrt((v-u)/v*c*c+u/v*_*_),O=.98*Math.asin(((I-p)*m/(d-p)+C)/n),E=.98*Math.asin(((D-_)*S/(c-_)+y)/n),P=(1+B._FUNNEL_RATIO)/2*this._funnelHeight+o,L=(1-B._FUNNEL_RATIO)/2*this._funnelHeight-o;t?(b=[n*Math.sin(O)+r,P-o*Math.cos(O),n*Math.sin(E)+r,P-o*Math.cos(E),n*Math.sin(E)+r,L+o*Math.cos(E),n*Math.sin(O)+r,L+o*Math.cos(O)],M=0,T=1):(b=[this._funnelWidth-r-n*Math.sin(O),P-o*Math.cos(O),this._funnelWidth-r-n*Math.sin(E),P-o*Math.cos(E),this._funnelWidth-r-n*Math.sin(E),L+o*Math.cos(E),this._funnelWidth-r-n*Math.sin(O),L+o*Math.cos(O)],M=1,T=0);var w=e.PathUtils.moveTo(b[0],b[1]),R=null;w+=e.PathUtils.arcTo(l*(b[1]-b[7])/2,(b[1]-b[7])/2,Math.PI,T,b[6],b[7]),w+=e.PathUtils.arcTo(l*(b[1]-b[7])/2,(b[1]-b[7])/2,Math.PI,T,b[0],b[1]),w+=e.PathUtils.arcTo(n,o,a,M,b[2],b[3]),w+=e.PathUtils.arcTo(l*(b[3]-b[5])/2,(b[3]-b[5])/2,Math.PI,T,b[4],b[5]),w+=e.PathUtils.arcTo(n,o,a,M,b[6],b[7]);var k=new e.Rectangle(Math.min(b[0],b[2]),b[5],Math.abs(b[0]-b[2]),Math.abs(b[3]-b[5]));if(null!=this._fillPercent){var F=Math.max(Math.min(this._fillPercent,1),0),N=t?-F*Math.PI:F*Math.PI;R=e.PathUtils.moveTo(b[0],b[1]),R+=e.PathUtils.arcTo(n,o,a,M,b[2],b[3]),R+=e.PathUtils.arcTo(l*(b[3]-b[5])/2,(b[3]-b[5])/2,N,T,b[2]+l*(b[3]-b[5])/2*Math.sin(N),(b[5]+b[3])/2+(b[3]-b[5])/2*Math.cos(N)),this._fillPercent>.95?R+=e.PathUtils.arcTo(n,o,a,M,b[6],b[1]+F*(b[7]-b[1])):this._fillPercent<.05?R+=e.PathUtils.arcTo(n,o,a,T,b[6],b[1]+F*(b[7]-b[1])):R+=e.PathUtils.lineTo(b[6]+l*(b[1]-b[7])/2*Math.sin(N),(b[7]+b[1])/2+(b[1]-b[7])/2*Math.cos(N)),R+=e.PathUtils.arcTo(l*(b[1]-b[7])/2,(b[1]-b[7])/2,N,M,b[0],b[1]),R+=e.PathUtils.closePath();var H=new e.Rectangle(Math.min(b[0],b[2]),b[5]+Math.abs(b[3]-b[5])*(1-F),Math.abs(b[0]-b[2]),Math.abs(b[3]-b[5])*F)}return{slice:w,bar:R,sliceBounds:k,barBounds:R?H:k}},B.prototype._getSliceLabel=function(t,i){var r=p.getDataLabel(this._chart,this._seriesIndex,0);if(r||(r=g.getSeriesLabel(this._chart,this._seriesIndex)),r&&"none"!=w.getDataLabelPosition(this._chart,this._seriesIndex,0)){var a=new e.MultilineText(this.getCtx(),r,0,0),s=null!=p.getPattern(this._chart,this._seriesIndex,0),n=this._chart.getOptions().styleDefaults,o=[n._dataLabelStyle,n.dataLabelStyle,new e.CSSStyle(g.getDataItem(this._chart,this._seriesIndex,0).labelStyle)],l=e.CSSStyle.mergeStyles(o);if(a.setCSSStyle(l),e.TextUtils.fitText(a,t.h-this._3dRatio*(.8-this._valuePercent)*50,t.w,this,B._MIN_CHARS_DATA_LABEL)){var h=a.getDimensions(),u=this._getLabelPosition(t);if(s){var d=.15*h.h,c=e.Agent.isRightToLeft(this.getCtx())?.5:-.5,_=e.PathUtils.roundedRectangle(h.x-d,h.y,h.w+2*d,h.h,2,2,2,2),f=new e.Path(this.getCtx(),_);f.setSolidFill("#FFFFFF",.9),u=u.translate(c*h.h,-c*h.w),f.setMatrix(u),this.addChild(f)}var v=s?"#000000":i.containsPoint(t.x,t.y+(t.h-h.w)/2)?e.ColorUtils.getContrastingTextColor(this._dataColor):e.ColorUtils.getContrastingTextColor(this._backgroundColor),m=new e.CSSStyle({color:v});return o.splice(1,0,m),e.Agent.isHighContrast()&&o.push(m),l=e.CSSStyle.mergeStyles(o),a.setCSSStyle(l),a.setMatrix(this._getLabelPosition(t)),a.alignCenter(),a.alignMiddle(),a}}},B.prototype._getLabelPosition=function(t){var i=this._3dRatio*(t.h*this._funnelWidth/this._funnelHeight*B._FUNNEL_3D_WIDTH_RATIO/2),r=new e.Matrix;return r=e.Agent.isRightToLeft(this.getCtx())?(r=r.rotate(Math.PI/2)).translate(t.x+t.w/2-i,t.y+t.h/2):(r=r.rotate(3*Math.PI/2)).translate(t.x+t.w/2+i,t.y+t.h/2)},B.prototype._setColorProperties=function(t){var i=R.getFunnelPyramidSliceFill(this._chart,this._seriesIndex,this._dataColor,t),r=p.getBorderColor(this._chart,this._seriesIndex,0),a=p.getUserBorderWidth(this._chart,this._seriesIndex,0),s=p.getDefaultBorderWidth(this._chart,this._seriesIndex,0),n=!1,o="redwood"===this.getCtx().getThemeBehavior();null==r&&this._3dRatio>0&&(n=!0,r=B._BORDER_COLOR);var l=null!==a?a:s;!r||o&&this._chart.isSelectionSupported()&&!this._bar&&n||this.setSolidStroke(r,null,l);var h=e.SelectionEffectUtils.getHoverBorderColor(this._dataColor),u=R.getFunnelPyramidSliceFill(this._chart,this._seriesIndex,this._backgroundColor,t,!0);this._bar?(this.setFill(u),this._bar.setFill(i),this._bar.setStyle(p.getStyle(this._chart,this._seriesIndex,0)),this._bar.setClassName(p.getClassName(this._chart,this._seriesIndex,0))):(this.setFill(i),this.setStyle(p.getStyle(this._chart,this._seriesIndex,0)),this.setClassName(p.getClassName(this._chart,this._seriesIndex,0))),this.OriginalStroke=this.getStroke();var g=null!=this._bar?this._bar:this;if(this._chart.isSelectionSupported())if(this.setCursor(e.SelectionEffectUtils.getSelectingCursor()),o)if(null!=this._bar)g.setSolidStroke(this._dataColor,null,0),g.setFeedbackClassName("oj-dvt-selectable");else{var d=null==r||n?this._dataColor:r,c=null!==a?a:0;g.setSolidStroke(d,null,c),g.setFeedbackClassName("oj-dvt-selectable"),r&&(n&&g.addClassName("oj-dvt-default-border-color"),null==a&&g.addClassName("oj-dvt-default-border-width"))}else{var _=p.getSelectedInnerColor(this._chart),f=p.getSelectedOuterColor(this._chart)?p.getSelectedOuterColor(this._chart):this._dataColor;g.setHoverStroke(new e.Stroke(h,1,2)),g.setSelectedStroke(new e.Stroke(_,1,1.5),new e.Stroke(f,1,4.5)),g.setSelectedHoverStroke(new e.Stroke(_,1,1.5),new e.Stroke(h,1,4.5))}},B.prototype.getAnimationParams=function(){return[this._startPercent,this._valuePercent,this._fillPercent,this.getAlpha(),this._3dRatio]},B.prototype.setAnimationParams=function(t){this._startPercent=t[0],this._valuePercent=t[1],this._fillPercent=null!=this._fillPercent?t[2]:null,this.setAlpha(t[3]),this._3dRatio=t[4];var e=this._getPath();this.setCmds(e.slice),e.bar&&this._bar&&this._bar.setCmds(e.bar),this._label&&this._label.setMatrix(this._getLabelPosition(e.sliceBounds))},B.prototype.setSelected=function(t){if(null!=this._bar){if(this.IsSelected==t)return;this.IsSelected=t,this._bar.setSelected(t)}else B.superclass.setSelected.call(this,t);var e=this.getDimensions(),i=null!=this._bar?this._bar:this,r=e.w;t?(i.setScaleX((r-3)/r),i.setTranslateX(Math.ceil(1.5)+3/r*e.x)):(i.setScaleX(1),i.setTranslateX(0))},B.prototype.showHoverEffect=function(){null!=this._bar?this._bar.showHoverEffect():B.superclass.showHoverEffect.call(this)},B.prototype.hideHoverEffect=function(){null!=this._bar?this._bar.hideHoverEffect():B.superclass.hideHoverEffect.call(this)},B.prototype.copyShape=function(){return new B(this._chart,this._seriesIndex,this._numDrawnSeries,this._funnelWidth,this._funnelHeight,this._startPercent,this._valuePercent,this._fillPercent,this._gap)};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var k=new Object;e.Obj.createSubclass(k,e.Obj),k.setVisibility=function(t,e,i){var r=f.getRefObj(t,e);null!=r&&(r.visibility=i);var a=g.getHiddenCategories(t),s=a.indexOf(e);"hidden"==i&&s<0?a.push(e):"visible"==i&&s>=0&&a.splice(s,1);var n=t.getOptions();if(n&&n.legend&&n.legend.sections){for(var o=0;o<n.legend.sections.length;o++){var l=n.legend.sections[o];if(l&&l.items)for(var h=0;h<l.items.length;h++)l.items[h].id==e&&(l.items[h].categoryVisibility=i)}return!0}return!1},k.processIds=function(t,e){for(var i=[],r=0;r<e.length;r++){var a=e[r];if(a.series==c.OTHER_SLICE_SERIES_ID){var s=c.getOtherSliceIds(t);i=i.concat(s)}else i.push(a)}return i},k.adjustBounds=function(t){null!=t.x&&(t.x-=1),null!=t.w&&(t.w+=2),null!=t.y&&(t.y-=1),null!=t.h&&(t.h+=2)},k.getBoundedObjects=function(t,e){for(var i=t.getChartObjPeers().concat(k.getFilteredChartObjPeers(t)),r=[],a=0;a<i.length;a++){var s=i[a],n=s.getDataPosition();if(n){n=t.getPlotArea().localToStage(n);var o=null==e.x||n.x>=e.x&&n.x<=e.x+e.w,l=null==e.y||n.y>=e.y&&n.y<=e.y+e.h;o&&l&&r.push(s)}}return r},k.getFilteredChartObjPeers=function(t){if(!t.getCache().getFromCache("dataFiltered"))return[];var e=t.getCache().getFromCache("filteredChartObjPeers");if(!e){e=[];for(var i=0;i<g.getSeriesCount(t);i++)for(var r=0;r<g.getGroupCount(t);r++){var a;if(g.isDataItemFiltered(t,i,r))a="bar"==g.getSeriesType(t,i)?w.getBarInfo(t,i,r).dataPos:g.getMarkerPosition(t,i,r),e.push(new m(t,[],i,r,null,a))}t.getCache().putToCache("filteredChartObjPeers",e)}return e},k.getAxisBounds=function(t,i,r){var a=t.getPlotArea(),s=a.stageToLocal(new e.Point(i.x,i.y)),n=a.stageToLocal(new e.Point(i.x+i.w,i.y+i.h));null==i.x&&(s.x=null,n.x=null),null==i.y&&(s.y=null,n.y=null);var o=k._convertToAxisCoord(t,s.x,n.x,s.y,n.y),l={},h={},u={},g={};return t.xAxis&&(l=k._getAxisMinMax(t.xAxis,o.xMin,o.xMax,r),g=k.getAxisStartEndGroup(t.xAxis,l.min,l.max)),t.yAxis&&(h=k._getAxisMinMax(t.yAxis,o.yMin,o.yMax,r)),t.y2Axis&&(u=k._getAxisMinMax(t.y2Axis,o.yMin,o.yMax,r)),{xMin:l.min,xMax:l.max,unchanged:l.unchanged,yMin:h.min,yMax:h.max,y2Min:u.min,y2Max:u.max,startGroup:g.startGroup,endGroup:g.endGroup}},k._getAxisMinMax=function(t,e,i,r){if(null==e||null==i)return{min:null,max:null};var a=t.getUnboundedLinearValueAt(e),s=t.getUnboundedLinearValueAt(i);if(r){var n=t.getInfo().getMinimumExtent();if(s-a<n){var o=(s+a)/2;s=o+n/2,a=o-n/2}return k._limitToGlobal(t,a,s)}return k.getActualMinMax(t,a,s)},k.getAxisBoundsByDelta=function(t,e,i,r,a){var s=k._convertToAxisCoord(t,e,i,r,a),n=E.getZoomDirection(t),o={},l={},h={},u={};return t.xAxis&&"y"!=n&&(o=k._getAxisMinMaxByDelta(t.xAxis,s.xMin,s.xMax),u=k.getAxisStartEndGroup(t.xAxis,o.min,o.max)),t.yAxis&&"x"!=n&&(l=k._getAxisMinMaxByDelta(t.yAxis,s.yMin,s.yMax)),t.y2Axis&&(h=k._getAxisMinMaxByDelta(t.y2Axis,s.yMin,s.yMax)),{xMin:o.min,xMax:o.max,unchanged:o.unchanged,yMin:l.min,yMax:l.max,y2Min:h.min,y2Max:h.max,startGroup:u.startGroup,endGroup:u.endGroup}},k._getAxisMinMaxByDelta=function(t,e,i){var r=t.getLinearViewportMin(),a=t.getLinearViewportMax();if(i==e&&t.isFullViewport())return k.getActualMinMax(t,r,a);var s=t.getUnboundedLinearValueAt(e)-t.getUnboundedLinearValueAt(0),n=t.getUnboundedLinearValueAt(i)-t.getUnboundedLinearValueAt(0),o=1,l=a+n-(r+s),h=t.getInfo().getMinimumExtent();return e!=i&&l<h&&(o=(a-r-h)/(s-n)),r+=s*o,a+=n*o,k._limitToGlobal(t,r,a)},k._convertToAxisCoord=function(t,i,r,a,s){var n={},o=e.Agent.isRightToLeft(t.getCtx());return l.isHorizontal(t)?(n.xMin=a,n.xMax=s,n.yMin=o?r:i,n.yMax=o?i:r):(n.xMin=o?r:i,n.xMax=o?i:r,n.yMin=s,n.yMax=a),n},k._limitToGlobal=function(t,e,i){var r=t.getLinearGlobalMin(),a=t.getLinearGlobalMax();return i-e>=a-r?(e=r,i=a):e<r?(i+=r-e,e=r):i>a&&(e-=i-a,i=a),k.getActualMinMax(t,e,i)},k.getActualMinMax=function(t,e,i){var r={min:t.linearToActual(e),max:t.linearToActual(i)};if(t.isGroupAxis()){var a=t.getLinearViewportMin(),s=t.getLinearViewportMax();Math.abs(e-a)<1e-4&&Math.abs(i-s)<1e-4&&(r.unchanged=!0)}return r},k.getAxisStartEndGroup=function(t,e,i){if(t.isGroupAxis()&&null!=e&&null!=i){var r=Math.ceil(e),a=Math.floor(i);if(a>=r)return{startGroup:t.getInfo().getGroup(r),endGroup:t.getInfo().getGroup(a)}}return{startGroup:null,endGroup:null}},k.setInitialSelection=function(t,e){var i=t.getSelectionHandler();if(i)if(e&&0!=e.length){for(var r=[],a=0;a<e.length;a++)null!=e[a].id?r.push(e[a].id):null!=e[a].series&&null!=e[a].group&&r.push(s(e[a].series,e[a].group));for(var n=new(t.getCtx().KeySetImpl)(r),o=t.getChartObjPeers(),l=[],h=0;h<o.length;h++){var u=o[h];if(u.isSelectable()){var g=u.getDataItemId(),d=s(u.getSeries(),u.getGroup());(n.has(g)||n.has(d))&&l.push(u.getId())}}i.processInitialSelections(l,o)}else i.clearSelection()},k.getKeyboardNavigables=function(t){var e=[];if(l.isPie(t))for(var i=t.pieChart.__getSlices(),r=0;r<i.length;r++)g.isSeriesRendered(t,i[r].getSeriesIndex())&&e.push(i[r]);else{var a=t.getChartObjPeers();for(r=0;r<a.length;r++)a[r].isNavigable()&&e.push(a[r])}return e},k.addEventData=function(t,e){var i=g.getSeriesIndex(t,e.series),r=g.getGroupIndex(t,e.group),a=g.getNestedDataItemIndex(t,i,r,e.id),s=p.getDataContext(t,i,r,a);s&&(e.data=s.data,e.itemData=s.itemData,e.seriesData=s.seriesData,s.groupData?e.groupData=s.groupData:null!=r&&(e.groupData=g.getGroupsDataForContext(t)[r]))},k.addGroupDrillEventData=function(t,e){var i={};Object.assign(i,e);var r=t.xAxis.getInfo().getItemsRange(e.group);delete i.series;for(var a=r.startIndex,s=r.endIndex,n=[],o=a;o<s+1;o++)for(var l=g.getSeriesCount(t),h=0;h<l;h++)n.push(g.getRawDataItem(t,h,o));return i.items=n,i.groupData=r.groupData,i},k.addMultiSeriesDrillEventData=function(t,e){var i={};Object.assign(i,e);var r=c._getSeriesIndicesArrays(t).other;delete i.group;for(var a=[],s=[],n=[],o=0;o<r.length;o++){var l=g.getSeriesDataForContext(t,r[o]),h=g.getRawDataItem(t,r[o],0);a.push(l),s.push(h),n.push(g.getSeries(t,r[o]))}return i.seriesData=a,i.items=s,i.series=n,i},k.addSeriesDrillEventData=function(t,e){var i={};Object.assign(i,e);var r=g.getSeriesIndex(t,e.id),a=g.getGroupCount(t);i.series=e.id,delete i.group,i.seriesData=g.getSeriesDataForContext(t,r);for(var s=[],n=0;n<a;n++){var o=g.getRawDataItem(t,r,n);s.push(o)}return i.items=s,i},k.addItemDrillEventData=function(t,e){var i={};Object.assign(i,e);var r=g.getSeriesIndex(t,e.series),a=g.getGroupIndex(t,e.group),s=g.getNestedDataItemIndex(t,r,a,e.id);return i.seriesData=g.getSeriesDataForContext(t,r),i.groupData=g.getGroupsDataForContext(t)[a],i.data=g.getRawDataItem(t,r,a,s),i.itemData=g.getDataItem(t,r,a,s)._itemData,i},k.addPlotAreaDnDBackground=function(t,i,r,a){var s=E.isPlotAreaDraggable(t);(E.isPlotAreaDropTarget(t)||s)&&(background=new e.Rect(t.getCtx(),0,0,a?r.w:r.h,a?r.h:r.w),background.setInvisibleFill(),i.addChild(background),t.getCache().putToCache("plotAreaBackground",background),s&&background.setClassName("oj-draggable"))};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var F=new Object;e.Obj.createSubclass(F,e.Obj),F._DEFAULT_3D_GAP_RATIO=1/36,F._DEFAULT_2D_GAP_RATIO=1/70,F._MAX_WIDTH_FOR_GAPS=.25,F._GROUP_INDEX=0,F._SLICE_VALUE_THRESHOLD=1e-4,F.render=function(t,i,r){var a=new e.Container(t.getCtx());a.setTranslate(r.x,r.y),i.addChild(a),t.setPlotArea(a);var s,n=l.isHorizontal(t);if(n)s=new e.Rectangle(0,0,r.w,r.h);else{var o=new e.Matrix,h=e.Agent.isRightToLeft(t.getCtx())?-1:1;o=(o=(o=o.translate(-r.h/2,-r.w/2)).rotate(h*Math.PI/2)).translate(r.x+r.w/2,r.y+r.h/2),s=new e.Rectangle(0,0,r.h,r.w),a.setMatrix(o)}k.addPlotAreaDnDBackground(t,a,r,n),F._renderFunnelSlices(t,a,s)||P.renderEmptyText(t,i,r);var u=g.getInitialSelection(t);k.setInitialSelection(t,u),t.highlight(g.getHighlightedCategories(t))},F._renderFunnelSlices=function(t,e,i){for(var r=t.getOptions(),a=g.getSeriesCount(t),s=p.getDataItemGaps(t),n=("on"==r.styleDefaults.threeDEffect?F._DEFAULT_3D_GAP_RATIO:F._DEFAULT_2D_GAP_RATIO)*i.w,o=s*Math.min(F._MAX_WIDTH_FOR_GAPS*i.w/(a-1),n),l=0,h=0,u=0,d=0;d<a;d++){if(g.isDataItemRendered(t,d))null==(_=g.getTargetValue(t,d))&&(_=g.getValue(t,d,F._GROUP_INDEX)),_<=0||(l+=_)}if(0==l)return!1;for(d=a-1;d>=0;d--)if(g.isDataItemRendered(t,d)){var c,_=g.getValue(t,d,F._GROUP_INDEX),f=g.getTargetValue(t,d);if(!(_<=0&&null==f||null!=f&&f<=0))if(!((null!=f?f:_)<F._SLICE_VALUE_THRESHOLD*l))null!=f?(u+=f/l,c=new B(t,d,h,i.w,i.h,1-u,f/l,_/f,o)):(u+=_/l,c=new B(t,d,h,i.w,i.h,1-u,_/l,null,o)),h++,e.addChild(c),m.associate(c,t,d,F._GROUP_INDEX)}return!0};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var N=function(t,e,i,r,a,s,n,o){this.Init(t,e,i,r,a,s,n,o)};e.Obj.createSubclass(N,e.Path),N.prototype.Init=function(t,i,r,a,s,n,o,l){N.superclass.Init.call(this,t.getCtx()),this._chart=t;var h=t.getOptions().styleDefaults;this._seriesIndex=i,this._numDrawnSeries=r,this._pyramidWidth=a,this._pyramidHeight=s,this._startPercent=n,this._valuePercent=o,this._3dRatio="on"==h.threeDEffect?1:0,this._gap=l;var u=this._getPath();this._dataColor=p.getColor(this._chart,this._seriesIndex,0),this._3dRatio>0?(this.setCmds(u.threeDPathTop),this._threeDPathSide=new e.Path(this.getCtx(),u.threeDPathSide),this._mainFace=new e.Path(this.getCtx(),u.slice),this.addChild(this._threeDPathSide),this.addChild(this._mainFace)):this.setCmds(u.slice),this._setColorProperties(u.sliceBounds),this._label=this._getSliceLabel(u.sliceBounds),null!=this._label&&(this._label.setMouseEnabled(!1),this.addChild(this._label))},N._BORDER_COLOR="#FFFFFF",N._MIN_CHARS_DATA_LABEL=3,N._SLICE_LABEL_HORIZONTAL_PADDING=4,N._3D_WIDTH_FACTOR=.2,N.prototype._getPath=function(){var t,i,r,a,s,n,o=e.Agent.isRightToLeft(this.getCtx()),l=g.getSeriesCount(this._chart),h=(l-this._numDrawnSeries-1)*this._gap,u=this._3dRatio*N._3D_WIDTH_FACTOR*.98*this._pyramidWidth,d=this._chart.getOptions(),c=Math.sqrt(Math.pow(this._pyramidHeight-(l-1)*this._gap,2)*(1-this._startPercent)),p=this._startPercent+this._valuePercent>=1?0:Math.sqrt(Math.pow(this._pyramidHeight-(l-1)*this._gap,2)*(1-this._startPercent-this._valuePercent)),_=.98*(1-this._3dRatio*N._3D_WIDTH_FACTOR)*this._pyramidWidth*(p/this._pyramidHeight),f=0==this._numDrawnSeries?c:c-this._gap,v=.98*(1-this._3dRatio*N._3D_WIDTH_FACTOR)*this._pyramidWidth*(f/this._pyramidHeight);if(o?(i=[this._pyramidWidth-.5*this._pyramidWidth+u/2-_/2,h+p],a=[this._pyramidWidth-.5*this._pyramidWidth+u/2-v/2,h+c],r=[this._pyramidWidth-.5*this._pyramidWidth+u/2+v/2,h+c],t=[this._pyramidWidth-.5*this._pyramidWidth+u/2+_/2,h+p]):(t=[.5*this._pyramidWidth-u/2-_/2,h+p],r=[.5*this._pyramidWidth-u/2-v/2,h+c],a=[.5*this._pyramidWidth-u/2+v/2,h+c],i=[.5*this._pyramidWidth-u/2+_/2,h+p]),"on"==d.styleDefaults.threeDEffect){var m=Math.atan(2*c/v),S=Math.min(.9*m,Math.PI/4),C=this._3dRatio*N._3D_WIDTH_FACTOR*v*Math.sqrt(2)/2,y=this._3dRatio*N._3D_WIDTH_FACTOR*_*Math.sqrt(2)/2,x=y/Math.tan(S);s=e.PathUtils.moveTo(i[0],i[1]),s+=e.PathUtils.lineTo(i[0]+(o?-1:1)*Math.max(y,1),i[1]-Math.max(y,.5)),s+=e.PathUtils.lineTo(t[0]+(o?-1:1)*Math.max(x,1),t[1]-Math.max(y,.5)),s+=e.PathUtils.lineTo(t[0],t[1]),s+=e.PathUtils.closePath(),n=e.PathUtils.moveTo(i[0],i[1]),n+=e.PathUtils.lineTo(i[0]+(o?-1:1)*Math.max(y,1),i[1]-Math.max(y,.5)),n+=e.PathUtils.lineTo(a[0]+(o?-1:1)*C,a[1]-C),n+=e.PathUtils.lineTo(a[0],a[1]),n+=e.PathUtils.closePath()}var A=e.PathUtils.moveTo(i[0],i[1]);A+=e.PathUtils.lineTo(a[0],a[1]),A+=e.PathUtils.lineTo(r[0],r[1]),A+=e.PathUtils.lineTo(t[0],t[1]),A+=e.PathUtils.closePath();var b=_/v,M=.5*Math.abs(t[1]-r[1])*(1+b),T=.5*Math.abs(a[0]-r[0])*(1+b)-N._SLICE_LABEL_HORIZONTAL_PADDING,I=r[1]-M,D=r[0]+(v-T)/2*(o?-1:1);return{slice:A,sliceBounds:new e.Rectangle(D,I,T,M),threeDPathTop:s,threeDPathSide:n}},N.prototype._getSliceLabel=function(t){var i=p.getDataLabel(this._chart,this._seriesIndex,0);if(i||(i=g.getSeriesLabel(this._chart,this._seriesIndex)),i&&"none"!=w.getDataLabelPosition(this._chart,this._seriesIndex,0)){var r=new e.MultilineText(this.getCtx(),i,0,0),a=null!=p.getPattern(this._chart,this._seriesIndex,0),s=this._chart.getOptions().styleDefaults,n=[s._dataLabelStyle,s.dataLabelStyle,new e.CSSStyle(g.getDataItem(this._chart,this._seriesIndex,0).labelStyle)],o=e.CSSStyle.mergeStyles(n);if(r.setCSSStyle(o),e.TextUtils.fitText(r,t.w,t.h,this,N._MIN_CHARS_DATA_LABEL)){var l=r.getDimensions(),h=this._getLabelPosition(t);if(a){var u=.15*l.h,d=e.PathUtils.roundedRectangle(l.x-u,l.y,l.w+2*u,l.h,2,2,2,2),c=new e.Path(this.getCtx(),d);c.setSolidFill("#FFFFFF",.9),h=h.translate(-.5*l.w,-.5*l.h),c.setMatrix(h),this.addChild(c)}var _=a?"#000000":t.containsPoint(t.x+(t.w-l.w)/2,t.y)?e.ColorUtils.getContrastingTextColor(this._dataColor):e.ColorUtils.getContrastingTextColor(null),f=new e.CSSStyle({color:_});return n.splice(1,0,f),e.Agent.isHighContrast()&&n.push(f),o=e.CSSStyle.mergeStyles(n),r.setCSSStyle(o),r.setMatrix(this._getLabelPosition(t)),r.alignCenter(),r.alignMiddle(),r}}},N.prototype._getLabelPosition=function(t){var i=new e.Matrix;return i=e.Agent.isRightToLeft(this.getCtx())?i.translate(t.x-t.w/2,t.y+t.h/2):i.translate(t.x+t.w/2,t.y+t.h/2)},N.prototype._setColorProperties=function(t){var i=R.getFunnelPyramidSliceFill(this._chart,this._seriesIndex,this._dataColor,t),r=p.getBorderColor(this._chart,this._seriesIndex,0),a=p.getUserBorderWidth(this._chart,this._seriesIndex,0),s=p.getDefaultBorderWidth(this._chart,this._seriesIndex,0),n=null!==a?a:s,o=!1,l="redwood"===this.getCtx().getThemeBehavior();null==r&&this._3dRatio>0&&(o=!0,r=N._BORDER_COLOR),!r||l&&this._chart.isSelectionSupported()&&o||(this.setSolidStroke(r,null,n),this._3dRatio>0&&(this._threeDPathSide.setSolidStroke(r,null,n),this._mainFace.setSolidStroke(r,null,n)));var h=e.SelectionEffectUtils.getHoverBorderColor(this._dataColor);if(this._3dRatio>0){var u=!i.getPattern&&!i.getAlphas;this._mainFace.setFill(i),this._mainFace.setStyle(p.getStyle(this._chart,this._seriesIndex,0)),this._mainFace.setClassName(p.getClassName(this._chart,this._seriesIndex,0)),this._threeDPathSide.setFill(u?new e.SolidFill(e.ColorUtils.getDarker(i.getColor(),.3)):i),this._threeDPathSide.setStyle(p.getStyle(this._chart,this._seriesIndex,0)),this._threeDPathSide.setClassName(p.getClassName(this._chart,this._seriesIndex,0)),this.setFill(u?new e.SolidFill(e.ColorUtils.getDarker(i.getColor(),.3)):i),this.setStyle(p.getStyle(this._chart,this._seriesIndex,0)),this.setClassName(p.getClassName(this._chart,this._seriesIndex,0))}else this.setFill(i),this.setStyle(p.getStyle(this._chart,this._seriesIndex,0)),this.setClassName(p.getClassName(this._chart,this._seriesIndex,0));if(this.OriginalStroke=this.getStroke(),this._chart.isSelectionSupported())if(this.setCursor(e.SelectionEffectUtils.getSelectingCursor()),this._3dRatio>0)if(this._mainFace.setCursor(e.SelectionEffectUtils.getSelectingCursor()),this._threeDPathSide.setCursor(e.SelectionEffectUtils.getSelectingCursor()),l){this._mainFace.setFeedbackClassName("oj-dvt-selectable"),this._threeDPathSide.setFeedbackClassName("oj-dvt-selectable");var g=null==r||o?this._dataColor:r,d=null!==a?a:0;this._mainFace.setSolidStroke(g,null,d),this._threeDPathSide.setSolidStroke(g,null,d),r&&(o&&(this._mainFace.addClassName("oj-dvt-default-border-color"),this._threeDPathSide.addClassName("oj-dvt-default-border-color")),null==a&&(this._mainFace.addClassName("oj-dvt-default-border-width"),this._threeDPathSide.addClassName("oj-dvt-default-border-width")))}else{var c=p.getSelectedInnerColor(this._chart),_=p.getSelectedOuterColor(this._chart)?p.getSelectedOuterColor(this._chart):this._dataColor;this._mainFace.setHoverStroke(new e.Stroke(h,1,2)),this._threeDPathSide.setHoverStroke(new e.Stroke(h,1,2)),this._mainFace.setSelectedStroke(new e.Stroke(c,1,1.5),new e.Stroke(_,1,4.5)),this._mainFace.setSelectedHoverStroke(new e.Stroke(c,1,1.5),new e.Stroke(h,1,4.5))}else if(this.setCursor(e.SelectionEffectUtils.getSelectingCursor()),l){this.setFeedbackClassName("oj-dvt-selectable");g=null==r||o?this._dataColor:r,d=null!==a?a:0;this.setSolidStroke(g,null,d),r&&(o&&this.addClassName("oj-dvt-default-border-color"),null==a&&this.addClassName("oj-dvt-default-border-width"))}else{c=p.getSelectedInnerColor(this._chart),_=p.getSelectedOuterColor(this._chart)?p.getSelectedOuterColor(this._chart):this._dataColor;this.setHoverStroke(new e.Stroke(h,1,2)),this.setSelectedStroke(new e.Stroke(c,1,1.5),new e.Stroke(_,1,4.5)),this.setSelectedHoverStroke(new e.Stroke(c,1,1.5),new e.Stroke(h,1,4.5))}},N.prototype.getAnimationParams=function(){return[this._startPercent,this._valuePercent,this.getAlpha(),this._3dRatio]},N.prototype.setAnimationParams=function(t){this._startPercent=t[0],this._valuePercent=t[1],this.setAlpha(t[2]),this._3dRatio=t[3];var e=this._getPath();this._threeDPathSide&&this._mainFace?(this.setCmds(e.threeDPathTop),this._threeDPathSide.setCmds(e.threeDPathSide),this._mainFace.setCmds(e.slice)):this.setCmds(e.slice),this._label&&this._label.setMatrix(this._getLabelPosition(e.sliceBounds))},N.prototype.setSelected=function(t){if(this._3dRatio>0)if(this._mainFace.setSelected(t),"redwood"===this.getCtx().getThemeBehavior()&&this._threeDPathSide.setSelected(t),t){var e=this.getDimensions(),i=e.w,r=e.h,a=(i-3)/i,s=(r-5)/r;this._mainFace.setScaleX(a),this._mainFace.setScaleY(s),this._mainFace.setTranslateX(Math.ceil(1.5)+3/i*e.x),this._mainFace.setTranslateY(Math.ceil(2.5)+5/r*e.y)}else this._mainFace.setScaleX(1),this._mainFace.setScaleY(1),this._mainFace.setTranslateX(0),this._mainFace.setTranslateY(0);else N.superclass.setSelected.call(this,t)},N.prototype.showHoverEffect=function(){"redwood"===this.getCtx().getThemeBehavior()&&0!==this._3dRatio||N.superclass.showHoverEffect.call(this),this._3dRatio>0&&(this._threeDPathSide.showHoverEffect(),this._mainFace.showHoverEffect())},N.prototype.hideHoverEffect=function(){"redwood"===this.getCtx().getThemeBehavior()&&0!==this._3dRatio||N.superclass.hideHoverEffect.call(this),this._3dRatio>0&&(this._threeDPathSide.hideHoverEffect(),this._mainFace.hideHoverEffect())},N.prototype.copyShape=function(){return new N(this._chart,this._seriesIndex,this._numDrawnSeries,this._pyramidWidth,this._pyramidHeight,this._startPercent,this._valuePercent,this._gap)},N.prototype.getPrimaryFill=function(){return this._mainFace?this._mainFace.getFill():this.getFill()};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var H=new Object;e.Obj.createSubclass(H,e.Obj),H._DEFAULT_GAP_RATIO=1/70,H._MAX_HEIGHT_FOR_GAPS=.25,H._GROUP_INDEX=0,H.render=function(t,i,r){var a=new e.Container(t.getCtx());a.setTranslate(r.x,r.y),i.addChild(a),t.setPlotArea(a);var s=new e.Rectangle(0,0,r.w,r.h);k.addPlotAreaDnDBackground(t,a,r,!0),H._renderPyramidSlices(t,a,s)||P.renderEmptyText(t,i,r);var n=g.getInitialSelection(t);k.setInitialSelection(t,n),t.highlight(g.getHighlightedCategories(t))},H._renderPyramidSlices=function(t,e,i){for(var r=g.getSeriesCount(t),a=p.getDataItemGaps(t),s=H._DEFAULT_GAP_RATIO*i.h,n=a*Math.min(H._MAX_HEIGHT_FOR_GAPS*i.h/(r-1),s),o=0,l=0,h=0,u=0;u<r;u++){if(g.isDataItemRendered(t,u))(d=g.getValue(t,u,H._GROUP_INDEX))<=0||(o+=d)}if(0==o)return!1;for(u=0;u<r;u++){var d;if(g.isDataItemRendered(t,u))if(!((d=g.getValue(t,u,H._GROUP_INDEX))<=0)){var c=new N(t,u,l,i.w,i.h,h,d/o,n);h+=d/o,l++,e.addChild(c),m.associate(c,t,u,H._GROUP_INDEX)}}return!0};
/**
   * @license
   * Copyright (c) 2011 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var G=function(t,e,i,r,a,s,n,o,l,h){this.Init(t,null,h),this.setWedgeParams(e,i,r,a,s,n,o,l)};e.Obj.createSubclass(G,e.Path),G._OUTER_BORDER_WIDTH=2,G._OUTER_BORDER_WIDTH_HOVER=1.25,G._INNER_BORDER_WIDTH=1,G.prototype.Init=function(t,e,i){G.superclass.Init.call(this,t,e,i)},G.prototype.setWedgeParams=function(t,e,i,r,a,s,n,o){this._cx=t,this._cy=e,this._rx=i,this._ry=r,this._sa=a,this._ae=s,this._gap=n,this._ir=o;var l=this._makeWedgePath(0);this.setCmds(l)},G.prototype._makeWedgePath=function(t){var i,r=Math.max(this._rx-t,0),a=Math.max(this._ry-t,0),s=360==this._ae||r<t?0:this._gap+2*t,n=this._ir?this._ir+t:0,o=360==this._ae?e.Math.degreesToRads(359.99):e.Math.degreesToRads(this._ae),l=e.Math.degreesToRads(this._sa),h=s/2,u=h<r?Math.asin(h/r):0,g=-o/2-l,d=Math.min(5*h,o>0?Math.abs(h/Math.sin(o/2)):0),c=0==r?d:d*a/r,p=this._cx+Math.cos(g)*d,_=this._cy+Math.sin(g)*c,f=this._cx+Math.cos(-u-l)*r,v=this._cy+Math.sin(-u-l)*a,m=this._cx+Math.cos(-l-o+u)*r,S=this._cy+Math.sin(-l-o+u)*a,C=e.Math.calculateAngleBetweenTwoVectors(m-this._cx,S-this._cy,f-this._cx,v-this._cy);if(C=Math.min(C,o),n>0){var y=h<n?Math.asin(h/n):0,x=this._cx+Math.cos(-y-l)*n,A=this._cy+Math.sin(-y-l)*n,b=this._cx+Math.cos(-l-o+y)*n,M=this._cy+Math.sin(-l-o+y)*n,T=e.Math.calculateAngleBetweenTwoVectors(b-this._cx,M-this._cy,x-this._cx,A-this._cy);T=Math.min(T,C,o),360==this._ae?(i=e.PathUtils.moveTo(m,S),i+=e.PathUtils.arcTo(r,a,o,1,f,v),i+=e.PathUtils.lineTo(m,S),i+=e.PathUtils.moveTo(x,A),i+=e.PathUtils.arcTo(n,n,o,0,b,M)):(i=e.PathUtils.moveTo(b,M),i+=e.PathUtils.lineTo(m,S),i+=e.PathUtils.arcTo(r,a,C,1,f,v),i+=e.PathUtils.lineTo(x,A),i+=e.PathUtils.arcTo(n,n,T,0,b,M))}else 360==this._ae?(i=e.PathUtils.moveTo(m,S),i+=e.PathUtils.arcTo(r,a,o,1,f,v)):(i=e.PathUtils.moveTo(p,_),i+=e.PathUtils.lineTo(m,S),i+=e.PathUtils.arcTo(r,a,C,1,f,v));return i+=e.PathUtils.closePath()},G.prototype._initializeSelectionEffects=function(){var t="redwood"===this.getCtx().getThemeBehavior(),i=this.isSelected()||t?G._OUTER_BORDER_WIDTH:G._OUTER_BORDER_WIDTH_HOVER,r=this._makeWedgePath(i),a=this._makeWedgePath(i+G._INNER_BORDER_WIDTH);if(this.OuterChild)return this.OuterChild.setCmds(r),void this.InnerChild.setCmds(a);this.OuterChild=new e.Path(this.getCtx(),r),this.OuterChild.setInvisibleFill(),this.OuterChild.setMouseEnabled(!0),this.addChild(this.OuterChild),this.InnerChild=new e.Path(this.getCtx(),a),this.InnerChild.setInvisibleFill(),this.InnerChild.setMouseEnabled(!0),this.addChild(this.InnerChild)},G.prototype._showNestedBorders=function(t,e){this._initializeSelectionEffects(),e?(this.setSolidFill(t),this.setStroke(null),this.setClassName().setStyle(),this.OuterChild.setSolidFill(e),this.OuterChild.setClassName().setStyle(),this.InnerChild.setFill(this._fill),this.InnerChild.setClassName(this._shapeClassName).setStyle(this._shapeStyle)):t?(this.setSolidFill(t),this.setStroke(null),this.setClassName().setStyle(),this.OuterChild.setFill(this._fill),this.OuterChild.setClassName(this._shapeClassName).setStyle(this._shapeStyle),this.InnerChild.setInvisibleFill(),this.InnerChild.setClassName().setStyle()):(this.setFill(this._fill),this.setStroke(this._shapeStroke),this.setClassName(this._shapeClassName).setStyle(this._shapeStyle),this.OuterChild.setInvisibleFill(),this.OuterChild.setClassName().setStyle(),this.InnerChild.setInvisibleFill(),this.InnerChild.setClassName().setStyle())},G.prototype.setStyleProperties=function(t,i,r,a,s,n,o){this._fill=t,this._shapeStroke=i;var l="redwood"===this.getCtx().getThemeBehavior();this._hoverColor=l?r:e.SelectionEffectUtils.getHoverBorderColor(r),this._innerColor=a,this._outerColor=s,this._shapeClassName=n,this._shapeStyle=o,this.setStyle(o).setClassName(n),this.setFill(t),i&&this.setStroke(i)},G.prototype.showHoverEffect=function(){this.IsShowingHoverEffect=!0;var t="redwood"===this.getCtx().getThemeBehavior()&&this.isSelected()?this._outerColor:this._hoverColor;this._showNestedBorders(t,this._innerColor)},G.prototype.hideHoverEffect=function(){this.IsShowingHoverEffect=!1,this.isSelected()?this._showNestedBorders(this._outerColor,this._innerColor):this._showNestedBorders()},G.prototype.setSelected=function(t){if(this.IsSelected!=t){this.IsSelected=t;var e="redwood"===this.getCtx().getThemeBehavior();if(this.isHoverEffectShown()){var i=e&&this.isSelected()?this._outerColor:this._hoverColor;this._showNestedBorders(i,this._innerColor)}else this.isSelected()?this._showNestedBorders(this._outerColor,this._innerColor):this._showNestedBorders()}},G.prototype.UpdateSelectionEffect=function(){};
/**
   * @license
   * Copyright (c) 2008 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var U=function(){this._init()};e.Obj.createSubclass(U,e.Obj),U.prototype._init=function(){this._sliceLabel=null,this._slice=null,this._angle=-1,this._position=-1,this._width=-1,this._height=-1,this._x=-1,this._y=-1,this._initialNumLines=-1,this._hasFeeler=!1,this._maxY=-1,this._minY=-1},U.prototype.getAngle=function(){return this._angle},U.prototype.setAngle=function(t){this._angle=t},U.prototype.getHeight=function(){return this._height},U.prototype.setHeight=function(t){this._height=t},U.prototype.getInitialNumLines=function(){return this._initialNumLines},U.prototype.setInitialNumLines=function(t){this._initialNumLines=t},U.prototype.getMaxY=function(){return this._maxY},U.prototype.setMaxY=function(t){this._maxY=t},U.prototype.getMinY=function(){return this._minY},U.prototype.setMinY=function(t){this._minY=t},U.prototype.boundY=function(t){return this._minY<=this._maxY&&(t=Math.max(t,this._minY),t=Math.min(t,this._maxY)),t},U.prototype.hasFeeler=function(){return this._hasFeeler},U.prototype.setHasFeeler=function(t){this._hasFeeler=t},U.prototype.getPosition=function(){return this._position},U.prototype.setPosition=function(t){this._position=t},U.prototype.getSlice=function(){return this._slice},U.prototype.setSlice=function(t){this._slice=t},U.prototype.getSliceLabel=function(){return this._sliceLabel},U.prototype.setSliceLabel=function(t){this._sliceLabel=t},U.prototype.getWidth=function(){return this._width},U.prototype.setWidth=function(t){this._width=t},U.prototype.getX=function(){return this._x},U.prototype.setX=function(t){this._x=t},U.prototype.getY=function(){return this._y},U.prototype.setY=function(t){this._y=t};
/**
   * @license
   * Copyright (c) 2008 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var j=function(){};e.Obj.createSubclass(j,e.Obj),j.TWOD="2D",j.THREED="3D",j.CRUST="CRUST",j.SIDE="SIDE",j.BORDER="BORDER",j.SURFACE_CRUST=0,j.SURFACE_LEFT=1,j.SURFACE_RIGHT=2,j.SURFACE_TOP=3,j.reflectAngleOverYAxis=function(t,i,r,a,s){var n=e.Math.degreesToRads(360-t);return{x:i+Math.cos(n)*a,y:r+Math.sin(n)*s}},j.getGradientColors=function(t,i){return i==j.TWOD||i==j.THREED?[e.ColorUtils.adjustHSL(t,0,-.04,-.05),e.ColorUtils.adjustHSL(t,0,-.09,.04)]:i==j.CRUST?[e.ColorUtils.adjustHSL(t,0,-.04,-.05),e.ColorUtils.adjustHSL(t,0,0,-.14)]:i==j.SIDE?[e.ColorUtils.adjustHSL(t,0,-.1,.06),e.ColorUtils.adjustHSL(t,0,-.04,-.05)]:void 0},j.getGradientAlphas=function(t,e){var i=null==t||isNaN(t)||0==t?1:t;return e==j.TWOD?[i,i,i]:e==j.BORDER?[i/1.59375,i/5.3125,i/(255/96)]:e==j.THREED?[i,i,i,i,i]:e==j.CRUST?[i,i,i,i]:e==j.SIDE?[i,i]:void 0},j.createTopSurface=function(t,i){var r=t.getPieChart(),a=r.getCtx(),s=t.getCenter(),n=t.getInnerRadius(),o=r.is3D()||t.getSliceGaps()>Math.sin(e.Math.degreesToRads(t.getAngleExtent()))*t._radiusX+1?null:t.getSliceGaps(),l=new G(a,s.x,s.y,t._radiusX,t._radiusY,t.getAngleStart(),t.getAngleExtent(),o,n),h=p.getSelectedInnerColor(r.chart),u=p.getSelectedOuterColor(r.chart),g=new e.Stroke(t.getStrokeColor(),1,t.getBorderWidth()),d=t.getSeriesIndex(),c=p.getClassName(r.chart,d,0),_=p.getStyle(r.chart,d,0);l.setStyleProperties(i,g,t.getFillColor(),h,u,c,_);var f=[l];return j.associate(t,f),f},j.associate=function(t,e){if(e)for(var i=0;i<e.length;i++)t.getPieChart().chart.getEventManager().associate(e[i],t)},j.createLateralSurface=function(t,i,r){if(0==t.getAngleExtent())return[];var a=[];if(e.ColorUtils.getAlpha(t.getFillColor())>0)if(i==j.SURFACE_LEFT||i==j.SURFACE_RIGHT)a.push(j._generateLateralShape(t,i,null,r));else if(i==j.SURFACE_CRUST)for(var s=j._createCrustPathCommands(t),n=s.length,o=0;o<n;o++)a.push(j._generateLateralShape(t,i,s[o],r));return j.associate(t,a),a},j.generateLateralGradientFill=function(t,i){t.getPieChart(),i==j.CRUST&&t.getDepth();var r=j.getGradientColors(e.ColorUtils.getRGB(t.getFillColor()),i),a=j.getGradientAlphas(e.ColorUtils.getAlpha(t.getFillColor()),i);return new e.LinearGradientFill(270,r,a,[0,1],null)},j._generateLateralShape=function(t,i,r,a){var s=t.getPieChart().getCtx();if(i==j.SURFACE_LEFT||i==j.SURFACE_RIGHT){for(var n=t.getAngleStart(),o=t.getAngleExtent(),l=t.getCenter().x,h=t.getCenter().y,u=t._radiusX,g=t._radiusY,d=t.getDepth(),c=j.reflectAngleOverYAxis(i==j.SURFACE_LEFT?n+o:n,l,h,u,g),p=j._generateInnerPoints(l,h,c.x,c.y,d),_=[],f=0;f<p.length;f++)_.push(p[f].x,p[f].y);var v=new e.Polygon(s,_);return v.setFill(a),t.getStrokeColor()&&v.setSolidStroke(t.getStrokeColor()),v}if(r){var m=new e.Path(s,null);return m.setCmds(r),m.setTranslate(t.__getExplodeOffsetX(),t.__getExplodeOffsetY()),m.setFill(a),t.getStrokeColor()&&m.setSolidStroke(t.getStrokeColor()),m}return null},j._createCrustPathCommands=function(t){var e=t.getAngleStart(),i=t.getAngleExtent(),r=e+i,a=t.getCenter().x,s=t.getCenter().y,n=t._radiusX,o=t._radiusY,l=t.getDepth(),h=[];return e<180&&r>360?(h.push(j._makeOuterPath(a,s,n,o,l,e,180-e)),h.push(j._makeOuterPath(a,s,n,o,l,360,r-360)),h.push(j._makeOuterPath(a,s,n,o,l,180,180))):r>360?(h.push(j._makeOuterPath(a,s,n,o,l,e,360-e)),h.push(j._makeOuterPath(a,s,n,o,l,360,r-360))):e<180&&r>180?(h.push(j._makeOuterPath(a,s,n,o,l,e,180-e)),h.push(j._makeOuterPath(a,s,n,o,l,180,r-180))):h.push(j._makeOuterPath(a,s,n,o,l,e,i)),h},j._makeOuterPath=function(t,i,r,a,s,n,o){var l=e.Math.degreesToRads(o),h=-(e.Math.degreesToRads(n)+l),u=j.reflectAngleOverYAxis(n,t,i,r,a),g=t+Math.cos(h)*r,d=i+Math.sin(h)*a,c=e.PathUtils.moveTo(u.x,u.y);return c+=e.PathUtils.arcTo(r,a,l,0,g,d),c+=e.PathUtils.lineTo(g,d+s),c+=e.PathUtils.arcTo(r,a,l,1,u.x,u.y+s),c+=e.PathUtils.lineTo(u.x,u.y)},j._generateInnerPoints=function(t,e,i,r,a){var s=[];return s.push({x:t,y:e}),s.push({x:i,y:r}),s.push({x:i,y:r+a}),s.push({x:t,y:e+a}),s};
/**
   * @license
   * Copyright (c) 2008 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var V=function(){};e.Obj.createSubclass(V,e.Obj),V._MAX_LINES_PER_LABEL=3,V._COLLISION_MARGIN=1,V._LEFT_SIDE_LABELS=1,V._RIGHT_SIDE_LABELS=2,V._OUTSIDE_LABEL_DISTANCE=1.04,V._FEELER_RAD_MINSIZE=.1,V._FEELER_HORIZ_MINSIZE=.1,V._LABEL_TO_FEELER_OFFSET=.5,V._LABEL_TO_FEELER_DISTANCE=3,V._NO_COLLISION=0,V._HALF_COLLISION=1,V._ALL_COLLISION=2,V.layoutLabelsAndFeelers=function(t){var e=t.getLabelPosition();V._layoutInsideLabels(t,"auto"==e),V._layoutOutsideLabelsAndFeelers(t)},V._layoutInsideLabels=function(t,i){for(var r=t.__getSlices(),a=0;a<r.length;a++){var s=r[a],n=t.getSeriesLabelPosition(s.getSeriesIndex());if("none"!=n&&"outsideSlice"!=n&&!V._skipSliceLabel(t,s)){var o=s.getAngleStart()+s.getAngleExtent()/2,l=s.getInnerRadius(),h=s.getCenter(),u=0,g=0,d=V._createLabel(s,!0);if(1==r.length)u=h.x,g=h.y;else{var c=Math.max(.45,.65-.45*l/Math.max(s.getRadiusY(),.001)),p=j.reflectAngleOverYAxis(o,h.x,h.y,l+(s.getRadiusX()-l)*c,l+(s.getRadiusY()-l)*c);u=p.x,g=p.y}d.setX(u),d.setY(g),d.alignMiddle(),d.alignCenter();for(var _=d.getDimensions(),f=u,v=u,m=g-_.h/2,S=g+_.h/2;s.contains(f,m)&&s.contains(f,S);)f--;for(;s.contains(v,m)&&s.contains(v,S);)v++;f=Math.ceil(f+3),v=Math.floor(v-3);var C=2*Math.min(u-f,v-u);if(C<_.w&&(d.setX((f+v)/2),C=v-f),i&&"center"!=n){d.getDimensions().w<C?s.setSliceLabel(d):s.setSliceLabel(null)}else{var y=t.getCtx().getStage(),x=V._isTextLabel(t,s)?null:d.getTextString().length;e.TextUtils.fitText(d,C,_.h,y,x)&&(y.removeChild(d),s.setSliceLabel(d))}null!=s.getSliceLabel()&&s.setNoOutsideFeeler()}}},V._layoutOutsideLabelsAndFeelers=function(t){var e,i,r=V._generateInitialLayout(t);e=r[0],i=r[1];var a=V._refineInitialLayout(t,e,V._LEFT_SIDE_LABELS),s=V._refineInitialLayout(t,i,V._RIGHT_SIDE_LABELS);a==V._HALF_COLLISION&&s!=V._NO_COLLISION&&V._columnLabels(t,e,!0,!0,!0),a!=V._NO_COLLISION&&s==V._HALF_COLLISION&&V._columnLabels(t,i,!1,!0,!0),V._setLabelsAndFeelers(t,e,V._LEFT_SIDE_LABELS),V._setLabelsAndFeelers(t,i,V._RIGHT_SIDE_LABELS)},V._createLabel=function(t,i){var r=t.getPieChart(),a=r.getCtx(),s=i?new e.OutputText(a):new e.MultilineText(a),n=e.ColorUtils.getContrastingTextColor(t.getFillColor()),o=new e.CSSStyle({color:n}),l=r.getOptions().styleDefaults,h=[l._dataLabelStyle];i&&h.push(o),h.push(l.dataLabelStyle);var u=g.getDataItem(r.chart,t.getSeriesIndex(),0);u&&h.push(new e.CSSStyle(u.labelStyle)),e.Agent.isHighContrast()&&h.push(o);var d=e.CSSStyle.mergeStyles(h);s.setCSSStyle(d);var c=V.generateSliceLabelString(t,l.sliceLabelType);return s.setTextString(c),t.setSliceLabelString(c),s},V.createPieCenter=function(t){var i=t.getOptions(),r=t.getCtx(),a=V.getPieCenterOptions(i),s=a.label,n=a.renderer,o=t.getLabelPosition(),l=i.tooltip,h=l?l.renderer:null,g=t.getCenter(),d=t.getInnerRadius();if(s||n){var c=t.getRadiusX(),p=(d=d>0?d:"outsideSlice"==o?.9*c:.5*c)*Math.sqrt(2);if(s){var _=new e.MultilineText(r),f=a.labelStyle;if(_.setCSSStyle(f),"number"==typeof s&&(s=u.formatValue(t,a,s,s,s,0)),_.setTextString(s),e.TextUtils.fitText(_,p,p,t)){var v=_.getDimensions();_.setY(g.y-v.h/2),_.setX(g.x),_.alignCenter(),h||t.chart.getEventManager().associate(_,new e.SimpleObjPeer(_.getTextString(),null,null,{type:"pieCenterLabel"})),t.addChild(_),t.setCenterLabel(_)}}if(h){var m=new e.Circle(r,g.x,g.y,d);m.setInvisibleFill(),t.addChild(m);var S=t.getCtx().getTooltipManager();t.chart.getEventManager().associate(m,new e.CustomDatatipPeer(S,h,"#4b4b4b",{component:i._widgetConstructor,label:s}))}if(n){var C={outerBounds:{x:g.x-d,y:g.y-d,width:2*d,height:2*d},innerBounds:{x:g.x-p/2,y:g.y-p/2,width:p,height:p},label:s,totalValue:t.getTotalValue(),component:i._widgetConstructor};C=r.fixRendererContext(C);var y=r.getContainer(),x=t.chart.pieCenterDiv;x&&y.removeChild(x);var A=n(C);if(!A)return;var b=r.createOverlayDiv();Array.isArray(A)?A.forEach(function(t){b.appendChild(t)}):b.appendChild(A),t.chart.pieCenterDiv=b,y.appendChild(b);var M=r.getOverlayAttachedCallback();M&&M(b)}}},V.generateSliceLabelString=function(t,e){var i,r=V.getDefaultSliceLabelString(t,e),a=t.getPieChart().getOptions().dataLabel;if(a){var s=p.getDataContext(t._chart,t.getSeriesIndex(),0);if(s.label=r,"number"==typeof(i=a(s))){var n=u.getValueFormat(t.getPieChart().chart,"label");i=u.formatValue(t.getPieChart(),n,i)}}return i||r},V.getDefaultSliceLabelString=function(t,e){var i=t.getPieChart(),r=t.getCustomLabel(),a=u.getValueFormat(i.chart,"label");return null!=r?"number"==typeof r?u.formatValue(i,a,r):r:"percent"==e?V.generateSlicePercentageString(t):"number"==e?u.formatValue(i,a,t.getValue()):"text"==e?t.getSeriesLabel():"textAndPercent"==e?t.getSeriesLabel()+", "+V.generateSlicePercentageString(t):null},V.generateSlicePercentageString=function(t){var e=t.getPieChart(),i=e.getTotalValue(),r=0==i?0:t.getValue()/i,a=r<.01?3:r<.1?2:r<1?1:0;2*e.getRadiusX()<150&&(a=Math.max(a-1,0));var s=e.getCtx().getNumberConverter({style:"percent",maximumFractionDigits:a,minimumFractionDigits:a}),n="";return s&&s.format?n=s.format(r):(r*=100,n=u.formatValue(e,{},r,null,null,100==r?1:Math.pow(10,-1*a))+"%"),n},V._refineInitialLayout=function(t,e,i){if(e&&e.length>0){for(var r,a=t.__getFrame().y,s=!1,n=!1,o=!1,l=0,h=!1,u=h,g=i==V._LEFT_SIDE_LABELS,d=0;d<e.length;d++)u=h,(r=e[d]).getPosition()>90&&(h=!0),l=r.getY()+r.getHeight(),a-r.getY()>V._COLLISION_MARGIN&&(h?h&&!u?n=!0:o=!0:s=!0),l>a&&(a=l);return s&&o||n?(V._columnLabels(t,e,g,!0,!0),V._ALL_COLLISION):s?(V._columnLabels(t,e,g,!0,!1),V._HALF_COLLISION):o?(V._columnLabels(t,e,g,!1,!0),V._HALF_COLLISION):V._NO_COLLISION}},V._setLabelsAndFeelers=function(t,i,r){if(!(null==i||i.length<=0)){var a,s,n,o,l,h=r==V._LEFT_SIDE_LABELS,u=t.__getFrame(),g=1/0;for(a=0;a<i.length;a++)if(s=(o=i[a]).getSlice(),o.hasFeeler()){l=V._calculateFeeler(o,s,h);var d=e.TextUtils.getTextStringHeight(t.getCtx(),o.getSliceLabel().getCSSStyle()),c=o.getWidth(),p=V._isTextLabel(t,s)?Math.min(2*d,c):c;if(V.getMaxLabelWidth(t,o.getX(),h)+l<p||0==o.getWidth()){o.setSliceLabel(null),s.setNoOutsideFeeler();continue}g=Math.min(g,l)}else s.setNoOutsideFeeler();for(a=0;a<i.length;a++)s=(o=i[a]).getSlice(),(n=o.getSliceLabel())&&(o.hasFeeler()&&(h?o.setX(o.getX()+g):o.setX(o.getX()-g),V._calculateFeeler(o,s,h)),n.setY(o.getY()),n.setX(o.getX()),o.getY()<u.y||o.getY()+o.getHeight()>u.y+u.h?(s.setSliceLabel(null),s.setNoOutsideFeeler()):(V._truncateSliceLabel(t,s,o,h),0==o.getWidth()||0==o.getHeight()?(s.setSliceLabel(null),s.setNoOutsideFeeler()):s.setSliceLabel(n)))}},V._calculateFeeler=function(t,i,r){var a,s=t.getX(),n=t.getY()+t.getHeight()*V._LABEL_TO_FEELER_OFFSET,o=V._FEELER_HORIZ_MINSIZE*i.getRadiusX(),l={x:r?(s+=V._LABEL_TO_FEELER_DISTANCE)+o:(s-=V._LABEL_TO_FEELER_DISTANCE)-o,y:n},h={x:s,y:n},u=t.getAngle(),g=V._adjustForDepth(u,i.getDepth());a=j.reflectAngleOverYAxis(u,i.getCenter().x,i.getCenter().y+g,i.getRadiusX(),i.getRadiusY());var d=e.Math.degreesToRads(t.getPosition()),c=Math.abs(Math.atan2(l.x-a.x,a.y-l.y)),p=(a.y-l.y)*Math.tan(d);return(d>Math.PI/2&&c>Math.PI/2&&c<d||d<Math.PI/2&&c<Math.PI/2&&c>d)&&(l.x=r?a.x-p:a.x+p),i.setOutsideFeelerPoints(a,l,h),Math.abs(h.x-l.x)-o},V._adjustForDepth=function(t,e){var i=0;return t>189&&t<351&&(i=e),i},V._getMiddleLabel=function(t){for(var e=91,i=-1,r=0;r<t.length;r++){var a=t[r].getPosition();Math.abs(a-90)<e&&(e=Math.abs(a-90),i=r)}return i},V._setOptimalLabelPosition=function(t,i,r,a){i.setX(r);var s=t.getRadiusY()*(1+V._FEELER_RAD_MINSIZE),n=e.Math.degreesToRads(i.getPosition()),o=s*Math.cos(n),l=V._adjustForDepth(i.getAngle(),t.getDepth()),h=t.getCenter().y-o-i.getHeight()*V._LABEL_TO_FEELER_OFFSET+l;i.setY(i.boundY(h))},V._getRadFeelerAngle=function(t,e,i){var r=t.getSlice(),a=r.getCenter(),s=t.getAngle(),n=V._adjustForDepth(s,r.getDepth()),o=j.reflectAngleOverYAxis(s,a.x,a.y+n,r.getRadiusX(),r.getRadiusY());return Math.atan2(Math.abs(e-o.x),o.y-i)},V._columnLabels=function(t,i,r,a,s){var n,o,l,h=t.__getFrame(),u=h.y,g=h.y+h.h,d=0,c=t.getCenter().x,p=t.getRadiusX()*(1+V._FEELER_RAD_MINSIZE+V._FEELER_HORIZ_MINSIZE);for(l=r?(c-=p)+t.getRadiusX()*V._FEELER_HORIZ_MINSIZE:(c+=p)-t.getRadiusX()*V._FEELER_HORIZ_MINSIZE,n=0;n<i.length;n++)o=i[n],d=e.Math.degreesToRads(o.getPosition()),V._getRadFeelerAngle(o,l,u)-d>.45*Math.PI||V._skipSliceLabel(t,o.getSlice())?(i.splice(n,1),n--):(i[n].setMinY(u),u+=i[n].getHeight());for(n=i.length-1;n>=0;n--)o=i[n],(d=e.Math.degreesToRads(o.getPosition()))-V._getRadFeelerAngle(o,l,g)>.45*Math.PI||V._skipSliceLabel(t,o.getSlice())?i.splice(n,1):(g-=i[n].getHeight(),i[n].setMaxY(g));if(0!=i.length){var _=V._getMiddleLabel(i),f=i[_];a&&!s&&f.getMinY()+f.getHeight()>t.getCenter().y&&(s=!0),s&&!a&&f.getMaxY()<t.getCenter().y&&(a=!0);var v=f.getPosition();(s&&a||v>90&&s||v<=90&&a)&&(V._setOptimalLabelPosition(t,f,c,r),f.setHasFeeler(!0));var m,S,C=f.getY(),y=f.getY()+f.getHeight();if(a)for(n=_-1;n>=0;n--)S=(o=i[n]).getHeight(),V._setOptimalLabelPosition(t,o,c,r),o.setHasFeeler(!0),(m=o.getY())+S<C?C=m:C-=S,o.setY(C);if(s)for(n=_+1;n<i.length;n++)S=(o=i[n]).getHeight(),V._setOptimalLabelPosition(t,o,c,r),o.setHasFeeler(!0),(m=o.getY())>y?y=m+S:y+=S,o.setY(y-S)}},V._truncateSliceLabel=function(t,e,i,r){var a,s,n=i.getSliceLabel(),o=n.getCSSStyle(),l=t.getNumChildren(),h=!1;t.contains(n)||(t.addChild(n),h=!0),n.setCSSStyle(o);var u=e.getSliceLabelString();return n.setTextString(u),h&&t.removeChildAt(l),a=V.getMaxLabelWidth(t,i.getX(),r),s=V._getTextDimension(t,e,n,a,i.getInitialNumLines()),i.setWidth(s.x),i.getHeight()!=s.y&&(i.setHeight(s.y),!0)},V._generateInitialLayout=function(t){for(var e=new Array(2),i=[],r=[],a=t.__getSlices(),s=t.__getFrame(),n=0;n<a.length;n++){var o=a[n],l=t.getSeriesLabelPosition(o.getSeriesIndex());if(null==o.getSliceLabel()&&"none"!=l&&"center"!=l&&!V._skipSliceLabel(t,o)){var h=V._createLabel(o,!1),u=o.getAngleStart()+o.getAngleExtent()/2;u>360&&(u-=360),u<0&&(u+=360);var g=j.reflectAngleOverYAxis(u,t.getCenter().x,t.getCenter().y,t.getRadiusX()*V._OUTSIDE_LABEL_DISTANCE,t.getRadiusY()*V._OUTSIDE_LABEL_DISTANCE),d=u>=90&&u<270,c=V.getMaxLabelWidth(t,g.x,d),p=V._getTextDimension(t,o,h,c,V._MAX_LINES_PER_LABEL);u<165&&u>15?g.y-=1*p.y:u<15||u>345?(g.y-=.5*p.y,g.x+=.2*p.y):u>165&&u<195&&(g.y-=.5*p.y,g.x-=.2*p.y);var _,f=V._adjustForDepth(u,t.getDepth());if(g.y+=f,1==a.length&&(g.x-=p.x/2),!(g.y<s.y||g.y+p.y>s.y+s.h))u>=90&&u<270?(h.alignRight(),V._createLabelInfo(o,h,u,_=u-90,p,g,i)):(_=u<=90?Math.abs(90-u):180-(u-270),V._createLabelInfo(o,h,u,_,p,g,r))}}return e[0]=i,e[1]=r,e},V._createLabelInfo=function(t,e,i,r,a,s,n){for(var o,l=-1,h=e,u=0;u<n.length;u++)if((o=n[u]).getPosition()>r){l=u;break}-1==l&&(l=n.length),(o=new U).setPosition(r),o.setAngle(i),o.setSliceLabel(h),o.setSlice(t),o.setWidth(a.x),o.setHeight(a.y),o.setX(s.x),o.setY(s.y),o.setInitialNumLines(h.getLineCount()),n.splice(l,0,o)},V._getTextDimension=function(t,i,r,a,s){r.setMaxLines(s);var n=V._isTextLabel(t,i)?null:r.getTextString().length;if(e.TextUtils.fitText(r,a,1/0,t,n)){t.addChild(r);var o=r.getDimensions();return t.removeChild(r),{x:o.w,y:o.h}}return{x:0,y:0}},V._isTextLabel=function(t,e){var i=e.getCustomLabel(),r=null!=t.getOptions().dataLabel;return-1!=t.getOptions().styleDefaults.sliceLabelType.indexOf("text")||null!=i&&"number"!=typeof i||r},V.getMaxLabelWidth=function(t,e,i){var r=t.__getFrame();return i?e-r.x:r.x+r.w-e},V.getPieCenterOptions=function(t){var i=e.JsonUtils.clone(t.pieCenter),r=t.pieCenterLabel;if(r){var a=r.style,s=r.text;s&&(i.label=s),a&&(i.labelStyle=new e.CSSStyle(a))}return i},V._skipSliceLabel=function(t,e){return e.getAngleExtent()<3&&g.getSeriesCount(t.chart)>120};
/**
   * @license
   * Copyright (c) 2008 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var Y=function(t,e){this.Init(t,e)};e.Obj.createSubclass(Y,e.Obj),Y.THREED_TILT=.59,Y.prototype.Init=function(t,e){this._pieChart=t,this._chart=t.chart,this._angleStart=0,this._angleExtent=0,this._topSurface=null,this._leftSurface=null,this._rightSurface=null,this._crustSurface=null,this._explodeOffsetX=0,this._explodeOffsetY=0,this._sliceLabel=null,this._sliceLabelString=null,this._hasFeeler=!1,this._feelerRad=null,this._feelerHoriz=null,this._outsideFeelerStart=null,this._outsideFeelerMid=null,this._outsideFeelerEnd=null,this._selected=!1,this._selecting=!1,this._centerX=this._pieChart.getCenter().x,this._centerY=this._pieChart.getCenter().y,this._radiusX=this._pieChart.getRadiusX(),this._radiusY=this._pieChart.getRadiusY(),this._depth=this._pieChart.getDepth();var i=this._chart.getOptions();if(null!=e){var r=g.getDataItem(this._chart,e,0);this._value=g.getValue(this._chart,e,0),this._explode=c.getSliceExplode(this._chart,e),this._fillColor=p.getColor(this._chart,e,0),this._fillPattern=p.getPattern(this._chart,e,0),this._strokeColor=p.getBorderColor(this._chart,e),this._borderWidth=p.getBorderWidth(this._chart,e),this._customLabel=r?r.label:null,this._seriesLabel=g.getSeries(this._chart,e),this._drillable=g.isDataItemDrillable(this._chart,e,0),this._id=c.getSliceId(this._chart,e),this._seriesIndex=e,this._categories=g.getCategories(this._chart,e,0)}else this._value=c.getOtherValue(this._chart),this._explode=0,this._fillColor=i.styleDefaults.otherColor,this._fillPattern=null,this._strokeColor=i.styleDefaults.borderColor,this._borderWidth=i.styleDefaults.borderWidth,this._customLabel=null,this._seriesLabel=i.translations.labelOther,this._drillable=g.isMultiSeriesDrillEnabled(this._chart),this._id=c.getOtherSliceId(this._chart)},Y.prototype.getPieChart=function(){return this._pieChart},Y.prototype.render=function(t){for(var i=Y._sortPieSurfaces(this._topSurface,this._leftSurface,this._rightSurface,this._crustSurface,this._angleStart,this._angleExtent),r=i.length,a=0;a<r;a++)for(var s=i[a],n=s.length,o=0;o<n;o++){this._pieChart.__getShapesContainer().addChild(s[o]),s[o].render&&s[o].render()}if(this._sliceLabel&&(this._pieChart.addChild(this._sliceLabel),j.associate(this,[this._sliceLabel]),t?(this._pieChart.addChild(this._feelerRad),this._pieChart.addChild(this._feelerHoriz)):this._renderOutsideFeeler()),this._explodeSlice(),this._drillable||this._pieChart.chart.isSelectionSupported()){var l=this.getDisplayables();for(a=0;a<l.length;a++)l[a].setCursor(e.SelectionEffectUtils.getSelectingCursor())}var h=this.getTopDisplayable();h&&(h.setAriaRole("img"),this._updateAriaLabel())},Y.prototype._feelerFromPts=function(t,i){var r=new e.Line(this._pieChart.getCtx(),t.x,t.y,i.x,i.y),a=this._pieChart.getOptions().styleDefaults.pieFeelerColor,s=new e.Stroke(a);return r.setStroke(s),this._pieChart.addChild(r),r},Y.prototype._renderOutsideFeeler=function(){if(this._hasFeeler){var t=this._feelerFromPts(this._outsideFeelerStart,this._outsideFeelerMid),e=this._feelerFromPts(this._outsideFeelerMid,this._outsideFeelerEnd);this._feelerRad=t,this._feelerHoriz=e}},Y.prototype.preRender=function(){var t,i=this._bFillerSlice?"color":p.getSeriesEffect(this._chart),r=this.getFillColor(),a=this.getFillPattern();if("pattern"==i||null!=a)t=new e.PatternFill(a,r),i="pattern";else if("gradient"==i){var s=this._pieChart.is3D()?"3D":"2D",n=j.getGradientColors(e.ColorUtils.getRGB(r),s),o=j.getGradientAlphas(e.ColorUtils.getAlpha(r),s),l=[Math.floor(this._centerX-this._radiusX),Math.floor(this._centerY-this._radiusY),Math.ceil(2*this._radiusX),Math.ceil(2*this._radiusY)];t=new e.LinearGradientFill(270,n,o,[0,1],l)}else t=new e.SolidFill(r);if(this._topSurface=j.createTopSurface(this,t),this._depth>0||this._radiusX!=this._radiusY){var h="gradient"==i,u=new e.SolidFill(e.ColorUtils.getDarker(r,.4)),g=h?j.generateLateralGradientFill(this,j.SIDE):u,d=h?j.generateLateralGradientFill(this,j.CRUST):u;this._leftSurface=j.createLateralSurface(this,j.SURFACE_LEFT,g),this._rightSurface=j.createLateralSurface(this,j.SURFACE_RIGHT,g),this._crustSurface=j.createLateralSurface(this,j.SURFACE_CRUST,d)}this.setSliceLabel(null),this.setNoOutsideFeeler()},Y._sortPieSurfaces=function(t,e,i,r,a,s){var n=[];return e&&i&&r&&(a<=270&&a+s>270?(n.push(e),n.push(i),n.push(r)):a>270||a+s<=90?(n.push(e),n.push(r),n.push(i)):(n.push(i),n.push(r),n.push(e))),n.push(t),n},Y.oppositeDirection=function(t,e,i){return t-e>0!=t-i>0},Y.prototype._explodeSlice=function(){if(0!=this._explode){var t=this._angleExtent,i=(360-(this._angleStart+t/2))*e.Math.RADS_PER_DEGREE,r=this._pieChart.is3D()?Y.THREED_TILT:1,a=this._explode*this._pieChart.__calcMaxExplodeDistance();this._explodeOffsetX=Math.cos(i)*a,this._explodeOffsetY=Math.sin(i)*r*a,"safari"!==e.Agent.browser&&"blink"!==e.Agent.engine||(this._explodeOffsetX=Math.round(this._explodeOffsetX),this._explodeOffsetY=Math.round(this._explodeOffsetY))}else this._explodeOffsetX=0,this._explodeOffsetY=0;if(this._topSurface){var s=this._pieChart.is3D()&&this._topSurface[0].getSelectionOffset?this._topSurface[0].getSelectionOffset():[];Y._translateShapes(this._topSurface,s[0]?s[0]+this._explodeOffsetX:this._explodeOffsetX,s[1]?s[1]+this._explodeOffsetY:this._explodeOffsetY)}if(this._rightSurface&&Y._translateShapes(this._rightSurface,this._explodeOffsetX,this._explodeOffsetY),this._leftSurface&&Y._translateShapes(this._leftSurface,this._explodeOffsetX,this._explodeOffsetY),this._crustSurface&&Y._translateShapes(this._crustSurface,this._explodeOffsetX,this._explodeOffsetY),this._hasFeeler){var n=this._outsideFeelerStart.x,o=this._outsideFeelerStart.y,l=n+this._explodeOffsetX,h=o+this._explodeOffsetY;this._feelerRad.setX1(l),this._feelerRad.setY1(h);var u=this._outsideFeelerMid.x,g=this._outsideFeelerMid.y;Y.oppositeDirection(u,n,l)?(this._feelerRad.setX2(l),this._feelerHoriz.setX1(l)):(this._feelerRad.setX2(u),this._feelerHoriz.setX1(u)),Y.oppositeDirection(g,o,h)?(this._feelerRad.setY2(h),this._feelerHoriz.setY1(h)):(this._feelerRad.setY2(g),this._feelerHoriz.setY1(g))}this._sliceLabel&&!this._hasFeeler&&this._sliceLabel.setTranslate(this._explodeOffsetX,this._explodeOffsetY)},Y._translateShapes=function(t,e,i){if(t)for(var r=t.length,a=0;a<r;a++){t[a].setTranslate(e,i)}},Y.prototype.getRadiusX=function(){return this._radiusX},Y.prototype.getRadiusY=function(){return this._radiusY},Y.prototype.getCenter=function(){return new e.Point(this._centerX,this._centerY)},Y.prototype.getDepth=function(){return this._depth},Y.prototype.getAngleExtent=function(){return this._angleExtent},Y.prototype.setAngleExtent=function(t){this._angleExtent=t},Y.prototype.getAngleStart=function(){return this._angleStart},Y.prototype.setAngleStart=function(t){this._angleStart=t},Y.prototype.__getExplodeOffsetX=function(){return this._explodeOffsetX},Y.prototype.__getExplodeOffsetY=function(){return this._explodeOffsetY},Y.prototype.setOutsideFeelerPoints=function(t,e,i){this._outsideFeelerStart=t,this._outsideFeelerMid=e,this._outsideFeelerEnd=i,this._hasFeeler=!0},Y.prototype.setNoOutsideFeeler=function(){this._outsideFeelerStart=null,this._outsideFeelerMid=null,this._outsideFeelerEnd=null,this._hasFeeler=!1},Y.prototype.getLabelAndFeeler=function(){var t=[];return this._sliceLabel&&t.push(this._sliceLabel),this._feelerRad&&t.push(this._feelerRad),this._feelerHoriz&&t.push(this._feelerHoriz),t},Y.prototype.getSliceLabel=function(){return this._sliceLabel},Y.prototype.setSliceLabel=function(t){this._sliceLabel=t},Y.prototype.getSliceLabelString=function(){return this._sliceLabelString},Y.prototype.setSliceLabelString=function(t){this._sliceLabelString=t},Y.prototype.getTopSurface=function(){return this._topSurface},Y.prototype.getValue=function(){return this._value},Y.prototype.getId=function(){return this._id},Y.prototype.getSeriesIndex=function(){return this._seriesIndex},Y._shapeIsSelectable=function(t){return t instanceof G},Y.prototype.contains=function(t,e){for(var i=this._pieChart.getInnerRadius(),r=this._pieChart.getCenter(),a=(t-r.x)/this._radiusX,s=(e-r.y)/this._radiusY,n=-Math.atan2(s,a)*(180/Math.PI);n<this._angleStart;)n+=360;for(;n-this._angleStart>=360;)n-=360;var o=Math.pow(a,2)+Math.pow(s,2),l=Math.sqrt(o)>i/this._radiusX&&o<=1,h=n<=this._angleStart+this._angleExtent;return l&&h},Y.prototype.GetAnimationParams=function(){var t=e.ColorUtils.getRed(this._fillColor),i=e.ColorUtils.getGreen(this._fillColor),r=e.ColorUtils.getBlue(this._fillColor),a=e.ColorUtils.getAlpha(this._fillColor);return[this._value,this._radiusX,this._radiusY,this._explode,this._centerX,this._centerY,this._depth,t,i,r,a]},Y.prototype.SetAnimationParams=function(t){this._value=t[0],this._radiusX=t[1],this._radiusY=t[2],this._explode=t[3],this._centerX=t[4],this._centerY=t[5],this._depth=t[6];var i=Math.round(t[7]),r=Math.round(t[8]),a=Math.round(t[9]),s=Math.round(t[10]);this._fillColor=e.ColorUtils.makeRGBA(i,r,a,s)},Y.prototype.getDeletedAnimationParams=function(){var t=this.GetAnimationParams();return t[0]=0,t[1]=this.getInnerRadius(),t[2]=this.getInnerRadius(),t[3]=0,t},Y.prototype.animateUpdate=function(t,i){var r=i.GetAnimationParams(),a=this.GetAnimationParams();if(!e.ArrayUtils.equals(r,a)){var s=new e.CustomAnimation(this._pieChart.getCtx(),this,this.getPieChart().getAnimationDuration());s.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this,this.GetAnimationParams,this.SetAnimationParams,a),t.add(s,0),this.SetAnimationParams(r)}},Y.prototype.animateInsert=function(t){var i=new e.CustomAnimation(this._pieChart.getCtx(),this,this.getPieChart().getAnimationDuration());i.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this,this.GetAnimationParams,this.SetAnimationParams,this.GetAnimationParams()),t.add(i,0),this.SetAnimationParams(this.getDeletedAnimationParams())},Y.prototype.animateDelete=function(t,i){var r=i.__getSlices(),a=this.getPieChart().__getSlices(),s=a.indexOf(this)-1;if(s>=0){for(var n=a[s].getId(),o=0;o<r.length;o++)if(r[o].getId().equals(n)){r.splice(o+1,0,this);break}}else r.splice(0,0,this);this._pieChart=i;var l=new e.CustomAnimation(i.getCtx(),this,this.getPieChart().getAnimationDuration());l.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this,this.GetAnimationParams,this.SetAnimationParams,this.getDeletedAnimationParams()),l.setOnEnd(this._removeDeletedSlice,this),t.add(l,0)},Y.prototype._removeDeletedSlice=function(){var t=this.getPieChart().__getSlices(),e=t.indexOf(this);e>=0&&t.splice(e,1)},Y.prototype.getDisplayables=function(){var t=new Array;return this._topSurface&&(t=t.concat(this._topSurface)),this._leftSurface&&(t=t.concat(this._leftSurface)),this._rightSurface&&(t=t.concat(this._rightSurface)),this._crustSurface&&(t=t.concat(this._crustSurface)),this._sliceLabel&&t.push(this._sliceLabel),this._feelerRad&&t.push(this._feelerRad),this._feelerHoriz&&t.push(this._feelerHoriz),t},Y.prototype.getAriaLabel=function(){var t,i=this._pieChart.getOptions().translations;t=null==this._seriesIndex?v.getOtherSliceDatatip(this._chart,this._value,!1):v.getDatatip(this._chart,this._seriesIndex,0,null,!1);var r=i.labelPercentage,a=V.generateSlicePercentageString(this);t+="; "+e.ResourceUtils.format(i.labelAndValue,[r,a]);var s=[];return this.isSelectable()&&s.push(i[this.isSelected()?"stateSelected":"stateUnselected"]),g.isDataItemDrillable(this._chart,this._seriesIndex,this._groupIndex)&&s.push(i.stateDrillable),e.Displayable.generateAriaLabel(t,s)},Y.prototype._updateAriaLabel=function(){var t=this.getTopDisplayable();t&&!e.Agent.deferAriaCreation()&&t.setAriaProperty("label",this.getAriaLabel())},Y.prototype.getTopDisplayable=function(){return this._topSurface&&this._topSurface.length>0?this._topSurface[0]:null},Y.prototype.isSelectable=function(){return this._chart.isSelectionSupported()},Y.prototype.isSelected=function(){return this._selected},Y.prototype.setSelected=function(t,i){if(this._selected=t,this.getTopSurface()){if(this._selected?this._pieChart.bringToFrontOfSelection(this):this._selecting||this._pieChart.pushToBackOfSelection(this),p.isSelectionHighlighted(this._chart))for(var r=this.getDisplayables(),a=0;a<r.length;a++)Y._shapeIsSelectable(r[a])&&r[a].setSelected(t);if(p.isSelectionExploded(this._chart)){var s=t?1:0;if(i||"none"==p.getAnimationOnDataChange(this._chart))this.setExplode(s);else{var n=new e.CustomAnimation(this._pieChart.getCtx(),this,this._pieChart.getAnimationDuration()/2);n.getAnimator().addProp(e.Animator.TYPE_NUMBER,this,this.getExplode,this.setExplode,s),n.play()}}this._updateAriaLabel()}},Y.prototype.showHoverEffect=function(){this._selecting=!0,this._pieChart.bringToFrontOfSelection(this);for(var t=this.getDisplayables(),e=0;e<t.length;e++)Y._shapeIsSelectable(t[e])&&t[e].showHoverEffect()},Y.prototype.hideHoverEffect=function(){this._selecting=!1,this._selected||this._pieChart.pushToBackOfSelection(this);for(var t=this.getDisplayables(),e=0;e<t.length;e++)Y._shapeIsSelectable(t[e])&&t[e].hideHoverEffect()},Y.prototype.getDatatip=function(t,e,i){return t==this._sliceLabel&&this._sliceLabel&&this._sliceLabel.isTruncated()?this.getSliceLabelString():this.getTooltip()},Y.prototype.getDatatipColor=function(){return this.getFillColor()},Y.prototype.getCategories=function(){return this._categories&&this._categories.length>0?this._categories:[this.getId().series]},Y.prototype.getNextNavigable=function(t){var i=t.keyCode;if(t.type==e.MouseEvent.CLICK)return this;if(i==e.KeyboardEvent.SPACE&&t.ctrlKey)return this;var r=e.Agent.isRightToLeft(this._chart.getCtx()),a=this._pieChart.__getSlices(),s=a.indexOf(this),n=null;return i==e.KeyboardEvent.RIGHT_ARROW||i==e.KeyboardEvent.DOWN_ARROW&&!r||i==e.KeyboardEvent.UP_ARROW&&r?n=s<a.length-1?a[s+1]:a[0]:(i==e.KeyboardEvent.LEFT_ARROW||i==e.KeyboardEvent.DOWN_ARROW&&r||i==e.KeyboardEvent.UP_ARROW&&!r)&&(n=0==s?a[a.length-1]:a[s-1]),n},Y.prototype.getKeyboardBoundingBox=function(t){var i=this.getDisplayables();return i[0]?i[0].getDimensions(t):new e.Rectangle(0,0,0,0)},Y.prototype.getTargetElem=function(){var t=this.getDisplayables();return t[0]?t[0].getElem():null},Y.prototype.showKeyboardFocusEffect=function(){this._isShowingKeyboardFocusEffect=!0,this.showHoverEffect()},Y.prototype.hideKeyboardFocusEffect=function(){this._isShowingKeyboardFocusEffect=!1,this.hideHoverEffect()},Y.prototype.isShowingKeyboardFocusEffect=function(){return this._isShowingKeyboardFocusEffect},Y.prototype.isDragAvailable=function(t){return!0},Y.prototype.getDragTransferable=function(t,e){return[this.getId()]},Y.prototype.getDragFeedback=function(t,e){if(this._chart.isSelectionSupported()&&this._chart.getSelectionHandler().getSelectedCount()>1){for(var i=this._chart.getSelectionHandler().getSelection(),r=[],a=0;a<i.length;a++)r=r.concat(i[a].getDisplayables());return r}return this.getDisplayables()},Y.prototype.getExplode=function(){return this._explode},Y.prototype.setExplode=function(t){this._explode=t,this._explodeSlice()},Y.prototype.getCustomLabel=function(){return this._customLabel},Y.prototype.getSeriesLabel=function(){return this._seriesLabel},Y.prototype.getFillColor=function(){return this._fillColor},Y.prototype.getFillPattern=function(){return this._fillPattern},Y.prototype.getStrokeColor=function(){return this._strokeColor},Y.prototype.getBorderWidth=function(){return this._borderWidth},Y.prototype.getSliceGaps=function(){return 0==this._depth?3*p.getDataItemGaps(this._chart):0},Y.prototype.getInnerRadius=function(){return this._pieChart.getInnerRadius()},Y.prototype.getTooltip=function(){return null==this._seriesIndex?v.getOtherSliceDatatip(this._chart,this._value,!0):v.getDatatip(this._chart,this._seriesIndex,0,null,!0)},Y.prototype.isDrillable=function(){return this._drillable},Y.createFillerSlice=function(t,e){var i=new Y(t);return i._value=e,i._bFillerSlice=!0,i._centerX=t.getCenter().x,i._centerY=t.getCenter().y,i._fillColor="rgba(255,255,255,0)",i._strokeColor="rgba(255,255,255,0)",i._id=new o(null,null,null,null),i},Y.prototype.getSeriesIndex=function(){return this._seriesIndex};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var W=function(t){this._chart=t,this._options=this._chart.getOptions(),this._legend=this._chart.legend,this._xAxis=this._chart.xAxis,this._yAxis=this._chart.yAxis,this._y2Axis=this._chart.y2Axis,this._legendAutomation=this._legend?this._legend.getAutomation():null,this._xAxisAutomation=this._xAxis?this._xAxis.getAutomation():null,this._yAxisAutomation=this._yAxis?this._yAxis.getAutomation():null,this._y2AxisAutomation=this._y2Axis?this._y2Axis.getAutomation():null};e.Obj.createSubclass(W,e.Automation),W.PLOT_AREA_SUBID="plotArea",W.PIE_CENTER_LABEL_SUBID="pieCenterLabel",W.prototype.GetSubIdForDomElement=function(t){var i=null;if(t.isDescendantOf(this._xAxis))return(i=this._xAxisAutomation.GetSubIdForDomElement(t))?this._convertAxisSubIdToChartSubId(i,"xAxis"):null;if(t.isDescendantOf(this._yAxis))return(i=this._yAxisAutomation.GetSubIdForDomElement(t))?this._convertAxisSubIdToChartSubId(i,"yAxis"):null;if(t.isDescendantOf(this._y2Axis))return(i=this._y2AxisAutomation.GetSubIdForDomElement(t))?this._convertAxisSubIdToChartSubId(i,"y2Axis"):null;if(t.isDescendantOf(this._legend)){var r=this._legendAutomation.GetSubIdForDomElement(t);return r?this._convertLegendSubIdToChartSubId(r):null}var a=this._chart.getEventManager().GetLogicalObject(t);if(!a)return null;if(a instanceof e.SimpleObjPeer){var s=a.getParams().type;if("pieCenterLabel"==s)return W.PIE_CENTER_LABEL_SUBID;if("plotArea"==s)return W.PLOT_AREA_SUBID}if(a instanceof Y)return"dataItem["+a.getSeriesIndex()+"]";if(a instanceof m){var n=a.getSeriesIndex(),o=a.getGroupIndex();if(null!=n&&o>=0&&("funnel"!=this._options.type||"pyramid"!=this._options.type))return"dataItem["+n+"]["+o+"]";if(null!=n&&o==F._GROUP_INDEX&&("funnel"==this._options.type||"pyramid"==this._options.type))return"dataItem["+n+"]";if(null!=n&&(null==o||o<0))return"series["+n+"]"}else if(a instanceof S){var l=a.getAxisType(),h=a.getIndex();return l&&h>=0?l+":referenceObject["+h+"]":null}return null},W.prototype._convertLegendSubIdToChartSubId=function(t){var e=this._legend.getOptions(),i=this._legendAutomation.getLegendItem(e,t);if(i){for(var r=0;r<this._options.series.length;r++){if(this._options.series[r].name==i.text)return"series["+r+"]"}return"legend:"+t}return null},W.prototype._convertAxisSubIdToChartSubId=function(t,e){if("title"==t&&e)return e+":"+t;var i=t.substring(t.indexOf("["));return i?"group"+i:null},W.prototype.getDomElementForSubId=function(t){if(t==e.Automation.TOOLTIP_SUBID)return this.GetTooltipElement(this._chart,v.isDataCursorEnabled(this._chart)?_.TOOLTIP_ID:null);if(t==W.PIE_CENTER_LABEL_SUBID)return this._chart.pieChart.getCenterLabel().getElem();if(t==W.PLOT_AREA_SUBID)return this._chart.getPlotArea().getElem();var i,r,a,s=t.indexOf("["),n=t.indexOf("]"),o=t.indexOf(":");if(s>0&&n>0||o>0){var l=o<0?t.substring(0,s):t.substring(0,o);if("group"==l)return this._xAxisAutomation.getDomElementForSubId(t);if("series"==l)return t=this._convertToLegendSubId(t),this._legendAutomation.getDomElementForSubId(t);if("legend"==t.substring(0,o))return t=t.substring(o+1),this._legendAutomation.getDomElementForSubId(t);var h,u=t.substring(s+1,n);if("xAxis"==l||"yAxis"==l||"y2Axis"==l){var g=t.substring(o+1);if("title"==g){if("xAxis"==l)return this._xAxisAutomation.getDomElementForSubId(g);if("yAxis"==l)return this._yAxisAutomation.getDomElementForSubId(g);if("y2Axis"==l)return this._y2AxisAutomation.getDomElementForSubId(g)}else if(i=g.indexOf("["),r=g.indexOf("]"),"referenceObject"==g.substring(0,i)){var d=g.substring(i+1,r);if(a=this._getRefObjPeer(d))return a.getDisplayables()[0].getElem()}}if("pie"==this._options.type){var c=this._chart.pieChart.getSliceDisplayable(u);if(c)return c.getElem()}if("funnel"==this._options.type?h=F._GROUP_INDEX:"pyramid"==this._options.type?h=H._GROUP_INDEX:(i=(t=t.substring(n+1)).indexOf("["),r=t.indexOf("]"),i>=0&&r>=0&&(h=t.substring(i+1,r))),a=this._getChartObjPeer(u,h))return a.getDisplayables()[0].getElem()}return null},W.prototype._getChartObjPeer=function(t,e){for(var i=this._chart.getChartObjPeers(),r=0;r<i.length;r++){var a=i[r].getSeriesIndex(),s=i[r].getGroupIndex();if(a==t&&s==e)return i[r]}return null},W.prototype._getRefObjPeer=function(t){for(var e=this._chart.getRefObjPeers(),i=0;i<e.length;i++)if(t==e[i].getIndex())return e[i];return null},W.prototype._convertToLegendSubId=function(t){var e=t.indexOf("["),i=t.indexOf("]"),r=t.substring(e+1,i),a=this._legend.getOptions(),s=this._options.series[r];return"section"+this._legendAutomation.getIndicesFromSeries(s,a)},W.prototype.getDataItem=function(t,e){"pie"!=this._options.type&&"funnel"!=this._options.type&&"pyramid"!=this._options.type||(e=0);var i=g.getDataItem(this._chart,t,e);return i?{borderColor:p.getBorderColor(this._chart,t,e),color:p.getColor(this._chart,t,e),label:p.getDataLabel(this._chart,t,e),targetValue:g.getTargetValue(this._chart,t,e),tooltip:v.getDatatip(this._chart,t,e,null,!1),value:g.getValue(this._chart,t,e),open:i.open,close:i.close,high:g.getHighValue(this._chart,t,e),low:g.getLowValue(this._chart,t,e),volume:i.volume,x:g.getXValue(this._chart,t,e),y:i.y,z:i.z,min:i.min,max:i.max,group:g.getGroup(this._chart,e),series:g.getSeries(this._chart,t),selected:g.isDataSelected(this._chart,t,e)}:null},W.prototype.getGroup=function(t){return g.getGroup(this._chart,t)},W.prototype.getSeries=function(t){return this._options.series[t].name},W.prototype.getGroupCount=function(){return g.getGroupCount(this._chart)},W.prototype.getSeriesCount=function(){return this._options.series.length},W.prototype.getTitle=function(){return this._options.title.text},W.prototype.getLegend=function(){var t=this._legend.__getBounds(),i=this._legend.localToStage(new e.Point(t.x,t.y));return{bounds:{x:i.x,y:i.y,width:t.w,height:t.h},title:this._legend.getOptions().title}},W.prototype.getPlotArea=function(){var t=this._chart.__getPlotAreaSpace();return{bounds:{x:t.x,y:t.y,width:t.w,height:t.h}}},W.prototype.getXAxis=function(){return this._getAxis("x")},W.prototype.getYAxis=function(){return this._getAxis("y")},W.prototype.getY2Axis=function(){return this._getAxis("y2")},W.prototype._getAxis=function(t){var i="x"==t?this._xAxis:"y"==t?this._yAxis:this._y2Axis;if(i){var r=i.__getBounds(),a=i.localToStage(new e.Point(r.x,r.y)),s={x:a.x,y:a.y,width:r.w,height:r.h},n=this._chart;return{bounds:s,title:this._options[t+"Axis"].title,getPreferredSize:function(e,r){var a,s=i.getOptions(),o=s.position,l=L.getTickLabelGapSize(n,t),h=L.isStandaloneXAxis(n)||L.isStandaloneYAxis(n)||L.isStandaloneY2Axis(n)?2:0;return"top"==o||"bottom"==o?(a=i.getPreferredSize(s,e,r-l-h)).h=Math.ceil(a.h+l+h):(a=i.getPreferredSize(s,e-l-h,r)).w=Math.ceil(a.w+l+h),{width:a.w,height:a.h}}}}return null},e.Automation.prototype.IsTooltipElement=function(t){var i=t.getAttribute("id");return!(!i||0!=i.indexOf(_.TOOLTIP_ID)&&0!=i.indexOf(e.HtmlTooltipManager._TOOLTIP_DIV_ID))};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var z=function(t){z.superclass.Init.call(this,t.getCtx(),t.processEvent,t,t),this._chart=t,this._dragMode=null,this._dragButtonsVisible=e.Agent.isTouchDevice(),this.panButton=null,this.zoomButton=null,this.selectButton=null,this._dataCursorHandler=null,this._panZoomHandler=null,this._marqueeZoomHandler=null,this._marqueeSelectHandler=null};e.Obj.createSubclass(z,e.EventManager),z.DRAG_MODE_PAN="pan",z.DRAG_MODE_ZOOM="zoom",z.DRAG_MODE_SELECT="select",z.DRAG_MODE_OFF="off",z.prototype.addListeners=function(t){e.SvgDocumentUtils.addDragListeners(this._chart,this._onDragStart,this._onDragMove,this._onDragEnd,this),z.superclass.addListeners.call(this,t),e.Agent.isTouchDevice()||t.addEvtListener(e.MouseEvent.MOUSEWHEEL,this.OnMouseWheel,!1,this)},z.prototype.RemoveListeners=function(t){z.superclass.RemoveListeners.call(this,t),e.Agent.isTouchDevice()||t.removeEvtListener(e.MouseEvent.MOUSEWHEEL,this.OnMouseWheel,!1,this)},z.prototype.getLogicalObject=function(t){return this.GetLogicalObject(t,!0)},z.prototype._getDragHandler=function(t){return t&&"user"==this._chart.getOptions().dragMode&&l.isBLAC(this._chart)&&(this._dragMode==z.DRAG_MODE_PAN||this._dragMode==z.DRAG_MODE_ZOOM)&&(this._panZoomHandler&&this._panZoomHandler.isWithinBounds(t)?this._dragMode=z.DRAG_MODE_PAN:this._dragMode=z.DRAG_MODE_ZOOM),this._dragMode==z.DRAG_MODE_PAN?this._panZoomHandler:this._dragMode==z.DRAG_MODE_ZOOM?this._marqueeZoomHandler:this._dragMode==z.DRAG_MODE_SELECT?this._marqueeSelectHandler:null},z.prototype._onDragStart=function(t){return e.Agent.isTouchDevice()?this._onTouchDragStart(t):this._onMouseDragStart(t)},z.prototype._onDragMove=function(t){return e.Agent.isTouchDevice()?this._onTouchDragMove(t):this._onMouseDragMove(t)},z.prototype._onDragEnd=function(t){return e.Agent.isTouchDevice()?this._onTouchDragEnd(t):this._onMouseDragEnd(t)},z.prototype._onMouseDragStart=function(t){var e,i=this._context.pageToStageCoords(t.pageX,t.pageY),r=this._getDragHandler(i),a=this.GetLogicalObject(t.target);return!(a&&a.isSelectable&&a.isSelectable())&&0==t.button&&r&&((e=r.processDragStart(i,t.ctrlKey))&&this._callback.call(this._callbackObj,e),this._chart.setCursor(r.getCursor(i)),this.setDragButtonsVisible(!1),this._chart!=this.getCtx().getCurrentKeyboardFocus()&&this.getCtx().setCurrentKeyboardFocus(this._chart)),!!e&&(this._dataCursorHandler&&this._dataCursorHandler.processEnd(),!0)},z.prototype._onMouseDragMove=function(t){var e,i=this._context.pageToStageCoords(t.pageX,t.pageY),r=this._getDragHandler();r&&(e=r.processDragMove(i,t.ctrlKey))&&(this._callback.call(this._callbackObj,e),this.setDragButtonsVisible(!1)),e&&t.stopPropagation()},z.prototype._onMouseDragEnd=function(t){var e,i=this._context.pageToStageCoords(t.pageX,t.pageY),r=this._getDragHandler();if(r){(e=r.processDragEnd(i,t.ctrlKey))&&(this._callback.call(this._callbackObj,e),this.autoToggleZoomButton()),this._chart.setCursor(r.getCursor(i));var a=this._chart.__getAxisSpace();a&&this.setDragButtonsVisible(a.containsPoint(i.x,i.y))}},z.prototype.OnMouseMove=function(t){z.superclass.OnMouseMove.call(this,t);var i=this._context.pageToStageCoords(t.pageX,t.pageY);this._dataCursorHandler&&(this.GetLogicalObjectAndDisplayable(t.target).displayable instanceof e.IconButton?this._dataCursorHandler.processEnd():this._dataCursorHandler.processMove(i));var r=this._getDragHandler(i);r?this._chart.setCursor(r.getCursor(i)):this._chart.setCursor("default")},z.prototype.OnMouseOut=function(t){z.superclass.OnMouseOut.call(this,t);var e=this._context.pageToStageCoords(t.pageX,t.pageY),i=this._chart.__getAxisSpace();i&&this.setDragButtonsVisible(i.containsPoint(e.x,e.y)),this._dataCursorHandler&&this._dataCursorHandler.processOut(e);this.GetLogicalObject(t.target)},z.prototype.OnMouseWheel=function(t){if(E.isZoomable(this._chart)){var e=null!=t.wheelDelta?t.wheelDelta:0,i=this._context.pageToStageCoords(t.pageX,t.pageY);if(this._panZoomHandler){var r=this._panZoomHandler.processMouseWheel(i,e);r&&(t.preventDefault(),t.stopPropagation(),this._callback.call(this._callbackObj,r),this._dataCursorHandler&&this._dataCursorHandler.processMove(i))}}},z.prototype.ShowFocusEffect=function(t,i){if(this._dataCursorHandler){var r=i.getDataPosition();if(r){var a=this._chart.__getPlotAreaSpace();this._dataCursorHandler.processMove(new e.Point(r.x+a.x,r.y+a.y))}}z.superclass.ShowFocusEffect.call(this,t,i)},z.prototype.OnBlur=function(t){this._dataCursorHandler&&this._dataCursorHandler.processEnd(),z.superclass.OnBlur.call(this,t)},z.prototype.OnClickInternal=function(t){var e=this.GetLogicalObject(t.target),i=this._context.pageToStageCoords(t.pageX,t.pageY);this.SeriesFocusHandler&&this.SeriesFocusHandler.processSeriesFocus(i,e),e&&(e.isSelectable&&e.isSelectable()||this.processDrillEvent(e))},z.prototype.OnDblClickInternal=function(t){var e=this.GetLogicalObject(t.target);e&&e.isSelectable&&e.isSelectable()&&this.processDrillEvent(e)},z.prototype.HandleTouchHoverStartInternal=function(t){if(this._dataCursorHandler&&!this.isTouchResponseTouchStart()){var e=this._context.pageToStageCoords(t.touch.pageX,t.touch.pageY);return this._dataCursorHandler.processMove(e),!1}var i=this.GetLogicalObject(t.target);return this.TouchManager.setTooltipEnabled(t.touch.identifier,this.getTooltipsEnabled(i)),!1},z.prototype.HandleTouchHoverMoveInternal=function(t){if(this._dataCursorHandler&&!this.isTouchResponseTouchStart()){var e=this._context.pageToStageCoords(t.touch.pageX,t.touch.pageY);return this._dataCursorHandler.processMove(e),!1}var i=this.GetLogicalObject(t.target);return this.TouchManager.setTooltipEnabled(t.touch.identifier,this.getTooltipsEnabled(i)),!1},z.prototype.HandleTouchHoverEndInternal=function(t){this.endDrag();var e=this.GetLogicalObject(t.target);e&&(e.isSelectable&&e.isSelectable()||this.processDrillEvent(e))},z.prototype.HandleTouchClickInternal=function(t){var e=this.GetLogicalObject(t.target);e&&(e.isSelectable&&e.isSelectable()||this.processDrillEvent(e))},z.prototype.HandleTouchDblClickInternal=function(t){var e=this.GetLogicalObject(t.target);e&&e.isSelectable&&e.isSelectable()&&(t.preventDefault(),t.stopPropagation(),this.processDrillEvent(e))},z.prototype.processDrillEvent=function(t){if(t&&t.isDrillable&&t.isDrillable()){var i=t.getId();if(t instanceof m)this.FireEvent(e.EventFactory.newChartDrillEvent(null!=i.id?i.id:i,t.getSeries(),t.getGroup(),"item"));else if(t instanceof Y){var r="_dvtOther"===i.series?"multiSeries":"item";this.FireEvent(e.EventFactory.newChartDrillEvent(i.id,i.series,i.group,r))}}},z.prototype.ProcessRolloverEvent=function(t,i,r){var a=this._chart.getOptions();if("dim"==E.getHoverBehavior(this._chart)){var s=i.getCategories?i.getCategories():[];a.highlightedCategories=r?s.slice():null;var n=e.EventFactory.newCategoryHighlightEvent(a.highlightedCategories,r),o=p.getHoverBehaviorDelay(this._chart),l=this._chart.getObjects();this._chart.pieChart&&(l=l.concat(this._chart.pieChart.__getSlices())),this.RolloverHandler.processEvent(n,l,o,"any"==a.highlightMatch)}},z.prototype._onTouchDragStart=function(t){var e,i,r=t.touches;if(1==r.length){var a=this._context.pageToStageCoords(r[0].pageX,r[0].pageY),s=this._getDragHandler();s?e=s.processDragStart(a,!0):this._dataCursorHandler&&this.isTouchResponseTouchStart()&&(this._dataCursorHandler.processMove(a),i=!0)}else if(2==r.length&&this._panZoomHandler&&E.isZoomable(this._chart)){this.endDrag();var n=this._context.pageToStageCoords(r[0].pageX,r[0].pageY),o=this._context.pageToStageCoords(r[1].pageX,r[1].pageY);e=this._panZoomHandler.processPinchStart(n,o)}return e&&(this._callback.call(this._callbackObj,e),this.getCtx().getTooltipManager().hideTooltip()),!(!e&&!i)&&(t.preventDefault(),t.stopPropagation(),this.setDragButtonsVisible(!1),!0)},z.prototype._onTouchDragMove=function(t){var e,i,r=t.touches;if(1==r.length){var a=this._context.pageToStageCoords(r[0].pageX,r[0].pageY),s=this._getDragHandler();s?e=s.processDragMove(a,!0):this._dataCursorHandler&&this.isTouchResponseTouchStart()&&(this._dataCursorHandler.processMove(a),i=!0)}else if(2==r.length&&this._panZoomHandler&&E.isZoomable(this._chart)){var n=this._context.pageToStageCoords(r[0].pageX,r[0].pageY),o=this._context.pageToStageCoords(r[1].pageX,r[1].pageY);e=this._panZoomHandler.processPinchMove(n,o)}(e||i)&&t.preventDefault(),e&&(this._callback.call(this._callbackObj,e),this.getCtx().getTooltipManager().hideTooltip())},z.prototype._onTouchDragEnd=function(t){var e,i=this.endDrag();if(this._panZoomHandler&&E.isZoomable(this._chart)&&(e=this._panZoomHandler.processPinchEnd())&&this._callback.call(this._callbackObj,e),i||e){t.preventDefault(),this.getCtx().getTooltipManager().hideTooltip();var r=this.getTouchManager(),a=1==t.changedTouches.length?t.changedTouches[0].identifier:null,s=null!=a?r.getTouchInfo(a):null;s&&!s.touchMoved||r.reset()}this.setDragButtonsVisible(!0)},z.prototype.endDrag=function(){var t,e=this._getDragHandler();return e&&(t=e.processDragEnd(null,!0)),this._dataCursorHandler&&this._dataCursorHandler.processEnd(),t&&this._callback.call(this._callbackObj,t),t},z.prototype.zoomBy=function(t){if(this._panZoomHandler&&E.isZoomable(this._chart)){var e=this._panZoomHandler.zoomBy(t);e&&this._callback.call(this._callbackObj,e)}},z.prototype.panBy=function(t,e){if(this._panZoomHandler&&E.isScrollable(this._chart)){var i=this._panZoomHandler.panBy(t,e);i&&this._callback.call(this._callbackObj,i)}},z.prototype.hideHoverFeedback=function(){this.hideTooltip(),this._dataCursorHandler&&this._dataCursorHandler.processEnd()},z.prototype.hideTooltip=function(){this._dataCursorHandler&&this._dataCursorHandler.isDataCursorShown()||z.superclass.hideTooltip.call(this)},z.prototype.getTooltipsEnabled=function(t){return(!this._dataCursorHandler||!(t instanceof m||t instanceof S||this._dataCursorHandler.isDataCursorShown()))&&z.superclass.getTooltipsEnabled.call(this)},z.prototype.getDataCursorHandler=function(){return this._dataCursorHandler},z.prototype.setDataCursorHandler=function(t){this._dataCursorHandler=t},z.prototype.setPanZoomHandler=function(t){this._panZoomHandler=t},z.prototype.setMarqueeZoomHandler=function(t){this._marqueeZoomHandler=t},z.prototype.setMarqueeSelectHandler=function(t){this._marqueeSelectHandler=t},z.prototype.getMarqueeGlassPane=function(){return this._dragMode==z.DRAG_MODE_ZOOM?this._marqueeZoomHandler.getGlassPane():this._dragMode==z.DRAG_MODE_SELECT?this._marqueeSelectHandler.getGlassPane():null},z.prototype.cancelMarquee=function(t){this._dragMode==z.DRAG_MODE_ZOOM?this._marqueeZoomHandler.cancelMarquee()&&t.preventDefault():this._dragMode==z.DRAG_MODE_SELECT&&this._marqueeSelectHandler&&this._marqueeSelectHandler.cancelMarquee()&&this._chart.render()},z.prototype.getDragMode=function(){return this._dragMode},z.prototype.setDragMode=function(t){this._dragMode=null==t?this._getDefaultDragMode():t,!this._chart.xAxis.isFullViewport()||this._chart.yAxis&&!this._chart.yAxis.isFullViewport()||this.autoToggleZoomButton()},z.prototype._getDefaultDragMode=function(){return e.Agent.isTouchDevice()?z.DRAG_MODE_OFF:E.isScrollable(this._chart)?z.DRAG_MODE_PAN:"multiple"==this._chart.getOptions().selectionMode?z.DRAG_MODE_SELECT:null},z.prototype.onZoomButtonClick=function(t){this.zoomButton.isToggled()?(this.selectButton&&this.selectButton.setToggled(!1),this.setDragMode(z.DRAG_MODE_ZOOM)):this.setDragMode(null)},z.prototype.onPanButtonClick=function(t){this.panButton.isToggled()?(this.selectButton&&this.selectButton.setToggled(!1),this.setDragMode(z.DRAG_MODE_PAN)):this.setDragMode(null)},z.prototype.onSelectButtonClick=function(t){this.selectButton.isToggled()?(this.zoomButton&&this.zoomButton.setToggled(!1),this.panButton&&this.panButton.setToggled(!1),this.setDragMode(z.DRAG_MODE_SELECT)):this.setDragMode(null)},z.prototype.setDragButtonsVisible=function(t){t&&!this._dragButtonsVisible?(this._chart.showDragButtons(),this._dragButtonsVisible=!0):!t&&this._dragButtonsVisible&&(this._chart.hideDragButtons(),this._dragButtonsVisible=!1)},z.prototype.areDragButtonsVisible=function(){return this._dragButtonsVisible},z.prototype.autoToggleZoomButton=function(){!e.Agent.isTouchDevice()&&this.zoomButton&&(this._chart.xAxis.isFullViewport()&&this._chart.yAxis.isFullViewport()?this._dragMode==z.DRAG_MODE_PAN&&(this.zoomButton.setToggled(!0),this.onZoomButtonClick(null)):this._dragMode==z.DRAG_MODE_ZOOM&&(this.zoomButton.setToggled(!1),this.onZoomButtonClick(null)))},z.prototype.GetTouchResponse=function(){return this._dragMode&&this._dragMode!=z.DRAG_MODE_OFF?e.EventManager.TOUCH_RESPONSE_TOUCH_HOLD:this._chart.getOptions().touchResponse},z.prototype.isDndSupported=function(){return!0},z.prototype.GetDragSourceType=function(t){var e=this.DragSource.getDragObject();return e instanceof m&&e.getSeriesIndex()>=0&&e.getGroupIndex()>=0||e instanceof Y?"items":null},z.prototype.GetDragDataContexts=function(t){if(this._chart.isSelectionSupported()&&this._chart.getSelectionHandler().getSelectedCount()>1){for(var i=this._chart.getSelectionHandler().getSelection(),r=[],a=0;a<i.length;a++){var s=p.getDataContext(this._chart,i[a].getSeriesIndex(),i[a].getGroupIndex(),i[a].getNestedDataItemIndex());t&&e.ToolkitUtils.cleanDragDataContext(s),r.push(s)}return r}var n=this.DragSource.getDragObject(),o=null;return n instanceof m&&(o=p.getDataContext(this._chart,n.getSeriesIndex(),n.getGroupIndex(),n.getNestedDataItemIndex())),n instanceof Y&&(o=p.getDataContext(this._chart,n.getSeriesIndex(),0)),o&&t&&e.ToolkitUtils.cleanDragDataContext(o),o?[o]:null},z.prototype.GetDropOffset=function(t){var i=this.DragSource.getDragObject();if(i instanceof m){var r=i.getDataPosition();if(r){r=this._chart.getPlotArea().localToStage(r);var a=this._context.pageToStageCoords(t.pageX,t.pageY);return new e.Point(r.x-a.x,r.y-a.y)}}return null},z.prototype.GetDropTargetType=function(t){var e=this._context.pageToStageCoords(t.pageX,t.pageY),i=this._chart.getOptions().dnd.drop,r=this._chart.__getPlotAreaSpace();return Object.keys(i.plotArea).length>0&&r.containsPoint(e.x,e.y)?"plotArea":Object.keys(i.xAxis).length>0&&L.isAxisRendered(this._chart,"x")&&L.axisContainsPoint(this._chart.xAxis,e)?"xAxis":Object.keys(i.yAxis).length>0&&L.isAxisRendered(this._chart,"y")&&L.axisContainsPoint(this._chart.yAxis,e)?"yAxis":Object.keys(i.y2Axis).length>0&&L.isAxisRendered(this._chart,"y2")&&L.axisContainsPoint(this._chart.y2Axis,e)?"y2Axis":null},z.prototype.GetDropEventPayload=function(t){var i=t.getNativeEvent().dataTransfer,r=Number(i.getData(e.EventManager.DROP_OFFSET_X_DATA_TYPE))||0,a=Number(i.getData(e.EventManager.DROP_OFFSET_Y_DATA_TYPE))||0,s=this._context.pageToStageCoords(t.pageX,t.pageY);return this._chart.getValuesAt(s.x+r,s.y+a)},z.prototype.ShowDropEffect=function(t){var e=this._getDropObject(t);e&&(e.setClassName("oj-active-drop"),e.setSolidFill(this._chart.getOptions()._dropColor))},z.prototype.ClearDropEffect=function(){var t=this._chart.getCache().getFromCache("plotAreaBackground");if(t){var i=p.getBackgroundColor(this._chart);i?t.setSolidFill(i):t.setInvisibleFill(),e.ToolkitUtils.removeClassName(t.getElem(),"oj-invalid-drop"),e.ToolkitUtils.removeClassName(t.getElem(),"oj-active-drop")}var r=function(t){if(t){var i=t.getCache().getFromCache("background");i&&(i.setInvisibleFill(),e.ToolkitUtils.removeClassName(i.getElem(),"oj-invalid-drop"),e.ToolkitUtils.removeClassName(i.getElem(),"oj-active-drop"))}};r(this._chart.xAxis),r(this._chart.yAxis),r(this._chart.y2Axis)},z.prototype.ShowRejectedDropEffect=function(t){var e=this._getDropObject(t);e&&e.setClassName("oj-invalid-drop")},z.prototype._getDropObject=function(t){var e,i=this.GetDropTargetType(t);return"plotArea"==i?e=this._chart.getCache().getFromCache("plotAreaBackground"):"xAxis"==i?e=this._chart.xAxis.getCache().getFromCache("background"):"yAxis"==i?e=this._chart.yAxis.getCache().getFromCache("background"):"y2Axis"==i&&(e=this._chart.y2Axis.getCache().getFromCache("background")),e};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var X=function(t,e){this.Init(t,e)};e.Obj.createSubclass(X,e.KeyboardHandler),X.prototype.Init=function(t,e){X.superclass.Init.call(this,t),this._chart=e},X.prototype.isSelectionEvent=function(t){return this.isNavigationEvent(t)&&!t.ctrlKey},X.prototype.isMultiSelectEvent=function(t){return t.keyCode==e.KeyboardEvent.SPACE&&t.ctrlKey},X.prototype.processKeyDown=function(t){var i=t.keyCode;if(i==e.KeyboardEvent.TAB){if(a=this._eventManager.getFocus())return e.EventManager.consumeEvent(t),a;var r=k.getKeyboardNavigables(this._chart);if(r.length>0)return e.EventManager.consumeEvent(t),this.getDefaultNavigable(r)}else if(i==e.KeyboardEvent.ENTER){var a;if(a=this._eventManager.getFocus())return this._eventManager.processDrillEvent(a),e.EventManager.consumeEvent(t),a}else i==e.KeyboardEvent.ESCAPE?this._eventManager.cancelMarquee(t):i==e.KeyboardEvent.PAGE_UP?((t.ctrlKey||t.shiftKey||l.isBLAC(this._chart))&&l.isVertical(this._chart)?this._eventManager.panBy(-.25,0):this._eventManager.panBy(0,-.25),e.EventManager.consumeEvent(t)):i==e.KeyboardEvent.PAGE_DOWN?((t.ctrlKey||t.shiftKey||l.isBLAC(this._chart))&&l.isVertical(this._chart)?this._eventManager.panBy(.25,0):this._eventManager.panBy(0,.25),e.EventManager.consumeEvent(t)):e.KeyboardEvent.isEquals(t)||e.KeyboardEvent.isPlus(t)?this._eventManager.zoomBy(1.5):(e.KeyboardEvent.isMinus(t)||e.KeyboardEvent.isUnderscore(t))&&this._eventManager.zoomBy(1/1.5);return X.superclass.processKeyDown.call(this,t)},X.prototype.getDefaultNavigable=function(t){if(!t||t.length<=0)return null;for(var e,i,r,a,s=l.isPie(this._chart),n=0;n<t.length;n++)a=t[n],!e||a.getSeriesIndex()<i?(e=a,i=a.getSeriesIndex(),s||(r=a.getGroupIndex())):!s&&a.getGroupIndex()<r&&(e=a,i=a.getSeriesIndex(),r=a.getGroupIndex());return e};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var K=function(t,e){this.Init(t,e)};e.Obj.createSubclass(K,e.Obj),K.prototype.animateUpdate=function(t,e){var i=e._shape;this._shape&&this._shape.getUpdateAnimation&&t.add(this._shape.getUpdateAnimation(this._updateDuration,i),1)},K.prototype.animateInsert=function(t){if(this._shape&&this._shape.getInsertAnimation)t.add(this._shape.getInsertAnimation(this._insertDuration),2);else{var i=new e.AnimFadeIn(this._shape.getCtx(),this._shape,this._insertDuration);t.add(i,0)}},K.prototype.animateDelete=function(t,i){if(i.addChild(this._shape),this._shape&&this._shape.getDeleteAnimation)t.add(this._shape.getDeleteAnimation(this._deleteDuration),0);else{var r=new e.AnimFadeOut(this._shape.getCtx(),this._shape,this._deleteDuration);t.add(r,0)}},K.prototype.getId=function(){return this._animId},K.prototype.setId=function(t){this._animId=t},K.prototype.Init=function(t,e){this._peer=t,this._updateDuration=.75*e,this._insertDuration=.5*e,this._deleteDuration=.5*e,this._shape=t.getDisplayables()[0],this._animId=t.getDataItemId()||t.getSeries()+"/"+t.getGroup()},K.prototype.setOldChart=function(t){this._oldChart=t};
/**
   * @license
   * Copyright (c) 2008 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var Z=new Object;e.Obj.createSubclass(Z,e.Obj),Z.DIR_UP=0,Z.DIR_DOWN=1,Z.DIR_NOCHANGE=2,Z.makeIndicator=function(t,e,i,r,a,s){if(l.isPolar(r))return null;var n=Z.getDirection(t,e,i,r,a,s);if(n==Z.DIR_NOCHANGE)return null;var o=n===Z.DIR_DOWN,h=o?p.getAnimationDownColor(r):p.getAnimationUpColor(r),u=Z._drawIndicator(r.getCtx(),o,l.isHorizontal(r),h);return r.getPlotArea().addChild(u),u},Z.getDirection=function(t,e,i,r,a,s){var n=g.getValue(t,e,i),o=g.getValue(r,a,s);return null==o||null==n||o==n?Z.DIR_NOCHANGE:o>n?Z.DIR_UP:Z.DIR_DOWN},Z._drawIndicator=function(t,i,r,a){var s;r?s=(e.Agent.isRightToLeft(t)?!i:i)?"M3.5,-5L3.5,5L-3.5,0L3.5,-5":"M-3.5,-5L-3.5,5L3.5,0L-3.5,-5":s=i?"M-5,-3.5L5,-3.5L0,3.5L-5,-3.5Z":"M-5,3.5L5,3.5L0,-3.5L-5,3.5Z";var n=i?"oj-chart-animation-down":"oj-chart-animation-up",o=new e.Path(t,s);return o.setClassName(n),o.setStyle({fill:a}),o};
/**
   * @license
   * Copyright (c) 2008 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var q=function(t,e){this.Init(t,e)};e.Obj.createSubclass(q,K),q.prototype.Init=function(t,e){q.superclass.Init.call(this,t,e),this._indicator=null,this._animId+="/bar"},q.prototype.animateInsert=function(t){var e=this._shape.getInsertAnimation(this._insertDuration);t.add(e,2)},q.prototype.animateDelete=function(t,e){e.addChild(this._shape);var i=this._shape.getDeleteAnimation(this._deleteDuration);t.add(i,0)},q.prototype.animateUpdate=function(t,i){var r=this._oldChart,a=this._peer.getChart(),s=l.isHorizontal(r)!=l.isHorizontal(a),n=i._getAnimationParams(s),o=this._getAnimationParams(),h=i._shape.getPrimaryFill(),u=this._shape.getPrimaryFill(),g=i._shape.isSelected()||this._shape.isSelected()||h.equals(u);if(!e.ArrayUtils.equals(n,o)||!h.equals(u)){var d=this._peer.getSeriesIndex(),c=i._peer.getSeriesIndex(),_=this._peer.getGroupIndex(),f=i._peer.getGroupIndex();"none"!==p.getAnimationIndicators(a)&&(this._indicator=Z.makeIndicator(r,c,f,a,d,_)),this._setAnimationParams(n),g||this._shape.setFill(h);var v=new e.CustomAnimation(this._shape.getCtx(),this,this._updateDuration);v.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this,this._getAnimationParams,this._setAnimationParams,o),g||v.getAnimator().addProp(e.Animator.TYPE_FILL,this._shape,this._shape.getFill,this._shape.setFill,u),this._indicator&&(v.setOnEnd(this._onEndAnimation,this),this._indicator.setAlpha(0)),t.add(v,1)}},q.prototype._getAnimationParams=function(t){return this._shape.getAnimationParams(t)},q.prototype._setAnimationParams=function(t){this._shape.setAnimationParams(t,this._indicator)},q.prototype._onEndAnimation=function(){this._indicator&&(this._indicator.getParent().removeChild(this._indicator),this._indicator=null)};
/**
   * @license
   * Copyright (c) 2008 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var Q=function(t,e){this.Init(t,e)};e.Obj.createSubclass(Q,K),Q.prototype.Init=function(t,e){Q.superclass.Init.call(this,t,e),this._animId+="/boxAndWhisker"};
/**
   * @license
   * Copyright (c) 2013 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var J=function(t,e){this.Init(t,e)};e.Obj.createSubclass(J,K),J.prototype.animateUpdate=function(t,i){var r=this._shape,a=i._shape.getAnimationParams(),s=r.getAnimationParams(),n=i._shape.getFill(),o=this._shape.getFill();if(!e.ArrayUtils.equals(a,s)||!n.equals(o)){r.setAnimationParams(a);var l=new e.CustomAnimation(r.getCtx(),this,this._updateDuration);l.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,r,r.getAnimationParams,r.setAnimationParams,s),n.equals(o)||(this._shape.setFill(n),l.getAnimator().addProp(e.Animator.TYPE_FILL,r,r.getFill,r.setFill,o)),this._indicator&&l.setOnEnd(this._onEndAnimation,this),t.add(l,1)}},J.prototype.animateInsert=function(t){var i=this._shape,r=i.getAnimationParams(),a=r.slice(0);a[0]+=a[1]/2,a[1]=0,a[3]=0,i.setAnimationParams(a);var s=new e.CustomAnimation(i.getCtx(),this,this._insertDuration);s.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,i,i.getAnimationParams,i.setAnimationParams,r),t.add(s,2)},J.prototype.animateDelete=function(t,i){var r=this._shape;i.setClipPath(null),i.addChild(r);var a=r.getAnimationParams(),s=a.slice(0);s[0]+=a[1]/2,s[1]=0,s[3]=0;var n=new e.CustomAnimation(r.getCtx(),this,this._deleteDuration);n.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,r,r.getAnimationParams,r.setAnimationParams,s),t.add(n,0)},J.prototype.Init=function(t,e){J.superclass.Init.call(this,t,e),this._animId+="/funnel"};
/**
   * @license
   * Copyright (c) 2008 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var $=function(t,e){this.Init(t,e)};e.Obj.createSubclass($,K),$.prototype.animateUpdate=function(t,i){this._baseCoords=this._shape.getBaseCoords(),this._coords=this._shape.getCoords();var r,a,s=this._shape.isArea(),n=this._oldChart,o=this._chart,l=this._peer.getSeriesIndex(),h=i._peer.getSeriesIndex(),u=this._shape.getCommonGroupIndices(i._shape),d=i._shape.getCommonGroupIndices(this._shape);if(s){var c=i._getBaseAnimationParams(this._shape),_=this._getBaseAnimationParams(i._shape);$._matchGroupIndices(c,_),e.ArrayUtils.equals(c,_)||(this._setBaseAnimationParams(c),(r=new e.CustomAnimation(this._context,this,this._updateDuration)).getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this,this._getBaseAnimationParams,this._setBaseAnimationParams,_))}var f=i._getAnimationParams(this._shape),v=this._getAnimationParams(i._shape);$._matchGroupIndices(f,v),e.ArrayUtils.equals(f,v)||(this._setAnimationParams(f),(a=new e.CustomAnimation(this._context,this,this._updateDuration)).getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this,this._getAnimationParams,this._setAnimationParams,v));var m=g.getSeriesType(this._peer.getChart(),l);if("none"!==p.getAnimationIndicators(o)&&(!s||"lineWithArea"!=m))for(var S,C,y=0;y<u.length;y++)S=Z.getDirection(n,h,d[y],o,l,u[y]),(C=Z.makeIndicator(n,h,d[y],o,l,u[y]))&&this._shape.addIndicator(u[y],S,C);if(r||a){var x=new e.ParallelPlayable(this._context,r,a);x.setOnEnd(this._onAnimationEnd,this),t.add(x,1)}},$.prototype.animateInsert=function(t){this._shape.setAlpha(0);var i=new e.AnimFadeIn(this._context,this._shape,this._insertDuration);t.add(i,2)},$.prototype.animateDelete=function(t,i){var r;if("area"==g.getSeriesType(this._oldChart,this._peer.getSeriesIndex())){var a=this._chart.__getAreaContainer();if(this._deletedAreas=this._shape.getParent().getParent(),!a)return;a.addChild(this._deletedAreas),(r=new e.AnimFadeOut(this._context,this._deletedAreas,this._deleteDuration)).setOnEnd(this._removeDeletedAreas,this),t.add(r,0)}else i.addChild(this._shape),r=new e.AnimFadeOut(this._context,this._shape,this._deleteDuration),t.add(r,0)},$.prototype._removeDeletedAreas=function(){var t=this._chart.__getAreaContainer();t&&t.removeChild(this._deletedAreas)},$.prototype._getAnimationParams=function(t){return this._shape.getAnimationParams(t)},$.prototype._setAnimationParams=function(t){this._shape.setAnimationParams(t)},$.prototype._getBaseAnimationParams=function(t){return this._shape.getBaseAnimationParams(t)},$.prototype._setBaseAnimationParams=function(t){this._shape.setBaseAnimationParams(t)},$.prototype._onAnimationEnd=function(){this._shape.removeIndicators(),this._shape.setCoords(this._coords,this._baseCoords)},$._matchGroupIndices=function(t,e){for(var i=3;i<t.length;i+=4)t[i]=e[i]},$.prototype.Init=function(t,e){$.superclass.Init.call(this,t,e),this._context=this._shape.getCtx(),this._chart=this._peer.getChart(),this._animId+="/"+(this._shape.isArea()?"area":"line")};
/**
   * @license
   * Copyright (c) 2008 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var tt=function(t,e){this.Init(t,e)};e.Obj.createSubclass(tt,K),tt.prototype.animateUpdate=function(t,i){var r=i._shape.getCenterDimensions(),a=this._shape.getCenterDimensions();if(!a.equals(r)){this._shape.setCenterDimensions(r);var s=new e.CustomAnimation(this._shape.getCtx(),this,this._updateDuration);s.getAnimator().addProp(e.Animator.TYPE_RECTANGLE,this._shape,this._shape.getCenterDimensions,this._shape.setCenterDimensions,a);var n=this._peer.getChart();if(this.isValueChange(i)&&"none"!=p.getAnimationIndicators(n)&&l.isScatterBubble(n)){var o=i._shape;o.setAlpha(.9),o.setClassName("oj-chart-animation-marker"),o.setCenterDimensions(r),this._peer.getChart().getPlotArea().addChild(o),s.getAnimator().addProp(e.Animator.TYPE_RECTANGLE,o,o.getCenterDimensions,o.setCenterDimensions,a),s.getAnimator().addProp(e.Animator.TYPE_NUMBER,o,o.getAlpha,o.setAlpha,0),this._overlay=o,s.setOnEnd(this._onEndAnimation,this)}t.add(s,1)}},tt.prototype.animateInsert=function(t){this._shape.setAlpha(0);var i=new e.AnimFadeIn(this._shape.getCtx(),this._shape,this._insertDuration);t.add(i,2)},tt.prototype.animateDelete=function(t,i){i.addChild(this._shape);var r=new e.AnimFadeOut(this._shape.getCtx(),this._shape,this._deleteDuration);t.add(r,0)},tt.prototype.isValueChange=function(t){var e=!1;if(t){var i=t._peer.getSeriesIndex(),r=t._peer.getGroupIndex(),a=this._peer.getSeriesIndex(),s=this._peer.getGroupIndex(),n=t._oldChart.getOptions(),o=this._peer.getChart().getOptions(),l=n.series[i].items[r].x,h=n.series[i].items[r].y,u=n.series[i].items[r].z,g=o.series[a].items[s].x,d=o.series[a].items[s].y,c=o.series[a].items[s].z;e=g!==l||d!==h||c!==u}return e},tt.prototype._onEndAnimation=function(){this._overlay&&(this._peer.getChart().getPlotArea().removeChild(this._overlay),this._overlay=null)},tt.prototype.Init=function(t,e){tt.superclass.Init.call(this,t,e),this._animId+="/marker"};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var et=function(t,e){this.Init(t,e)};e.Obj.createSubclass(et,K),et.prototype.animateUpdate=function(t,i){var r=this._shape,a=i._shape.getAnimationParams(),s=r.getAnimationParams(),n=i._shape.getPrimaryFill(),o=this._shape.getPrimaryFill();if(!e.ArrayUtils.equals(a,s)||!n.equals(o)){r.setAnimationParams(a);var l=new e.CustomAnimation(r.getCtx(),this,this._updateDuration);l.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,r,r.getAnimationParams,r.setAnimationParams,s),n.equals(o)||(this._shape.setFill(n),l.getAnimator().addProp(e.Animator.TYPE_FILL,r,r.getFill,r.setFill,o)),t.add(l,1)}},et.prototype.animateInsert=function(t){var i=this._shape,r=i.getAnimationParams(),a=r.slice(0);a[1]=0,a[2]=0,i.setAnimationParams(a);var s=new e.CustomAnimation(i.getCtx(),this,this._insertDuration);s.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,i,i.getAnimationParams,i.setAnimationParams,r),t.add(s,2)},et.prototype.animateDelete=function(t,i){var r=this._shape;i.setClipPath(null),i.addChild(r);var a=r.getAnimationParams().slice(0);a[1]=0,a[2]=0;var s=new e.CustomAnimation(r.getCtx(),this,this._deleteDuration);s.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,r,r.getAnimationParams,r.setAnimationParams,a),t.add(s,0)},et.prototype.Init=function(t,e){et.superclass.Init.call(this,t,e),this._animId+="/pyramid"};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var it=function(t,e){this.Init(t,e)};e.Obj.createSubclass(it,K),it.prototype.Init=function(t,e){it.superclass.Init.call(this,t,e),this._animId+="/rangeMarker"},it.prototype.animateInsert=function(t){this._shape.setAlpha(0);var i=new e.AnimFadeIn(this._shape.getCtx(),this._shape,this._insertDuration);t.add(i,2)},it.prototype.animateDelete=function(t,i){i.addChild(this._shape);var r=new e.AnimFadeOut(this._shape.getCtx(),this._shape,this._deleteDuration);t.add(r,0)},it.prototype.animateUpdate=function(t,i){var r=i._shape.getAnimationParams(),a=this._shape.getAnimationParams();this._shape.setAnimationParams(r);var s=new e.CustomAnimation(this._shape.getCtx(),this,this._updateDuration);s.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this._shape,this._shape.getAnimationParams,this._shape.setAnimationParams,a),t.add(s,1)};
/**
   * @license
   * Copyright (c) 2011 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var rt=function(t,e,i){this._x1=Math.min(e[0],e[4]),this._x2=Math.max(e[0],e[4]),this._y1=Math.min(e[1],e[5]),this._y2=Math.max(e[1],e[5]),this.Init(t,[this._x1,this._y1,this._x2,this._y1,this._x2,this._y2,this._x1,this._y2],i)};e.Obj.createSubclass(rt,e.Polygon),rt.OUTER_BORDER_WIDTH=2,rt.OUTER_BORDER_WIDTH_HOVER=1.25,rt.INNER_BORDER_WIDTH=1,rt.prototype.setStyleProperties=function(t,i,r,a,s,n,o){this._fill=t,this._borderStroke=i,this._hoverColor=e.SelectionEffectUtils.getHoverBorderColor(r),this._innerColor=a,this._outerColor=s,this._shapeClassName=n,this._shapeStyle=o,this.setStyle(o).setClassName(n),this.setFill(t),i&&this.setStroke(i)},rt.prototype.setAnimationParams=function(t){this._x1=Math.min(t[0],t[4]),this._x2=Math.max(t[0],t[4]),this._y1=Math.min(t[1],t[5]),this._y2=Math.max(t[1],t[5]),this.setPoints(t),this._initializeSelectionEffects()},rt.prototype.showHoverEffect=function(){if(!this.IsShowingHoverEffect)if(this.IsShowingHoverEffect=!0,"redwood"===this.getCtx().getThemeBehavior()){if(!this.isSelected()){var t=this.getFill().getColor();this._showNestedBorders(t,this._innerColor)}}else this._showNestedBorders(this._hoverColor,this._innerColor)},rt.prototype.hideHoverEffect=function(){this.IsShowingHoverEffect&&(this.IsShowingHoverEffect=!1,"redwood"===this.getCtx().getThemeBehavior()?this.isSelected()||this._showNestedBorders():this.isSelected()?this._showNestedBorders(this._outerColor,this._innerColor):this._showNestedBorders())},rt.prototype.setSelected=function(t){if(this.IsSelected!=t)if(this.IsSelected=t,"redwood"===this.getCtx().getThemeBehavior()){var e=this.getPrimaryFill().getColor();this.isSelected()?this._showNestedBorders(this._outerColor,this._innerColor):this.isHoverEffectShown()?this._showNestedBorders(e,this._innerColor):this._showNestedBorders()}else this.isHoverEffectShown()?this._showNestedBorders(this._hoverColor,this._innerColor):this.isSelected()?this._showNestedBorders(this._outerColor,this._innerColor):this._showNestedBorders()},rt.prototype.UpdateSelectionEffect=function(){},rt.prototype.getPrimaryFill=function(){return this._fill},rt.prototype._initializeSelectionEffects=function(){var t=this.isSelected()?rt.OUTER_BORDER_WIDTH:rt.OUTER_BORDER_WIDTH_HOVER,i=this._createPointsArray(t),r=this._createPointsArray(t+rt.INNER_BORDER_WIDTH);if(this.OuterChild)return this.OuterChild.setPoints(i),void this.InnerChild.setPoints(r);this.OuterChild=new e.Polygon(this.getCtx(),i),this.OuterChild.setInvisibleFill(),this.OuterChild.setMouseEnabled(!0),this.addChild(this.OuterChild),this.InnerChild=new e.Polygon(this.getCtx(),r),this.InnerChild.setInvisibleFill(),this.InnerChild.setMouseEnabled(!0),this.addChild(this.InnerChild)},rt.prototype._showNestedBorders=function(t,e){this._initializeSelectionEffects(),e?(this.setSolidFill(t),this.setStroke(null),this.setClassName().setStyle(),this.OuterChild.setSolidFill(e),this.OuterChild.setClassName().setStyle(),this.InnerChild.setFill(this._fill),this.InnerChild.setClassName(this._shapeClassName).setStyle(this._shapeStyle)):t?(this.setSolidFill(t),this.setStroke(null),this.setClassName().setStyle(),this.OuterChild.setFill(this._fill),this.OuterChild.setClassName(this._shapeClassName).setStyle(this._shapeStyle),this.InnerChild.setInvisibleFill(),this.InnerChild.setClassName().setStyle()):(this.setFill(this._fill),this.setStroke(this._borderStroke),this.setClassName(this._shapeClassName).setStyle(this._shapeStyle),this.OuterChild.setInvisibleFill(),this.OuterChild.setClassName().setStyle(),this.InnerChild.setInvisibleFill(),this.InnerChild.setClassName().setStyle())},rt.prototype._createPointsArray=function(t){var e=this._x1+t,i=this._x2-t,r=this._y1+t,a=this._y2-t;return[e,r,i,r,i,a,e,a]};
/**
   * @license
   * Copyright (c) 2011 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var at=function(t,e,i,r,a,s,n){n||this.Init(t.getCtx()),this._bHoriz=l.isHorizontal(t),this._bStacked=g.isStacked(t),this._barGapRatio=w.getBarGapRatio(t),this._dataItemGaps=p.getDataItemGaps(t),this._axisCoord=e,this._doNotRender=!!n,this._setBarCoords(i,r,a,s,!0)};e.Obj.createSubclass(at,rt),at._INDICATOR_OFFSET=8,at._MIN_BAR_WIDTH_FOR_GAPS=5,at._MIN_BAR_WIDTH_FOR_GAPS_PIXEL_HINTING=15,at._MIN_BAR_LENGTH_FOR_GAPS=5,at._MAX_GAP_SIZE=2,at.prototype.setSelected=function(t){if(this.IsSelected!=t){if(this.IsSelected=t,"redwood"===this.getCtx().getThemeBehavior())var e=this.getPrimaryFill().getColor();else e=this._hoverColor;this.isSelected()?(this._tempX1=this._x1,this._tempX2=this._x2,this._tempBaselineCoord=this._baselineCoord,this._x1=this._origX1,this._x2=this._origX2,this._baselineCoord=this._origBaselineCoord,this.setPoints(this._createPointsArray()),"redwood"===this.getCtx().getThemeBehavior()?this._showNestedBorders(this._outerColor,this._innerColor):this._showNestedBorders(this.isHoverEffectShown()?e:this._outerColor,this._innerColor)):(this._x1=this._tempX1,this._x2=this._tempX2,this._baselineCoord=this._tempBaselineCoord,this.setPoints(this._createPointsArray()),"redwood"===this.getCtx().getThemeBehavior()?this.isHoverEffectShown()?this._showNestedBorders(e,this._innerColor):this._showNestedBorders(null):this._showNestedBorders(this.isHoverEffectShown()?e:null))}},at.prototype.getAnimationParams=function(t){return t?this._bHoriz?[this._x2,this._x1,this._baselineCoord,this._endCoord]:[this._x1,this._x2,this._endCoord,this._baselineCoord]:[this._baselineCoord,this._endCoord,this._x1,this._x2]},at.prototype.setAnimationParams=function(t,e){if(this._setBarCoords(t[0],t[1],t[2],t[3],!1),e){var i=this.getIndicatorPosition();e.setTranslate(i.x,i.y),e.setAlpha(1),e.getParent().addChild(e)}},at.prototype.getDisplayAnimation=function(t){var i=this.getAnimationParams();this.setAnimationParams([this._axisCoord,this._axisCoord,this._x1,this._x2]);var r=new e.CustomAnimation(this.getCtx(),this,t);return r.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this,this.getAnimationParams,this.setAnimationParams,i),r},at.prototype.getDeleteAnimation=function(t){var i=[this._baselineCoord,this._baselineCoord,this._x1,this._x2],r=new e.CustomAnimation(this.getCtx(),this,t);return r.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this,this.getAnimationParams,this.setAnimationParams,i),r.getAnimator().addProp(e.Animator.TYPE_NUMBER,this,this.getAlpha,this.setAlpha,0),r},at.prototype.getInsertAnimation=function(t){this.setAlpha(0);var i=this.getDisplayAnimation(t);return i.getAnimator().addProp(e.Animator.TYPE_NUMBER,this,this.getAlpha,this.setAlpha,1),i},at.prototype.getIndicatorPosition=function(){var t,i,r=(this._x1+this._x2)/2;if(this._bStacked){var a=(this._endCoord+this._baselineCoord)/2;t=this._bHoriz?a:r,i=this._bHoriz?r:a}else{var s=this._endCoord>=this._baselineCoord?this._endCoord+at._INDICATOR_OFFSET:this._endCoord-at._INDICATOR_OFFSET;t=this._bHoriz?s:r,i=this._bHoriz?r:s}return new e.Point(t,i)},at.prototype._setBarCoords=function(t,i,r,a,s){this._baselineCoord=t,this._endCoord=i,this._x1=r,this._x2=a;var n=this._x2-this._x1;if(n<1&&(this._x1=Math.floor(this._x1),this._x2=this._x1+1,n=1),this._origX1=this._x1,this._origX2=this._x2,this._origBaselineCoord=this._baselineCoord,this._origSize=this._x2-this._x1,this._dataItemGaps>0&&s&&!this.isSelected()){var o=Math.ceil(at._MAX_GAP_SIZE*this._dataItemGaps),l=Math.abs(this._baselineCoord-this._endCoord),h=this._axisCoord==this._baselineCoord;l>=at._MIN_BAR_LENGTH_FOR_GAPS&&this._bStacked&&!h&&(this._baselineCoord+=this._endCoord>this._baselineCoord?o:-o),n>=at._MIN_BAR_WIDTH_FOR_GAPS&&(1==e.Agent.getDevicePixelRatio()&&this._barGapRatio>0&&n>at._MIN_BAR_WIDTH_FOR_GAPS_PIXEL_HINTING?("firefox"===e.Agent.browser||this._doNotRender||this.setPixelHinting(!0),this._x1=Math.round(this._x1),this._x2=Math.round(this._x2),this._origX1=this._x1,this._origX2=this._x2,this._x2-=o):(this._x1+=o/2,this._x2-=o/2),this._origSize-=o)}if(!this._doNotRender){var u=this._createPointsArray();this.setPoints(u),this.OuterChild&&this.OuterChild.setPoints(this._createPointsArray(rt.OUTER_BORDER_WIDTH)),this.InnerChild&&this.InnerChild.setPoints(this._createPointsArray(rt.OUTER_BORDER_WIDTH+rt.INNER_BORDER_WIDTH))}},at.prototype._createPointsArray=function(t){var e=this._baselineCoord,i=this._endCoord,r=this._x1,a=this._x2;if(t>0){if(Math.abs(r-a)<2*t||Math.abs(e-i)<2*t)return[];r+=t,a-=t,i<e?(e-=t,i+=t):(e+=t,i-=t)}return this._bHoriz?[i,r,i,a,e,a,e,r]:[r,i,a,i,a,e,r,e]},at.prototype.getBoundingBox=function(){var t=Math.min(this._x2,this._x1),i=Math.min(this._endCoord,this._baselineCoord),r=Math.abs(this._x2-this._x1),a=Math.abs(this._endCoord-this._baselineCoord);return this._bHoriz?new e.Rectangle(i,t,a,r):new e.Rectangle(t,i,r,a)},at.prototype.getOriginalBarSize=function(){return this._origSize},at.prototype.getDimensionsSelf=function(t){return this.ConvertCoordSpaceRect(this.getBoundingBox(),t)};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var st=function(t,i,r,a,s,n,o,h,u){this.Init(t.getCtx()),this._chart=t,this._bHoriz=l.isHorizontal(t),this._styleOptions=u,this._innerColor=p.getSelectedInnerColor(this._chart),this._outerColor=p.getSelectedOuterColor(this._chart),this._hoverColor=e.SelectionEffectUtils.getHoverBorderColor(this._styleOptions._color);var g=i-r/2,d=i+r/2;p.getDataItemGaps(t)>0&&r>at._MIN_BAR_WIDTH_FOR_GAPS&&d--,this._render(g,d,a,s,n,o,h)};e.Obj.createSubclass(st,e.Shape),st.prototype._render=function(t,i,r,a,s,n,o){this._cleanUp();var l=this.getCtx();this._x1=Math.round(t),this._x2=Math.round(i),this._low=Math.round(r),this._q1=Math.round(a),this._q2=Math.round(s),this._q3=Math.round(n),this._high=Math.round(o);var h=i-t,u=p.getSizeInPixels(this._styleOptions.whiskerEndLength,h);u=Math.min(h,u),u=2*Math.floor((u-1)/2)+1;var g=Math.floor((t+i)/2)+.5,d=g-Math.floor(u/2)-.5,c=g+Math.floor(u/2)+.5;this._drawLine(g,this._low,g,this._high,"whisker"),this._drawLine(d,this._low,c,this._low,"whiskerEnd"),this._drawLine(d,this._high,c,this._high,"whiskerEnd"),this._q2Box=new e.Polygon(l,this._createQ2PointsArray(0));var _=R.getRectangleFill(this._chart,this._styleOptions.q2Color,this._styleOptions._q2Pattern,h);this._q2Box.setFill(_),this._applyCustomStyle(this._q2Box,"q2"),this.addChild(this._q2Box),this._q3Box=new e.Polygon(l,this._createQ3PointsArray(0));var f=R.getRectangleFill(this._chart,this._styleOptions.q3Color,this._styleOptions._q3Pattern,h);this._q3Box.setFill(f),this._applyCustomStyle(this._q3Box,"q3"),this.addChild(this._q3Box),this._drawMedianLine(0),this._borderColor=this._styleOptions.borderColor,this._borderColor&&(this._borderWidth=this._styleOptions.borderWidth,this._drawBorders(this._borderColor,this._borderWidth)),this.IsSelected&&(this.IsSelected=!1,this.setSelected(!0))},st.prototype.showHoverEffect=function(){this.IsShowingHoverEffect||(this.IsShowingHoverEffect=!0,this.isSelected()?"redwood"!==this.getCtx().getThemeBehavior()&&this._drawBorders(this._hoverColor,rt.OUTER_BORDER_WIDTH,this._innerColor,rt.INNER_BORDER_WIDTH):this._drawBorders(this._hoverColor,rt.OUTER_BORDER_WIDTH_HOVER,this._innerColor,rt.INNER_BORDER_WIDTH))},st.prototype.hideHoverEffect=function(){this.IsShowingHoverEffect&&(this.IsShowingHoverEffect=!1,this.isSelected()?this._drawBorders(this._outerColor,rt.OUTER_BORDER_WIDTH,this._innerColor,rt.INNER_BORDER_WIDTH):this._drawBorders(this._borderColor,this._borderWidth))},st.prototype.setSelected=function(t){this.IsSelected!=t&&(this.IsSelected=t,this.isHoverEffectShown()?t?"redwood"===this.getCtx().getThemeBehavior()?this._drawBorders(this._outerColor,rt.OUTER_BORDER_WIDTH,this._innerColor,rt.INNER_BORDER_WIDTH):this._drawBorders(this._hoverColor,rt.OUTER_BORDER_WIDTH,this._innerColor,rt.INNER_BORDER_WIDTH):this._drawBorders(this._hoverColor,rt.OUTER_BORDER_WIDTH_HOVER,this._innerColor,rt.INNER_BORDER_WIDTH):t?this._drawBorders(this._outerColor,rt.OUTER_BORDER_WIDTH,this._innerColor,rt.INNER_BORDER_WIDTH):this._drawBorders(this._hoverColor,this._borderWidth))},st.prototype.UpdateSelectionEffect=function(){},st.prototype.getDisplayAnimation=function(t){return this.getInsertAnimation(t)},st.prototype.getDeleteAnimation=function(t){var i=new e.CustomAnimation(this.getCtx(),this,t),r=[this._x1,this._x2,this._q2,this._q2,this._q2,this._q2,this._q2];return i.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this,this._getAnimationParams,this._setAnimationParams,r),i.getAnimator().addProp(e.Animator.TYPE_NUMBER,this,this.getAlpha,this.setAlpha,0),i},st.prototype.getInsertAnimation=function(t){var i=new e.CustomAnimation(this.getCtx(),this,t),r=this._getAnimationParams();return this._setAnimationParams([this._x1,this._x2,this._q2,this._q2,this._q2,this._q2,this._q2]),i.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this,this._getAnimationParams,this._setAnimationParams,r),this.setAlpha(0),i.getAnimator().addProp(e.Animator.TYPE_NUMBER,this,this.getAlpha,this.setAlpha,1),i},st.prototype.getUpdateAnimation=function(t,i){var r=new e.CustomAnimation(this.getCtx(),this,t),a=i._getQ2Fill(),s=this._getQ2Fill();a.equals(s)||(this._setQ2Fill(a),r.getAnimator().addProp(e.Animator.TYPE_FILL,this,this._getQ2Fill,this._setQ2Fill,s));var n=i._getQ3Fill(),o=this._getQ3Fill();n.equals(o)||(this._setQ3Fill(n),r.getAnimator().addProp(e.Animator.TYPE_FILL,this,this._getQ3Fill,this._setQ3Fill,o));var l=this._getAnimationParams();return this._setAnimationParams(i._getAnimationParams()),r.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this,this._getAnimationParams,this._setAnimationParams,l),r},st.prototype._getAnimationParams=function(){return[this._x1,this._x2,this._low,this._q1,this._q2,this._q3,this._high]},st.prototype._setAnimationParams=function(t){this._render(t[0],t[1],t[2],t[3],t[4],t[5],t[6])},st.prototype._getQ2Fill=function(){return new e.SolidFill(this._styleOptions.q2Color)},st.prototype._setQ2Fill=function(t){this._styleOptions.q2Color=t.getColor()},st.prototype._getQ3Fill=function(){return new e.SolidFill(this._styleOptions.q3Color)},st.prototype._setQ3Fill=function(t){this._styleOptions.q3Color=t.getColor()},st.prototype._drawLine=function(t,i,r,a,s){var n=this._bHoriz?new e.Line(this.getCtx(),i,t,a,r):new e.Line(this.getCtx(),t,i,r,a);return this._applyCustomStyle(n,s),n.setPixelHinting(!0),this.addChild(n),n},st.prototype._drawMedianLine=function(t){if(!this._medianLine){var i=new e.Line(this.getCtx(),0,0,0,0);this._applyCustomStyle(i,"median"),i.setPixelHinting(!0),this.addChild(i),this._medianLine=i}var r=this._x1+t,a=this._x2-t,s=this._q2;this._bHoriz?(this._medianLine.setX1(s),this._medianLine.setX2(s),this._medianLine.setY1(r),this._medianLine.setY2(a)):(this._medianLine.setY1(s),this._medianLine.setY2(s),this._medianLine.setX1(r),this._medianLine.setX2(a))},st.prototype._drawBorders=function(t,i,r,a){if(!this._outerBorderShape){var s=this.getChildIndex(this._q2Box);this._innerBorderShape=new e.Polygon(this.getCtx()),this._innerBorderShape.setInvisibleFill(),this.addChildAt(this._innerBorderShape,s),this._outerBorderShape=new e.Polygon(this.getCtx()),this._outerBorderShape.setInvisibleFill(),this.addChildAt(this._outerBorderShape,s)}var n=0;i?(this._outerBorderShape.setPoints(this._createBoxPointsArray(0)),this._outerBorderShape.setSolidFill(t),n+=i,a?(this._innerBorderShape.setPoints(this._createBoxPointsArray(i)),this._innerBorderShape.setSolidFill(r),n+=a):this._innerBorderShape.setInvisibleFill()):(this._outerBorderShape.setInvisibleFill(),this._innerBorderShape.setInvisibleFill()),this._q2Box.setPoints(this._createQ2PointsArray(n)),this._q3Box.setPoints(this._createQ3PointsArray(n)),this._drawMedianLine(n)},st.prototype._createBoxPointsArray=function(t){var e,i,r=this._x1+t,a=this._x2-t;return this._q1<this._q3?(e=this._q1+t,i=this._q3-t):(e=this._q1-t,i=this._q3+t),this._createPointsArray(r,a,e,i)},st.prototype._createQ3PointsArray=function(t){var e,i=this._x1+t,r=this._x2-t,a=this._q2;return e=this._q2<this._q3?this._q3-t:this._q3+t,this._createPointsArray(i,r,a,e)},st.prototype._createQ2PointsArray=function(t){var e,i=this._x1+t,r=this._x2-t,a=this._q2;return e=this._q2<this._q1?this._q1-t:this._q1+t,this._createPointsArray(i,r,e,a)},st.prototype._createPointsArray=function(t,e,i,r){return this._bHoriz?[i,t,i,e,r,e,r,t]:[t,i,e,i,e,r,t,r]},st.prototype._applyCustomStyle=function(t,e){t.setStyle(this._styleOptions[e+"Style"]||this._styleOptions[e+"SvgStyle"],!0),t.setClassName(this._styleOptions[e+"ClassName"]||this._styleOptions[e+"SvgClassName"],!0)},st.prototype._cleanUp=function(){this.removeChildren(),this._q2Box=null,this._q3Box=null,this._medianLine=null,this._outerBorderShape=null,this._innerBorderShape=null};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var nt=function(t,e,i,r,a,s,n){this.Init(t),i=Math.max(2*Math.round(i/2),1);var o=Math.min(2*Math.ceil(nt._BAR_WIDTH*i/2),i),l=Math.round(e)-i/2,h=l+i;if(null!=s&&null!=n){var u=Math.round(e)-o/2,g=u+o;this._rangeShape=new rt(t,[u,s,g,s,g,n,u,n]),this.addChild(this._rangeShape)}this._changeShape=new rt(t,[l,r,h,r,h,a,l,a]),this.addChild(this._changeShape),this.setPixelHinting(!0)};e.Obj.createSubclass(nt,e.Container),nt._BAR_WIDTH=.3,nt.prototype.setChangeStyle=function(t,e,i,r,a){this._changeShape.setStyleProperties(t,e,i,r,a)},nt.prototype.setRangeStyle=function(t,e,i,r){this._rangeShape&&this._rangeShape.setStyleProperties(t,e,i,null,r)},nt.prototype.setSelected=function(t){this._changeShape.setSelected(t),this._rangeShape&&this._rangeShape.setSelected(t)},nt.prototype.showHoverEffect=function(){this._changeShape.showHoverEffect(),this._rangeShape&&this._rangeShape.showHoverEffect()},nt.prototype.hideHoverEffect=function(){this._changeShape.hideHoverEffect(),this._rangeShape&&this._rangeShape.hideHoverEffect()},nt.prototype.getDisplayAnimation=function(t){var i=new e.CustomAnimation(this.getCtx(),this,t),r=this._changeShape.getPoints();if(this._changeShape.setPoints(nt._getInitialPoints(r)),i.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this._changeShape,this._changeShape.getPoints,this._changeShape.setAnimationParams,r),this._rangeShape){var a=this._rangeShape.getPoints();this._rangeShape.setPoints(nt._getInitialPoints(a)),i.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this._rangeShape,this._rangeShape.getPoints,this._rangeShape.setAnimationParams,a)}return i},nt.prototype.getDeleteAnimation=function(t){var i=new e.CustomAnimation(this.getCtx(),this,t),r=nt._getInitialPoints(this._changeShape.getPoints());if(i.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this._changeShape,this._changeShape.getPoints,this._changeShape.setAnimationParams,r),this._rangeShape){var a=nt._getInitialPoints(this._rangeShape.getPoints());i.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this._rangeShape,this._rangeShape.getPoints,this._rangeShape.setAnimationParams,a)}return i.getAnimator().addProp(e.Animator.TYPE_NUMBER,this,this.getAlpha,this.setAlpha,0),i},nt.prototype.getInsertAnimation=function(t){this.setAlpha(0);var i=this.getDisplayAnimation(t);return i.getAnimator().addProp(e.Animator.TYPE_NUMBER,this,this.getAlpha,this.setAlpha,1),i},nt.prototype.getUpdateAnimation=function(t,i){var r=new e.CustomAnimation(this.getCtx(),this,t),a=this._changeShape.getPoints();this._changeShape.setPoints(i._changeShape.getPoints()),r.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this._changeShape,this._changeShape.getPoints,this._changeShape.setAnimationParams,a);var s=i._changeShape.getPrimaryFill(),n=this._changeShape.getPrimaryFill();if(i._changeShape.isSelected()||this._changeShape.isSelected()||s.equals(n)||(this._changeShape.setFill(s),r.getAnimator().addProp(e.Animator.TYPE_FILL,this._changeShape,this._changeShape.getFill,this._changeShape.setFill,n)),this._rangeShape&&i._rangeShape){var o=this._rangeShape.getPoints();this._rangeShape.setPoints(i._rangeShape.getPoints()),r.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this._rangeShape,this._rangeShape.getPoints,this._rangeShape.setAnimationParams,o)}return r},nt.prototype.UpdateSelectionEffect=function(){},nt._getInitialPoints=function(t){var e=t[0],i=t[2],r=(t[1]+t[5])/2;return[e,r,i,r,i,r,e,r]};
/**
   * @license
   * Copyright (c) 2011 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var ot=function(t,e,i,r,a,s){this.x=t,this.y1=e,this.y2=i,this.groupIndex=r,this.group=a,this.filtered=s};e.Obj.createSubclass(ot,e.Obj),ot.prototype.isUpstep=function(t){return Math.abs(this.y2-t)>Math.abs(this.y1-t)},ot.prototype.clone=function(){return new ot(this.x,this.y1,this.y2,this.groupIndex,this.group,this.filtered)};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var lt=function(t,e,i,r,a,s,n,o,l,h,u,g){this.Init(t.getCtx()),this._chart=t,this._bArea=e,this._availSpace=i,this._baseline=r,this._style=a,this._className=s,this._fill=n,this._stroke=o,this._type=l,this._baseType=u||l,this._indicatorMap={},this.setCoords(h,g)};e.Obj.createSubclass(lt,e.Container),lt.prototype.chartShapeType="lineArea",lt._INDICATOR_OFFSET=8,lt.prototype.setCoords=function(t,e){this._arCoord=t,e&&(this._arBaseCoord=e),this.removeChildren(),this._bArea?this._renderAreas():this._renderLines(),this._positionIndicators()},lt.prototype.getCoords=function(){return this._arCoord},lt.prototype.getBaseCoords=function(){return this._arBaseCoord},lt.prototype.getBaseline=function(){return this._baseline},lt.prototype.isArea=function(){return this._bArea},lt.prototype._getPointArrays=function(t,i){var r=[],a=[];r.push(a),t=lt._convertToPointCoords(t);var s,n,o,h,u,g=l.isPolar(this._chart),d="centeredStepped"==i||"centeredSegmented"==i,c=d||"stepped"==i||"segmented"==i,_=p.getGroupWidth(this._chart),f=e.Agent.isRightToLeft(this.getCtx())&&l.isVertical(this._chart)?-1:1;g&&(s=t[t.length-1]);for(var v=!1,m=0;m<t.length;m++)null!=t[m]?(n=t[m],h=t[m]._isY2,o=d?n.x-_/2*f:n.x,h&&(v&&c&&(o+=_*f),v=!v),"curved"==i&&h&&a.push(null,null),s&&c&&this._pushCoord(a,o,s.y),this._bArea||"segmented"!=i&&"centeredSegmented"!=i||(a=[],r.push(a)),this._pushCoord(a,o,n.y),s=n):l.isMixedFrequency(this._chart)||(c&&!g&&s&&!h&&(u=d?s.x+.5*_*f:s.x+_*f,this._pushCoord(a,u,s.y)),a=[],r.push(a),s=null);if(c&&!g&&s&&!h&&(u=d?s.x+.5*_*f:s.x+_*f,this._pushCoord(a,u,s.y)),g&&r.length>1){var S=r.pop();r[0]=S.concat(r[0])}return r},lt.prototype._pushCoord=function(t,i,r){var a=h.convertAxisCoord(this._chart,new e.Point(i,r),this._availSpace);t.push(Math.round(10*a.x)/10,Math.round(10*a.y)/10)},lt.prototype._isRing=function(){if(!l.isPolar(this._chart)||!l.hasGroupAxis(this._chart)||this._arCoord.length<g.getGroupCount(this._chart))return!1;for(var t=0;t<this._arCoord.length;t++)if(null==this._arCoord[t].x)return!1;return!0},lt.prototype._getSplineType=function(){return l.isScatterBubble(this._chart)?e.PathUtils.SPLINE_TYPE_CARDINAL:l.isPolar(this._chart)?this._isRing()?e.PathUtils.SPLINE_TYPE_CARDINAL_CLOSED:e.PathUtils.SPLINE_TYPE_CARDINAL:l.isHorizontal(this._chart)?e.PathUtils.SPLINE_TYPE_MONOTONE_HORIZONTAL:e.PathUtils.SPLINE_TYPE_MONOTONE_VERTICAL},lt.prototype._renderLines=function(){for(var t,i=this._getPointArrays(this._arCoord,this._type),r=0;r<i.length;r++){var a=i[r];if(a&&a.length>1){if("curved"==this._type){var s=lt._getCurvedPathCommands(a,!1,this._getSplineType());(t=new e.Path(this.getCtx(),s)).setFill(null)}else this._isRing()?(t=new e.Polygon(this.getCtx(),a)).setFill(null):t=new e.Polyline(this.getCtx(),a);t.setStroke(this._stroke),t.setClassName(this._className).setStyle(this._style),this.addChild(t)}}},lt.prototype._renderAreas=function(){var t=this._arCoord,i=this._arBaseCoord;!l.isPolar(this._chart)&&t.length>0&&i.length>0&&(t=t.slice(0),i=i.slice(0),null!=t[0].x&&null!=i[0].x&&(lt._removeAreaEdge(t,0,this._baseline),lt._removeAreaEdge(i,0,this._baseline),i[0].x=t[0].x),null!=t[t.length-1].x&&null!=i[i.length-1].x&&(lt._removeAreaEdge(t,t.length-1,this._baseline),lt._removeAreaEdge(i,i.length-1,this._baseline),i[i.length-1].x=t[t.length-1].x));var r=this._getPointArrays(t,this._type),a=this._getPointArrays(i,this._baseType);if(r.length==a.length)for(var s,n=0;n<r.length;n++){var o=r[n],h=a[n];if(!(o.length<2)){var u="curved"==this._type,g="curved"==this._baseType;this._isRing()&&(u||o.push(o[0],o[1]),h.length>=2&&!g&&h.push(h[0],h[1]));for(var d=[],c=0;c<h.length;c+=2)d.unshift(h[c],h[c+1]);if(u||g){var p=this._getSplineType(),_=u?lt._getCurvedPathCommands(o,!1,p):e.PathUtils.polyline(o,!1);_+=g?lt._getCurvedPathCommands(d,!0,p):e.PathUtils.polyline(d,!0),_+=e.PathUtils.closePath(),s=new e.Path(this.getCtx(),_)}else{var f=d.concat(o);s=new e.Polygon(this.getCtx(),f)}s.setFill(this._fill),s.setClassName(this._className).setStyle(this._style),this._stroke&&s.setStroke(this._stroke),this.addChild(s)}}},lt.prototype._positionIndicators=function(){for(var t,i,r,a,s,n=0;n<this._arCoord.length;n++)s=this._arCoord[n],(t=this._indicatorMap[s.groupIndex])&&t.indicator&&(a=(s.isUpstep(this._baseline)?s.y2:s.y1)+lt._INDICATOR_OFFSET*(t.direction==Z.DIR_UP?-1:1),r=h.convertAxisCoord(this._chart,new e.Point(s.x,a),this._availSpace),(i=t.indicator).setTranslate(r.x,r.y),i.setAlpha(1),i.getParent().addChild(i))},lt.prototype.getAnimationParams=function(t){return lt._coordsToAnimationParams(this._arCoord,t?t._arCoord:null,this._baseline)},lt.prototype.setAnimationParams=function(t){var e=lt._animationParamsToCoords(t);this.setCoords(e)},lt.prototype.getBaseAnimationParams=function(t){return lt._coordsToAnimationParams(this._arBaseCoord,t?t._arBaseCoord:null,this._baseline)},lt.prototype.setBaseAnimationParams=function(t){this._arBaseCoord=lt._animationParamsToCoords(t)},lt.prototype.getCommonGroupIndices=function(t){for(var e=[],i=0;i<this._arCoord.length;i++)if(!this._arCoord[i].filtered&&null!=this._arCoord[i].x)for(var r=0;r<t._arCoord.length;r++)if(!t._arCoord[r].filtered&&null!=t._arCoord[r].x&&this._arCoord[i].group==t._arCoord[r].group){e.push(this._arCoord[i].groupIndex);break}return e},lt.prototype.addIndicator=function(t,e,i){i.setAlpha(0),this._indicatorMap[t]={direction:e,indicator:i}},lt.prototype.removeIndicators=function(){for(var t in this._indicatorMap){var e=this._indicatorMap[t].indicator;e&&e.getParent().removeChild(e)}this._indicatorMap={}},lt._convertToPointCoords=function(t){for(var i=[],r=0;r<t.length;r++)if(!t[r].filtered)if(null==t[r].x)i.push(null);else if(i.push(new e.Point(t[r].x,t[r].y1)),t[r].y1!=t[r].y2){var a=new e.Point(t[r].x,t[r].y2);a._isY2=!0,i.push(a)}return i},lt._coordsToAnimationParams=function(t,e,i){if(e&&e.length>0)if(t&&t.length>0){t=t.slice(0);for(var r,a,s,n=lt._coordsToGroups(e),o=lt._coordsToGroups(t),l=t.length,h=n.length-1;h>=0;h--)r=n[h],-1==(a=o.indexOf(r))?(0==l?(s=t[0].clone(),t[0]=t[0].clone(),lt._removeCoordJump(s,t[0],i)):(s=t[l-1].clone(),t[l-1]=t[l-1].clone(),lt._removeCoordJump(t[l-1],s,i)),s.groupIndex=-1,t.splice(l,0,s)):l=a}else{t=[];for(h=0;h<e.length;h++)t.push(new ot(e[h].x,i,i))}for(var u=[],g=0;g<t.length;g++)t[g].filtered||(null==t[g].x?(u.push(1/0),u.push(1/0),u.push(1/0)):(u.push(t[g].x),u.push(t[g].y1),u.push(t[g].y2)),u.push(t[g].groupIndex));return u},lt._animationParamsToCoords=function(t){for(var e=[],i=0;i<t.length;i+=4)t[i]==1/0||isNaN(t[i])?e.push(new ot(null,null,null,t[i+3])):e.push(new ot(t[i],t[i+1],t[i+2],t[i+3]));return e},lt._coordsToGroups=function(t){for(var e=[],i=0;i<t.length;i++)t[i].filtered||e.push(t[i].group);return e},lt._removeCoordJump=function(t,e,i){t.isUpstep(i)?e.y1=e.y2:t.y2=t.y1},lt._getCurvedPathCommands=function(t,i,r){var a=[],s=[];a.push(s);for(var n=0;n<t.length;n+=2)null==t[n]?(s=[],a.push(s)):s.push(t[n],t[n+1]);if(r==e.PathUtils.SPLINE_TYPE_CARDINAL_CLOSED&&a.length>1){var o=a.pop();a[0]=o.concat(a[0]),r=e.PathUtils.SPLINE_TYPE_CARDINAL}var l="";for(n=0;n<a.length;n++)s=a[n],l+=e.PathUtils.curveThroughPoints(s,i,r),i=!0;return l},lt._removeAreaEdge=function(t,e,i){var r=t[e].clone();r.isUpstep(i)?r.y1=r.y2:r.y2=r.y1,t[e]=r};
/**
   * @license
   * Copyright (c) 2011 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var ht=function(t,e,i,r,a,s){this.Init(t,e,i,r,a,a,null,null,!0),s&&this.setStroke(ht.DEFAULT_STROKE)};e.Obj.createSubclass(ht,e.SimpleMarker),ht.DEFAULT_STROKE=new e.Stroke("none"),ht.SELECTED_FILL=new e.SolidFill("#FFFFFF"),ht.SELECTED_STROKE=new e.Stroke("#5A5A5A",1,1.5),ht.prototype.setDataColor=function(t){this._dataColor=t,this._hoverStroke=new e.Stroke(t,1,1.5)},ht.prototype.getDataColor=function(){return this._dataColor},ht.prototype.showHoverEffect=function(){this.IsShowingHoverEffect=!0,this.setStroke(this._hoverStroke)},ht.prototype.hideHoverEffect=function(){this.IsShowingHoverEffect=!1,this.setStroke(this.isSelected()?ht.SELECTED_STROKE:ht.DEFAULT_STROKE)},ht.prototype.setSelected=function(t){this.IsSelected!=t&&(this.IsSelected=t,this.isSelected()?(this.setFill(ht.SELECTED_FILL),this.setStroke(this.isHoverEffectShown()?this._hoverStroke:ht.SELECTED_STROKE)):(this.setInvisibleFill(),this.setStroke(this.isHoverEffectShown()?this._hoverStroke:ht.DEFAULT_STROKE)))},ht.prototype.UpdateSelectionEffect=function(){};
/**
   * @license
   * Copyright (c) 2011 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var ut=function(t,e,i,r,a,s,n){this.Init(t.getCtx()),this._axisCoord=e,this._availSpace=n.clone(),this._bbox=null,this._dataItemGaps=p.getDataItemGaps(t)*ut._MAX_DATA_ITEM_GAP,this._setBarCoords(i,r,a,s)};e.Obj.createSubclass(ut,G),ut._MIN_BAR_LENGTH_FOR_GAPS=4,ut._MAX_DATA_ITEM_GAP=3,ut.prototype.getAnimationParams=function(){return[this._baselineCoord,this._endCoord,this._x1,this._x2]},ut.prototype.setAnimationParams=function(t,e){this._setBarCoords(t[0],t[1],t[2],t[3])},ut.prototype.getPrimaryFill=function(){return this.getFill()},ut.prototype.getDisplayAnimation=function(t){var i=this.getAnimationParams();this.setAnimationParams([this._axisCoord,this._axisCoord,0,0]);var r=new e.CustomAnimation(this.getCtx(),this,t);return r.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this,this.getAnimationParams,this.setAnimationParams,i),r},ut.prototype.getDeleteAnimation=function(t){var i=[this._baselineCoord,this._baselineCoord,this._x1,this._x2],r=new e.CustomAnimation(this.getCtx(),this,t);return r.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this,this.getAnimationParams,this.setAnimationParams,i),r.getAnimator().addProp(e.Animator.TYPE_NUMBER,this,this.getAlpha,this.setAlpha,0),r},ut.prototype.getInsertAnimation=function(t){this.setAlpha(0);var i=this.getAnimationParams();this.setAnimationParams([this._baselineCoord,this._baselineCoord,this._x1,this._x2]);var r=new e.CustomAnimation(this.getCtx(),this,t);return r.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this,this.getAnimationParams,this.setAnimationParams,i),r.getAnimator().addProp(e.Animator.TYPE_NUMBER,this,this.getAlpha,this.setAlpha,1),r},ut.prototype._setBarCoords=function(t,i,r,a){var s=this._availSpace.x+this._availSpace.w/2,n=this._availSpace.y+this._availSpace.h/2,o=Math.max(i,t),l=Math.abs(i-t)>=ut._MIN_BAR_LENGTH_FOR_GAPS&&this._axisCoord!=t?Math.min(i,t)+this._dataItemGaps:Math.min(i,t),u=360-e.Math.radsToDegrees(Math.max(r,a))+90,g=e.Math.radsToDegrees(Math.abs(a-r));this.setWedgeParams(s,n,o,o,u,g,this._dataItemGaps,l);var d=h.polarToCartesian(t,r,this._availSpace),c=h.polarToCartesian(t,a,this._availSpace),p=h.polarToCartesian(i,r,this._availSpace),_=h.polarToCartesian(i,a,this._availSpace),f=Math.min(d.x,c.x,p.x,_.x),v=Math.max(d.x,c.x,p.x,_.x),m=Math.min(d.y,c.y,p.y,_.y),S=Math.max(d.y,c.y,p.y,_.y);this._bbox=new e.Rectangle(f,m,v-f,S-m),this._baselineCoord=t,this._endCoord=i,this._x1=r,this._x2=a},ut.prototype.getBoundingBox=function(){return this._bbox},ut.prototype.getOriginalBarSize=function(){return this._bbox.w};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var gt=function(t,e,i,r,a,s,n){this.Init(t),this._markerSize=s,this._isInvisible=n,this._drawPath(e,i,r,a)};e.Obj.createSubclass(gt,e.Path),gt.prototype._drawPath=function(t,i,r,a){var s=Math.atan2(a-i,r-t),n=this._markerSize/2,o=Math.PI/8,l=e.PathUtils.moveTo(t+n*Math.cos(s+o),i+n*Math.sin(s+o))+e.PathUtils.arcTo(n,n,2*(Math.PI-o),1,t+n*Math.cos(s-o),i+n*Math.sin(s-o))+e.PathUtils.lineTo(r-n*Math.cos(s+o),a-n*Math.sin(s+o))+e.PathUtils.arcTo(n,n,2*(Math.PI-o),1,r-n*Math.cos(s-o),a-n*Math.sin(s-o))+e.PathUtils.closePath();this.setCmds(l),this._x1=t,this._y1=i,this._x2=r,this._y2=a},gt.prototype.setStyleProperties=function(t,i,r,a,s){this._dataColor=r;var n=e.SelectionEffectUtils.getHoverBorderColor(r);this._isInvisible?(this.setInvisibleFill(),this._hoverStroke=new e.Stroke(n,1,1.5)):(this.setFill(t),this.setStroke(i),this.setHoverStroke(new e.Stroke(a,1,1),new e.Stroke(n,1,3.5)),this.setSelectedStroke(new e.Stroke(a,1,1.5),new e.Stroke(s,1,4.5)),this.setSelectedHoverStroke(new e.Stroke(a,1,1.5),new e.Stroke(n,1,4.5)))},gt.prototype.getDataColor=function(){return this._dataColor},gt.prototype.showHoverEffect=function(){this._isInvisible?(this.IsShowingHoverEffect=!0,this.setStroke(this._hoverStroke)):gt.superclass.showHoverEffect.call(this)},gt.prototype.hideHoverEffect=function(){this._isInvisible?(this.IsShowingHoverEffect=!1,this.setStroke(this.isSelected()?ht.SELECTED_STROKE:ht.DEFAULT_STROKE)):gt.superclass.hideHoverEffect.call(this)},gt.prototype.setSelected=function(t){if(this._isInvisible){if(this.IsSelected==t)return;this.IsSelected=t,this.isSelected()?(this.setFill(ht.SELECTED_FILL),this.setStroke(this.isHoverEffectShown()?this._hoverStroke:ht.SELECTED_STROKE)):(this.setInvisibleFill(),this.setStroke(this.isHoverEffectShown()?this._hoverStroke:ht.DEFAULT_STROKE))}else gt.superclass.setSelected.call(this,t)},gt.prototype.UpdateSelectionEffect=function(){this._isInvisible||gt.superclass.UpdateSelectionEffect.call(this)},gt.prototype.getAnimationParams=function(){return[this._x1,this._y1,this._x2,this._y2]},gt.prototype.setAnimationParams=function(t){this._drawPath(t[0],t[1],t[2],t[3])},gt.prototype.isInvisible=function(){return this._isInvisible},gt.prototype.getBoundingBox=function(){return this.getBoundingBox1().getUnion(this.getBoundingBox2())},gt.prototype.getBoundingBox1=function(){return new e.Rectangle(this._x1-this._markerSize/2,this._y1-this._markerSize/2,this._markerSize,this._markerSize)},gt.prototype.getBoundingBox2=function(){return new e.Rectangle(this._x2-this._markerSize/2,this._y2-this._markerSize/2,this._markerSize,this._markerSize)};
/**
   * @license
   * Copyright (c) 2008 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var dt=function(){};e.Obj.createSubclass(dt,e.Obj),dt.createAnimation=function(t,i,r,a,s){if(!dt._canAnimate(t,i))return null;var n,o=i.getCtx(),h=[],u=[];l.isPie(i)?(h.push(t.pieChart),u.push(i.pieChart)):dt._buildAnimLists(o,h,t,u,i,a);var g=new e.DataAnimationHandler(o,s);g.constructAnimation(h,u),g.getNumPlayables()>0&&(n=g.getAnimation(!0));var d=i.getDataLabels();if(n&&d.length>0){for(var c=0;c<d.length;c++)d[c].setAlpha(0);n=new e.SequentialPlayable(o,n,new e.AnimFadeIn(o,d,a/4))}return n},dt._buildAnimLists=function(t,i,r,a,s,n){var o,l,h,u,g,d=r.getChartObjPeers(),c=i,p=s.getCache().getFromCache("dataFiltered");for(o=0;o<2;o++){var _={},f={};for(l=0;l<d.length;l++){if(g=null,(u=(h=d[l]).getDisplayables()[0])instanceof B)g=new J(h,n);else if(u instanceof N)g=new et(h,n);else if(u instanceof at||u instanceof ut){if(g=new q(h,n),p){var v=h.getSeries();_[v]=_[v]?_[v]+1:1,g.setId(v+"/"+_[v]+"/bar")}}else if(u instanceof lt){var m=(g=new $(h,n)).getId();f[m]=f[m]?f[m]+1:1,g.setId(m+"/"+f[m])}else if(u instanceof e.SimpleMarker){if(u instanceof ht&&!u.isSelected())continue;g=new tt(h,n)}else if(u instanceof gt){if(u.isInvisible()&&!u.isSelected())continue;g=new it(h,n)}else u instanceof nt?g=new K(h,n):u instanceof st&&(g=new Q(h,n));g&&(c.push(g),g.setOldChart(r))}c=a,d=s.getChartObjPeers()}},dt._canAnimate=function(t,e){return l.isPie(t)&&l.isPie(e)?t&&e:l.isPolar(t)==l.isPolar(e)&&(!(!l.isBLAC(t)||!l.isBLAC(e))||(!(!l.isScatterBubble(t)||!l.isScatterBubble(e))||t.getType()==e.getType()))};
/**
   * @license
   * Copyright (c) 2008 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var ct=function(){};e.Obj.createSubclass(ct,e.Obj),ct.createAnimation=function(t,i,r){var a=[];if(l.isBLAC(t))ct._animBarLineArea(t,r,a);else if(l.isScatterBubble(t)||l.isFunnel(t)||l.isPyramid(t))ct._animBubbleScatterFunnelPyramid(t,r,a);else if(l.isPie(t)&&t.pieChart)return t.pieChart.getDisplayAnimation();return a.length>0?new e.ParallelPlayable(t.getCtx(),a):null},ct._animBarLineArea=function(t,i,r){var a=t.getChartObjPeers(),s=a?a.length:0;if(s)for(var n,o,l,h=0;h<s;h++){n=(o=a[h]).getDisplayables()[0];var u=g.getSeriesType(o.getChart(),o.getSeriesIndex());if(l=null,n instanceof at||n instanceof ut||n instanceof nt||n instanceof st)l=n.getDisplayAnimation(i);else if(n instanceof lt)l="line"==u?ct._getLinePlayable(t,n,i):ct._getAreaPlayable(t,n,i);else if(n instanceof e.SimpleMarker||n instanceof gt){if(n instanceof ht&&!n.isSelected())continue;l=new e.AnimFadeIn(t.getCtx(),n,i-.8,.8)}l&&r.push(l)}},ct._animBubbleScatterFunnelPyramid=function(t,i,r){var a=t.getObjects(),s=a?a.length:0;if(s)for(var n,o,l=0;l<s;l++)(n=a[l].getDisplayables()[0])instanceof e.SimpleMarker?o=new e.AnimPopIn(t.getCtx(),n,!0,i):(n instanceof B||n instanceof N)&&(o=ct._getFunnelPyramidPlayable(t,n,i)),o&&r.push(o)},ct._getAreaPlayable=function(t,i,r){var a,s=t.getCtx(),n=i.getBaseline();if(i.isArea()){for(var o=i.getBaseCoords(),l=i.getBaseAnimationParams(),h=l.slice(0),u=0;u<l.length;u++)u%4!=1&&u%4!=2||(l[u]=n);i.setBaseAnimationParams(l),(a=new e.CustomAnimation(s,i,r)).getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,i,i.getBaseAnimationParams,i.setBaseAnimationParams,h)}var g=i.getCoords(),d=i.getAnimationParams(),c=d.slice(0);for(u=0;u<d.length;u++)u%4!=1&&u%4!=2||(d[u]=n);i.setAnimationParams(d);var p=new e.CustomAnimation(s,i,r);p.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,i,i.getAnimationParams,i.setAnimationParams,c);var _=new e.ParallelPlayable(t.getCtx(),a,p);return _.setOnEnd(function(){i.setCoords(g,o)}),_},ct._getFunnelPyramidPlayable=function(t,i,r){var a=t.getCtx(),s=i.getAnimationParams(),n=s.slice(0),o=s.slice(0);s[0]=0,l.isFunnel(t)&&(s[2]=0,n[2]=0),i.setAnimationParams(s);var h=new e.CustomAnimation(a,i,r/2);h.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,i,i.getAnimationParams,i.setAnimationParams,n);var u=new e.CustomAnimation(a,i,r/2);return u.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,i,i.getAnimationParams,i.setAnimationParams,o),new e.SequentialPlayable(a,[h,u])},ct._getLinePlayable=function(t,i,r){var a=i.getCoords(),s=i.getAnimationParams(),n=s.slice(0);ct._getMeanPoints(s),i.setAnimationParams(s);var o=new e.CustomAnimation(t.getCtx(),i,r);return o.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,i,i.getAnimationParams,i.setAnimationParams,n),o.setOnEnd(function(){i.setCoords(a)}),o},ct._getMeanPoints=function(t){var e,i=0,r=Number.MAX_VALUE,a=-1*Number.MAX_VALUE,s=t.length;for(e=0;e<s;e++){var n=t[e];e%4!=0&&e%4!=3&&n!=1/0&&(n<r&&(r=n),n>a&&(a=n),i+=n)}for(s>8?(i-=2*r,i-=2*a,i/=s/2-4):i/=s/2,e=0;e<s;e++)e%4!=1&&e%4!=2||(t[e]=i)};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var pt=function(t,e,i){this.Init(t,e,i)};e.Obj.createSubclass(pt,x),x.registerConstructor("data",pt),pt.prototype.Init=function(t,e,i){pt.superclass.Init.call(this,t,e,i),this.MixinInit.call(this,t,e,i)},pt.MAX_ZOOM_FACTOR=64,pt.prototype.getMinLabel=function(){return this.ZeroBaseline||"on"==this.Options._continuousExtent&&null==this.Options.min?Math.ceil(this.LinearMinValue/this.MajorIncrement)*this.MajorIncrement:Math.ceil((this.LinearMinValue-this.LinearGlobalMin)/this.MajorIncrement)*this.MajorIncrement+this.LinearGlobalMin},pt.prototype.getLabels=function(t,e){if(e&&e>0)return null;var i=this.getAllLabels(t),r=[],a=t.getStage();return"tangential"!=this.Position&&(r=this.GetLabelDims(i,a),i=this.SkipLabels(i,r)),i},pt.prototype.getAllLabels=function(t,e){var r=[];if(this.Options.tickLabel&&this.Options.tickLabel.scaling){var a=this.Options.tickLabel.autoPrecision?this.Options.tickLabel.autoPrecision:"on";this._axisValueFormatter=new i.LinearScaleAxisValueFormatter(t,this.LinearMinValue,this.LinearMaxValue,this.MajorIncrement,this.Options.tickLabel.scaling,a,this.Options.translations)}for(var s=0;s<=this.MajorTickCount;s++){var n=s*this.MajorIncrement+this.getMinLabel();if(n-this.LinearMaxValue>this.MAJOR_TICK_INCREMENT_BUFFER)break;var o,l=this.GetUnboundedCoordAt(n);if(this.Options._skipHighestTick){if(n==this.LinearMaxValue)continue;if("tangential"!=this.Position&&Math.abs(l-this.MaxCoord)<this.getTickLabelHeight())continue}this.IsLog?(n=this.linearToActual(n),this._axisValueFormatter=new i.LinearScaleAxisValueFormatter(t,n,n,n,this.Options.tickLabel.scaling,a,this.Options.translations),o=this._formatValue(n)):o=this._formatValue(n),e?r.push(o):r.push(this.CreateLabel(t,o,l))}return r},pt.prototype.getMajorTickCoords=function(){for(var t=[],e=0;e<=this.MajorTickCount;e++){var i=e*this.MajorIncrement+this.getMinLabel();if(i-this.LinearMaxValue>this.MAJOR_TICK_INCREMENT_BUFFER)break;if(!this.Options._skipHighestTick||i!=this.LinearMaxValue){var r=this.GetUnboundedCoordAt(i);t.push(r)}}return t},pt.prototype.getMinorTickCoords=function(){for(var t=[],i=-1;i<=this.MajorTickCount;i++){var r=i*this.MajorIncrement+this.getMinLabel();if(this.IsLog&&1==this.MajorIncrement&&1==this.MinorIncrement)for(var a=2;a<=9;a++){var s=r+e.Math.log10(a);if(s>this.LinearMaxValue)break;s<this.LinearMinValue||(o=this.GetUnboundedCoordAt(s),t.push(o))}else for(a=1;a<this.MinorTickCount;a++){var n=r+a*this.MinorIncrement;if(n>this.LinearMaxValue)break;if(!(n<this.LinearMinValue)){var o=this.GetUnboundedCoordAt(n);t.push(o)}}}return t},pt.prototype._formatValue=function(t){if(this.Converter&&this.Converter.format)return this._axisValueFormatter?this._axisValueFormatter.format(t,this.Converter):this.Converter.format(t);if(this._axisValueFormatter)return this._axisValueFormatter.format(t);var i=e.Math.log10(this.MajorIncrement),r=Math.max(Math.ceil(-i),0);return t.toFixed(r)},pt.prototype.getMajorTickCount=function(){return this.MajorTickCount},pt.prototype.getMinorTickCount=function(){return this.MinorTickCount},pt.prototype.getMajorIncrement=function(){return this.linearToActual(this.MajorIncrement)},pt.prototype.getMinorIncrement=function(){return this.linearToActual(this.MinorIncrement)},pt.prototype.getMinimumExtent=function(){return(this.LinearGlobalMax-this.LinearGlobalMin)/pt.MAX_ZOOM_FACTOR},pt.prototype.getStartOverflow=function(){return"top"!=this.Position&&"bottom"!=this.Position||!e.Agent.isRightToLeft(this.getCtx())?this.StartOverflow:this.EndOverflow},pt.prototype.getEndOverflow=function(){return"top"!=this.Position&&"bottom"!=this.Position||!e.Agent.isRightToLeft(this.getCtx())?this.EndOverflow:this.StartOverflow},pt.prototype.alignLogScaleToTickCount=function(t,e){if(this.IsLog)for(var i=this.getMajorTickCount();e<i;)this.MajorIncrement=null,this.MajorTickCount=null,this.MinorIncrement=null,this.MinorTickCount=null,t++,this.CalcMajorMinorIncr(t),i=this.getMajorTickCount();return t},pt.prototype.getLogScaleUnit=function(){return this.LogScaleUnit},i.DataAxisInfoMixin.call(pt.prototype);
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var _t=function(t,e,i){this.Init(t,e,i)};e.Obj.createSubclass(_t,x),x.registerConstructor("time",_t),_t.TIME_MONTH_MIN=28*(_t.TIME_DAY=24*(_t.TIME_HOUR=60*(_t.TIME_MINUTE=60*(_t.TIME_SECOND=1e3)))),_t.TIME_MONTH_MAX=31*_t.TIME_DAY,_t.TIME_YEAR_MIN=365*_t.TIME_DAY,_t.TIME_YEAR_MAX=366*_t.TIME_DAY,_t.prototype.Init=function(t,r,a){_t.superclass.Init.call(this,t,r,a),"top"==this.Position||"bottom"==this.Position?(r._isOverview||"on"!=r.tickLabel.rendered||(this.StartOverflow=Math.max(i.BaseAxisInfo.MINIMUM_AXIS_BUFFER-r.leftBuffer,0),this.EndOverflow=Math.max(i.BaseAxisInfo.MINIMUM_AXIS_BUFFER-r.rightBuffer,0)),e.Agent.isRightToLeft(t)?(this._startCoord=this.EndCoord-this.EndOverflow,this._endCoord=this.StartCoord+this.StartOverflow):(this._startCoord=this.StartCoord+this.StartOverflow,this._endCoord=this.EndCoord-this.EndOverflow)):(this._startCoord=this.StartCoord,this._endCoord=this.EndCoord);var s=null!=r.tickLabel?r.tickLabel.converter:null;this._label1Converter=s&&s[0]?s[0]:s,this._label2Converter=s&&s[1]?s[1]:null,this._dateToIsoWithTimeZoneConverter=t.getLocaleHelpers().dateToIsoWithTimeZoneConverter,this._groups=r.groups;var n=r.timeAxisType;this._skipGaps="skipGaps"==n,this._mixedFrequency="mixedFrequency"==n,this.DataMin=r.dataMin,this.DataMax=r.dataMax,this._groups.length>1?this._averageInterval=(this.DataMax-this.DataMin)/(this._groups.length-1):this.DataMax-this.DataMin>0?this._averageInterval=this.DataMax-this.DataMin:this._averageInterval=6*_t.TIME_MINUTE,this._step=r.step;var o=r.endGroupOffset>0?r.endGroupOffset*this._averageInterval:0,l=r.startGroupOffset>0?r.startGroupOffset*this._averageInterval:0;this.GlobalMin=null!=r.min?r.min:this.DataMin-l,this.GlobalMax=null!=r.max?r.max:this.DataMax+o,null!=r.viewportStartGroup&&(this.MinValue=r.viewportStartGroup-l),null!=r.viewportEndGroup&&(this.MaxValue=r.viewportEndGroup+o),null!=r.viewportMin&&(this.MinValue=r.viewportMin),null!=r.viewportMax&&(this.MaxValue=r.viewportMax),null==this.MinValue&&(this.MinValue=this.GlobalMin),null==this.MaxValue&&(this.MaxValue=this.GlobalMax),this.GlobalMin>this.MinValue&&(this.GlobalMin=this.MinValue),this.GlobalMax<this.MaxValue&&(this.GlobalMax=this.MaxValue),this._timeRange=this.MaxValue-this.MinValue,this._level1Labels=null,this._level2Labels=null,this._level1Coords=null,this._level2Coords=null,this._isOneLevel=!0,this._level1Overflow=[],this._level2Overflow=[],this._locale=r._locale.toLowerCase(),this._monthResources=t.LocaleData.getMonthNames("abbreviated")},_t._getAMString=function(t){var e=t.substring(0,2);if("en-au"==t||"en-ie"==t||"en-ph"==t)return"am";if("en-gb"==t)return"";switch(e){case"en":return"AM";case"ar":return"ص";case"el":return"πμ";case"ko":return"오전";case"zh":return"上午";default:return""}},_t._getPMString=function(t){var e=t.substring(0,2);if("en-au"==t||"en-ie"==t||"en-ph"==t)return"pm";if("en-gb"==t)return"";switch(e){case"en":return"PM";case"ar":return"م";case"el":return"μμ";case"ko":return"오후";case"zh":return"下午";default:return""}},_t._getAMPMBefore=function(t){var e=t.substring(0,2);return"ko"==e||"zh"==e},_t._getDMYOrder=function(t){var e=t.substring(0,2);return"en-us"==t||"en-ph"==t?"MDY":"fa"==e||"hu"==e||"ja"==e||"ko"==e||"lt"==e||"mn"==e||"zh"==e?"YMD":"DMY"},_t._getYearTrailingCharacters=function(t){return 0==t.indexOf("ja")||0==t.indexOf("zh")?"年":0==t.indexOf("ko")?"년":""},_t._getDayTrailingCharacters=function(t){return 0==t.indexOf("ja")||0==t.indexOf("zh")?"日":0==t.indexOf("ko")?"일":""},_t.prototype.formatLabel=function(t){var e=new Date(t),i=this._formatAxisLabel(e,null,!0);return null!=i[1]?"YMD"==_t._getDMYOrder(this._locale)||this._timeRange<_t.TIME_MONTH_MIN&&this._step<_t.TIME_DAY?i[1]+" "+i[0]:i[0]+" "+i[1]:i[0]},_t.prototype._calculateGranularity=function(){return this._step>=_t.TIME_YEAR_MIN||this._timeRange>=6*_t.TIME_YEAR_MIN?_t.TIME_YEAR_MIN:this._step>=_t.TIME_MONTH_MIN||this._timeRange>=6*_t.TIME_MONTH_MIN?_t.TIME_MONTH_MIN:this._step>=_t.TIME_DAY||this._timeRange>=6*_t.TIME_DAY?_t.TIME_DAY:this._step>=_t.TIME_HOUR||this._timeRange>=6*_t.TIME_HOUR?_t.TIME_HOUR:this._step>=_t.TIME_MINUTE||this._timeRange>=6*_t.TIME_MINUTE?_t.TIME_MINUTE:_t.TIME_SECOND},_t.prototype._formatAxisLabelWithConverter=function(t,e,i){if(i){var r=null,a=null;if(i.format&&(r=i.format(this._dateToIsoWithTimeZoneConverter&&t?this._dateToIsoWithTimeZoneConverter(t):t),a=i.format(this._dateToIsoWithTimeZoneConverter&&e?this._dateToIsoWithTimeZoneConverter(e):e)),a!=r)return r}return null},_t.prototype._formatAxisLabel=function(t,e,i){var r=null,a=null,s="left"==this.Position||"right"==this.Position,n=this._calculateGranularity();return this._label1Converter||this._label2Converter?(this._label1Converter&&(r=this._formatAxisLabelWithConverter(t,e,this._label1Converter)),this._label2Converter&&(a=this._formatAxisLabelWithConverter(t,e,this._label2Converter)),[r,a]):(n===_t.TIME_YEAR_MIN?r=this._formatDate(t,!1,!1,!0):n===_t.TIME_MONTH_MIN?(null!=e&&e.getMonth()==t.getMonth()||(r=this._formatDate(t,!1,!0,!1)),null!=e&&e.getYear()==t.getYear()||(a=this._formatDate(t,!1,!1,!0))):n===_t.TIME_DAY?i?r=this._formatDate(t,!0,!0,!0):(null!=e&&e.getDate()==t.getDate()||(r=this._formatDate(t,!0,!1,!1)),null==e||e.getYear()!=t.getYear()?a=this._formatDate(t,!1,!0,!0):e.getMonth()!=t.getMonth()&&(a=this._formatDate(t,!1,!0,!1))):(n===_t.TIME_HOUR?null!=e&&e.getHours()==t.getHours()||(r=this._formatTime(t,!1,!1)):n===_t.TIME_MINUTE?null!=e&&e.getMinutes()==t.getMinutes()||(r=this._formatTime(t,!0,!1)):null!=e&&e.getSeconds()==t.getSeconds()||(r=this._formatTime(t,!0,!0)),s?null!=e&&e.getDate()==t.getDate()||(a=this._formatDate(t,!0,!0,!1)):null==e||e.getYear()!=t.getYear()?a=this._formatDate(t,!0,!0,!0):e.getMonth()!=t.getMonth()?a=this._formatDate(t,!0,!0,!1):e.getDate()!=t.getDate()&&(a=this._formatDate(t,!0,!1,!1))),[r,a])},_t.prototype._formatDate=function(t,e,i,r){var a,s=t.getFullYear();a=this._monthResources&&this._monthResources.length>=12?this._monthResources[t.getMonth()]:t.toString().split(" ")[1];var n=t.getDate();s+=_t._getYearTrailingCharacters(this._locale),n+=_t._getDayTrailingCharacters(this._locale);for(var o=_t._getDMYOrder(this._locale),l="",h=0;h<o.length;h++)e&&"D"==o[h]?l+=n+" ":i&&"M"==o[h]?l+=a+" ":r&&"Y"==o[h]&&(l+=s+" ");return l.length>0?l.slice(0,l.length-1):l},_t.prototype._formatTime=function(t,i,r){var a,s=t.getHours(),n=t.getMinutes(),o=t.getSeconds(),l=_t._getAMString(this._locale),h=_t._getPMString(this._locale),u=_t._getAMPMBefore(this._locale),g=""!=l&&""!=h,d="";return e.Agent.isRightToLeft(this.getCtx())&&(d="‏"),g?(s<12?(a=l,0==s&&(s=12)):(a=h,s>12&&(s-=12)),d+=s,(i||0!=n)&&(d+=":"+this._doubleDigit(n))):d+=this._doubleDigit(s)+":"+this._doubleDigit(n),r&&(d+=":"+this._doubleDigit(o)),g?u?a+" "+d:d+" "+a:d},_t.prototype._doubleDigit=function(t){return t<10?"0"+t:""+t},_t.prototype._getMixedFrequencyStep=function(){return this._timeRange>=6*_t.TIME_YEAR_MIN?_t.TIME_YEAR_MIN:this._timeRange>=6*_t.TIME_MONTH_MIN?_t.TIME_MONTH_MIN:this._timeRange>=6*_t.TIME_DAY?_t.TIME_DAY:this._timeRange>=_t.TIME_DAY?3*_t.TIME_HOUR:this._timeRange>=6*_t.TIME_HOUR?_t.TIME_HOUR:this._timeRange>=_t.TIME_HOUR?15*_t.TIME_MINUTE:this._timeRange>=30*_t.TIME_MINUTE?5*_t.TIME_MINUTE:this._timeRange>=6*_t.TIME_MINUTE?_t.TIME_MINUTE:this._timeRange>=_t.TIME_MINUTE?15*_t.TIME_SECOND:this._timeRange>=30*_t.TIME_SECOND?5*_t.TIME_SECOND:_t.TIME_SECOND},_t._getLabelPositions=function(t,e,i){var r=new Date(t),a=r.getTimezoneOffset();r.setMonth(0,1),r.setHours(0,0,0,0);var s=60*(a-r.getTimezoneOffset())*1e3,n=r.getTime()+s,o=[];if(i>=_t.TIME_YEAR_MIN&&i<=_t.TIME_YEAR_MAX){for(;n<t;)n=_t._addOneYear(n);for(;n<=e;)o.push(n),n=_t._addOneYear(n)}else if(i>=_t.TIME_MONTH_MIN&&i<=_t.TIME_MONTH_MAX){for(;n<t;)n=_t._addOneMonth(n);for(;n<=e;)o.push(n),n=_t._addOneMonth(n)}else for(n+=Math.ceil((t-n)/i)*i;n<=e;)o.push(n),n+=i;return o},_t._addOneYear=function(t){var e=new Date(t);return e.setFullYear(e.getFullYear()+1),e.getTime()},_t._addOneMonth=function(t){var e=new Date(t);return e.setMonth(e.getMonth()+1),e.getTime()},_t.prototype._generateLabels=function(t){var i=[],r=[],a=[],s=[],n=[],o=null,l=0,h=0,u=t.getStage(t),g=e.Agent.isRightToLeft(t),d="left"==this.Position||"right"==this.Position,c="off"!=this.Options.zoomAndScroll,p=!0,_=0;d&&"blink"===e.Agent.engine&&(_=.16*this.getTickLabelHeight());var f=[];if(null!=this._step)f=_t._getLabelPositions(this.MinValue,this.MaxValue,this._step);else if(this._mixedFrequency)this._step=this._getMixedFrequencyStep(),f=_t._getLabelPositions(this.MinValue,this.MaxValue,this._step);else{for(var v=0;v<this._groups.length;v++)this._groups[v]>=this.MinValue&&this._groups[v]<=this.MaxValue&&f.push(this._groups[v]);if(this._step=this._averageInterval,!this._skipGaps){var m;if((f=_t._treatMissingValues(f,this._calculateGranularity())).length>1&&(this._step=(f[f.length-1]-f[0])/(f.length-1)),d)m=e.TextUtils.getTextStringHeight(t,this.Options.tickLabel.style);else{var S=this._formatAxisLabel(new Date(f[0]))[0];m=e.TextUtils.getTextStringWidth(t,S,this.Options.tickLabel.style)}(m+this.GetTickLabelGapSize())*(f.length-1)>Math.abs(this._endCoord-this._startCoord)&&(this._step=this._getMixedFrequencyStep(),f=_t._getLabelPositions(this.MinValue,this.MaxValue,this._step))}}0==f.length&&(f=[this.MinValue]);for(v=0;v<f.length;v++){var C=f[v],y=this.getCoordAt(C);if(null!=y){var x=new Date(C),A=this._formatAxisLabel(x,o),b=A[0],M=A[1];if(null!=b?(a.push({text:b,coord:null!=M?y+_:y}),s.push(y),l++):(a.push(null),s.push(null)),i.push(null),c&&p&&(y=this.MinValue?this.getCoordAt(this.MinValue):y),p=!1,null!=M){var T=this.CreateLabel(t,M,null!=M?y-_:y);n.push(y),d||(g?T.alignRight():T.alignLeft()),r.push(T),this._isOneLevel=!1,h++}else r.push(null),n.push(null);o=x}}if(l=this._skipLabelsUniform(a,i,u,!1,g),!c&&h>1&&l<1.5*h){i=r,r=null;for(var I=0;I<i.length;I++)null!=i[I]&&i[I].alignCenter();l=this._skipLabelsGreedy(i,this.GetLabelDims(i,u),!1,g)}else 0==(h=this._skipLabelsGreedy(r,this.GetLabelDims(r,u),!0,g))&&(r=null);d&&null!=r&&this._skipVertLabels(i,r,u),this._level1Labels=i,this._level2Labels=r,this._level1Coords=s,this._level2Coords=n},_t._getGCDInterval=function(t){for(var e=function(t,i){return 0===t?i:e(i%t,t)},i=t[0],r=1;r<t.length;r++)if(1===(i=e(i,t[r])))return 1;return i},_t._calculateGranularInterval=function(t,e,i){var r,a=t.getTimezoneOffset(),s=e.getTimezoneOffset(),n=e.getTime(),o=1e3*(a-s)*60;return o>0&&e.setTime(n+o),r=i===_t.TIME_YEAR_MIN?e.getFullYear()-t.getFullYear():i===_t.TIME_MONTH_MIN?12*(e.getFullYear()-t.getFullYear())+(e.getMonth()-t.getMonth()):Math.round((e.getTime()-t.getTime())/i),o>0&&e.setTime(n),r},_t._treatMissingValues=function(t,e){var i,r,a=new Set,s=!1,n=t,o=[],l=t.length,h=new Date(t[0]);for(r=1;r<l;r++){var u=new Date(t[r]),g=_t._calculateGranularInterval(h,u,e);h=u,o.push(g),g<=0||(a.add(g),i?g!==i&&(s=!0):i=g)}if(s){var d=_t._getGCDInterval([...a]);for((n=[]).push(t[0]),r=1;r<l;r++){var c=t[r],p=t[r-1];if((g=o[r-1])<=d)n.push(c);else{var _,f=g/d,v=f-1,m=Math.round((c-p)/f);for(_=1;_<=v;_++)p+=m,n.push(p);n.push(c),p=c}}}return n},_t._isOverlapping=function(t,e,i,r,a){return i>=t&&i-a<e||i<t&&r+a>t},_t.prototype._getLabelOverflow=function(t,e,i,r){var a=t-(i?r?e:0:.5*e);if(a<this.Options._minOverflowCoord)return Math.floor(a-this.Options._minOverflowCoord);var s=t+(i?r?0:e:.5*e);return s>this.Options._maxOverflowCoord?Math.ceil(s-this.Options._maxOverflowCoord):0},_t.prototype._skipLabelsGreedy=function(t,e,i,r){if(!e||e.length<=0)return!1;for(var a,s,n,o,l,h="left"==this.Position||"right"==this.Position,u=this.getTickLabelHeight(),g=h?.08*u:.24*u,d=0,c=Math.abs(this._endCoord-this._startCoord),p=0;p<e.length;p++)if(this._level2Overflow.push(0),null!=t[p]){var _=(l=t[p]).getDimensions().w;if(e[p].w>c)t[p]=null;else{var f=this._getLabelOverflow(l.getX(),_,i,r);this._level2Overflow[p]=f,0!=f&&(l.setX(l.getX()-f),e[p].x-=f)}}for(p=0;p<e.length;p++)null!=e[p]&&(h?(n=e[p].y,o=e[p].y+e[p].h):(n=e[p].x,o=e[p].x+e[p].w),null!=a&&null!=s&&_t._isOverlapping(a,s,n,o,g)&&(t[p]=null),null!=t[p]&&(a=n,s=o,d++));return d},_t.prototype._skipLabelsUniform=function(t,e,i,r){for(var a=[],s=[],n=Math.abs(this._endCoord-this._startCoord),o=0;o<t.length;o++)null!=t[o]&&(a.push(t[o]),s.push(null),this._level1Overflow.push(0));for(var l="left"==this.Position||"right"==this.Position,h=this,u=function(t){if(null==s[t])if(a[t].label=h.CreateLabel(i.getCtx(),a[t].text,a[t].coord),s[t]=a[t].label.getDimensions(i),s[t].w>n)a[t].label=null,s[t].w=0,s[t].h=0;else{var e=h._getLabelOverflow(a[t].coord,s[t].w,!1,r);0!=e&&(a[t].coord-=e,s[t].x-=e,a[t].label.setX(a[t].label.getX()-e),h._level1Overflow[t]=e)}return l?s[t].h:s[t].w},g=(u(0)+this.GetTickLabelGapSize())*(a.length-1),d=n>0?Math.ceil(g/n)-1:0,c=!0;c;){for(o=0;o<a.length;o++)o%(d+1)==0?(u(o),a[o].skipped=!1):a[o].skipped=!0;c=this.IsOverlapping(s,d),d++}var p=0;for(o=0;o<t.length;o++)null==t[o]||t[o].skipped||(e[o]=t[o].label,p++);return p},_t.prototype._skipVertLabels=function(t,e,i){for(var r=.08*this.getTickLabelHeight(),a=function(t,e){return _t._isOverlapping(t.y,t.y+t.h,e.y,e.y+e.h,r)},s=null,n=!1,o=0;o<t.length;o++)if(t[o]&&e[o]){if(t[o].alignTop(),e[o].alignBottom(),s&&a(s,e[o].getDimensions())){n=!0;break}s=t[o].getDimensions()}else if(t[o]||e[o]){var l=t[o]?t[o]:e[o];if(s&&a(s,l.getDimensions())){n=!0;break}s=l.getDimensions()}if(n){var h,u=null,g=null,d=null;for(o=0;o<t.length;o++)e[o]?(t[o]=null,e[o].alignMiddle(),h=e[o].getDimensions(),g&&a(g,h)&&(t[u]=null),d=h):t[o]&&(h=t[o].getDimensions(),d&&a(d,h)?t[o]=null:(g=h,u=o))}},_t.prototype.getLabels=function(t,e){return e&&e>1?null:(this._level1Labels||this._generateLabels(t),1==e?this._level2Labels:this._level1Labels)},_t.prototype.getMajorTickCoords=function(){var t=[];if(this._isOneLevel)for(var e=0;e<this._level1Coords.length;e++)null!=this._level1Coords[e]&&null!=this._level1Labels[e]&&t.push(this._level1Coords[e]);else for(e=1;e<this._level2Coords.length;e++)null!=this._level2Coords[e]&&t.push(this._level2Coords[e]);return t},_t.prototype.getMinorTickCoords=function(){if(this._isOneLevel)return[];for(var t=[],e=0;e<this._level1Coords.length;e++)null!=this._level1Coords[e]&&null!=this._level1Labels[e]&&t.push(this._level1Coords[e]);return t},_t.prototype.getUnboundedValueAt=function(t){if(null==t)return null;var e=(t-this._startCoord)/(this._endCoord-this._startCoord);if(this._skipGaps){var i=this._timeToIndex(this.MinValue),r=this._timeToIndex(this.MaxValue);return this._indexToTime(i+e*(r-i))}return this.MinValue+e*(this.MaxValue-this.MinValue)},_t.prototype.getUnboundedCoordAt=function(t){if(null==t)return null;var e;if(this._skipGaps){var i=this._timeToIndex(this.MinValue),r=this._timeToIndex(this.MaxValue);e=(this._timeToIndex(t)-i)/(r-i)}else e=(t-this.MinValue)/(this.MaxValue-this.MinValue);return this._startCoord+e*(this._endCoord-this._startCoord)},_t.prototype.linearToActual=function(t){return null==t?null:this._skipGaps?this._indexToTime(t):t},_t.prototype.actualToLinear=function(t){return null==t?null:this._skipGaps?this._timeToIndex(t):t},_t.prototype._timeToIndex=function(t){for(var e=this._groups.length,i=0;i<this._groups.length;i++)if(t<=this._groups[i]){e=i;break}var r=e-1,a=void 0!==this._groups[r]?this._groups[r]:this._groups[0]-this._averageInterval;return r+(t-a)/((void 0!==this._groups[e]?this._groups[e]:this._groups[this._groups.length-1]+this._averageInterval)-a)},_t.prototype._indexToTime=function(t){var e=Math.min(Math.max(Math.ceil(t),0),this._groups.length),i=e-1,r=void 0!==this._groups[i]?this._groups[i]:this._groups[0]-this._averageInterval;return r+(t-i)*((void 0!==this._groups[e]?this._groups[e]:this._groups[this._groups.length-1]+this._averageInterval)-r)},_t.prototype.getGroupWidth=function(){return this._skipGaps?Math.abs(this.getUnboundedCoordAt(this._indexToTime(1))-this.getUnboundedCoordAt(this._indexToTime(0))):Math.abs(this.getUnboundedCoordAt(this.MinValue+this._averageInterval)-this.getUnboundedCoordAt(this.MinValue))},_t.prototype.getMinimumExtent=function(){return this._skipGaps?1:this._mixedFrequency?Math.min((this.getGlobalMax()-this.getGlobalMin())/8,this._averageInterval):this._averageInterval},_t.prototype.getStartOverflow=function(){return"top"!=this.Position&&"bottom"!=this.Position||!e.Agent.isRightToLeft(this.getCtx())?this.StartOverflow:this.EndOverflow},_t.prototype.getEndOverflow=function(){return"top"!=this.Position&&"bottom"!=this.Position||!e.Agent.isRightToLeft(this.getCtx())?this.EndOverflow:this.StartOverflow};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var ft=new Object;e.Obj.createSubclass(ft,e.Obj),ft.renderBackgroundObjects=function(t,e,i){ft._renderObjects(t,e,i,"back")},ft.renderForegroundObjects=function(t,e,i){ft._renderObjects(t,e,i,"front")},ft._renderObjects=function(t,e,i,r){ft._renderObjectsForAxis(t,e,i,r,t.xAxis,g.getAxisRefObjs(t,"x")),ft._renderObjectsForAxis(t,e,i,r,t.yAxis,g.getAxisRefObjs(t,"y")),ft._renderObjectsForAxis(t,e,i,r,t.y2Axis,g.getAxisRefObjs(t,"y2"))},ft._renderObjectsForAxis=function(t,e,i,r,a,s){if(s&&a)for(var n=0;n<s.length;n++){var o=s[n];if(f.isObjectRendered(t,o)&&(o&&f.getLocation(o)==r)){var l,h,u=f.getType(o);if("area"==u?l=ft._createReferenceArea(o,t,i,a):"line"==u&&(l=ft._createReferenceLine(o,t,i,a),h=ft._createReferenceLine(o,t,i,a,!0)),null!=l){var g=a==t.xAxis?"xAxis":a==t.yAxis?"yAxis":"y2Axis",d=new S(t,h?[l,h]:[l],o,n,g);t.registerObject(d),t.getEventManager().associate(l,d),e.addChild(l),h&&e.addChild(h)}}}},ft._createReferenceArea=function(t,i,r,a){var s,n=i.getCtx(),o=a.getPosition(),u="top"==o||"bottom"==o,d="radial"==o,c=f.getColor(i,t),p=f.getLineType(t),_=t.style||t.svgStyle,v=t.className||t.svgClassName;if(null==t.items||a!=i.yAxis&&a!=i.y2Axis){var m=f.getLowValue(t),S=f.getHighValue(t);null!=m&&m!=-1/0||(m=a.getInfo().getGlobalMin()),null!=S&&S!=1/0||(S=a.getInfo().getGlobalMax());var C=ft._getAxisCoord(i,a,m),y=ft._getAxisCoord(i,a,S);if(l.isPolar(i)){var x,A=r.x+r.w/2,b=r.y+r.h/2;if(d)if(L.isGridPolygonal(i)){var M=g.getGroupCount(i),T=e.PolygonUtils.getRegularPolygonPoints(A,b,M,y,0,1),I=e.PolygonUtils.getRegularPolygonPoints(A,b,M,C,0,0);x=e.PathUtils.polyline(T)+e.PathUtils.polyline(I)+e.PathUtils.closePath()}else x=e.PathUtils.moveTo(A,b-y)+e.PathUtils.arcTo(y,y,Math.PI,1,A,b+y)+e.PathUtils.arcTo(y,y,Math.PI,1,A,b-y)+e.PathUtils.moveTo(A,b-C)+e.PathUtils.arcTo(C,C,Math.PI,0,A,b+C)+e.PathUtils.arcTo(C,C,Math.PI,0,A,b-C)+e.PathUtils.closePath();else{var D=i.getRadius(),O=h.polarToCartesian(D,C,r),E=h.polarToCartesian(D,y,r);x=e.PathUtils.moveTo(A,b)+e.PathUtils.lineTo(O.x,O.y)+e.PathUtils.arcTo(D,D,y-C,e.Agent.isRightToLeft(n)?0:1,E.x,E.y)+e.PathUtils.lineTo(E.x,E.y)+e.PathUtils.closePath()}s=new e.Path(n,x)}else{var P;P=u?[C,0,y,0,y,r.h,C,r.h]:[0,C,0,y,r.w,y,r.w,C],s=new e.Polygon(n,P)}s.setSolidFill(c),s.setStyle(_).setClassName(v)}else{var w=t.items,R=[],B=[];if(i.xAxis.isGroupAxis())for(;w.length<g.getGroupCount(i);)w.push(null);for(var k=0;k<w.length;k++){var F=w[k],N=f.getLowValue(F),H=f.getHighValue(F);if(null!=N&&null!=H){var G=a.getUnboundedCoordAt(N),U=a.getUnboundedCoordAt(H),j=i.xAxis.getUnboundedCoordAt(f.getXValue(i,w,k));R.push(new ot(j,U,U)),B.push(new ot(j,G,G))}else R.push(new ot),B.push(new ot)}s=new lt(i,!0,r,null,_,v,new e.SolidFill(c),null,p,R,p,B)}return s},ft._createReferenceLine=function(t,i,r,a,s){var n,o=a.getPosition(),l="top"==o||"bottom"==o,u="radial"==o,d="tangential"==o,c=f.getLineWidth(i,t),p=f.getLineType(t),_=f.getColor(i,t),v=t.style||t.svgStyle,m=s?"oj-chart-reference-object-inner-line":t.className||t.svgClassName,S=new e.Stroke(_,1,c,!1,e.Stroke.getDefaultDashProps(t.lineStyle,c)),C=i.getCtx();if(null==t.items||a!=i.yAxis&&a!=i.y2Axis){if(null==t.value)return null;var y=ft._getAxisCoord(i,a,t.value);if(null==y||y==1/0||y==-1/0)return null;s&&(y-=Math.ceil(c/2));var x=r.x+r.w/2,A=r.y+r.h/2;if(u){if(L.isGridPolygonal(i)){M=e.PolygonUtils.getRegularPolygonPoints(x,A,g.getGroupCount(i),y,0);n=new e.Polygon(C,M)}else n=new e.Circle(C,x,A,y);n.setFill(null)}else if(d){var b=h.polarToCartesian(i.getRadius(),y,r);n=new e.Line(C,x,A,b.x,b.y)}else(n=l?new e.Line(C,y,0,y,r.h):new e.Line(C,0,y,r.w,y)).setPixelHinting(!0);n.setStroke(S),n.setStyle(v).setClassName(m)}else{var M,T=t.items;if([].push(M=[]),i.xAxis.isGroupAxis())for(;T.length<g.getGroupCount(i);)T.push(null);for(var I=[],D=0;D<T.length;D++){var O=T[D],E=null;if(null!=O&&("object"!=typeof O?E=O:null!=O.value&&(E=O.value)),null!=E){var P=a.getUnboundedCoordAt(E)-(s?c/2:0),w=i.xAxis.getUnboundedCoordAt(f.getXValue(i,T,D));I.push(new ot(w,P,P))}else I.push(new ot)}n=new lt(i,!1,r,null,v,m,null,S,p,I)}return n},ft._getAxisCoord=function(t,e,i){if(e.isGroupAxis()){var r=g.getGroupIndex(t,i);if(r>=0)return e.getUnboundedCoordAt(r)}return isNaN(i)?null:e.getUnboundedCoordAt(i)};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var vt=new Object;e.Obj.createSubclass(vt,e.Obj),vt._MIN_BUBBLE_SIZE=6,vt._MAX_BUBBLE_SIZE_RATIO=.5,vt.calcBubbleSizes=function(t,i){for(var r,a,s=L.getMinMaxValue(t,"z"),n=s.min,o=s.max,h=vt._MIN_BUBBLE_SIZE,u=vt._MAX_BUBBLE_SIZE_RATIO*Math.min(i.w,i.h),d=g.getSeriesCount(t),c="withoutRescale"==E.getHideAndShowBehavior(t),p=t.getOptionsCache(),_=0;_<d;_++)if(c||g.isSeriesRendered(t,_))for(var f=g.getSeriesItem(t,_),v=f.items?f.items.length:0,m=0;m<v;m++){var S=f.items[m];if(S){var C=e.LayoutUtils.getBubbleSize(S.z,n,o,h,u);p.putToCachedMap2D("bubbleSizeCache",_,m,C)}}l.isPolar(t)?(r=1/0,a=t.getRadius()):(r=i.w-2.4*L.getTickLabelHeight(t,"y"),a=i.h-1.6*L.getTickLabelHeight(t,"x")),r-=.5*u,a-=.5*u;var y=t.getCache(),x=vt._getAxisValueRange(t,"x");y.putToCache("_xAxisBubbleRatio",x/r);var A=vt._getAxisValueRange(t,"y");y.putToCache("_yAxisBubbleRatio",A/a)},vt._getAxisValueRange=function(t,i){var r=t.getOptions()[i+"Axis"],a=L.isLog(t,i),s=!a&&"zero"==L.getBaselineScaling(t,i),n=L.getMinMaxValue(t,i,!0),o=r.min;null==o&&(o=s?Math.min(0,n.min):n.min);var l=r.max;return null==l&&(l=s?Math.max(0,n.max):n.max),a&&l>0&&o>0?l==o?6:e.Math.log10(l/o):l==o?60:l-o},vt.sortMarkers=function(t){t.sort(vt._compareSize)},vt.sortMarkerInfos=function(t){t.sort(vt._compareInfoSize)},vt._compareSize=function(t,e){return e.getSize()-t.getSize()},vt._compareInfoSize=function(t,e){return e.size-t.size},vt.checkPixelMap=function(t,e,i,r){var a=r/2,s=Math.max(Math.floor(e-a),0),n=Math.max(Math.floor(i-a),0),o=Math.max(Math.ceil(e+a),0),l=Math.max(Math.ceil(i+a),0);return t.isObscured(s,n,o,l)},vt.updatePixelMap=function(t,e,i,r,a){var s=.4*r,n=Math.max(Math.round(e-s),0),o=Math.max(Math.round(e+s),0),l=Math.max(Math.round(i-s),0),h=Math.max(Math.round(i+s),0);t.obscure(n,l,o,h,a)};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var mt=new Object;e.Obj.createSubclass(mt,e.Obj),mt._MIN_TOUCH_MARKER_SIZE=16,mt._MIN_CHARS_DATA_LABEL=3,mt.FILTER_THRESHOLD_SCATTER_BUBBLE=1e4,mt.render=function(t,e,i){"off"==t.getOptions().plotArea.rendered?mt._renderAxisLines(t,e,i):i.w>0&&i.h>0&&(t._currentMarkers=new Array,t._currentAreas=new Array,mt._renderBackgroundObjects(t,e,i),mt._renderTicks(t,e,i),mt._renderForegroundObjects(t,e,i))},mt._renderBackgroundObjects=function(t,i,r){var a=t.getOptions(),s=mt._getBackgroundShape(t,r),n=p.getBackgroundColor(t);if(n?s.setSolidFill(n):s.setInvisibleFill(),i.addChild(s),t.getCache().putToCache("plotAreaBackground",s),E.isPlotAreaDraggable(t)&&s.setClassName("oj-draggable"),a.xAxis.referenceObjects||a.yAxis.referenceObjects||a.y2Axis.referenceObjects){var o=mt.createClippedGroup(t,i,r);ft.renderBackgroundObjects(t,o,r)}if(l.isBLAC(t)){var h=new e.Container(t.getCtx());i.addChild(h),t.__setAreaContainer(h),g.hasAreaSeries(t)&&mt._renderAreas(t,h,r,!1)}},mt._getBackgroundShape=function(t,i){var r,a=t.getCtx();if(l.isPolar(t)){var s=i.x+i.w/2,n=i.y+i.h/2;if(L.isGridPolygonal(t)){var o=e.PolygonUtils.getRegularPolygonPoints(s,n,g.getGroupCount(t),t.getRadius(),0);r=new e.Polygon(a,o)}else r=new e.Circle(a,s,n,t.getRadius())}else r=new e.Rect(a,i.x,i.y,i.w,i.h);return r},mt._renderTicks=function(t,e,i){t.xAxis&&L.isMinorTickRendered(t,"x")&&mt._renderMinorTicks(t,e,t.xAxis,i),t.yAxis&&L.isMinorTickRendered(t,"y")&&mt._renderMinorTicks(t,e,t.yAxis,i),t.y2Axis&&L.isMinorTickRendered(t,"y2")&&mt._renderMinorTicks(t,e,t.y2Axis,i),t.xAxis&&L.isMajorTickRendered(t,"x")&&mt._renderMajorTicks(t,e,t.xAxis,i),t.yAxis&&L.isMajorTickRendered(t,"y")&&mt._renderMajorTicks(t,e,t.yAxis,i),t.y2Axis&&L.isMajorTickRendered(t,"y2")&&mt._renderMajorTicks(t,e,t.y2Axis,i)},mt._renderAxisLines=function(t,e,i){t.xAxis&&t.yAxis&&L.isAxisLineRendered(t,"x")&&mt._renderAxisLine(t,e,t.xAxis,t.yAxis,i),t.xAxis&&t.y2Axis&&L.isAxisLineRendered(t,"x")&&(t.yAxis&&!g.isSplitDualY(t)||mt._renderAxisLine(t,e,t.xAxis,t.y2Axis,i)),t.yAxis&&t.xAxis&&L.isAxisLineRendered(t,"y")&&mt._renderAxisLine(t,e,t.yAxis,t.xAxis,i),t.y2Axis&&t.xAxis&&L.isAxisLineRendered(t,"y2")&&mt._renderAxisLine(t,e,t.y2Axis,t.xAxis,i)},mt._renderMajorTicks=function(t,e,i,r){mt._renderGridlines(t,e,i.getOptions().majorTick,i.getPosition(),i.getMajorTickCoords(),i.getBaselineCoord(),r)},mt._renderMinorTicks=function(t,e,i,r){mt._renderGridlines(t,e,i.getOptions().minorTick,i.getPosition(),i.getMinorTickCoords(),null,r)},mt._renderAxisLine=function(t,e,i,r,a){var s=i.getOptions(),n=s.position,o="bottom"==n||"right"==n||"tangential"==n?r.getMaxCoord():r.getMinCoord();mt._renderGridlines(t,e,s.axisLine,r.getPosition(),[o],null,a)},mt._renderGridlines=function(t,i,r,a,s,n,o){var l=r.lineColor,h=r.lineStyle,u=new e.Stroke(l,1,r.lineWidth,!1,e.Stroke.getDefaultDashProps(h,r.lineWidth)),g=u.getColor();"inherit"!=r.baselineColor&&(g="auto"==r.baselineColor?e.ColorUtils.getDarker(l,.6):r.baselineColor);for(var d=null!=r.baselineWidth?r.baselineWidth:r.lineWidth,c=r.baselineStyle?r.baselineStyle:r.lineStyle,p=new e.Stroke(g,1,d,!1,e.Stroke.getDefaultDashProps(c,d)),_="",f=0;f<s.length;f++){var v=null!=n&&s[f]==n;"radial"==a||"tangential"==a||v?mt._renderGridline(t,i,a,s[f],v?p:u,o):_+="top"==a||"bottom"==a?e.PathUtils.moveTo(s[f],o.y)+e.PathUtils.verticalLineTo(o.y+o.h):e.PathUtils.moveTo(o.x,s[f])+e.PathUtils.horizontalLineTo(o.x+o.w)}if(""!=_){var m=new e.Path(t.getCtx(),_);(!e.Agent.isTouchDevice()||e.Agent.getDevicePixelRatio()>1)&&m.setPixelHinting(!0),m.setStroke(u),m.setMouseEnabled(!1),i.addChild(m)}},mt._renderGridline=function(t,i,r,a,s,n){var o,l=i.getCtx(),h=!e.Agent.isTouchDevice()||e.Agent.getDevicePixelRatio()>1;if("radial"==r){if(L.isGridPolygonal(t)){var u=e.PolygonUtils.getRegularPolygonPoints(0,0,g.getGroupCount(t),a,0);o=new e.Polygon(l,u)}else o=new e.Circle(l,0,0,a);o.setInvisibleFill(),o.setTranslate(n.x+n.w/2,n.y+n.h/2)}else if("tangential"==r){o=new e.Line(l,0,0,t.getRadius()*Math.sin(a),-t.getRadius()*Math.cos(a));var d=a%(Math.PI/2);(d<.001||d>Math.PI/2-.001)&&h&&o.setPixelHinting(!0),o.setTranslate(n.x+n.w/2,n.y+n.h/2)}else o="top"==r||"bottom"==r?new e.Line(l,a,n.y,a,n.y+n.h):new e.Line(l,n.x,a,n.x+n.w,a),h&&o.setPixelHinting(!0);o.setStroke(s),o.setMouseEnabled(!1),i.addChild(o)},mt._renderForegroundObjects=function(t,e,i){var r=t.getOptions(),a=mt.createClippedGroup(t,e,i);mt._renderAxisLines(t,e,i);var s=r.plotArea.borderColor,n=r.plotArea.borderWidth;if(s&&0!=n){var o=mt._getBackgroundShape(t,i);o.setInvisibleFill(),o.setSolidStroke(s,null,n),o.setMouseEnabled(!1),e.addChild(o)}l.isBLAC(t)?(g.hasLineWithAreaSeries(t)&&mt._renderAreas(t,e,i,!0),g.hasBarSeries(t)&&mt._renderBars(t,a,i),g.hasCandlestickSeries(t)&&mt._renderStock(t,a,i),g.hasBoxPlotSeries(t)&&mt._renderBoxPlot(t,a,i),g.hasLineSeries(t)&&mt._renderLines(t,e,a,i)):l.isScatterBubble(t)&&mt._renderScatterBubble(t,e,a,!0,i),(r.xAxis.referenceObjects||r.yAxis.referenceObjects||r.y2Axis.referenceObjects)&&(a=mt.createClippedGroup(t,e,i),ft.renderForegroundObjects(t,a,i));var h=g.getInitialSelection(t);k.setInitialSelection(t,h),t.highlight(g.getHighlightedCategories(t))},mt._renderDataLabel=function(t,i,r,a,s,n,o,h,u,d){if(!l.isOverview(t)){var c="bar"==g.getSeriesType(t,a),_=l.isHorizontal(t),f={width:_?r.w:d,height:_?d:r.h},v=t.getOptions(),m=v.styleDefaults,S=null!=t.y2Axis,C="on"===v.legend.rendered;c&&t.getOptionsCache().putToCachedMap2D("barDims",a,s,f);var y=p.getDataLabel(t,a,s,n,h,u);if(null!=y){var x=w.getDataLabelPosition(t,a,s,n,h,u);if("none"!=x){var A=new e.OutputText(t.getCtx(),y,0,0);A.setMouseEnabled(!1);var b=u?m.stackLabelStyle:p.getDataLabelStyle(t,a,s,n,o,x,h);A.setCSSStyle(b),A.setY(r.y+r.h/2),A.setX(r.x+r.w/2),A.alignCenter(),A.alignMiddle();var M=A.getDimensions(),T=t.getCache().getFromCache("plotAreaDims");T||(T=t.getPlotArea().getDimensions(),t.getCache().putToCache("plotAreaDims",T));var I=function(t,e,i,r){var a={x:null,y:null},s=r&&r.xAxis&&("left"==t||"right"==t),n=r&&r.top&&("left"==t||"right"==t),o=r&&((S||!C)&&r.y2Axis||r.legend)&&("top"==t||"bottom"==t),l=r&&r.yAxis&&("top"==t||"bottom"==t);"left"==t?a.x=e.x-i.w/2-p.MARKER_DATA_LABEL_GAP:"right"==t?a.x=e.x+e.w+i.w/2+p.MARKER_DATA_LABEL_GAP:"top"==t?a.y=e.y-i.h/2:"bottom"==t&&(a.y=e.y+e.h+i.h/2+p.MARKER_DATA_LABEL_GAP/2);var h=2*p.MARKER_DATA_LABEL_GAP;return o?a.x=T.x+T.w-i.w/2-h:l?a.x=i.w/2+h:s?a.y=T.y+T.h-i.h/2-h:n&&(a.y=i.h/2+h),a},D=m.dataLabelCollision,O=I(x,r,M);if("fitInBounds"===D){var E=p.getDataLabelCollisions(t,O,M,T,_),P=p.adjustDataLabelPosition(x,E,S);P!=x&&l.isBubble(t)&&(b=u?m.stackLabelStyle:p.getDataLabelStyle(t,a,s,n,o,P,h),A.setCSSStyle(b)),O=I(x=P,r,M,E)}if(null!=O.x||null!=O.y)null!=O.x&&A.setX(O.x),null!=O.y&&A.setY(O.y);else{if(c){if(M.w>f.width||M.h>f.height)return;"inLeft"==x?A.setX(r.x+M.w/2+p.MARKER_DATA_LABEL_GAP):"inRight"==x?A.setX(r.x+r.w-M.w/2-p.MARKER_DATA_LABEL_GAP):"inTop"==x?A.setY(r.y+M.h/2+p.MARKER_DATA_LABEL_GAP):"inBottom"==x&&A.setY(r.y+r.h-M.h/2-p.MARKER_DATA_LABEL_GAP/2)}else if(l.isBubble(t)){r.x+=p.MARKER_DATA_LABEL_GAP,r.y+=p.MARKER_DATA_LABEL_GAP,r.h-=2*p.MARKER_DATA_LABEL_GAP,r.w-=2*p.MARKER_DATA_LABEL_GAP;var L=e.TextUtils.getOptimalFontSize(A.getCtx(),A.getTextString(),A.getCSSStyle(),r);if(A.setFontSize(L),!e.TextUtils.fitText(A,r.w,r.h,i,mt._MIN_CHARS_DATA_LABEL))return}if(null!=p.getPattern(t,a,s)){var R=.15*(M=A.getDimensions()).h,B=e.PathUtils.roundedRectangle(M.x-R,M.y,M.w+2*R,M.h,2,2,2,2),k=new e.Path(t.getCtx(),B);k.setSolidFill("#FFFFFF",.9),i.addChild(k)}}if(l.isBar(t)){var F,N=A.getDimensions(),H=!1;if("left"==x&&N.x<0)H=!0,F=r.x-p.MARKER_DATA_LABEL_GAP;else if("right"==x&&N.x+N.w>T.w+p.MARKER_DATA_LABEL_GAP)H=!0,F=T.w-r.w-p.MARKER_DATA_LABEL_GAP;else{if("top"==x&&N.y<0)return;if("bottom"==x&&N.y+N.h>T.y+T.h+p.MARKER_DATA_LABEL_GAP)return}if(H){if(!isNaN(y))return;if(!e.TextUtils.fitText(A,F,r.h,i,1))return;M=A.getDimensions(),"left"==x?A.setX(r.x-M.w/2-p.MARKER_DATA_LABEL_GAP):"right"==x&&A.setX(r.x+r.w+M.w/2+p.MARKER_DATA_LABEL_GAP)}}p.optimizeMarkerStroke(t)&&A.setSolidStroke("none"),i.addChild(A),t.addDataLabel(A)}}}},mt._renderDataLabelForMarker=function(t,i,r){var a=t.getEventManager().getLogicalObject(r);if(a){var s=a.getSeriesIndex(),n=a.getGroupIndex(),o=a.getNestedDataItemIndex();if(r instanceof e.SimpleMarker){var l=new e.Rectangle(r.getCx()-r.getWidth()/2,r.getCy()-r.getHeight()/2,r.getWidth(),r.getHeight());mt._renderDataLabel(t,i,l,s,n,o,r.getDataColor())}else r instanceof gt&&(mt._renderDataLabel(t,i,r.getBoundingBox1(),s,n,o,r.getDataColor(),"low"),mt._renderDataLabel(t,i,r.getBoundingBox2(),s,n,o,r.getDataColor(),"high"))}},mt._renderScatterBubble=function(t,i,r,a,s){var n,o=mt._filterScatterBubble(t,a,s),h=g.getSeriesCount(t);for(n=0;n<h;n++)"none"!=p.getLineType(t,n)&&mt._renderLinesForSeries(t,r,n,s);var u=p.getMarkerBorderColor(t),d=p.getBorderWidth(t),c=new e.Stroke(u,1,d),_=[];if(o)for(var f=p.optimizeMarkerStroke(t),v=f?c.getColor():null,m=f?c.getWidth():null,S=0;S<o.length;S++){var C=o[S],y=mt._createMarker(t,C,v,m);_.push(y)}else{for(n=0;n<h;n++){var x=mt._getMarkersForSeries(t,n,s,c);_=_.concat(x)}a&&vt.sortMarkers(_)}l.isBubble(t)?mt._addMarkersToContainer(t,r,_,c):mt._addMarkersToContainer(t,i,_,c)},mt._renderMarkersForSeries=function(t,i,r,a){var s,n=p.getMarkerBorderColor(t,r),o=p.getBorderWidth(t,r),l=new e.Stroke(n,1,o);s=g.isRangeSeries(t,r)?mt._getRangeMarkersForSeries(t,r,a):mt._getMarkersForSeries(t,r,a,l),mt._addMarkersToContainer(t,i,s,l)},mt._addMarkersToContainer=function(t,i,r,a){var s=i,n=p.optimizeMarkerStroke(t),o=p.optimizeMarkerFill(t);(n||o)&&(s=new e.Container(t.getCtx()),n?s.setStroke(a):s.setInvisibleFill(),i.addChild(s));for(var l=0;l<r.length;l++)s.addChild(r[l]),mt._renderDataLabelForMarker(t,s,r[l]);t._currentMarkers.push(r)},mt._getMarkerInfo=function(t,i,r,a,s){var n=t.getOptions(),o=g.getValue(t,i,r,a);if(null==o||isNaN(o))return null;if(g.isDataItemFiltered(t,i,r))return null;var h=g.getGroupCount(t),u=p.isMarkerDisplayed(t,i,r,a);if(!u&&(null==a||a<0)){var d=h-1,c=l.isPolar(t),_=c&&d>0&&0==r?d:r-1,f=c&&d>0&&r==d?0:r+1,v=g.getValue(t,i,_),m=g.getValue(t,i,f);null!=v&&!isNaN(v)||null!=m&&!isNaN(m)||(u=!0)}if(!u){if(l.isSpark(t))return null;if((n._duringZoomAndScroll||l.isOverview(t))&&!g.isDataSelected(t,i,r,a))return null}if(!g.isDataItemRendered(t,i,r,a))return!1;var S=!0,C=g.getMarkerPosition(t,i,r,a,s),y=p.getMarkerSize(t,i,r,a);return s&&C&&y&&(S=s.intersects(new e.Rectangle(C.x-y/2,C.y-y/2,y,y))),C&&S?{seriesIndex:i,groupIndex:r,itemIndex:a,x:C.x,y:C.y,size:y,markerDisplayed:u}:null},mt._getScatterBubbleMarkerInfo=function(t,e,i,r){if(!g.isDataItemRendered(t,e,i))return!1;var a=g.getScatterBubbleMarkerPosition(t,e,i);if(!a)return null;var s=p.getMarkerSize(t,e,i);return s?{seriesIndex:e,groupIndex:i,x:a.x,y:a.y,size:s}:null},mt._getMarkersForSeries=function(t,e,i,r){if(!g.isSeriesRendered(t,e))return[];for(var a=p.optimizeMarkerStroke(t),s=a?r.getColor():null,n=a?r.getWidth():null,o=[],l=g.getGroupCount(t),h=0;h<l;h++){var u=mt._getMarkerInfo(t,e,h,null,i);if(u){var d=mt._createMarker(t,u,s,n);null!=d&&o.push(d)}}return o},mt._createMarker=function(t,i,r,a){var s,n=e.Agent.isTouchDevice(),o=t.getCtx(),h=p.optimizeMarkerStroke(t),u=p.optimizeMarkerFill(t),g=i.seriesIndex,d=i.groupIndex,c=i.itemIndex,_=p.getMarkerColor(t,g,d,c),f=p.getMarkerShape(t,g,d,c),v=i.markerDisplayed;if(null==v&&(v=p.isMarkerDisplayed(t,g,d,c)),v){var S=p.getImageSource(t,g,d,c,"source");if(S){var C=p.getImageSource(t,g,d,c,"sourceSelected"),y=p.getImageSource(t,g,d,c,"sourceHover"),x=p.getImageSource(t,g,d,c,"sourceHoverSelected");s=new e.ImageMarker(o,i.x,i.y,i.size,i.size,null,S,C,y,x),p.isSelectable(t,g,d)&&s.setCursor(e.SelectionEffectUtils.getSelectingCursor())}else{(s=new e.SimpleMarker(o,f,i.x,i.y,i.size,i.size,null,null,!0)).setFill(R.getMarkerFill(t,g,d,c));var A=p.getBorderColor(t,g,d,c),b=p.getDefaultMarkerBorderColor(t,g,d,c),M=p.getUserBorderWidth(t,g,d,c),T=p.getDefaultMarkerBorderWidth(t,g,d,c),I=A||b,D=null!==M?M:T;if(I===r&&D===a||s.setSolidStroke(I,null,D),s.setDataColor(_,!0),"redwood"===t.getCtx().getThemeBehavior())l.isBubble(t)&&s.addClassName("oj-dvt-bubble-marker"),A||l.isBubble(t)||s.addClassName("oj-dvt-default-border-color"),null==M&&s.addClassName("oj-dvt-default-border-width"),p.isSelectable(t,g,d)&&(s.setCursor(e.SelectionEffectUtils.getSelectingCursor()),l.isBubble(t)?s.setFeedbackClassName("oj-dvt-selectable"):s.setFeedbackClassName("oj-dvt-selectable-marker"));else{p.isSelectable(t,g,d)&&s.setCursor(e.SelectionEffectUtils.getSelectingCursor());var O=e.SelectionEffectUtils.getHoverBorderColor(_),E=p.getSelectedInnerColor(t),P=p.getSelectedOuterColor(t);s.setHoverStroke(new e.Stroke(E,1,1),new e.Stroke(O,1,3.5)),s.setSelectedStroke(new e.Stroke(E,1,1.5),new e.Stroke(P,1,4.5)),s.setSelectedHoverStroke(new e.Stroke(E,1,1.5),new e.Stroke(O,1,4.5))}s.addClassName(p.getMarkerClassName(t,g,d,c)),s.setStyle(p.getMarkerStyle(t,g,d,c))}n&&i.size<mt._MIN_TOUCH_MARKER_SIZE&&mt._addMarkerHitArea(s,i.x,i.y,h)}else p.isSelectable(t,g,d)?((s=new ht(o,f,i.x,i.y,i.size,h)).setCursor(e.SelectionEffectUtils.getSelectingCursor()),n&&mt._addMarkerHitArea(s,i.x,i.y,h)):(n&&(i.size=mt._MIN_TOUCH_MARKER_SIZE),s=new ht(o,e.SimpleMarker.SQUARE,i.x,i.y,i.size,h)),null!=s&&(u||s.setInvisibleFill(),s.setDataColor(_));return null!=s&&m.associate(s,t,g,d,c,i),s},mt._addMarkerHitArea=function(t,i,r,a){var s=new e.Rect(t.getCtx(),i-mt._MIN_TOUCH_MARKER_SIZE/2,r-mt._MIN_TOUCH_MARKER_SIZE/2,mt._MIN_TOUCH_MARKER_SIZE,mt._MIN_TOUCH_MARKER_SIZE);a&&s.setSolidStroke("none"),s.setInvisibleFill(),t.addChild(s)},mt._getRangeMarkersForSeries=function(t,i,r){if(!g.isSeriesRendered(t,i))return[];for(var a=e.Agent.isTouchDevice(),s=t.getCtx(),n=t.xAxis,o=g.isAssignedToY2(t,i)?t.y2Axis:t.yAxis,u=t.getOptions(),d=g.getGroupCount(t),c=[],_=0;_<d;_++)if(!g.isDataItemFiltered(t,i,_)&&g.isDataItemRendered(t,i,_)){var f=n.getCoordAt(g.getXValue(t,i,_)),v=o.getUnboundedCoordAt(g.getLowValue(t,i,_)),S=o.getUnboundedCoordAt(g.getHighValue(t,i,_));if(null!=f&&null!=v&&null!=S){var C=p.isMarkerDisplayed(t,i,_);if(!C){var y=d-1,x=l.isPolar(t),A=x&&y>0&&0==_?y:_-1,b=x&&y>0&&_==y?0:_+1,M=g.getLowValue(t,i,A),T=g.getHighValue(t,i,A),I=g.getLowValue(t,i,b),D=g.getHighValue(t,i,A);null==M&&null==T&&null==I&&null==D&&(C=!0)}if(!(u._duringZoomAndScroll||l.isOverview(t)||l.isSpark(t))||C||g.isDataSelected(t,i,_)){var O=h.convertAxisCoord(t,new e.Point(f,v),r),E=h.convertAxisCoord(t,new e.Point(f,S),r),P=new e.Point((O.x+E.x)/2,(O.y+E.y)/2),L=p.getMarkerSize(t,i,_),w=new gt(s,O.x,O.y,E.x,E.y,L,!C),B=R.getMarkerFill(t,i,_),k=p.getMarkerBorderColor(t,i,_),F=p.getBorderWidth(t,i,_),N=new e.Stroke(k,1,F),H=p.getMarkerColor(t,i,_),G=p.getSelectedInnerColor(t),U=p.getSelectedOuterColor(t);w.setStyleProperties(B,N,H,G,U),p.isSelectable(t,i,_)&&w.setCursor(e.SelectionEffectUtils.getSelectingCursor());var j=new e.Line(s,O.x,O.y,E.x,E.y);j.setSolidStroke("rgba(0,0,0,0)",null,a?Math.max(L,mt._MIN_TOUCH_MARKER_SIZE):L),w.addChild(j),c.push(w),m.associate(w,t,i,_,null,P)}}}return c},mt._renderBars=function(t,i,r){var a=l.isHorizontal(t),s=l.isPolar(t),n=l.isStock(t),o="pixel"==p.getBarSpacing(t),h=e.Agent.isRightToLeft(t.getCtx()),u=p.isStackLabelRendered(t),d=g.isStacked(t);g.getSeriesCount(t)<2&&u&&(d=!0);for(var c=p.getSelectedInnerColor(t),_=p.getSelectedOuterColor(t),f=t.getOptions()._duringZoomAndScroll,v=p.getGroupWidth(t),S={},C=0;C<g.getSeriesCount(t);C++)if("bar"==g.getSeriesType(t,C)){mt._filterPointsForSeries(t,C);for(var y="",x=t.getOptionsCache().getFromCachedMap("itemStyleSet",C),A=g.getStackCategory(t,C)||"",b=g.isAssignedToY2(t,C),M=L.getViewportMinMaxGroupIndex(t,C),T=M.min-1;T<=M.max+1;T++)if(!g.isDataItemFiltered(t,C,T)&&g.isDataItemRendered(t,C,T)&&0!=g.getZValue(t,C,T)){var I=w.getBarInfo(t,C,T,r);if(null!=I){var D=I.yCoord,O=I.baseCoord,E=I.axisCoord,P=I.x1,B=I.x2,k=I.barWidth;if(d){var F=""+T+A+b+(g.getValue(t,C,T)<0);if(Math.abs(O-D)<.5&&Math.abs(D-S[F])<.5&&!g.isOutermostBar(t,C,T))continue;S[F]&&(O=S[F]),S[F]=D}var N,H=!1;if(Math.abs(D-O)<1&&(g.isRangeSeries(t,C)?D--:d&&!g.isOutermostBar(t,C,T)||(H=!0,D=D>O||a&&!h&&D==O?O+3:O-3)),s)N=new ut(t,E,O,D,P,B,r);else{var G=f&&v<5&&!x;if(N=new at(t,E,O,D,P,B,G),G){var U=N.getBoundingBox();y+=e.PathUtils.moveTo(U.x,U.y)+e.PathUtils.horizontalLineTo(U.x+U.w)+e.PathUtils.verticalLineTo(U.y+U.h)+e.PathUtils.horizontalLineTo(U.x)+e.PathUtils.closePath();continue}}i.addChild(N),p.isSelectable(t,C,T)&&N.setCursor(e.SelectionEffectUtils.getSelectingCursor());var j,V=null;if(H)j=e.SolidFill.invisibleFill();else{j=R.getBarFill(t,C,T,k);var Y=p.getBorderColor(t,C,T),W=p.getBorderWidth(t,C,T);Y&&(V=new e.Stroke(Y,1,W))}var z=p.getColor(t,C,T),X=p.getClassName(t,C,T),K=p.getStyle(t,C,T);N.setStyleProperties(j,V,z,c,_,X,K),o&&N.setPixelHinting(!0),m.associate(N,t,C,T,null,I.dataPos),g.isRangeSeries(t,C)?(mt._renderDataLabel(t,i,N.getBoundingBox(),C,T,null,z,"low",!1,N.getOriginalBarSize()),mt._renderDataLabel(t,i,N.getBoundingBox(),C,T,null,z,"high",!1,N.getOriginalBarSize())):mt._renderDataLabel(t,i,N.getBoundingBox(),C,T,null,z,null,!1,N.getOriginalBarSize());var Z=new Array;Z.push(N),n&&0!=C||t._currentMarkers.push(Z),u&&g.isOutermostBar(t,C,T)&&mt._renderDataLabel(t,i,N.getBoundingBox(),C,T,null,null,null,!0,N.getOriginalBarSize())}}if(y){var q=new e.Path(t.getCtx(),y),Q=p.getColor(t,C);q.setSolidFill(Q);var J=p.getBorderColor(t,C);if(J){var $=p.getBorderWidth(t,C);q.setSolidStroke(J,null,$)}var tt=p.getClassName(t,C),et=p.getStyle(t,C);q.setClassName(tt).setStyle(et),o&&q.setPixelHinting(!0),i.addChild(q)}}},mt._renderStock=function(t,i,r){var a=t.getOptions(),s=t.xAxis,n=t.yAxis;if("candlestick"==g.getSeriesType(t,0))for(var o=L.getViewportMinMaxGroupIndex(t,0),l=o.min-1;l<=o.max+1;l++)if(g.isDataItemRendered(t,0,l)){var h=g.getDataItem(t,0,l);if(h){var u=h.open,d=h.close,c=h.low,_=h.high,f=null!=c&&null!=_;if(null!=u&&null!=d){var v,S=g.getXValue(t,0,l),C=s.getUnboundedCoordAt(S),y=p.getBarWidth(t,0,l),x=n.getBoundedCoordAt(u),A=n.getBoundedCoordAt(d),b=null;f&&(v=n.getBoundedCoordAt(c),b=n.getBoundedCoordAt(_));var M=new nt(t.getCtx(),C,y,x,A,v,b);i.addChild(M),p.isSelectable(t,0,l)&&M.setCursor(e.SelectionEffectUtils.getSelectingCursor());var T=R.getBarFill(t,0,l,y),I=null,D=p.getBorderColor(t,0,l),O=p.getBorderWidth(t,0,l);D?I=new e.Stroke(D,1,O):T instanceof e.PatternFill&&(I=new e.Stroke(T.getColor(),1,O));var E=p.getColor(t,0,l),P=p.getSelectedInnerColor(t),w=p.getSelectedOuterColor(t),B=a.styleDefaults.stockRangeColor;M.setChangeStyle(T,I,E,P,w),M.setRangeStyle(new e.SolidFill(B),I,B,w);var k=new e.Point(C,(x+A)/2);m.associate(M,t,0,l,null,k);var F=new Array;F.push(M._changeShape),t._currentMarkers.push(F)}}}},mt._renderBoxPlot=function(t,i,r){for(var a=t.xAxis,s=0;s<g.getSeriesCount(t);s++)for(var n=L.getViewportMinMaxGroupIndex(t,s),o=n.min-1;o<=n.max+1;o++)if(g.isDataItemRendered(t,s,o)&&"boxPlot"==g.getSeriesType(t,s)){var u=g.getDataItem(t,s,o);if(u){var d=u.low,c=u.q1,_=u.q2,f=u.q3,v=u.high;if(null!=d&&null!=c&&null!=_&&null!=f&&null!=v){var S=p.getBarWidth(t,s,o),C=p.getBarCategoryOffsetMap(t,o),y=g.isAssignedToY2(t,s),x=g.getStackCategory(t,s),A=C[y?"y2":"y"][x]+S/2;e.Agent.isRightToLeft(t.getCtx())&&l.isVertical(t)&&(A*=-1);var b=g.getXValue(t,s,o),M=a.getUnboundedCoordAt(b)+A,T=y?t.y2Axis:t.yAxis,I=T.getBoundedCoordAt(d),D=T.getBoundedCoordAt(c),O=T.getBoundedCoordAt(_),E=T.getBoundedCoordAt(f),P=T.getBoundedCoordAt(v),w=p.getBoxPlotStyleOptions(t,s,o),R=new st(t,M,S,I,D,O,E,P,w);i.addChild(R),p.isSelectable(t,s,o)&&R.setCursor(e.SelectionEffectUtils.getSelectingCursor());var B=h.convertAxisCoord(t,new e.Point(M,O),r);m.associate(R,t,s,o,null,B),mt._renderBoxPlotMarkers(t,i,s,o,r,M),t._currentMarkers.push([R._medianLine])}}}},mt._renderBoxPlotMarkers=function(t,i,r,a,s,n){for(var o=p.getMarkerBorderColor(t,r,a),h=p.getBorderWidth(t,r,a),u=new e.Stroke(o,1,h),d=[],c=g.getNestedDataItemCount(t,r,a),_=0;_<c;_++){var f=mt._getMarkerInfo(t,r,a,_,s);if(f){l.isHorizontal(t)?f.y=n:f.x=n;var v=mt._createMarker(t,f,o,h);null!=v&&d.push(v)}}mt._addMarkersToContainer(t,i,d,u)},mt._renderLines=function(t,e,i,r){var a,s=[],n=g.getSeriesCount(t);for(a=0;a<n;a++)g.isSeriesRendered(t,a)&&"line"==g.getSeriesType(t,a)&&s.push(a);for(var o=0;o<s.length;o++)a=s[o],"none"!=p.getLineType(t,a)&&(mt._filterPointsForSeries(t,a),mt._renderLinesForSeries(t,i,a,r));for(o=0;o<s.length;o++)mt._renderMarkersForSeries(t,e,s[o],r)},mt._renderAreas=function(t,e,i,r){for(var a=g.getSeriesCount(t),s=r?"lineWithArea":"area",n=[],o=[],l=0;l<a;l++)g.isSeriesRendered(t,l)&&g.getSeriesType(t,l)==s&&(g.isAssignedToY2(t,l)?o.push(l):n.push(l));n.length>0&&mt._renderAreasForAxis(t,e,n,t.yAxis.getBaselineCoord(),i,r),o.length>0&&mt._renderAreasForAxis(t,e,o,t.y2Axis.getBaselineCoord(),i,r)},mt._renderAreasForAxis=function(t,i,r,a,s,n){for(var o=g.isStacked(t),l=mt.createClippedGroup(t,i,s),h={},u={},d={},c={},_=[],f=g.getGroupCount(t),v=0;v<f;v++)_.push(new ot(null,a,a,v,g.getGroup(t,v),!0));for(var S=0;S<r.length;S++){var C=r[S],y=g.getStackCategory(t,C),x=g.isSeriesNegative(t,C),A=h[y],b=u[y],M=d[y],T=c[y];if("none"!=p.getLineType(t,C)){var I,D,O,E=R.getAreaFill(t,C),P=p.getBorderColor(t,C),L=p.getBorderWidth(t,C),w=p.getAreaClassName(t,C),B=p.getAreaStyle(t,C),k=P?new e.Stroke(P,1,L):null,F=p.getLineType(t,C);mt._filterPointsForSeries(t,C),g.isRangeSeries(t,C)?(I=mt._getCoordsForSeries(t,C,s,"high"),D=mt._getCoordsForSeries(t,C,s,"low"),O=F):x?(I=mt._getAreaCoordsForSeries(t,C,s,M||_),D=M||[],O=T):(I=mt._getAreaCoordsForSeries(t,C,s,A||_),D=A||[],O=b);var N=new lt(t,!0,s,a,B,w,E,k,F,I,O,D);l.addChild(N),t._currentAreas.push(N),m.associate(N,t,C),x?(d[y]=I,c[y]=F):(h[y]=I,u[y]=F),o||((n||p.getDataItemGaps(t)>0&&!P)&&mt._renderLinesForSeries(t,l,C,s,!n),n||mt._renderMarkersForSeries(t,i,C,s),S+1<r.length&&(l=mt.createClippedGroup(t,i,s)))}else mt._renderMarkersForSeries(t,i,C,s)}for(S=0;S<r.length;S++)if(C=r[S],"none"!=p.getLineType(t,C)){var H=p.getBorderColor(t,C)||p.getBorderColor(t,C+1);o&&(n||p.getDataItemGaps(t)>0&&!H)&&mt._renderLinesForSeries(t,l,C,s,!n),(o||n)&&mt._renderMarkersForSeries(t,i,C,s)}},mt._getAreaCoordsForSeries=function(t,e,i,r){for(var a=mt._getCoordsForSeries(t,e,i),s=[],n=0;n<r.length;n++)s.push(r[n].clone());var o=a.length-1,h=l.isPolar(t);for(n=0;n<a.length;n++)if(null!=a[n].x){var u=s[a[n].groupIndex],g=h&&0==n?o:n-1,d=h&&n==o?0:n+1;g>=0&&null!=a[g].x&&(u.y1=a[n].y1),d<=o&&null!=a[d].x&&(u.y2=a[n].y2),u.x=a[n].x,u.filtered=u.y1==u.y2&&a[n].filtered}return s},mt._renderLinesForSeries=function(t,i,r,a,s){var n;if(s){var o=2.5*p.getDataItemGaps(t);n=new e.Stroke(p.getBackgroundColor(t,!0),1,o)}else{var l=p.getColor(t,r),h=p.getLineWidth(t,r),u=p.getLineStyle(t,r);n=new e.Stroke(l,1,h,!1,e.Stroke.getDefaultDashProps(u,h))}var d=g.isAssignedToY2(t,r)?t.y2Axis.getBaselineCoord():t.yAxis.getBaselineCoord(),c=p.getLineType(t,r),_=p.getClassName(t,r),f=p.getStyle(t,r),v=function(e){var s=mt._getCoordsForSeries(t,r,a,e),o=new lt(t,!1,a,d,f,_,null,n,c,s);i.addChild(o),m.associate(o,t,r)};g.isRangeSeries(t,r)?(v("high"),v("low")):v("value")},mt._filterScatterBubble=function(t,i,r){var a,s=g.getSeriesCount(t),n=g.getGroupCount(t);if(s*n<mt.FILTER_THRESHOLD_SCATTER_BUBBLE)return null;for(var o=[],l=0;l<s;l++)if(g.isSeriesRendered(t,l))for(var h=0;h<n;h++)null!=(a=mt._getScatterBubbleMarkerInfo(t,l,h,r))&&o.push(a);if(o.length<mt.FILTER_THRESHOLD_SCATTER_BUBBLE)return null;i&&vt.sortMarkerInfos(o);for(var u=new e.PixelMap(25,new e.PixelMap(5,new e.PixelMap)),d=[],c=o.length-1;c>=0;c--){if(a=o[c],!vt.checkPixelMap(u,a.x,a.y,a.size)){var _=p.getColor(t,a.seriesIndex,a.groupIndex),f=p.isMarkerDisplayed(t,l,h)?e.ColorUtils.getAlpha(_):0;f>0&&(vt.updatePixelMap(u,a.x,a.y,a.size,f),d.push(a))}}return t.getCache().putToCache("dataFiltered",!0),d.reverse(),d},mt._filterPointsForSeries=function(t,e){if(!l.isPolar(t)&&!g.isRangeSeries(t,e)){var i=t.__getPlotAreaSpace(),r=l.isHorizontal(t)?i.h:i.w,a=g.getSeriesItem(t,e).items,s="bar"==g.getSeriesType(t,e),n=t.xAxis.getInfo(),o=(n.getDataMax()-n.getDataMin())/(n.getViewportMax()-n.getViewportMin()),h=s?.5:2,u=o?Math.round(h*(a.length/o)/r):1;if(u<(s?2:3))for(var d=0;d<a.length;d++)(v=a[d])&&(v._filtered=!1);else{var c,p,_,f,v,m,S=!1;for(d=0;d<a.length;d+=u){c=-1,p=-1/0,_=-1,f=1/0;for(var C=d;C<Math.min(d+u,a.length);C++)m=g.getCumulativeValue(t,e,C),v=a[C],null!=m&&null!=v&&((!s||m>0)&&m>p&&(c=C,p=m),(!s||m<0)&&m<f&&(_=C,f=m),v._filtered=!0,S=!0);for(C=d;C<Math.min(d+u,a.length);C++)null!=(v=a[C])&&(C!=c&&C!=_||(v._filtered=!1))}t.getCache().putToCache("dataFiltered",S)}}},mt._getCoordsForSeries=function(t,e,i,r){var a=t.xAxis,s=t.yAxis;g.isAssignedToY2(t,e)&&(s=t.y2Axis);for(var n=[],o=L.getViewportMinMaxGroupIndex(t,e),h=o.min-1;h<=o.max+1;h++){var u=g.getGroup(t,h);if(null!=u){var d=g.getXValue(t,e,h),c=null;if("low"==r?c=g.getLowValue(t,e,h):"high"==r?c=g.getHighValue(t,e,h):null!=g.getValue(t,e,h)&&(c=g.getCumulativeValue(t,e,h)),null!=c&&!isNaN(c)&&g.isDataItemRendered(t,e,h)){l.isPolar(t)&&(c=Math.max(c,s.getInfo().getViewportMin()));var p=a.getUnboundedCoordAt(d),_=s.getUnboundedCoordAt(c);if(null!=p&&null!=_){var f=new ot(p,_,_,h,u,g.isDataItemFiltered(t,e,h));n.push(f)}else n.push(new ot(null,null,null,h,u,!1))}else n.push(new ot(null,null,null,h,u,!1))}}return n},mt.createClippedGroup=function(t,i,r){var a=new e.Container(i.getCtx());i.addChild(a);var s=new e.ClipPath(t.getId()),n=mt._extendClipGroup(t);if(l.isPolar(t)){var o=r.x+r.w/2,h=r.y+r.h/2;if(L.isGridPolygonal(t)){var u=e.PolygonUtils.getRegularPolygonPoints(o,h,g.getGroupCount(t),t.getRadius(),0);s.addPolygon(u)}else s.addCircle(o,h,t.getRadius())}else l.isHorizontal(t)?s.addRect(r.x-n,r.y,r.w+2*n,r.h):s.addRect(r.x,r.y-n,r.w,r.h+2*n);return a.setClipPath(s),a},mt._extendClipGroup=function(t){if((g.hasLineSeries(t)||g.hasLineWithAreaSeries(t))&&!l.isSpark(t)){var e=p.getLineWidth(t),i=function(t){var i=t.getInfo(),r=i.getCoordAt(i.getGlobalMax()),a=i.getCoordAt(i.getDataMax()),s=i.getCoordAt(i.getGlobalMin()),n=i.getCoordAt(i.getDataMin());return null!=r&&null!=a&&a-r<=e/2||null!=s&&null!=n&&s-n<=e/2};if(t.yAxis&&i(t.yAxis)||t.y2Axis&&i(t.y2Axis))return Math.ceil(e/2)}return 0};
/**
   * @license
   * Copyright (c) 2008 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var St=function(t,e){this.Init(t,e)};e.Obj.createSubclass(St,e.Obj),St.prototype.Init=function(t,e){this._context=t.getCtx(),this._dataCursorShown=!1,this._dataCursor=e,this._chart=t},St.prototype.processMove=function(t,e){var i=this._chart.__getPlotAreaSpace();return i&&i.containsPoint(t.x,t.y)&&!this._chart.getOptions()._duringZoomAndScroll?(this._showDataCursor(i,t.x,t.y,e),!0):(this._removeDataCursor(e),!1)},St.prototype.processEnd=function(t){this._removeDataCursor(t)},St.prototype.processOut=function(t,e){var i=this._chart.__getPlotAreaSpace();i&&!i.containsPoint(t.x,t.y)&&this._removeDataCursor(e)},St.prototype._showDataCursor=function(t,e,i,r){if(this._context.isOffscreen(!0))this._removeDataCursor(r);else{var a=this._dataCursor,s=this._getClosestMatch(e,i);if(null!=s){var n=s.matchRegion.getCenter(),o=e,l=i;a.getBehavior()==_.BEHAVIOR_SNAP&&(a.isHorizontal()?l=Math.min(Math.max(n.y,t.y),t.y+t.h):o=Math.min(Math.max(n.x,t.x),t.x+t.w));var h=s.logicalObject,u=v.getDatatip(this._chart,h.getSeriesIndex(),h.getGroupIndex(),h.getNestedDataItemIndex(),!0);if(null!=u){a.setVisible(!0);var g=v.getDatatipColor(this._chart,h.getSeriesIndex(),h.getGroupIndex(),h.getNestedDataItemIndex()),d=a.isHorizontal()?l:o;if(a.render(t,n.x,n.y,d,u,g),this._dataCursorShown=!0,!r){var c=this._chart.getValuesAt(e,i);this._chart.changeOption("dataCursorPosition",c)}}else a.setVisible(!1)}else this._removeDataCursor(r)}},St.prototype._removeDataCursor=function(t){this._dataCursor.getVisible()&&this._dataCursor.setVisible(!1),this._context.getTooltipManager(_.TOOLTIP_ID).hideTooltip(),this._dataCursorShown=!1,t||this._chart.changeOption("dataCursorPosition",null)},St.prototype.isDataCursorShown=function(){return this._dataCursorShown},St._getClosestMatchSecondDirection=function(t,e,i,r){for(var a=null,s=1/0,n=t.length-1;0<=n;n--){var o=t[n],l=e?i:r,h=((e?o.matchRegion.x:o.matchRegion.y)+(e?o.matchRegion.x+o.matchRegion.w:o.matchRegion.y+o.matchRegion.h))/2,u=Math.round(Math.abs(h-l));u<s&&(s=u,a=o)}return a},St._getClosestMatchesFirstDirection=function(t,e,i,r,a){for(var s=1/0,n=new Array,o=0;o<t.length;o++){var l=t[o];if(a(l.logicalObject)){var h=l.matchRegion,u=e?r:i,g=((e?h.y:h.x)+(e?h.y+h.h:h.x+h.w))/2,d=Math.round(Math.abs(g-u));d<=s&&(d<s&&(n=new Array),n.push(l),s=d)}}return n},St.prototype._findMatches=function(){var t=this._context.getStage(),e=this._chart.getEventManager(),i=[];if(!this._chart._currentMarkers)return null;for(var r=0;r<this._chart._currentMarkers.length;r++)for(var a=this._chart._currentMarkers[r],s=a.length,n=0;n<s;n++){var o=a[n],l=e.GetLogicalObject(o),h={matchRegion:o.getDimensionsSelf?o.getDimensionsSelf(t):o.getDimensions(t),logicalObject:l};i.push(h)}return i},St.prototype._getClosestMatch=function(t,i){var r=l.isHorizontal(this._chart),a=l.isLineArea(this._chart)&&!l.isMixedFrequency(this._chart),s=this._findMatches(),n=g.getHighlightedCategories(this._chart),o="all"==this._chart.getOptions().highlightMatch,h=n.length>0?o?e.ArrayUtils.hasAllItems:e.ArrayUtils.hasAnyItem:null,u=function(t){return!h||h(t.getCategories(),n)},d=St._getClosestMatchesFirstDirection(s,r,t,i,u);if(!l.isScatterBubble(this._chart)){for(var c=1/0,p=-1/0,_=null,f=0;f<d.length;f++){var v=d[f];c=Math.min(c,r?v.matchRegion.y:v.matchRegion.x),p=Math.max(p,r?v.matchRegion.y+v.matchRegion.h:v.matchRegion.x+v.matchRegion.w),_=v.logicalObject.getGroupIndex()}for(f=0;f<s.length;f++){var m=s[f];if(u(m.logicalObject))if(a)m.logicalObject.getGroupIndex()==_&&d.push(m);else{var S=((r?m.matchRegion.y:m.matchRegion.x)+(r?m.matchRegion.y+m.matchRegion.h:m.matchRegion.x+m.matchRegion.w))/2;p>=S&&c<=S&&d.push(m)}}}return St._getClosestMatchSecondDirection(d,r,t,i)};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var Ct=function(t,e,i){this.Init(t,e,i)};e.Obj.createSubclass(Ct,O),Ct.prototype.axisToPlotArea=function(t){if("tangential"==this.getOptions().position)return t;if(null==t)return null;var e=t-this.getLeftOverflow();return Math.round(10*e)/10},Ct.prototype.plotAreaToAxis=function(t,e){if("tangential"==this.getOptions().position)return t;if(null==t)return null;var i=t+this.getLeftOverflow();return!1===e?i:Math.round(i)},Ct.prototype.linearToActual=function(t){return this.Info.linearToActual(t)},Ct.prototype.actualToLinear=function(t){return this.Info.actualToLinear(t)},Ct.prototype.getValueAt=function(t){return this.Info.getValueAt(this.plotAreaToAxis(t))},Ct.prototype.getCoordAt=function(t){return this.axisToPlotArea(this.Info.getCoordAt(t))},Ct.prototype.getBoundedCoordAt=function(t){return this.axisToPlotArea(this.Info.getBoundedCoordAt(t))},Ct.prototype.getUnboundedValueAt=function(t){return this.Info.getUnboundedValueAt(this.plotAreaToAxis(t))},Ct.prototype.getUnboundedCoordAt=function(t){return this.axisToPlotArea(this.Info.getUnboundedCoordAt(t))},Ct.prototype.getBaselineCoord=function(){return this.axisToPlotArea(this.Info.getBaselineCoord())},Ct.prototype.getPosition=function(){return this.getOptions().position},Ct.prototype.isGroupAxis=function(){return this.Info instanceof T},Ct.prototype.getMajorTickCoords=function(){for(var t=this.Info?this.Info.getMajorTickCoords():[],e=0;e<t.length;e++)t[e]=this.axisToPlotArea(t[e]);return t},Ct.prototype.getMinorTickCoords=function(){for(var t=this.Info?this.Info.getMinorTickCoords():[],e=0;e<t.length;e++)t[e]=this.axisToPlotArea(t[e]);return t},Ct.prototype.getBaselineCoord=function(){return this.axisToPlotArea(this.Info.getBaselineCoord())},Ct.prototype.getLinearGlobalMin=function(){return this.actualToLinear(this.Info.getGlobalMin())},Ct.prototype.getLinearGlobalMax=function(){return this.actualToLinear(this.Info.getGlobalMax())},Ct.prototype.getLinearViewportMin=function(){return this.actualToLinear(this.Info.getViewportMin())},Ct.prototype.getLinearViewportMax=function(){return this.actualToLinear(this.Info.getViewportMax())},Ct.prototype.getUnboundedLinearValueAt=function(t){return this.Info.actualToLinear(this.getUnboundedValueAt(t))},Ct.prototype.isFullViewport=function(){return this.Info.getViewportMin()==this.Info.getGlobalMin()&&this.Info.getViewportMax()==this.Info.getGlobalMax()},Ct.prototype.getLeftOverflow=function(){return e.Agent.isRightToLeft(this.getCtx())?this.Info.getEndOverflow():this.Info.getStartOverflow()},Ct.prototype.getRightOverflow=function(){return e.Agent.isRightToLeft(this.getCtx())?this.Info.getStartOverflow():this.Info.getEndOverflow()},Ct.prototype.getLength=function(){return Math.abs(this.Info.getStartCoord()-this.Info.getEndCoord())},Ct.prototype.getMinCoord=function(){return this.axisToPlotArea(Math.min(this.Info.getStartCoord(),this.Info.getEndCoord()))},Ct.prototype.getMaxCoord=function(){return this.axisToPlotArea(Math.max(this.Info.getStartCoord(),this.Info.getEndCoord()))};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var yt=new Object;e.Obj.createSubclass(yt,e.Obj),yt._DEFAULT_AXIS_MAX_SIZE=.33,yt.render=function(t,e,i){l.hasAxes(t)&&(L.applyInitialZooming(t,i),l.isBubble(t)&&vt.calcBubbleSizes(t,i),l.isPolar(t)?yt._renderPolar(t,e,i):yt._renderCartesian(t,e,i))},yt._renderCartesian=function(t,i,r){var a=t.getOptions(),s=l.isHorizontal(t),n=g.isSplitDualY(t),o=l.isOverview(t),h=r.clone(),u=L.getYAxisPosition(t),d=L.getY2AxisPosition(t),c=!o&&a.overview.content&&a.overview.content.yAxis&&"on"==a.overview.content.yAxis.rendered,_=!o&&a.overview.content&&a.overview.content.y2Axis&&"on"==a.overview.content.y2Axis.rendered;yt._addAxisGaps(t,r),n&&u==d&&(a.yAxis._skipHighestTick=s,a.y2Axis._skipHighestTick=!s);var f=yt._createYAxis(t,i,r,h,c),v=yt._createY2Axis(t,i,r,h,_),m=!n&&"on"==a.y2Axis.alignTickMarks&&null==a.y2Axis.step;m&&f&&v&&(yt._alignYAxes(t,f,v),s||(v.dim=yt._getPreferredSize(t,v.axis,t.y2Axis,v.options,"y2",r,h,_)));var S,C=L.getTickLabelGapSize(t,"y"),y=L.getTickLabelGapSize(t,"y2");n&&u==d?(s?(S=Math.max(f.dim.h+C,v.dim.h+y),f.dim.h=S-C,v.dim.h=S-y):(S=Math.max(f.dim.w+C,v.dim.w+y),f.dim.w=S-C,v.dim.w=S-y),yt._positionAxis(r.clone(),f,C,c),yt._positionAxis(r,v,y,_)):(yt._positionAxis(r,f,C,c),yt._positionAxis(r,v,y,_));var x=g.getGroupCount(t);if("pixel"==p.getBarSpacing(t)&&l.isBar(t)&&r.w>x){var A=Math.floor(r.w/x)*x;r.x+=(r.w-A)/2,r.w=A}var b=yt._createXAxis(t,i,r,h);b.axis.render(b.options,b.dim.w,b.dim.h),yt._positionAxis(r,b,L.getTickLabelGapSize(t,"x"));var M=p.getSplitterPosition(t),T=e.Agent.isRightToLeft(t.getCtx()),I=yt._getSplitAvailSpace(r,M,s,s&&T),D=yt._getSplitAvailSpace(r,1-M,s,!s||!T);s?(f&&(f.axis.setTranslateX(r.x),n?f.axis.render(f.options,I.w,f.dim.h,I.x,0):f.axis.render(f.options,r.w,f.dim.h)),m&&f&&v&&yt._alignYAxes(t,f,v),v&&(v.axis.setTranslateX(r.x),n?v.axis.render(v.options,D.w,v.dim.h,D.x,0):v.axis.render(v.options,r.w,v.dim.h)),yt._setOverflow(r,f,b)):(f&&(n?f.axis.render(f.options,f.dim.w,I.h,0,I.y):f.axis.render(f.options,f.dim.w,r.h)),m&&f&&v&&yt._alignYAxes(t,f,v),v&&(n?v.axis.render(v.options,v.dim.w,D.h,0,D.y):v.axis.render(v.options,v.dim.w,r.h)),yt._setOverflow(r,b,f,v)),yt._storeAxes(t,b,f,v)},yt._renderPolar=function(t,e,i){var r=yt._createXAxis(t,e,i,i);r.axis.setTranslateX(i.x),r.axis.setTranslateY(i.y),r.axis.render(r.options,i.w,i.h);var a=yt._createYAxis(t,e,i,i);a.axis.setTranslateX(i.x),a.axis.setTranslateY(i.y),a.axis.render(a.options,i.w,i.h),yt._storeAxes(t,r,a)},yt._createXAxis=function(t,i,r,a){var s=t.getOptions(),n=L.getXAxisPosition(t),o=e.JsonUtils.clone(s.xAxis);o.position=n,o.isStandalone=L.isStandaloneXAxis(t),o.groupSeparators=s.styleDefaults.groupSeparators,yt._addCommonAxisAttributes(o,"x",t),o.groups=s.groups,o._groupWidthRatios=w.getGroupWidthRatios(t),o.timeAxisType=l.getTimeAxisType(t),o._locale=s._locale,o.drilling=s.drilling,o._isGroupAxis=l.hasGroupAxis(t);var h="top"==n||"bottom"==n,u=L.isGridShifted(t);if("tangential"==n&&l.hasGroupAxis(t))u?(o.startGroupOffset=.5,o.endGroupOffset=.5):o.endGroupOffset=1;else{var d=L.getAxisOffset(t);if(o.startGroupOffset=d,o.endGroupOffset=d,p.hasUncenteredSeries(t)&&(o.endGroupOffset+=1),!E.isScrollable(t)&&!l.isOverview(t)){var c=g.getGroupCount(t);L.isAxisRendered(t,"y")&&L.isTickLabelInside(t,"y")&&(o[(h?"start":"end")+"GroupOffset"]+=.04*c),L.isAxisRendered(t,"y2")&&L.isTickLabelInside(t,"y2")&&(o[(h?"end":"start")+"GroupOffset"]+=.04*c)}}o.leftBuffer=h?r.x-a.x:0,o.rightBuffer=h?a.w+a.x-(r.w+r.x):0,o._renderGridAtLabels=!u||l.hasTimeAxis(t),o.translations=s.translations;var _=new Ct(t.getCtx(),t.processEvent,t);i.addChild(_);var f=yt._getPreferredSize(t,_,t.xAxis,o,"x",r,a);return o._minOverflowCoord=s._minOverflowCoord-r.x,o._maxOverflowCoord=s._maxOverflowCoord-r.x,{axis:_,options:o,dim:f}},yt._createYAxis=function(t,i,r,a,s){var n=t.getOptions();if(g.hasY2DataOnly(t))return null;var o=e.JsonUtils.clone(n.yAxis);o.position=L.getYAxisPosition(t),o.isStandalone=L.isStandaloneYAxis(t),yt._addCommonAxisAttributes(o,"y",t),yt._addCommonYAxisAttributes(o,t),o.translations=n.translations;var l=new Ct(t.getCtx(),t.processEvent,t);i.addChild(l);var h=yt._getPreferredSize(t,l,t.yAxis,o,"y",r,a,s);return yt._adjustYAxisForLabels(l,o,t,"y"),n.yAxis.min=o.min,n.yAxis.max=o.max,{axis:l,options:o,dim:h}},yt._createY2Axis=function(t,i,r,a,s){var n=t.getOptions();if(g.hasY2Data(t)){var o=e.JsonUtils.clone(n.y2Axis);o.position=L.getY2AxisPosition(t),o.isStandalone=L.isStandaloneY2Axis(t),yt._addCommonAxisAttributes(o,"y2",t),yt._addCommonYAxisAttributes(o,t),o.translations=n.translations;var l=new Ct(t.getCtx(),t.processEvent,t);i.addChild(l);var h=yt._getPreferredSize(t,l,t.y2Axis,o,"y2",r,a,s);return yt._adjustYAxisForLabels(l,o,t,"y2"),n.y2Axis.min=o.min,n.y2Axis.max=o.max,{axis:l,options:o,dim:h}}},yt._addCommonAxisAttributes=function(t,e,i){var r=i.getOptions();if(t.skin=r.skin,t.tickLabel.position=L.isTickLabelInside(i,e)?"inside":"outside",t.baselineScaling=L.getBaselineScaling(i,e),(L.isTickLabelInside(i,e)||"tangential"==t.position)&&(t._skipHighestTick=!0),t.zoomAndScroll=l.isPolar(i)?"off":r.zoomAndScroll,t._isOverview=l.isOverview(i),t._duringZoomAndScroll=r._duringZoomAndScroll,"x"!=e||!l.hasGroupAxis(i)){var a=L.getMinMaxValue(i,e);t.dataMin=null!=t.dataMin?t.dataMin:a.min,t.dataMax=null!=t.dataMax?t.dataMax:a.max}l.isPolar(i)&&(t.polarGridShape=L.isGridPolygonal(i)?"polygon":"circle",t._radius=i.getRadius()),t.dnd=r.dnd},yt._addCommonYAxisAttributes=function(t,r){if(t.timeAxisType="disabled",E.isLiveScroll(r)&&l.isBLAC(r)&&!l.isPolar(r)&&(t._continuousExtent="on"),t.isStandalone)t.leftBuffer=0,t.rightBuffer=0;else if(g.isSplitDualY(r))t.leftBuffer=1/0,t.rightBuffer=1/0;else{var a=e.Agent.isRightToLeft(r.getCtx());t.leftBuffer=a?0:i.BaseAxisInfo.MINIMUM_AXIS_BUFFER,t.rightBuffer=a?i.BaseAxisInfo.MINIMUM_AXIS_BUFFER:0}},yt._adjustYAxisForLabels=function(t,i,r,a){var s=r.getOptions();if(L.isYAdjustmentNeeded(r)){var n=e.CSSStyle.mergeStyles([s.styleDefaults._dataLabelStyle,s.styleDefaults.dataLabelStyle]),o=s.styleDefaults.stackLabelStyle,h=t.getInfo(),u=p.isStackLabelRendered(r),d=e.TextUtils.getTextStringHeight(r.getCtx(),u?o:n),c=0;if("log"==i.scale){c=t.getUnboundedValueAt(t.getUnboundedCoordAt(h.getDataMax())-d)-h.getDataMax()}else{var _=1;g.isSplitDualY(r)&&(_="y"==a?p.getSplitterPosition(r):1-p.getSplitterPosition(r));var f=Math.abs(h.getEndCoord()-h.getStartCoord())*_;c=Math.abs(h.getViewportMax()-h.getViewportMin())/f*d}l.isHorizontal(r)?c*=4:c*=2,h.getDataMin()-h.getGlobalMin()<=c&&h.getDataMin()<0&&(i.dataMin-=c),h.getGlobalMax()-h.getDataMax()<=c&&h.getDataMax()>0&&(i.dataMax+=c)}},yt._getPreferredSize=function(t,i,r,a,s,n,o,l){var h=a.isStandalone,u=a.position,g="top"==u||"bottom"==u,d=L.getTickLabelGapSize(t,s),c=a.maxSize,_=a.size,f=n.w,v=n.h;if("radial"==u||"tangential"==u)f=0,v=0;else if("off"!=a.rendered||l)if(h)g?v=n.h-d:f=n.w-d;else if(null!=_)g?(v=p.getSizeInPixels(_,o.h)-d,null!=c&&(v=Math.min(v,p.getSizeInPixels(c,o.h)-d))):(f=p.getSizeInPixels(_,o.w)-d,null!=c&&(f=Math.min(f,p.getSizeInPixels(c,o.w)-d)));else{if(!t.getOptions()._duringZoomAndScroll||!r)return c=null==c?yt._DEFAULT_AXIS_MAX_SIZE:c,g?i.getPreferredSize(a,n.w,p.getSizeInPixels(c,o.h)-d,l):i.getPreferredSize(a,p.getSizeInPixels(c,o.w)-d,n.h,l);if(g){var m=e.Agent.isRightToLeft(t.getCtx());a._startOverflow=m?r.getRightOverflow():r.getLeftOverflow(),a._endOverflow=m?r.getLeftOverflow():r.getRightOverflow(),v=r.getHeight()}else f=r.getWidth()}else g?v=0:f=0;return L.isYAdjustmentNeeded(t)&&i.getPreferredSize(a,f,v),new e.Dimension(f,v)},yt._addAxisGaps=function(t,e){var i=l.isHorizontal(t),r=L.getYAxisPosition(t),a=L.getY2AxisPosition(t),s=L.isAxisRendered(t,"x"),n=L.isAxisRendered(t,"y"),o=L.isAxisRendered(t,"y2"),h=t.getOptions().layout.verticalAxisGap;h*=i?L.getGapScalingFactor(t,"x"):Math.max(L.getGapScalingFactor(t,"y"),L.getGapScalingFactor(t,"y2")),h=Math.ceil(h),(!i||"top"==r&&n||"top"==a&&o)&&i||(e.y+=h,e.h-=h),(!i||"bottom"==r&&n||"bottom"==a&&o)&&(i||s)||(e.h-=h)},yt._positionAxis=function(t,i,r,a){if(i){var s=a?Math.max(i.dim.h,1):i.dim.h,n=a?Math.max(i.dim.w,1):i.dim.w;e.LayoutUtils.position(t,i.options.position,i.axis,n,s,r)}},yt._alignYAxes=function(t,e,i){var r=e.axis.getInfo();if(r){var a=r.getMajorTickCount(),s=r.getMinorTickCount(),n=i.options,o=i.axis.getInfo();o&&L.isLog(t,"y")&&L.isLog(t,"y2")&&a<o.getMajorTickCount()&&(n._logScaleUnit=o.alignLogScaleToTickCount(o.getLogScaleUnit(),a)),n._majorTickCount=a,n._minorTickCount=s}},yt._getSplitAvailSpace=function(t,e,i,r){var a=t.clone();return i?(a.w=t.w*e,a.x=r?t.w*(1-e):0):(a.h=t.h*e,a.y=r?t.h*(1-e):0),a},yt._setOverflow=function(t,e,i,r){if(e){var a=e.axis.getLeftOverflow(),s=e.axis.getRightOverflow();t.x+=a,t.w-=a+s,i&&i.axis.setTranslateX(i.axis.getTranslateX()+("left"==i.options.position?a:-s)),r&&r.axis.setTranslateX(r.axis.getTranslateX()+("left"==r.options.position?a:-s))}},yt._storeAxes=function(t,e,i,r){t.xAxis&&(t.xAxis.destroy(),t.removeChild(t.xAxis)),t.yAxis&&(t.yAxis.destroy(),t.removeChild(t.yAxis)),t.y2Axis&&(t.y2Axis.destroy(),t.removeChild(t.y2Axis)),t.xAxis=e.axis,t.yAxis=i?i.axis:null,t.y2Axis=r?r.axis:null};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var xt=new Object;e.Obj.createSubclass(xt,e.Obj),xt._DEFAULT_LINE_WIDTH_WITH_MARKER=2,xt._DEFAULT_MAX_SIZE=.3,xt._PIE_SIZE_RATIO=1.2,xt.render=function(t,i,a){var s=t.getOptions(),n=s.legend.position;if(!("off"==s.legend.rendered||"auto"==s.legend.rendered&&t.getOptionsCache().getFromCache("hasLargeSeriesCount"))){var o=e.JsonUtils.clone(s.legend);delete o.position,o.skin=s.skin,o.hideAndShowBehavior=E.getHideAndShowBehavior(t),o.hoverBehavior=E.getHoverBehavior(t),o.hoverBehaviorDelay=p.getHoverBehaviorDelay(t),o.hiddenCategories=g.getHiddenCategories(t),o.highlightedCategories=g.getHighlightedCategories(t),o.dnd=s.dnd,o._dropColor=s._dropColor,o.translations=s.translations,"auto"==n&&(n=a.w>=a.h?"end":"bottom");var h="top"==n||"bottom"==n;if(o.orientation=h?"horizontal":"vertical","start"==n&&(o.halign="end"),"start"!=n&&"end"!=n||(o.valign="middle"),"top"==n&&(o.valign="bottom"),"top"!=n&&"bottom"!=n||(o.halign="center"),xt._addLegendData(t,o),0!=o.sections.length){var u,c=r.Legend.newInstance(t.getCtx(),t.processEvent,t);if(null!=t.getId()&&c.setId(t.getId()+"legend"),i.addChild(c),null!=o.size)u=h?new e.Dimension(a.w,p.getSizeInPixels(o.size,a.h)):new e.Dimension(p.getSizeInPixels(o.size,a.w),a.h);else{var _=o.maxSize;if(null==_&&(_=xt._DEFAULT_MAX_SIZE,l.isPie(t))){var f=1-xt._PIE_SIZE_RATIO*(h?a.w/a.h:a.h/a.w);_=Math.max(_,f)}var v=h?a.w:p.getSizeInPixels(_,a.w),m=h?p.getSizeInPixels(_,a.h):a.h;u=c.getPreferredSize(o,v,m)}c.render(o,u.w,u.h);var S=h?d.getGapHeight(t,s.layout.legendGapHeight):d.getGapWidth(t,s.layout.legendGapWidth);e.LayoutUtils.position(a,n,c,u.w,u.h,S);var C=Object.keys(o.dnd.drag.series).length>0,y=c.getCache().getFromCache("background");C&&y&&y.setClassName("oj-draggable");var x=c.__getBounds(),A=c.localToStage(new e.Point(x.x,x.y));if(!l.isOverview(t)){var b=e.Agent.isRightToLeft(t.getCtx());"end"==n?b?s._minOverflowCoord=A.x+x.w+S/2:s._maxOverflowCoord=A.x-S/2:"start"==n&&(b?s._maxOverflowCoord=A.x-S/2:s._minOverflowCoord=A.x+x.w+S/2)}t.legend&&(t.legend.destroy(),i.removeChild(t.legend)),t.legend=c}}},xt._addLegendData=function(t,e){var i=xt._getSeriesItems(t,"vertical"==e.orientation);if(i.length>0){var r=e.seriesSection;r.items=i,e.sections.unshift(r),delete e.seriesSection}var a=xt._getRefObjItems(t);if(a.length>0){var s=e.referenceObjectSection;s.items=a,e.sections.push(s),delete e.referenceObjectSection}},xt._getSeriesItems=function(t,e){var i,r,a=[];if("pie"==t.getType()||"pyramid"==t.getType()||"funnel"==t.getType()){var s=c.getRenderedSeriesIndices(t);"pyramid"==t.getType()&&e&&(s=s.reverse());for(var n=0;n<s.length;n++){r=s[n];var o=g.getValue(t,r,0);o>=0&&null!=o&&(i=xt._createLegendItem(t,r))&&a.push(i)}c.hasOtherSeries(t)&&(i={id:c.OTHER_SLICE_SERIES_ID,drilling:t.getOptions().multiSeriesDrilling,text:t.getOptions().translations.labelOther,categoryVisibility:g.getHiddenCategories(t).indexOf(c.OTHER_SLICE_SERIES_ID)>=0?"hidden":"visible",symbolType:"marker",color:t.getOptions().styleDefaults.otherColor,borderColor:t.getOptions().styleDefaults.borderColor},a.push(i))}else{var h={},u={},d=g.getSeriesCount(t);for(r=0;r<d;r++)if(i=xt._createLegendItem(t,r)){var p=g.getStackCategory(t,r);g.isAssignedToY2(t,r)?u[p]?u[p].push(i):u[p]=[i]:h[p]?h[p].push(i):h[p]=[i]}var _=g.getStackCategories(t,null,!0),f=g.isStacked(t)&&l.isVertical(t)&&e;a=xt._getSeriesItemsForAxis(h,_.y,f,a),a=xt._getSeriesItemsForAxis(u,_.y2,f,a)}return a},xt._getSeriesItemsForAxis=function(t,e,i,r){for(var a,s=0;s<e.length;s++)(a=t[e[s]])&&(r=i?r.concat(a.reverse()):r.concat(a));return r},xt._createLegendItem=function(t,e){var i=g.getSeriesItem(t,e),r=t.getType(),a=g.getSeriesType(t,e),s=p.getLineType(t,e),n=i.displayInLegend;if(!i||"off"==n)return null;if("on"!=n&&(l.isFunnel(t)||l.isPyramid(t)||l.isStock(t)))return null;if("on"!=n&&!g.hasSeriesData(t,e))return null;var o=g.getSeriesLabel(t,e);if("on"!=n&&(null==o||"string"==typeof o&&0===o.trim().length))return null;var h={id:g.getSeries(t,e),text:o,categories:g.getCategories(t,e),categoryVisibility:g.isSeriesRendered(t,e)?"visible":"hidden",_getDataContext:p.getDataContext.bind(null,t,e,-1)};if("line"==a||"lineWithArea"==a||"scatter"==r||"bubble"==r)if(h.lineStyle=p.getLineStyle(t,e),h.lineWidth=p.getLineWidth(t,e),p.isMarkerDisplayed(t,e)){var u=p.getImageSource(t,e,null,null,"source");u?(h.symbolType="image",h.source=u):(h.symbolType="none"==s?"marker":"lineWithMarker","lineWithMarker"==h.symbolType&&(h.lineWidth=Math.min(xt._DEFAULT_LINE_WIDTH_WITH_MARKER,h.lineWidth)),h.markerShape=p.getMarkerShape(t,e),h.markerColor=p.getMarkerColor(t,e))}else h.symbolType="line";else if("boxPlot"==a){var d=p.getBoxPlotStyleOptions(t,e);d.q2Color!=d.q3Color?(h.symbolType=l.isHorizontal(t)?"_horizontalBoxPlot":"_verticalBoxPlot",h._boxPlot=d):h.symbolType="marker"}else h.symbolType="marker","none"==p.getLineType(t,e)&&(h.markerShape=p.getMarkerShape(t,e));return h.color=p.getColor(t,e),h.borderColor=p.getBorderColor(t,e),h.pattern=p.getPattern(t,e),h.svgStyle="area"==a?p.getAreaStyle(t,e):p.getStyle(t,e),h.svgClassName="area"==a?p.getAreaClassName(t,e):p.getClassName(t,e),h.markerSvgStyle=p.getMarkerStyle(t,e),h.markerSvgClassName=p.getMarkerClassName(t,e),h.drilling=g.isSeriesDrillable(t,e)?"on":"off",h.shortDesc=i.shortDesc,h},xt._getRefObjItems=function(t){var e=g.getRefObjs(t);if(e.length<=0)return[];for(var i=[],r=0;r<e.length;r++){var a=e[r];if(a&&"on"==a.displayInLegend&&a.text){var s=f.getType(a);i.push({symbolType:"area"==s?"square":"line",text:a.text,color:f.getColor(t,a),lineStyle:a.lineStyle,lineWidth:f.getLineWidth(t,a),categories:f.getRefObjCategories(a),categoryVisibility:f.isObjectRendered(t,a)?"visible":"hidden",shortDesc:a.shortDesc,svgStyle:a.style||a.svgStyle,svgClassName:a.className||a.svgClassName})}}return i};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var At=function(t){this.Init(t.getCtx(),t.processEvent,t),this._parentChart=t,this._chart=t.overview?t.overview.getBackgroundChart():null,this._newInstance=t.constructor.newInstance,this._id=t.getId()+"_overview"};e.Obj.createSubclass(At,a.Overview),At.prototype._renderChart=function(t,i,r){var a=this._parentChart.Defaults.getNoCloneObject();this._chartContainer=new e.Container(this.getCtx()),this.addChild(this._chartContainer);t=e.JsonUtils.merge({legend:{rendered:"off",size:null},xAxis:{viewportMin:null,viewportMax:null,viewportStartGroup:null,viewportEndGroup:null,axisLine:{rendered:"off"},size:null,maxSize:.5,title:null},yAxis:{rendered:"off",size:null},y2Axis:{rendered:"off",size:null},splitDualY:"off",title:{text:null},subtitle:{text:null},footnote:{text:null},titleSeparator:{rendered:"off"},styleDefaults:{animationIndicators:"none"},layout:{outerGapWidth:0,outerGapHeight:0},_isOverview:!0},t,a),l.hasGroupAxis(this._parentChart)&&(t.xAxis.tickLabel.rendered="off"),l.isStock(this._parentChart)&&t.series&&t.series[0]&&(t.series=[t.series[0]],t.series[0].type="lineWithArea");var s=this._parentChart.getOptions().overview.content,n=(t=e.JsonUtils.merge(s,t,a)).yAxis.rendered,o=t.y2Axis.rendered;t.zoomAndScroll="off",this._chart||(this._chart=this._newInstance(this.getCtx()),this._chart.setId(this._id));var h=i,u=this._parentChart.getWidth(),d=this._parentChart.__getPlotAreaSpace(),c=g.hasY2Data(this._parentChart),p=g.hasY2DataOnly(this._parentChart),_=(n="on"===t.yAxis.rendered&&!p,o="on"===t.y2Axis.rendered&&c,d.x),f=u-(_+i);n&&(h=_+i,t.yAxis.size=_),o&&(h=(n?_:0)+f+i,t.y2Axis.size=f),this._chartContainer.addChild(this._chart),this._chart.render(t,h,r);var v=new e.Rect(this.getCtx(),0,0,h,r);v.setInvisibleFill(),this._chartContainer.addChild(v),this._chart.getEventManager().setKeyboardHandler(null);var m=this._chart.__getPlotAreaSpace();if(n){var S=this._chartContainer.getTranslateX()-m.x;this._chartContainer.setTranslateX(S)}return new e.Dimension(i,m.h+m.y)},At.prototype.render=function(t,e,i){t.overview.style={overviewBackgroundColor:"rgba(0,0,0,0)",windowBackgroundColor:"rgba(0,0,0,0)",windowBorderTopColor:"#333333",windowBorderRightColor:"#333333",windowBorderBottomColor:"#333333",windowBorderLeftColor:"#333333",leftFilterPanelColor:"rgba(5,65,135,0.1)",rightFilterPanelColor:"rgba(5,65,135,0.1)",handleBackgroundClass:t.chart._resources.overviewGrippy,handleSize:16,handleFillColor:"rgba(0,0,0,0)"},t.overview.animationOnClick="off";var r=this._renderChart(t.chart,e,i);At.superclass.render.call(this,t.overview,r.w,r.h)},At.prototype.destroy=function(){At.superclass.destroy.call(this),this._parentChart=null,this._chart=null},At.prototype.getBackgroundChart=function(){return this._chart},At.prototype.isBackgroundRendered=function(){return!1},At.prototype.isLeftAndRightFilterRendered=function(){return!0},At.prototype.HandleKeyDown=function(t){},At.prototype.HandleKeyUp=function(t){};
/**
   * @license
   * Copyright (c) 2008 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var bt=function(t,e,i,r){this.Init(t,e,i,r)};bt._THREED_TILT=Y.THREED_TILT,bt._THREED_DEPTH=.1,bt._RADIUS=.45,bt._RADIUS_LABELS=.38,bt._MIN_ARC_LENGTH=1.5,e.Obj.createSubclass(bt,e.Container),bt.prototype.Init=function(t,i,r,a){bt.superclass.Init.call(this,t.getCtx()),this.chart=t,this._options=t.getOptions(),this._frame=i.clone(),t.pieChart=this;for(var s=this.getLabelPosition(),n=g.getSeriesCount(t),o=0;o<n;o++){var l=g.getDataItem(t,o,0);!l||"center"!=s&&"none"!=s||"outsideSlice"!=l.labelPosition||(s="outsideSlice")}this._center=new e.Point(i.x+Math.floor(i.w/2),i.y+Math.floor(i.h/2));var h="center"==s||"none"==s?bt._RADIUS:bt._RADIUS_LABELS;this._radiusX=Math.floor(Math.min(i.w,i.h)*h),this._radiusY=this._radiusX,this._depth=0,this._anchorOffset=90,this.is3D()&&(this._depth=i.h*bt._THREED_DEPTH,this._center.y-=Math.floor(this._depth/2),this._radiusY*=bt._THREED_TILT),this._slices=this._createSlices(),this._centerLabel=null,this._shapesContainer=new e.Container(this.getCtx()),this._numFrontObjs=0,this._numSelectedObjsInFront=0},bt.prototype.getOptions=function(){return this._options},bt.prototype.highlight=function(t){e.CategoryRolloverHandler.highlight(t,this._slices,"any"==this.getOptions().highlightMatch)},bt.prototype._createSlices=function(){for(var t,i,r=[],a=c.getRenderedSeriesIndices(this.chart),s=c.getOtherValue(this.chart),n=0;n<a.length;n++)if(i=a[n],g.isDataItemRendered(this.chart,i)){var o=(t=new Y(this,i)).getValue();null==o||o<=0||r.push(t)}var l=g.getHiddenCategories(this.chart).indexOf(c.OTHER_SLICE_SERIES_ID)>=0;if(s>0&&!l){var h=new Y(this);"ascending"==this.chart.getOptions().sorting?r.unshift(h):r.push(h)}return e.Agent.isRightToLeft(this.getCtx())&&r.reverse(),r},bt.prototype.setInitialSelection=function(){var t=this.chart.getSelectionHandler();if(t){for(var e=g.getInitialSelection(this.chart),i=[],r=0;r<e.length;r++)for(var a=0;a<this._slices.length;a++){var s=this._slices[a].getId();null!=s&&(null!=e[r].id&&s.id==e[r].id||s.series==e[r].series&&s.group==e[r].group)&&i.push(s)}if(c.isOtherSliceSelected(this.chart,e)){var n=c.getOtherSliceId(this.chart);i.push(n)}t.processInitialSelections(i,this._slices)}},bt.prototype.render=function(){k.addPlotAreaDnDBackground(this.chart,this,this._frame,!0),this.contains(this._shapesContainer)||(this._shapesContainer||(this._shapesContainer=new e.Container(this.getCtx())),this.addChild(this._shapesContainer)),bt._layoutSlices(this._slices,this._anchorOffset);for(var t=2*Math.PI*this.getRadiusX(),i=0,r={},a=this.chart.getOptionsCache().getFromCache("hasLargeSeriesCount"),s=0;s<this._slices.length;s++){if(a){var n=this._slices[s].getAngleExtent(),o=n/360*t,l=(this._slices[s].getAngleStart()+n)/360*t;if(o<bt._MIN_ARC_LENGTH&&Math.abs(i-l)<bt._MIN_ARC_LENGTH){r[this._slices[s].getSeriesIndex()]=!0;continue}i=l}this._slices[s].preRender()}var h=bt._orderSlicesForRendering(this._slices);this._duringDisplayAnim||(V.createPieCenter(this),V.layoutLabelsAndFeelers(this));for(s=0;s<h.length;s++)r[h[s].getSeriesIndex()]||h[s].render(this._duringDisplayAnim);this.setInitialSelection(),this.highlight(g.getHighlightedCategories(this.chart))},bt.prototype.getTotalValue=function(){for(var t=0,e=0;e<this._slices.length;e++){var i=this._slices[e].getValue();i>=0&&(t+=i)}return t},bt._layoutSlices=function(t,e){var i,r,a=0,s=t?t.length:0;e>360&&(e-=360),e<0&&(e+=360);var n=0;s>0&&(n=t[0].getPieChart().getTotalValue());for(var o=0;o<s;o++){var l=(i=t[o]).getValue();(r=e-(a=3.6*(l==n?100:0==n?0:Math.min(l/n*100,99.99))))<0&&(r+=360),i.setAngleStart(r),i.setAngleExtent(a),e=i.getAngleStart()}},bt._orderSlicesForRendering=function(t){for(var e,i,r,a,s=[],n=t?t.length:0,o=-1,l=0;l<n;l++)if((r=(i=(e=t[l]).getAngleStart())+e.getAngleExtent())>360&&(r-=360),r<0&&(r+=360),90==r||i<90&&r>90){o=l,a=r-90;break}var h=[];for(l=o;l<n;l++)h.push(t[l]);for(l=0;l<o;l++)h.push(t[l]);var u=0,g=0,d=180+a;for(l=0;l<n;l++)if(e=h[l]){if(u+e.getAngleExtent()>d){g=l;break}s.push(e),u+=e.getAngleExtent()}for(l=n-1;l>=g;l--)(e=h[l])&&s.push(e);return s},bt.prototype.is3D=function(){return"on"==this._options.styleDefaults.threeDEffect},bt.prototype.__calcMaxExplodeDistance=function(){var t=.5/bt._RADIUS-1;return this._radiusX*t},bt.prototype.getAnimationDuration=function(){return p.getAnimationDuration(this.chart)},bt.prototype.getDisplayAnimation=function(){this._duringDisplayAnim=!0;var t=new e.DataAnimationHandler(this.getCtx(),this),i=this.getAnimationDuration(),r=Y.createFillerSlice(this,this.getTotalValue());this._slices.push(r);var a=new e.CustomAnimation(this.getCtx(),r,i);a.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,r,r.GetAnimationParams,r.SetAnimationParams,r.getDeletedAnimationParams()),a.setOnEnd(r._removeDeletedSlice,r),t.add(a,0);for(var s=0;s<this._slices.length-1;s++)this._slices[s].animateInsert(t);var n=new e.CustomAnimation(this.getCtx(),this,i);n.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this,this._getAnimationParams,this._setAnimationParams,this._getAnimationParams()),t.add(n,0);var o=[];for(s=0;s<this._slices.length;s++)o=o.concat(this._slices[s].getLabelAndFeeler());var l=new e.AnimFadeIn(this._context,o,i);t.add(l,0),this._setAnimationParams();var h=t.getAnimation(!0);return h.setOnEnd(this._onEnd,this),h},bt.prototype._onEnd=function(){this._duringDisplayAnim=!1,this._setAnimationParams()},bt.prototype.getCenter=function(){return this._center},bt.prototype.getId=function(){return"chart/pie"},bt.prototype.getInnerRadius=function(){return this.is3D()?0:this._options.styleDefaults.pieInnerRadius*Math.min(this._radiusX,this._radiusY)*.95},bt.prototype.__getFrame=function(){return this._frame},bt.prototype.getRadiusX=function(){return this._radiusX},bt.prototype.getRadiusY=function(){return this._radiusY},bt.prototype.getDepth=function(){return this._depth},bt.prototype.getSliceDisplayable=function(t){var e=c.getSliceBySeriesIndex(this.chart,t);return e?e.getTopDisplayable():null},bt.prototype.__getShapesContainer=function(){return this._shapesContainer},bt.prototype.__getSlices=function(){return this._slices},bt.prototype.animateUpdate=function(t,i){var r=new e.DataAnimationHandler(this.getCtx(),this);r.constructAnimation(i.__getSlices(),this.__getSlices());var a=r.getAnimation(!0),s=new e.CustomAnimation(this.getCtx(),this,this.getAnimationDuration());s.getAnimator().addProp(e.Animator.TYPE_NUMBER_ARRAY,this,this._getAnimationParams,this._setAnimationParams,this._getAnimationParams());var n=new e.ParallelPlayable(this.getCtx(),a,s);n.setOnEnd(this._setAnimationParams,this),t.add(n,0),this._setAnimationParams([i.getDepth(),i.getRadiusY(),i.getCenter().y])},bt.prototype.animateInsert=function(t){},bt.prototype.animateDelete=function(t,e){},bt.prototype._getAnimationParams=function(){return[this._depth,this._radiusY,this._center.y]},bt.prototype._setAnimationParams=function(t){this.removeChildren(),this._shapesContainer&&this._shapesContainer.destroy(),this._shapesContainer=null,t&&(this._depth=t[0],this._radiusY=t[1],this._center.y=t[2]),this.render()},bt.prototype.bringToFrontOfSelection=function(t){var e=t.getPieChart()._shapesContainer;if(e){var i=e.getNumChildren();if(i-this._numFrontObjs>1){e.removeChild(t._topSurface[0]);var r=i-this._numFrontObjs-1;e.addChildAt(t._topSurface[0],r)}}},bt.prototype.pushToBackOfSelection=function(t){for(var e=this._slices.length,i=0,r=0;r<e;r++)this._slices[r].isSelected()&&i++;this._numSelectedObjsInFront=i;var a=t.getPieChart()._shapesContainer;if(a){var s=a.getNumChildren()-this._numFrontObjs-1-this._numSelectedObjsInFront;s>=0&&(a.removeChild(t._topSurface[0]),a.addChildAt(t._topSurface[0],s))}},bt.prototype.getLabelPosition=function(){return bt.parseLabelPosition(this._options.styleDefaults.dataLabelPosition)},bt.prototype.getSeriesLabelPosition=function(t){var e=this.getLabelPosition(),i=g.getDataItem(this.chart,t,0);return i&&i.labelPosition&&(e=i.labelPosition),bt.parseLabelPosition(e)},bt.parseLabelPosition=function(t){return"center"==t||"inside"==t?"center":"outsideSlice"==t||"outside"==t?"outsideSlice":"none"==t?"none":"auto"},bt.prototype.getSkin=function(){return this._options.skin},bt.prototype.setCenterLabel=function(t){this._centerLabel=t},bt.prototype.getCenterLabel=function(){return this._centerLabel};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var Mt=new Object;e.Obj.createSubclass(Mt,e.Obj),Mt._BUTTON_SIZE=16,Mt._BUTTON_PADDING=5,Mt._BUTTON_CORNER_DIST=4,Mt._BUTTON_OPACITY=.8,Mt._MOUSE_WHEEL_ZOOM_RATE_SLOW=.05,Mt._MOUSE_WHEEL_ZOOM_RATE_FAST=.2,Mt.render=function(t,e,i){if(Mt._renderBackground(t,e,i),g.hasInvalidData(t))P.renderEmptyText(t,e,i);else{l.isOverview(t)||(t.getOptions()._maxOverflowCoord=i.x+i.w,t.getOptions()._minOverflowCoord=i.x),Mt._addOuterGaps(t,i);var r=i.clone();Mt._renderTitles(t,e,i),Mt._adjustAvailSpace(i),xt.render(t,e,i),Mt._adjustAvailSpace(i);var a=Mt._prerenderHorizScrollbar(t,e,i),s=Mt._prerenderVertScrollbar(t,e,i);Mt._adjustAvailSpace(i),t.__setAxisSpace(i.clone()),yt.render(t,e,i),Mt._adjustAvailSpace(i),Mt._positionLegend(t.legend,i),t.__setPlotAreaSpace(i.clone()),Mt._setEventHandlers(t),Mt._renderScrollbars(t,a,s),Mt._updateTitles(t,e,r,i),Mt._renderPlotArea(t,e,i),Mt._renderDragButtons(t,e)}},Mt._setEventHandlers=function(t){var i=t.getOptions(),r=t.getEventManager();if(l.hasAxes(t)&&!l.isOverview(t)){var a,s,n=new e.Rectangle(0,0,t.getWidth(),t.getHeight()),o=t.__getPlotAreaSpace(),h=t.__getAxisSpace(),u=new e.Rectangle(o.x,h.y,o.w,h.h),g=new e.Rectangle(h.x,o.y,h.w,o.h),d=new e.SolidFill(i.styleDefaults.marqueeColor),c=new e.Stroke(i.styleDefaults.marqueeBorderColor);if(E.isScrollable(t)){var p=E.isDelayedScroll(t)?Mt._MOUSE_WHEEL_ZOOM_RATE_FAST:Mt._MOUSE_WHEEL_ZOOM_RATE_SLOW;if(s=new e.PanZoomHandler(t,o,n,p),r.setPanZoomHandler(s),E.isZoomable(t)){var _=E.getZoomDirection(t);a=l.isHorizontal(t)||"y"==_?new e.MarqueeHandler(t,o,n,d,c,!1,!0,null,g):l.isBLAC(t)||"x"==_?new e.MarqueeHandler(t,o,n,d,c,!0,!1,u,null):new e.MarqueeHandler(t,o,n,d,c,!0,!0,u,g),r.setMarqueeZoomHandler(a)}}"multiple"==i.selectionMode&&(a=new e.MarqueeHandler(t,o,n,d,c,!0,!0,u,g),r.setMarqueeSelectHandler(a))}},Mt.rerenderAxisAndPlotArea=function(t,e){if(!g.hasInvalidData(t)){var i=t.__getAxisSpace().clone(),r=t.getSelectionHandler();if(r)var a=r.getSelectedIds();var s=t.__cacheChartFocus();t.__cleanUpAxisAndPlotArea(),yt.render(t,e,i),Mt._adjustAvailSpace(i),t.__setPlotAreaSpace(i.clone()),Mt._renderPlotArea(t,e,i),r&&r.processInitialSelections(a,t.getChartObjPeers()),t.getEventManager().autoToggleZoomButton(),Mt.positionDragButtons(t),t.highlight(g.getHighlightedCategories(t)),t.__restoreChartFocus(s)}},Mt._renderBackground=function(t,i,r){var a=new e.Rect(t.getCtx(),r.x,r.y,r.w,r.h);a.setInvisibleFill(),i.addChild(a)},Mt._addOuterGaps=function(t,e){var i=t.getOptions(),r=d.getGapWidth(t,i.layout.outerGapWidth),a=d.getGapHeight(t,i.layout.outerGapHeight);Mt._needsOuterGaps(t)||(r=Math.min(r,1),a=Math.min(a,1)),e.x+=r,e.w-=2*r,e.y+=a,e.h-=2*a},Mt._needsOuterGaps=function(t){var e=t.getOptions();return!(!l.isFunnel(t)||"on"!==e.styleDefaults.threeDEffect)||!(L.isStandalonePlotArea(t)||L.isStandaloneXAxis(t)||L.isStandaloneYAxis(t)||L.isStandaloneY2Axis(t))},Mt._renderTitles=function(t,i,r){var a=t.getOptions();if(a.title.text){var s,n,o=P.createText(t.getEventManager(),i,a.title.text,a.title.style,r.x,r.y,r.w,r.h),l=null!=a.title.hAlign?a.title.hAlign:a.title.halign,h="plotArea"==l.substring(0,8);if(o?(s=(n=o.getDimensions()).h,o.setAriaProperty("hidden",null)):(s=0,n=new e.Rectangle(0,0,0,0)),a.subtitle.text){var u=new e.OutputText(t.getCtx(),a.subtitle.text,r.x,r.y);if(u){u.setCSSStyle(a.subtitle.style),i.addChild(u);var g=u.getDimensions(),c=d.getGapWidth(t,a.layout.titleSubtitleGapWidth),p=n.w+c+g.w;if(p>r.w||h)c=d.getGapHeight(t,a.layout.titleSubtitleGapHeight),u.setY(r.y+s+c),e.TextUtils.fitText(u,r.w,r.h,i)&&(s+=(g=u.getDimensions()).h+c,e.Agent.isRightToLeft(t.getCtx())&&(u&&u.setX(r.w-g.w),o&&o.setX(r.w-n.w)));else{var _=n.h-g.h;u.setY(_+r.y),o&&(e.LayoutUtils.align(r,l,o,p),e.Agent.isRightToLeft(t.getCtx())?(u.setX(o.getX()),o&&o.setX(o.getX()+g.w+c)):u.setX(o.getX()+p-g.w))}u.setAriaProperty("hidden",null),t.getEventManager().associate(u,new e.SimpleObjPeer(u.getUntruncatedTextString()))}}else e.LayoutUtils.align(r,l,o,n.w);h&&(t.getCache().putToCache("title",o),t.getCache().putToCache("subtitle",u));var f="on"==a.titleSeparator.rendered?a.layout.titleSeparatorGap:a.layout.titlePlotAreaGap;if(r.y+=s+d.getGapHeight(t,f),r.h-=s+d.getGapHeight(t,f),"on"==a.titleSeparator.rendered){var v=new e.Line(t.getCtx(),r.x,r.y,r.x+r.w,r.y),m=new e.Line(t.getCtx(),r.x,r.y+1,r.x+r.w,r.y+1);v.setSolidStroke(a.titleSeparator.upperColor),m.setSolidStroke(a.titleSeparator.lowerColor),i.addChild(v),i.addChild(m);var S=2+d.getGapHeight(t,a.layout.titlePlotAreaGap);r.y+=S,r.h-=S}}if(a.footnote.text){var C=P.createText(t.getEventManager(),i,a.footnote.text,a.footnote.style,r.x,0,r.w,r.h),y=null!=a.footnote.hAlign?a.footnote.hAlign:a.footnote.halign,x="plotArea"==y.substring(0,8);if(C){var A=C.getDimensions();C.setY(r.y+r.h-A.h),r.h-=A.h+d.getGapHeight(t,a.layout.footnoteGap),e.LayoutUtils.align(r,y,C,A.w),C.setAriaProperty("hidden",null)}x&&t.getCache().putToCache("footnote",C)}},Mt._updateTitles=function(t,e,i,r){var a=t.getOptions(),s=null!=a.title.hAlign?a.title.hAlign:a.title.halign,n=null!=a.footnote.hAlign?a.footnote.hAlign:a.footnote.halign,o=a.title.text&&"plotArea"==s.substring(0,8),l=a.footnote.text&&"plotArea"==n.substring(0,8);if(i.x=r.x,i.w=r.w,o){var h,u=t.getCache().getFromCache("title"),g=t.getCache().getFromCache("subtitle"),d=u.getDimensions();Mt._alignTextToPlotArea(e,i,s,u,d.w),g&&(h=g.getDimensions(),Mt._alignTextToPlotArea(e,i,s,g,h.w))}if(l){var c=t.getCache().getFromCache("footnote"),p=c.getDimensions();Mt._alignTextToPlotArea(e,i,n,c,p.w)}},Mt._alignTextToPlotArea=function(t,i,r,a,s){e.TextUtils.fitText(a,i.w,i.h,t)&&("plotAreaStart"==r?e.LayoutUtils.align(i,"start",a,s):"plotAreaCenter"==r?e.LayoutUtils.align(i,"center",a,s):"plotAreaEnd"==r&&e.LayoutUtils.align(i,"end",a,s))},Mt._renderPlotArea=function(t,i,r){if(l.hasAxes(t)){var a=new e.Container(t.getCtx());a.setTranslate(r.x,r.y),i.addChildAt(a,1),t.setPlotArea(a),t.getEventManager().associate(a,new e.SimpleObjPeer(null,null,null,{type:"plotArea"}));var s=new e.Rectangle(0,0,r.w,r.h);mt.render(t,a,s)}else if(l.isPie(t)){var n=new bt(t,r);n.__getSlices().length>0?(i.addChild(n),t.setPlotArea(n),n.render()):P.renderEmptyText(t,i,r)}else l.isFunnel(t)?F.render(t,i,r):l.isPyramid(t)&&H.render(t,i,r);r.w=0,r.h=0},Mt._prerenderHorizScrollbar=function(t,i,r){var a=r.w,s=0;return E.isScrollable(t)&&E.isHorizScrollbarSupported(t)?p.isOverviewRendered(t)?(s=Math.min(p.getOverviewHeight(t),r.h))>0&&(t.overview=new At(t),i.addChild(t.overview),e.LayoutUtils.position(r,"bottom",t.overview,a,s,10)):(s=t.getOptions().styleDefaults._scrollbarHeight,t.xScrollbar=new e.SimpleScrollbar(t.getCtx(),t.processEvent,t),i.addChild(t.xScrollbar),e.LayoutUtils.position(r,"bottom",t.xScrollbar,a,s,8),t.overview=null):t.overview=null,new e.Dimension(a,s)},Mt._prerenderVertScrollbar=function(t,i,r){var a=0,s=r.h;if(E.isScrollable(t)&&E.isVertScrollbarSupported(t)){a=t.getOptions().styleDefaults._scrollbarHeight;var n=new e.SimpleScrollbar(t.getCtx(),t.processEvent,t);i.addChild(n),e.LayoutUtils.position(r,e.Agent.isRightToLeft(t.getCtx())?"right":"left",n,a,s,8),l.isHorizontal(t)?t.xScrollbar=n:t.yScrollbar=n}return new e.Dimension(a,s)},Mt._renderScrollbars=function(t,i,r){var a=t.getOptions(),s={color:a.styleDefaults._scrollbarHandleColor,backgroundColor:a.styleDefaults._scrollbarTrackColor},n=t.__getPlotAreaSpace();if(t.xScrollbar&&(s.min=t.xAxis.getLinearGlobalMin(),s.max=t.xAxis.getLinearGlobalMax(),l.isHorizontal(t)?(s.isHorizontal=!1,s.isReversed=!1,t.xScrollbar.setTranslateY(n.y),t.xScrollbar.render(s,r.w,n.h)):(s.isHorizontal=!0,s.isReversed=e.Agent.isRightToLeft(t.getCtx()),t.xScrollbar.setTranslateX(n.x),t.xScrollbar.render(s,n.w,i.h)),t.xScrollbar.setViewportRange(t.xAxis.getLinearViewportMin(),t.xAxis.getLinearViewportMax())),t.yScrollbar&&(s.min=t.yAxis.getLinearGlobalMin(),s.max=t.yAxis.getLinearGlobalMax(),s.isHorizontal=!1,s.isReversed=!0,t.yScrollbar.setTranslateY(n.y),t.yScrollbar.render(s,r.w,n.h),t.yScrollbar.setViewportRange(t.yAxis.getLinearViewportMin(),t.yAxis.getLinearViewportMax())),t.overview){var o=t.Defaults.getNoCloneObject(),h={overview:{xMin:t.xAxis.getLinearGlobalMin(),xMax:t.xAxis.getLinearGlobalMax(),x1:t.xAxis.getLinearViewportMin(),x2:t.xAxis.getLinearViewportMax(),minimumWindowSize:t.xAxis.getInfo().getMinimumExtent()},chart:e.JsonUtils.clone(a,null,o)};E.isZoomable(t)||(h.featuresOff="zoom"),h.chart._minOverflowCoord=a._minOverflowCoord-n.x,h.chart._maxOverflowCoord=a._maxOverflowCoord-n.x,t.overview.setTranslateX(n.x),t.overview.render(h,n.w,i.h),t.overview.setViewportRange(t.xAxis.getLinearViewportMin(),t.xAxis.getLinearViewportMax())}},Mt._positionLegend=function(t,e){if(t){var i=t.getDimensions(),r=t.getOptions().orientation;"vertical"==r&&i.h<=e.h?t.setTranslateY(Math.round(e.y+e.h/2-i.h/2)):"horizontal"==r&&i.w<=e.w&&t.setTranslateX(Math.round(e.x+e.w/2-i.w/2))}},Mt._renderDragButtons=function(t,i){var r=Mt._BUTTON_SIZE+2*(Mt._BUTTON_PADDING+Mt._BUTTON_CORNER_DIST),a=t.__getPlotAreaSpace();if(!(!l.hasAxes(t)||l.isOverview(t)||a.w<r||a.h<r)){var s=t.getOptions(),n=s._resources,o=s.translations,h=t.getEventManager(),u=s.dragMode;if("user"==u){var g,d,c,p=e.Agent.isTouchDevice(),_=E.isScrollable(t);t.dragButtons=new e.Container(t.getCtx());var f=[],v="multiple"==s.selectionMode&&(p||_),m=_&&p,S=_&&!p&&E.isZoomable(t)&&l.isScatterBubble(t);v&&n.select&&f.push(n.select),m&&n.pan&&f.push(n.pan),S&&n.zoom&&f.push(n.zoom),c=e.ToolkitUtils.getIconStyles(t.getCtx(),f),v&&(d=m||S?"end":"solo",h.selectButton=Mt._createDragButton(t,t.dragButtons,c[n.select],h.onSelectButtonClick,h,d),g=o.tooltipSelect,h.selectButton.setTooltip(g),h.associate(h.selectButton,h.selectButton)),m&&(d=v?"start":"solo",h.panButton=Mt._createDragButton(t,t.dragButtons,c[n.pan],h.onPanButtonClick,h,d),g=o.tooltipPan,h.panButton.setTooltip(g),h.associate(h.panButton,h.panButton)),S&&(d=v?"start":"solo",h.zoomButton=Mt._createDragButton(t,t.dragButtons,c[n.zoom],h.onZoomButtonClick,h,d),g=o.tooltipZoom,h.zoomButton.setTooltip(g),h.associate(h.zoomButton,h.zoomButton)),Mt.positionDragButtons(t),h.setDragMode(null),t.dragButtons.getNumChildren()>0&&(t.addChild(t.dragButtons),p?_&&(h.panButton.setToggled(!0),h.onPanButtonClick(null)):t.hideDragButtons(),t.dragButtons.setCursor("default"))}else"pan"==u?h.setDragMode(z.DRAG_MODE_PAN):"zoom"==u?h.setDragMode(z.DRAG_MODE_ZOOM):"select"==u?h.setDragMode(z.DRAG_MODE_SELECT):h.setDragMode(z.DRAG_MODE_OFF)}},Mt._positionDragButton=function(t,i,r){var a;e.Agent.isRightToLeft(t.getCtx())?(a=r.x+Mt._BUTTON_PADDING,r.x+=Mt._BUTTON_SIZE+2*Mt._BUTTON_PADDING):a=r.x+r.w-Mt._BUTTON_SIZE-Mt._BUTTON_PADDING,r.w-=Mt._BUTTON_SIZE+2*Mt._BUTTON_PADDING,i.setTranslate(a,r.y+Mt._BUTTON_PADDING)},Mt.positionDragButtons=function(t){var e=t.__getPlotAreaSpace().clone();e.x+=Mt._BUTTON_CORNER_DIST,e.w-=2*Mt._BUTTON_CORNER_DIST,e.y+=Mt._BUTTON_CORNER_DIST;var i=t.getEventManager();i.selectButton&&Mt._positionDragButton(t,i.selectButton,e),i.panButton&&Mt._positionDragButton(t,i.panButton,e),i.zoomButton&&Mt._positionDragButton(t,i.zoomButton,e)},Mt._createDragButtonBackground=function(t,i){var r=2,a=2,s=e.Agent.isRightToLeft(t);"start"==i?s?r=0:a=0:"end"==i&&(s?a=0:r=0);var n=r,o=a,l=-Mt._BUTTON_PADDING,h=Mt._BUTTON_SIZE+2*Mt._BUTTON_PADDING,u=e.PathUtils.roundedRectangle(l,l,h,h,n,a,o,r),g=new e.Path(t,u);return g.setPixelHinting(e.Agent.getDevicePixelRatio()>1),g},Mt._getImageUrl=function(t,e,i,r){var a,s=t.getOptions()._resources[i];return null==s?r:null!=(a=e[s])?a:s},Mt._createDragButton=function(t,i,r,a,s,n){var o=t.getCtx(),l=Mt._createDragButtonBackground(o,n),h=new e.IconButton(o,"outlined",{style:r,size:Mt._BUTTON_SIZE},l,null,a,s);if(e.Agent.isTouchDevice()){var u,g=e.Agent.isRightToLeft(o),d=2*Mt._BUTTON_PADDING;(u="solo"==n?new e.Rect(o,-d,-d,Mt._BUTTON_SIZE+2*d,Mt._BUTTON_SIZE+2*d):"start"==n&&!g||"end"==n&&g?new e.Rect(o,-d,-d,Mt._BUTTON_SIZE+1.5*d,Mt._BUTTON_SIZE+2*d):new e.Rect(o,-.5*d,-d,Mt._BUTTON_SIZE+1.5*d,Mt._BUTTON_SIZE+2*d)).setInvisibleFill(),u.setSolidStroke("none"),h.addChild(u)}return h.setToggleEnabled(!0),i.addChild(h),h.addEvtListener(e.MouseEvent.MOUSEDOWN,function(t){t.stopPropagation()}),h},Mt._adjustAvailSpace=function(t){t.x=Math.round(t.x),t.y=Math.round(t.y),t.w=Math.round(t.w),t.h=Math.round(t.h)},Mt.renderDataCursor=function(t){var e=null,i=t.getOptions(),r=t.getEventManager();if(v.isDataCursorEnabled(t)){(e=new _(t.getCtx(),i.styleDefaults.dataCursor,l.isHorizontal(t))).setBehavior(v.getDataCursorBehavior(t)),t.addChild(e);var a=new St(t,e);r.setDataCursorHandler(a),t.positionDataCursor(i.dataCursorPosition)}else r.setDataCursorHandler(null);return e};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
const Tt={processDataObject:function(t){if(g.hasData(t)){var i=t.getOptions(),r=t.getOptionsCache(),a=g.getSeriesCount(t);l.isValidType(t)||(i.type="bar");var s=!1,n=!1,o=!0,h=null,u=!1,d=!1,c=!1,_=!1,f=l.isStock(t);f&&a>1&&(i.series=i.series.slice(0,1),a=1);var v=l.isMixedFrequency(t),m=a>100;r.putToCache("hasLargeSeriesCount",m);for(var S=0,C=t.getSeriesStyleArray(),y=0;y<a;y++){var x=g.getSeries(t,y);!m&&null!=x&&C.indexOf(x)<0&&C.push(x);var A=g.getSeriesItem(t,y);if(A.items&&A.items.length>S&&(S=A.items.length),"hidden"===A.visibility){var b=g.getHiddenCategories(t);b.indexOf(x)<0&&b.push(x)}if(A.visibility=null,"on"===A.assignedToY2&&(s=!0),"on"===A.displayInLegend&&(_=!0),A&&A.items)for(var M=A.items,T=0;T<M.length;T++)null!=M[T]&&("object"!=typeof(L=M[T])&&(L={y:L},M[T]=L),v||null==L.x||(L.x=Number(L.x)),null!=L.y&&(L.y=Number(L.y),L.y<0&&(d=!0)),null!=L.z?(L.z=Number(L.z),null==h?h=L.z:h!=L.z&&(o=!1)):h=1,null!=L.value&&(L.value=Number(L.value),L.value<0&&(d=!0)),null!=L.targetValue&&(L.targetValue=Number(L.targetValue)),null!=L.open&&(L.open=Number(L.open),u=!0),null!=L.close&&(L.close=Number(L.close),u=!0,L.close<0&&(d=!0)),null!=L.low&&(L.low=Number(L.low),u=!0),null!=L.high&&(L.high=Number(L.high),u=!0),null!=L.volume&&(L.volume=Number(L.volume),n=!0),(L.color||L.borderColor||L.borderWidth||L.style||L.svgStyle||L.className||L.svgClassName)&&r.putToCachedMap("itemStyleSet",y,!0),"outsideBarEdge"==L.labelPosition&&(c=!0))}if(r.putToCache("hasVolume",n),r.putToCache("hasConstantZValue",o),r.putToCache("constantZValue",o?h:null),r.putToCache("hasLowHighSeries",u),r.putToCache("hasNegativeValues",d),r.putToCache("hasDataOutsideBarEdge",c),r.putToCache("hasSeriesDisplayedInLegend",_),f&&g.hasVolumeSeries(t)&&!l.isOverview(t)){var I=e.JsonUtils.clone(g.getSeriesItem(t,0));I.assignedToY2="on",s=!0,I.type="bar",I.categories=g.getCategories(t,0),I.id="_volume",I._selectable="off",I.items=[];for(var D=0;D<A.items.length;D++){var O={};O.color=p.getStockVolumeColor(t,0,D),O.x=A.items[D].x,O.value=A.items[D].volume,O.drilling="off",I.items.push(O)}i.series.push(I),r.putToCachedMap("itemStyleSet",i.series.length-1,!0)}r.putToCache("hasY2Assignment",s);for(var E=g.getRefObjs(t),P=0;P<E.length;P++){if(M=E[P].items)for(T=0;T<M.length;T++){var L;(L=M[T])&&("object"!=typeof L?M[T]=Number(L):(!l.isMixedFrequency(t)&&L.x&&(L.x=Number(L.x)),L.max&&(L.max=Number(L.max)),L.min&&(L.min=Number(L.min)),L.value&&(L.value=Number(L.value))))}}i.groups||(i.groups=new Array);var w=g.getGroupCount(t);for(P=0;P<S-w;P++){var R=i.translations.labelDefaultGroupName||"Group {0}",B=e.ResourceUtils.format(R,[i.groups.length+1]);i.groups.push(B)}r.putToCache("groupsArray",null),Tt._processTimeAxis(t);var k=i.sorting;if(k="on"===k?"descending":"ascending"!==k&&"descending"!==k?"off":k,l.isBLAC(t)&&l.hasGroupAxis(t)&&"off"!=k&&1==g.getNumLevels(t)){var F=g.getGroups(t),N={};for(T=0;T<F.length;T++){var H=0;for(P=0;P<=a;P++)if(g.isSeriesRendered(t,P)&&!g.isAssignedToY2(t,P)){var G=g.getValue(t,P,T);H+=null==G||isNaN(G)?0:G}N[F[T]]={index:T,total:H,group:i.groups[T]}}"ascending"===k?F.sort(function(t,e){return N[t].total-N[e].total}):F.sort(function(t,e){return N[e].total-N[t].total});for(P=0;P<a;P++){var U=[];for(T=0;T<F.length;T++)U.push(g.getDataItem(t,P,N[F[T]].index));i.series[P].items=U}var j=[];for(T=0;T<F.length;T++)j.push(N[F[T]].group);i.groups=j,r.putToCache("groupsArray",null),r.putToCache("value",null)}i.styleDefaults.dataCursor.lineWidth=parseFloat(i.styleDefaults.dataCursor.lineWidth),Tt._sanitizeAxis(i.xAxis),Tt._sanitizeAxis(i.yAxis),Tt._sanitizeAxis(i.y2Axis)}},_processTimeAxis:function(t){var e,i,r=t.getCtx(),a=t.getOptions(),s=g.getSeriesCount(t),n=g.getGroupCount(t);if(l.isMixedFrequency(t))for(e=0;e<s;e++)for(i=0;i<n;i++){var o=g.getDataItem(t,e,i);null!=o&&"string"==typeof o.x&&null!=o.x&&(o.x=Tt._sanitizeDateTime(r,o.x))}else if(l.hasTimeAxis(t)){for(i=0;i<n;i++){var h=g.getGroup(t,i);null!=h&&(a.groups[i]=Tt._sanitizeDateTime(r,h))}t.getOptionsCache().putToCache("groupsArray",null)}if(l.hasTimeAxis(t)){var u=a.xAxis;null!=u.dataMin&&(u.dataMin=Tt._sanitizeDateTime(r,u.dataMin)),null!=u.dataMax&&(u.dataMax=Tt._sanitizeDateTime(r,u.dataMax)),null!=u.min&&(u.min=Tt._sanitizeDateTime(r,u.min)),null!=u.max&&(u.max=Tt._sanitizeDateTime(r,u.max)),null!=u.viewportMin&&(u.viewportMin=Tt._sanitizeDateTime(r,u.viewportMin)),null!=u.viewportMax&&(u.viewportMax=Tt._sanitizeDateTime(r,u.viewportMax)),null!=u.viewportStartGroup&&(u.viewportStartGroup=Tt._sanitizeDateTime(r,u.viewportStartGroup)),null!=u.viewportEndGroup&&(u.viewportEndGroup=Tt._sanitizeDateTime(r,u.viewportEndGroup));for(var d=g.getRefObjs(t),c=0;c<d.length;c++){var p=d[c].items;if(p)for(var _=0;_<p.length;_++)p[_]&&null!=p[_].x&&(p[_].x=Tt._sanitizeDateTime(r,p[_].x))}}},_sanitizeAxis:function(t){t.min==t.max&&(t.min=null,t.max=null)},_sanitizeDateTime:function(t,e){var i=null,r=t.getLocaleHelpers().isoToDateConverter;if(r){try{i=r(e)}catch(t){i=null}i=null!=i&&i.getTime?i.getTime():null}return null==i&&(i=Date.parse(e)),isNaN(i)&&(i=Number(e)),i}},It=function(t,e,i){this.Init(t,e,i)};
/**
   * @license
   * Copyright (c) 2008 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */e.Obj.createSubclass(It,e.BaseComponent),It.newInstance=function(t,e,i){return new It(t,e,i)},It.getDefaults=function(t){return(new d).getDefaults(t)},It.prototype.Init=function(t,i,r){It.superclass.Init.call(this,t,i,r),this.Defaults=new d(t),this.EventManager=new z(this),this.EventManager.addListeners(this),e.Agent.isTouchDevice()||this.EventManager.setKeyboardHandler(this.CreateKeyboardHandler(this.EventManager)),this.setId("chart1000"+Math.floor(1e9*Math.random())),this.legend=null,this.xAxis=null,this.yAxis=null,this.y2Axis=null,this.overview=null,this.xScrollbar=null,this.yScrollbar=null,this.dragButtons=null,this.pieChart=null,this.pieCenterDiv=null,this.Peers=[],this.SeriesStyleArray=[],this._numFrontObjs=0,this._numSelectedObjsInFront=0,this._dataLabels=null,this._rawOptions=null},It.prototype.GetComponentDescription=function(){var t=this.getOptions(),i=t.translations.componentName,r="",a=e.AriaUtils.ARIA_LABEL_DESC_DELIMITER;return t.title.text&&(r+=this.Options.title.text,t.subtitle.text&&(r+=a+this.Options.subtitle.text)),t.footnote.text&&(r=0==r.length?this.Options.footnote.text:r.concat(a,this.Options.footnote.text)),r.length>0?e.ResourceUtils.format(this.Options.translations.labelAndValue,[i,r]):i},It.prototype.SetOptions=function(t){t?(this._rawOptions=t,this.Options=this.Defaults.calcOptions(t),this.getOptionsCache().clearCache(),Tt.processDataObject(this),(e.Agent.isEnvironmentTest()||l.isScatterBubble(this)&&g.getSeriesCount(this)*g.getGroupCount(this)>mt.FILTER_THRESHOLD_SCATTER_BUBBLE)&&(this.Options.animationOnDisplay="none",this.Options.animationOnDataChange="none")):this.Options||(this.Options=this.GetDefaults());var i=this.Options.selectionMode;this._selectionHandler="single"==i?new e.SelectionHandler(this.getCtx(),e.SelectionHandler.TYPE_SINGLE):"multiple"==i?new e.SelectionHandler(this.getCtx(),e.SelectionHandler.TYPE_MULTIPLE):null,this.EventManager.setSelectionHandler(this._selectionHandler)},It.prototype.render=function(t,i,r){this.getCache().clearCache();var a=this.getCtx(),s=this.Options?this.Options.animationOnDataChange:"none",n="none"!=s?new Dt(this):null,o=this.__cacheChartFocus();this._container&&this.__cleanUp(),this.SetOptions(t),isNaN(i)||isNaN(r)||(this.Width=i,this.Height=r);var h=new e.Container(a);this.addChild(h),Mt.render(this,h,new e.Rectangle(0,0,this.Width,this.Height)),l.isSpark(this)&&this.EventManager.removeListeners(this),this.StopAnimation();var u=p.getAnimationOnDisplay(this),g=p.getAnimationDuration(this),d=new e.Rectangle(0,0,this.Width,this.Height),c=!1;if(this._container){if("none"!=s&&t)if(this.Animation=e.BlackBoxAnimationHandler.getCombinedAnimation(a,s,this._container,h,d,g),this.Animation)c=!0;else if("auto"==s&&this.getPlotArea()){var _=this.__getPlotAreaSpace();this._delContainer=mt.createClippedGroup(this,this._container,new e.Rectangle(0,0,_.w,_.h)),this.Animation=dt.createAnimation(n,this,s,g,this._delContainer),this._delContainer.getNumChildren()>0&&this.getPlotArea().addChild(this._delContainer)}}else"none"!=u&&(this.Animation=e.BlackBoxAnimationHandler.getInAnimation(a,u,h,d,g),this.Animation||"auto"!=u||(this.Animation=ct.createAnimation(this,u,g)));this.Animation?(this.EventManager.removeListeners(this),e.Playable.appendOnEnd(this.Animation,this._onAnimationEnd,this),this.Animation.play(),this._oldContainer=this._container,!c&&this._oldContainer&&this._oldContainer.removeFromParent()):this._container&&(this._container.removeFromParent(),this._container.destroy(),this._container=null),this._container=h,this._dataCursor=Mt.renderDataCursor(this),this.UpdateAriaAttributes(),this.__restoreChartFocus(o),this.Animation||this.RenderComplete()},It.prototype.__cleanUp=function(){this._dataCursor&&(this.removeChild(this._dataCursor),this._dataCursor=null),this.EventManager&&(this.EventManager.hideHoverFeedback(),this.EventManager.setPanZoomHandler(null),this.EventManager.setMarqueeZoomHandler(null),this.EventManager.setMarqueeSelectHandler(null),this.EventManager.panButton=null,this.EventManager.zoomButton=null,this.EventManager.selectButton=null),this.pieCenterDiv&&(this.getCtx().getContainer().removeChild(this.pieCenterDiv),this.pieCenterDiv=null),this.Peers=[],this.xScrollbar=null,this.yScrollbar=null,this.dragButtons&&(this.removeChild(this.dragButtons),this.dragButtons.destroy(),this.dragButtons=null),this._plotArea=null,this._areaContainer=null,this._dataLabels=null,this.getCache().clearCache()},It.prototype.__cleanUpAxisAndPlotArea=function(){this.EventManager.hideHoverFeedback(),this.Peers=[],this.xAxis&&(this._container.removeChild(this.xAxis),this.xAxis.destroy()),this.yAxis&&(this._container.removeChild(this.yAxis),this.yAxis.destroy()),this.y2Axis&&(this._container.removeChild(this.y2Axis),this.y2Axis.destroy()),this._plotArea&&this._plotArea==this._panZoomTarget?this._plotArea.setVisible(!1):this._plotArea&&(this._container.removeChild(this._plotArea),this._plotArea.destroy()),this._plotArea=null,this.getCache().clearCache()},It.prototype._onAnimationEnd=function(){this._oldContainer&&(this._oldContainer.removeFromParent(),this._oldContainer.destroy(),this._oldContainer=null),this._delContainer&&(this._delContainer.removeFromParent(),this._delContainer.destroy(),this._delContainer=null),this.AnimationStopped||this.RenderComplete(),this.EventManager.addListeners(this),this.Animation=null,this.AnimationStopped=!1},It.prototype.CreateKeyboardHandler=function(t){return new X(t,this)},It.prototype.getAutomation=function(){return new W(this)},It.prototype.getValuesAt=function(t,e){var i=this.__getPlotAreaSpace(),r=t-i.x,a=e-i.y,s=l.isPolar(this),n=l.isHorizontal(this);if(s){r-=i.w/2,a-=i.h/2;var o=Math.sqrt(r*r+a*a),h=Math.atan2(r,-a);return h<0&&(h+=2*Math.PI),{x:this.xAxis?this.xAxis.getValueAt(h):null,y:this.yAxis?this.yAxis.getValueAt(o):null}}return{x:this.xAxis?this.xAxis.getValueAt(n?a:r):null,y:this.yAxis?this.yAxis.getValueAt(n?r:a):null,y2:this.y2Axis?this.y2Axis.getValueAt(n?r:a):null}},It.prototype.filter=function(t,e){var i="out"==e?"hidden":"visible";k.setVisibility(this,t,i),this.render(this.Options)},It.prototype.highlight=function(t){this.getOptions().highlightedCategories=e.JsonUtils.clone(t),e.CategoryRolloverHandler.highlight(t,this.getObjects(),"any"==this.getOptions().highlightMatch),this.legend&&this.legend.highlight(t),this.pieChart&&this.pieChart.highlight(t),this.overview&&this.overview.getBackgroundChart().highlight(t)},It.prototype.select=function(t){this.getOptions().selection=e.JsonUtils.clone(t);var i=g.getInitialSelection(this);k.setInitialSelection(this,i),this.pieChart&&this.pieChart.setInitialSelection()},It.prototype.positionDataCursor=function(t){var i=this.getEventManager().getDataCursorHandler();if(i){if(t){var r=this.xAxis&&null!=t.x?this.xAxis.getCoordAt(t.x):null,a=null;if(l.isBLAC(this)?this.yAxis&&null!=t.y?a=this.yAxis.getBoundedCoordAt(t.y):this.y2Axis&&null!=t.y2&&(a=this.yAxis.getBoundedCoordAt(t.y2)):a=this.yAxis&&null!=t.y?this.yAxis.getCoordAt(t.y):null,null!=r&&null!=a){var s=this.__getPlotAreaSpace(),n=h.convertAxisCoord(this,new e.Point(r,a),s);return void i.processMove(new e.Point(s.x+n.x,s.y+n.y),!0)}}i.processEnd(!0)}},It.prototype.processEvent=function(t,e){var i=t.type;if("categoryHide"==i||"categoryShow"==i)this.filter(t.category,"categoryHide"==i?"out":"in");else if("categoryHighlight"==i)this!=e&&this.highlight(t.categories),this.legend&&this.legend!=e&&this.legend.processEvent(t,e);else if("selection"==i)t=this._processSelectionEvent(t);else if("dvtPanZoom"==i)t=this._processPanZoomEvent(t);else if("dvtMarquee"==i)t=this._processMarqueeEvent(t);else if("overview"==i){var r=t.subtype;if("dropCallback"==r)return;var a="scrollTime"==r||"scrollEnd"==r||"rangeChange"==r;t=this._processScrollbarEvent(t.newX1,t.newX2,a,e)}else if("dvtSimpleScrollbar"==i)t=this._processScrollbarEvent(t.newMin,t.newMax,"end"==t.subtype,e);else if("ready"==i&&this!=e)return;if(t){if("selection"==(i=t.type)){var s,n,o=this.getOptions(),l=o.selection,h=g.getCurrentSelection(this);t.complete&&(o.selection=h),l=l||[],h=h||[];var u={};for(s=0;s<l.length;s++)u[l[s].id]=!0;var d={};for(n=0;n<h.length;n++)d[h[n].id]=!0;var c={};for(n=0;n<h.length;n++){var p=h[n].id;u[p]||(c[p]=!0)}var _={};for(s=0;s<l.length;s++){var f=l[s].id;d[f]||(_[f]=!0)}t.addedSet=c,t.removedSet=_;for(var v=0;v<t.selection.length;v++)k.addEventData(this,t.selection[v]);t.component=this.getOptions()._widgetConstructor}else if("drill"===i){if(t.subType||(t.subType="_dvtOther"===t.id?"multiSeries":"series",t.series=t.id),this._processDrillSubType(t),"multiSeries"===t.subType)return;k.addEventData(this,t),delete t.subType,t.component=this.getOptions()._widgetConstructor}this.dispatchEvent(t)}},It.prototype._processDrillSubType=function(t){var e,i=t.subType;"item"===i?e=k.addItemDrillEventData(this,t):"group"===i?e=k.addGroupDrillEventData(this,t):"series"===i?e=k.addSeriesDrillEventData(this,t):"multiSeries"===i&&(e=k.addMultiSeriesDrillEventData(this,t)),this.dispatchEvent(e)},It.prototype._processSelectionEvent=function(t){var i=k.processIds(this,t.selection);return this._updateOverviewSelection(),e.EventFactory.newChartSelectionEvent(i,!0)},It.prototype._processPanZoomEvent=function(t){var i=t.subtype;return"panStart"==i||"pinchStart"==i?(e.Agent.isTouchDevice()&&this._panZoomTarget!=this._plotArea&&(this._container.removeChild(this._panZoomTarget),this._panZoomTarget=this._plotArea),null):(this._lastPanZoomEvent?(t.dxMin+=this._lastPanZoomEvent.dxMin,t.dxMax+=this._lastPanZoomEvent.dxMax,t.dyMin+=this._lastPanZoomEvent.dyMin,t.dyMax+=this._lastPanZoomEvent.dyMax):e.Context.requestAnimationFrame(e.Obj.createCallback(this,this._animatePanZoomEvent)),this._lastPanZoomEvent=t,null)},It.prototype._animatePanZoomEvent=function(){var t=this._lastPanZoomEvent;this._lastPanZoomEvent=null;var i,r,a=t.subtype,s="panEnd"==a||"zoom"==a||"pinchEnd"==a;(E.isLiveScroll(this)?(i=k.getAxisBoundsByDelta(this,t.dxMin,t.dxMax,t.dyMin,t.dyMax),this._setScrollbarViewport(i),this._setViewport(i,s)):(i=k.getAxisBoundsByDelta(this,t.dxMinTotal,t.dxMaxTotal,t.dyMinTotal,t.dyMaxTotal),this._setScrollbarViewport(i),s&&this._setViewport(i,s)),s&&(Mt._setEventHandlers(this),this._panZoomTarget!=this._plotArea&&(this._container.removeChild(this._panZoomTarget),this._panZoomTarget=null)),s||!i.unchanged)&&(r=l.isBLAC(this)?e.EventFactory.newChartViewportChangeEvent(s,i.xMin,i.xMax,i.startGroup,i.endGroup,null,null):e.EventFactory.newChartViewportChangeEvent(s,i.xMin,i.xMax,null,null,i.yMin,i.yMax),this.dispatchEvent(r))},It.prototype._processMarqueeEvent=function(t){var i,r=t.subtype,a=this.EventManager;if(k.adjustBounds(t),a.getDragMode()==z.DRAG_MODE_SELECT){var s=a.getSelectionHandler();if("start"==r)this._initSelection=t.ctrlKey?s.getSelectedIds():[];else{var n=k.getBoundedObjects(this,t);s.processInitialSelections(this._initSelection,this.getChartObjPeers()),s.processGroupSelection(n,!0)}var o=s.getSelectedIds();i=k.getAxisBounds(this,t,!1);var h="end"==r,u=e.EventFactory.newChartSelectionEvent(o,h,i.xMin,i.xMax,i.startGroup,i.endGroup,i.yMin,i.yMax,i.y2Min,i.y2Max);return"end"==r&&this._updateOverviewSelection(),u}return a.getDragMode()==z.DRAG_MODE_ZOOM?"end"!=r?null:(i=k.getAxisBounds(this,t,!0),this._setViewport(i,!0),this._setScrollbarViewport(i),Mt._setEventHandlers(this),l.isBLAC(this)?e.EventFactory.newChartViewportChangeEvent(!0,i.xMin,i.xMax,i.startGroup,i.endGroup,null,null):e.EventFactory.newChartViewportChangeEvent(!0,i.xMin,i.xMax,null,null,i.yMin,i.yMax)):null},It.prototype._processScrollbarEvent=function(t,i,r,a){return this._lastScrollbarEvent||e.Context.requestAnimationFrame(e.Obj.createCallback(this,this._animateScrollbarEvent)),this._lastScrollbarEvent={start:t,end:i,actionDone:r,source:a},null},It.prototype._animateScrollbarEvent=function(){var t=this._lastScrollbarEvent.start,i=this._lastScrollbarEvent.end,r=this._lastScrollbarEvent.actionDone,a=this._lastScrollbarEvent.source;this._lastScrollbarEvent=null;var s=a==this.yScrollbar?this.yAxis:this.xAxis,n=k.getActualMinMax(s,t,i);if(t=n.min,i=n.max,(E.isLiveScroll(this)||r)&&(a==this.yScrollbar?this._setViewport({yMin:t,yMax:i},r):this._setViewport({xMin:t,xMax:i,unchanged:n.unchanged},r)),r||!n.unchanged){var o;if(a==this.yScrollbar)o=e.EventFactory.newChartViewportChangeEvent(r,null,null,null,null,t,i,null,null);else{var l=k.getAxisStartEndGroup(this.xAxis,t,i);o=e.EventFactory.newChartViewportChangeEvent(r,t,i,l.startGroup,l.endGroup,null,null,null,null)}this.dispatchEvent(o)}},It.prototype._updateOverviewSelection=function(){if(this.overview){var t=this.overview.getBackgroundChart();t.getOptions().selection=g.getCurrentSelection(this),t.render()}},It.prototype.changeOption=function(t,i,r){this.getOptions()[t]=i,this.dispatchEvent(e.EventFactory.newOptionChangeEvent(t,i,r))},It.prototype.registerObject=function(t){this.Peers.push(t)},It.prototype.getObjects=function(){return this.Peers},It.prototype.getChartObjPeers=function(){for(var t=[],e=0;e<this.Peers.length;e++)this.Peers[e]instanceof m&&t.push(this.Peers[e]);return t},It.prototype.getRefObjPeers=function(){for(var t=[],e=0;e<this.Peers.length;e++)this.Peers[e]instanceof S&&t.push(this.Peers[e]);return t},It.prototype.getObject=function(t,e){for(var i=0;i<this.Peers.length;i++)if(this.Peers[i]instanceof m&&this.Peers[i].getSeriesIndex()==t&&this.Peers[i].getGroupIndex()==e)return this.Peers[i];return null},It.prototype.getWidth=function(){return this.Width},It.prototype.getHeight=function(){return this.Height},It.prototype.getSeriesStyleArray=function(){return this.SeriesStyleArray},It.prototype.getPlotArea=function(){return this._plotArea},It.prototype.setPlotArea=function(t){this._plotArea=t},It.prototype.getType=function(){return this.getOptions().type},It.prototype.getSkin=function(){return this.getOptions().skin},It.prototype.getGapWidthRatio=function(){var t=this.getOptions();return null!==t.layout.gapWidthRatio?t.layout.gapWidthRatio:Math.min(this.Width/400,1)},It.prototype.getGapHeightRatio=function(){var t=this.getOptions();return null!==t.layout.gapHeightRatio?t.layout.gapHeightRatio:Math.min(this.Height/300,1)},It.prototype.getSelectionHandler=function(){return this._selectionHandler},It.prototype.isSelectionSupported=function(){return!!this._selectionHandler},It.prototype._setViewport=function(t,e){!e&&t.unchanged||(null!=t.xMax&&(this.Options.xAxis.viewportMax=t.xMax),null!=t.xMin&&(this.Options.xAxis.viewportMin=t.xMin),l.isBLAC(this)?(this.Options.xAxis.viewportStartGroup=null,this.Options.xAxis.viewportEndGroup=null,this.Options._initialZoomed=!1):(null!=t.yMax&&(this.Options.yAxis.viewportMax=t.yMax),null!=t.yMin&&(this.Options.yAxis.viewportMin=t.yMin)),this.Options._duringZoomAndScroll=!e,Mt.rerenderAxisAndPlotArea(this,this._container))},It.prototype._setScrollbarViewport=function(t){if(this.xAxis&&null!=t.xMin&&null!=t.xMax){var e=this.xAxis.actualToLinear(t.xMin),i=this.xAxis.actualToLinear(t.xMax);this.overview&&this.overview.setViewportRange(e,i),this.xScrollbar&&this.xScrollbar.setViewportRange(e,i)}if(this.yAxis&&null!=t.yMin&&null!=t.yMax){var r=this.yAxis.actualToLinear(t.yMin),a=this.yAxis.actualToLinear(t.yMax);this.yScrollbar&&this.yScrollbar.setViewportRange(r,a)}},It.prototype.__setAxisSpace=function(t){var e,i;this._axisSpace=t,L.isAxisRendered(this,"x")?(e=.8*t.w,i=t.h-4*L.getTickLabelHeight(this,"x")):L.isAxisRendered(this,"y")?(e=t.w,i=t.h-L.getTickLabelHeight(this,"y")):(e=t.w,i=t.h),this._radius=Math.min(e,i)/2},It.prototype.__getAxisSpace=function(){return this._axisSpace},It.prototype.__setPlotAreaSpace=function(t){this._plotAreaSpace=t},It.prototype.__getPlotAreaSpace=function(){return this._plotAreaSpace},It.prototype.__setAreaContainer=function(t){this._areaContainer=t},It.prototype.__getAreaContainer=function(){return this._areaContainer},It.prototype.getRadius=function(){return this._radius},It.prototype.showDragButtons=function(){this.dragButtons&&this.dragButtons.setVisible(!0)},It.prototype.hideDragButtons=function(){this.dragButtons&&this.dragButtons.setVisible(!1)},It.prototype.addDataLabel=function(t){this.getDataLabels().push(t)},It.prototype.getDataLabels=function(){return this._dataLabels||(this._dataLabels=[]),this._dataLabels},It.prototype.__cacheChartFocus=function(){var t=this.EventManager.getFocus();if(t)var e=t.isShowingKeyboardFocusEffect();if(this.xAxis){var i=this.xAxis.getKeyboardFocus();if(i)var r=i.isShowingKeyboardFocusEffect()}if(this.legend){var a=this.legend.getKeyboardFocus();if(a)var s=a.isShowingKeyboardFocusEffect()}return{chartFocus:t,chartShowingFocusEffect:e,axisFocus:i,axisShowingFocusEffect:r,legendFocus:a,legendShowingFocusEffect:s,sorting:this.getOptions().sorting}},It.prototype.__restoreChartFocus=function(t){if(!l.isOverview(this)&&!l.isSpark(this)){var e=[this];if(this.xAxis&&this.xAxis.isNavigable()&&e.push(this.xAxis),this.legend&&this.legend.isNavigable()&&e.push(this.legend),this.getCtx().setKeyboardFocusArray(e),t.legendFocus&&(this.legend.setKeyboardFocus(t.legendFocus,t.legendShowingFocusEffect),t.legendShowingFocusEffect&&this.getCtx().setCurrentKeyboardFocus(this.legend)),this.Options.sorting!=t.sorting){if(t.chartFocus){var i=k.getKeyboardNavigables(this);this.EventManager.setFocusObj(this.EventManager.getKeyboardHandler().getDefaultNavigable(i))}return t.axisFocus&&this.xAxis.setKeyboardFocus(this.xAxis.EventManager.getKeyboardHandler().getDefaultNavigable(this.xAxis.__getKeyboardObjects()),t.axisShowingFocusEffect),void(t.axisShowingFocusEffect&&this.getCtx().setCurrentKeyboardFocus(this.xAxis))}if(t.chartFocus){for(var r=k.getKeyboardNavigables(this),a=!1,s=0;s<r.length;s++){var n=r[s].getId();if(n instanceof o&&n.equals(t.chartFocus.getId())){this.EventManager.setFocusObj(r[s]),t.chartShowingFocusEffect&&r[s].showKeyboardFocusEffect(),a=!0;break}}a||this.EventManager.setFocusObj(this.EventManager.getKeyboardHandler().getDefaultNavigable(r))}t.axisFocus&&(this.xAxis.setKeyboardFocus(t.axisFocus,t.axisShowingFocusEffect),t.axisShowingFocusEffect&&this.getCtx().setCurrentKeyboardFocus(this.xAxis))}},It.prototype.getRawOptions=function(){return this._rawOptions};var Dt=function(t){this.Options=t.Options,this.Peers=t.Peers,this.SeriesStyleArray=t.SeriesStyleArray,this.Cache=t.Cache,this.pieChart=t.pieChart,this._optionsCache=new e.BaseComponentCache,this._cache=new e.BaseComponentCache};e.Obj.createSubclass(Dt,It),Dt.prototype.getCache=function(){return this._cache},Dt.prototype.getOptionsCache=function(){return this._optionsCache};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var Ot=function(t){this._sparkChart=t};e.Obj.createSubclass(Ot,e.Automation),Ot.prototype.getDataItem=function(t){var e=this._sparkChart.__getChart().getAutomation().getDataItem(0,t);return e?{borderColor:e.borderColor,color:e.color,date:e.x,low:e.low,high:e.high,value:null==e.low||null==e.high?e.value:e.high-e.low}:null};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var Et=function(t){this.Init({alta:Et.SKIN_ALTA},t)};e.Obj.createSubclass(Et,e.BaseComponentDefaults),Et.SKIN_ALTA={skin:e.CSSStyle.SKIN_ALTA,type:"line",animationOnDisplay:"none",animationOnDataChange:"none",areaSvgClassName:"",emptyText:null,color:"#267db3",firstColor:"",lastColor:"",highColor:"",lowColor:"",visualEffects:"auto",baselineScaling:"min",barSpacing:"auto",lineWidth:1,lineStyle:"solid",lineType:"straight",markerSize:5,markerShape:"auto",barGapRatio:.25,referenceObjects:[],svgClassName:"",_statusMessageStyle:new e.CSSStyle("font-size: 12px; color: #404259;")},Et.prototype.getAnimationDuration=function(t){return t.animationDuration};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var Pt=function(t){this.Init(t.getCtx(),t.dispatchEvent,t,t),this._sparkChart=t};e.Obj.createSubclass(Pt,e.EventManager),Pt.prototype.ProcessKeyboardEvent=function(t){if(!this.KeyboardHandler)return!1;if(t.keyCode==e.KeyboardEvent.TAB){var i=this._sparkChart.getCtx().getStageAbsolutePosition();this.ProcessObjectTooltip(t,i.x,i.y,this._sparkChart.__getLogicalObject(),this._sparkChart)}return!1},Pt.prototype.OnBlur=function(t){Pt.superclass.OnBlur.call(this,t),this.hideTooltip()};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var Lt=new Object;e.Obj.createSubclass(Lt,e.Obj),Lt.render=function(t,e,i){var r=t.__getChart(),a=Lt._convertOptionsObj(t),s=t.getOptions();if("area"==s.type||"line"==s.type||"lineWithArea"==s.type){var n=Lt._getDataItems(t),o=!1;if(s.firstColor||s.lastColor||s.highColor||s.lowColor)o=!0;else for(var l=0;l<n.length;l++)if(n[l]&&"on"==n[l].markerDisplayed){o=!0;break}if(o&&n.length>0||"none"==s.lineType){var h=s.markerSize/2;e-=2*h,i-=2*h,r.setTranslate(h,h)}}r.render(a,e,i)},Lt._getDataItems=function(t){var e=t.getOptions();return e&&e.items?e.items:[]},Lt._convertOptionsObj=function(t){var i=t.getOptions(),r={styleDefaults:{},xAxis:{},yAxis:{},groups:[]};r.translations=i.translations;for(var a=[],s=-1,n=-1,o=-1/0,l=1/0,h=Lt._getDataItems(t),u=0;u<h.length;u++){var g=h[u],d={};g instanceof Object?(d.value=g.value,d.low=g.low,d.high=g.high,g.date&&(r.timeAxisType="enabled",r.groups.push(g.date)),"on"==g.markerDisplayed&&(d.markerDisplayed="on"),g.color&&(d.color=g.color),g.borderColor&&(d.borderColor=g.borderColor),g.markerShape&&(d.markerShape=g.markerShape),g.markerSize&&(d.markerSize=g.markerSize),(g.className||g.svgClassName)&&(d.svgClassName=g.className||g.svgClassName),(g.style||g.svgStyle)&&(d.svgStyle=g.style||g.svgStyle)):d.value=g,a.push(d);var c=null!=d.value?d.value:Math.max(d.low,d.high);o<c&&(o=c,s=u);var p=null!=d.value?d.value:Math.min(d.low,d.high);l>p&&(l=p,n=u)}i.highColor&&s>=0&&(a[s].markerDisplayed="on",a[s].color||(a[s].color=i.highColor)),i.lowColor&&n>=0&&(a[n].markerDisplayed="on",a[n].color||(a[n].color=i.lowColor)),i.firstColor&&a.length>0&&(a[0].markerDisplayed="on",a[0].color||(a[0].color=i.firstColor)),i.lastColor&&a.length>0&&(a[a.length-1].markerDisplayed="on",a[a.length-1].color||(a[a.length-1].color=i.lastColor)),r.series=[{items:a,areaColor:i.areaColor,svgClassName:i.className||i.svgClassName,svgStyle:i.style||i.svgStyle,areaSvgClassName:i.areaClassName||i.areaSvgClassName,areaStyle:i.areaStyle||i.areaSvgStyle}],i.referenceObjects&&i.referenceObjects.length>0&&(r.yAxis.referenceObjects=i.referenceObjects),r.__spark=!0;var _=i.barSpacing;"auto"==_&&(_=e.Agent.getDevicePixelRatio()>1?"subpixel":"pixel"),r.__sparkBarSpacing=_,r.type=i.type,r.animationOnDataChange=i.animationOnDataChange,r.animationOnDisplay=i.animationOnDisplay,r.emptyText=i.emptyText,i.color&&(r.styleDefaults.colors=[i.color]),r.styleDefaults.animationDuration=i.animationDuration,r.styleDefaults.animationIndicators="none",r.styleDefaults.lineWidth=i.lineWidth,r.styleDefaults.lineStyle=i.lineStyle,r.styleDefaults.lineType=i.lineType,r.styleDefaults.markerSize=i.markerSize,r.styleDefaults.markerShape=i.markerShape,r.styleDefaults.barGapRatio=i.barGapRatio,r.styleDefaults.dataItemGaps="0%",r.xAxis.rendered="off",r.yAxis.rendered="off";var f="zero"==i.baselineScaling,v=o!=l?.1*(o-l):.1*Math.abs(o);return r.yAxis.min=f&&l>=0?0:l-v,r.yAxis.max=f&&o<=0?0:o+v,"none"==i.visualEffects||"area"!=i.type&&"lineWithArea"!=i.type?r.styleDefaults.seriesEffect="color":r.styleDefaults.seriesEffect="gradient",r.layout={gapWidthRatio:0,gapHeightRatio:0},r.legend={rendered:"off"},r._statusMessageStyle=i._statusMessageStyle,r};
/**
   * @license
   * Copyright (c) 2008 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
const wt=function(){};e.Obj.createSubclass(wt,e.BaseComponent),wt.newInstance=function(t,e,i){var r=new wt;return t.getStage().setCursor(""),r.Init(t,e,i),r},wt.getDefaults=function(t){return(new Et).getDefaults(t)},wt.prototype.Init=function(t,i,r){wt.superclass.Init.call(this,t,i,r),this.Defaults=new Et(t),this.EventManager=new Pt(this),this.EventManager.addListeners(this),this._chart=It.newInstance(t,this._onRenderEnd,this),this.addChild(this._chart),e.Agent.isTouchDevice()||this.EventManager.setKeyboardHandler(new e.KeyboardHandler(this.EventManager,this)),this._tooltipMask=new e.Rect(t),this.addChild(this._tooltipMask),this.setId("sparkChart1000"+Math.floor(1e9*Math.random()))},wt.prototype.SetOptions=function(t){t?(this.Options=this.Defaults.calcOptions(t),e.Agent.isEnvironmentTest()&&(this.Options.animationOnDisplay="none",this.Options.animationOnDataChange="none")):this.Options||(this.Options=this.GetDefaults())},wt.prototype.setId=function(t){wt.superclass.setId.call(this,t),this._chart&&this._chart.setId(t+"chart")},wt.prototype.render=function(t,i,r){this.SetOptions(t),isNaN(i)||isNaN(r)||(this.Width=i,this.Height=r),this._eventReceived=!1,this._isDoneRendering=!1,Lt.render(this,this.Width,this.Height);var a=this.Options.shortDesc;this._tooltipMask.setWidth(this.Width),this._tooltipMask.setHeight(this.Height),this._tooltipMask.setInvisibleFill();var s=this.Options.tooltip,n=s?s.renderer:null,o=this.Options.color;if(n){var l={component:this.Options._widgetConstructor,color:o};this._peer=new e.CustomDatatipPeer(this.getCtx().getTooltipManager(),n,o,l),this.EventManager.associate(this._tooltipMask,this._peer)}else a?(this._peer=new e.SimpleObjPeer(null,a,o),this.EventManager.associate(this._tooltipMask,this._peer)):this._peer=null;this.Options._selectingCursor&&this.setCursor(e.SelectionEffectUtils.getSelectingCursor()),this.UpdateAriaAttributes(),this._eventReceived&&this.RenderComplete(),this._isDoneRendering=!0},wt.prototype._onRenderEnd=function(t){this._eventReceived=!0,"ready"==t.type&&this._isDoneRendering&&this.RenderComplete()},wt.prototype.__getChart=function(){return this._chart},wt.prototype.getAutomation=function(){return new Ot(this)},wt.prototype.UpdateAriaAttributes=function(){var t=e.Displayable.generateAriaLabel(e.AriaUtils.processAriaLabel(this.GetComponentDescription()),this.Options.shortDesc?[this.Options.shortDesc]:null),i=this.Options.translations;this.IsParentRoot()?(this.getCtx().setAriaRole("img"),this.getCtx().setAriaLabel(e.ResourceUtils.format(i.labelAndValue,[i.labelDataVisualization,t]))):(this.setAriaRole("img"),this.setAriaProperty("label",t))},wt.prototype.__getLogicalObject=function(){return this._peer},t.Chart=It,t.SparkChart=wt,Object.defineProperty(t,"__esModule",{value:!0})});
//# sourceMappingURL=ojchart-toolkit.js.map