/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["exports","ojs/ojcontext","ojs/ojlogger","ojs/ojthemeutils"],function(e,t,r,i){"use strict";t=t&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t;const n={};class s{static isValidCustomElementName(e){const t=s._RESERVED_TAGS.has(e),r=s._ELEMENT_NAME_REGEXP.test(e);return!t&&r&&!e.startsWith("oj-bind-",0)}static getSupportedTypes(e){if(!e)return{};let t=n[e];if(!t){t={};const r=e.toLowerCase(),i=r.match(/(?=[^|])(?:[^|]*<[^>]+>)*[^|]*/g);let s=0;i.forEach(e=>{const r=e.trim();"any"===r||"boolean"===r||"number"===r||"string"===r||"array"===r||"object"===r||"null"===r?t[r]=1:0===r.indexOf("array<")?t.array=1:0===r.indexOf("object<")?t.object=1:t.other=1,s++}),t.typeCount=s,n[r]=t}return t}static getUniqueId(e){if(e)return e;const t=s._UNIQUE+s._UNIQUE_INCR;return s._UNIQUE_INCR+=1,t}}s._UNIQUE_INCR=0,s._UNIQUE="_ojcustomelem",s._RESERVED_TAGS=new Set(["annotation-xml","color-profile","font-face","font-face-src","font-face-uri","font-face-format","font-face-name","missing-glyph"]),s._ELEMENT_NAME_REGEXP=/^[a-z][.0-9_a-z]*-[-.0-9_a-z]*$/;const o={accessKey:"accesskey",autocapitalize:"autocapitalize",autofocus:"autofocus",class:"class",contentEditable:"contenteditable",dir:"dir",draggable:"draggable",enterKeyHint:"enterkeyhint",hidden:"hidden",id:"id",inputMode:"inputmode",is:"is",itemid:"itemid",itemprop:"itemprop",itemref:"itemref",itemscope:"itemscope",itemtype:"itemtype",lang:"lang",nonce:"nonce",role:"role",slot:"slot",spellcheck:"spellcheck",style:"style",tabIndex:"tabindex",title:"title",translate:"translate"},a={acceptCharset:"accept-charset",allowFullscreen:"allowfullscreen",allowPaymentRequest:"allowpaymentrequest",colSpan:"colspan",crossOrigin:"crossorigin",dateTime:"datetime",dirName:"dirname",encoding:"enctype",formAction:"formaction",formEnctype:"formenctype",formMethod:"formmethod",formNoValidate:"formnovalidate",formTarget:"formtarget",for:"for",httpEquiv:"http-equiv",imageSizes:"imagesizes",imageSrcset:"imagesrcset",inputMode:"inputmode",isMap:"ismap",maxLength:"maxlength",minLength:"minlength",noModule:"nomodule",noValidate:"novalidate",readOnly:"readonly",referrerPolicy:"referrerpolicy",rowSpan:"rowspan",useMap:"usemap"},l=/^\s*\[[^]*\]\s*$/,d=/^\s*\{[^]*\}\s*$/,c=/^(?:\{\{)([^]+)(?:\}\})$/,u=/^(?:\[\[)([^]+)(?:\]\])$/,m={};Object.keys(o).forEach(function(e){var t=o[e];e!==t&&(m[t]=e,a[e]=t)});class g{static getExpressionInfo(e){let t,r=!1;if(e){const i=e.trim();let n=c.exec(i);t=null==n?void 0:n[1],t||(r=!0,n=u.exec(i),t=null==n?void 0:n[1])}return{downstreamOnly:r,expr:t}}static coerceValue(e,t,r,i){var n=e.tagName.toLowerCase();if(!i)throw new Error(`Unable to parse ${t}='${r}' for ${n} with id '${e.id}'.         This attribute only supports data bound values. Check the API doc for supported types`);const o=s.getSupportedTypes(i);var a=l.test(r),c=d.test(r);if(o.array&&a||o.object&&c||o.any&&(a||c))try{return JSON.parse(r)}catch(i){throw new Error(`Unable to parse ${t}='${r}' for ${n} with id '${e.id}'           to a JSON Object. Check the value for correct JSON syntax, e.g. double quoted strings. ${i}`)}else{if(o.string||o.any)return r;if(o.boolean)return g.coerceBooleanValue(e,t,r,i);if(o.number&&!isNaN(r))return Number(r)}throw new Error(`Unable to parse ${t}='${r}' for ${n} with id '${e.id}'       to a ${i}.`)}static coerceBooleanValue(e,t,r,i){if(null==r||"true"===r||""===r||r.toLowerCase()===t)return!0;if("false"===r)return!1;const n=e.tagName.toLowerCase();throw new Error(`Unable to parse ${t}='${r}' for ${n} with id '${e.id}' to a ${i}.`)}static isGlobalOrData(e){return Object.prototype.hasOwnProperty.call(o,e)||e.startsWith("data-")||e.startsWith("aria-")}static getGlobalAttrForProp(e){return o[e]||e}static getGlobalPropForAttr(e){return m[e]||e}static getNativeAttr(e){return a[e]||e}}function h(e,t){let r=e.cache;return r||(r=new Map,e.cache=r),r.has(t)||r.set(t,e(t)),r.get(t)}g.attributeToPropertyName=h.bind(null,e=>e.toLowerCase().replace(/-(.)/g,(e,t)=>t.toUpperCase())),g.propertyNameToAttribute=h.bind(null,e=>e.replace(/([A-Z])/g,e=>"-"+e.toLowerCase())),g.eventTypeToEventListenerProperty=h.bind(null,e=>"on"+e.substr(0,1).toUpperCase()+e.substr(1)),g.isEventListenerProperty=h.bind(null,e=>/^on[A-Z]/.test(e)),g.eventListenerPropertyToEventType=h.bind(null,e=>e.substr(2,1).toLowerCase()+e.substr(3)),g.propertyNameToChangeEventType=h.bind(null,e=>e+"Changed"),g.propertyNameToChangedCallback=h.bind(null,e=>`on${e[0].toUpperCase()}${e.substr(1)}Changed`),g.eventTriggerToEventType=h.bind(null,e=>`oj${e.substr(0,1).toUpperCase()}${e.substr(1)}`);class p{static registerElement(e,t){const r=e.toUpperCase();if(!p._CUSTOM_ELEMENT_REGISTRY[r]){if(!t.descriptor)throw new Error(`Custom element ${e} must be registered with a descriptor.`);return p._CUSTOM_ELEMENT_REGISTRY[e]=t,p._CUSTOM_ELEMENT_REGISTRY[r]=t,!0}return!1}static isComposite(e){var t,r;return null!==(r=null===(t=p.getElementRegistration(e))||void 0===t?void 0:t.composite)&&void 0!==r&&r}static isElementRegistered(e){return null!=p._CUSTOM_ELEMENT_REGISTRY[e]}static getElementRegistration(e){var t;return null!==(t=p._CUSTOM_ELEMENT_REGISTRY[e])&&void 0!==t?t:null}static getElementDescriptor(e){var t;return(null===(t=p.getElementRegistration(e))||void 0===t?void 0:t.descriptor)||{}}static getElementProperties(e){var t,r;const i=p.getElementDescriptor(e.tagName);return(null===(r=null!==(t=i._metadata)&&void 0!==t?t:i.metadata)||void 0===r?void 0:r.properties)||{}}static getElementInfo(e){return e?`${e.tagName.toLowerCase()} with id '${e.id}'`:""}static getElementState(e){let t=e[p._ELEMENT_STATE_KEY];if(!t&&p.isElementRegistered(e.tagName)){t=new(0,p.getElementRegistration(e.tagName).stateClass)(e),Object.defineProperty(e,p._ELEMENT_STATE_KEY,{value:t})}return null!=t?t:null}static getElementBridge(e){let t=e[p._ELEMENT_BRIDGE_KEY];if(!t&&p.isElementRegistered(e.tagName)){const r=p.getElementRegistration(e.tagName).bridgeProto;t=Object.create(r);const i=p.getElementDescriptor(e.tagName);t.initializeBridge(e,i),Object.defineProperty(e,p._ELEMENT_BRIDGE_KEY,{value:t})}return null!=t?t:null}static getSlotMap(e){const t={},r=e.childNodes;for(var i=0;i<r.length;i++){const e=r[i];if(p.isSlotable(e)){const r=p.getSlotAssignment(e);t[r]||(t[r]=[]),t[r].push(e)}}return t}static getSlotAssignment(e){const t=null!=e.__oj_slots?e.__oj_slots:e.getAttribute&&e.getAttribute("slot");return t||""}static isSlotable(e){return 1===e.nodeType||3===e.nodeType&&!!e.nodeValue.trim()}static getElementProperty(e,t){if(p.isElementRegistered(e.tagName)){const r=e._vcomp;return r&&!r.isCustomElementFirst()?p.getComplexProperty(r.props,t):e.getProperty(t)}return e[t]}static getComplexProperty(e,t){let r=e,i=t.split(".");try{i.forEach(e=>r=r[e])}catch(e){return}return r}}p._CUSTOM_ELEMENT_REGISTRY={},p._ELEMENT_STATE_KEY="_ojElementState",p._ELEMENT_BRIDGE_KEY="_ojBridge";e.AttributeUtils=g,e.CustomElementUtils=p,e.ElementState=class{constructor(e){this.isComplete=!1,this.isConnected=!1,this.isDisposed=!1,this.isInitializingProperties=!1,this.dirtyProps=new Set,this.Element=e}getTrackChildrenOption(){var e,t;const r=p.getElementDescriptor(this.Element.tagName).metadata;return null!==(t=null===(e=null==r?void 0:r.extension)||void 0===e?void 0:e._TRACK_CHILDREN)&&void 0!==t?t:"none"}registerBusyState(){const e=t.getContext(this.Element).getBusyContext();this._resolveCreatedBusyState&&this.throwError("Registering busy state before previous state is resolved."),this._resolveCreatedBusyState=e.addBusyState({description:p.getElementInfo(this.Element)+" is being upgraded."})}resolveBusyState(){const e=this._resolveCreatedBusyState;e||this.throwError("Resolving busy state before one is registered."),this._resolveCreatedBusyState=null,e()}beginCreate(e){this._preCreatedPromise||(this._preCreatedPromise=this.GetPreCreatedPromise()),this.isComplete&&this._resetStateFlags(),this._createdPromise=this._preCreatedPromise.then(e),this._createdPromise.then(()=>{this.Element.classList.add("oj-complete"),this._completeHandler()},e=>{if(this.Element.classList.add("oj-incomplete"),this._completeHandler(),e)throw e})}throwError(e,t){let r=p.getElementInfo(this.Element)+": "+e;throw t&&(r=r+" "+(t.stack?t.stack:t)),new Error(r)}resolveBindingProvider(e){var t;this._resolveBindingProviderCallback?(null===(t=this._bindingProviderCallback)||void 0===t||t.call(this),this._resolveBindingProviderCallback(e),this._resolveBindingProviderCallback=null,this._rejectBindingProviderCallback=null):this._bindingProvider=e}rejectBindingProvider(e){this._rejectBindingProviderCallback&&(this._rejectBindingProviderCallback(e),this._resolveBindingProviderCallback=null,this._rejectBindingProviderCallback=null)}disposeBindingProvider(){this.isDisposed=!0,this.isComplete||this.rejectBindingProvider()}setBindingProviderCallback(e){this._bindingProviderCallback=e}getBindingProviderPromise(){var e,t;if(!this._bindingProviderPromise){i.verifyThemeVersion();const r=this._walkBindingProviders(this.Element);"none"===r?(null===(e=this._bindingProviderCallback)||void 0===e||e.call(this),this._bindingProviderPromise=Promise.resolve(null)):"knockout"===r?this._bindingProvider?(null===(t=this._bindingProviderCallback)||void 0===t||t.call(this),this._bindingProviderPromise=Promise.resolve(this._bindingProvider)):this._bindingProviderPromise=new Promise((e,t)=>{this._resolveBindingProviderCallback=e,this._rejectBindingProviderCallback=t}):this.throwError("Unknown binding provider '"+r+"'.")}return this._bindingProviderPromise}getDescriptiveText(){let e=this.GetDescriptiveValue("aria-label")||this.GetDescriptiveValue("title")||this.GetDescriptiveLabelByValue("labelled-by")||this.GetDescriptiveValue("label-hint")||this.GetDescriptiveLabelByValue("aria-labelledby");return e=e?e.trim().replace(/\s+/g," "):"",e}GetCreatedPromise(){return this._createdPromise}GetPreCreatedPromise(){let e=this.getBindingProviderPromise();return"none"!==this.getTrackChildrenOption()&&(e=e.then(e=>this._getTrackedChildrenPromises(e))),e}IsTransferAttribute(e){return!1}GetDescriptiveValue(e){const t=g.attributeToPropertyName(e),r=p.getElementProperties(this.Element);let i;return i=r&&r[t]?this.Element[t]:this.IsTransferAttribute(e)?this.GetDescriptiveTransferAttributeValue(e):this.Element.getAttribute(e),i}GetDescriptiveTransferAttributeValue(e){return""}GetDescriptiveLabelByValue(e){const t=this.GetDescriptiveValue(e);if(t){const e=document.getElementById(t);if(e)return e.textContent}return null}GetBindingProviderName(e){return null}_completeHandler(){this.isComplete||(this.isConnected&&this.resolveBusyState(),this.isComplete=!0)}_walkBindingProviders(e){let t=e._ojBndgPrv;if(t)return t;if(t=e.getAttribute("data-oj-binding-provider")||this.GetBindingProviderName(e),!t){const r=e.parentElement;null==r?e===document.documentElement?t="knockout":this.throwError("Cannot determine binding provider for a disconnected subtree."):t=this._walkBindingProviders(r)}return Object.defineProperty(e,"_ojBndgPrv",{value:t}),t}_getTrackedChildrenPromises(e){const i=this.getTrackChildrenOption(),n=t.getContext(this.Element).getBusyContext(),s=this._getChildrenToTrack(this.Element,i,[]).map(t=>{if(!e){const e=n.addBusyState({description:"Waiting for element "+t.localName+" to be defined."}),i=setInterval(()=>{r.warn("Waiting for element "+t.localName+" to be defined.")},2e4);return customElements.whenDefined(t.localName).then(()=>(e(),clearInterval(i),p.isElementRegistered(t.tagName)?p.getElementState(t).GetCreatedPromise():null)).catch(r=>{throw e(),clearInterval(i),new Error("Error defining element "+t.localName+" : "+r)})}return p.isElementRegistered(t.tagName)?p.getElementState(t).GetCreatedPromise():null});return Promise.all(s)}_getChildrenToTrack(e,t,r){const i=e.childNodes;for(let e=0;e<i.length;e++){const n=i[e];s.isValidCustomElementName(n.localName)?r.push(n):"nearestCustomElement"===t&&this._getChildrenToTrack(n,t,r)}return r}_resetStateFlags(){this._createdPromise=null,this.isComplete=!1}},e.ElementUtils=s,Object.defineProperty(e,"__esModule",{value:!0})});
//# sourceMappingURL=ojcustomelement-utils.js.map