/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["exports","ojs/ojcore-base","jquery","ojs/ojcontext","ojs/ojcomponentcore","ojs/ojlogger","ojs/ojdomutils","ojs/ojfocusutils","touchr"],function(e,t,i,s,n,a,r,o,l){"use strict";t=t&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t,i=i&&Object.prototype.hasOwnProperty.call(i,"default")?i.default:i,s=s&&Object.prototype.hasOwnProperty.call(s,"default")?s.default:s,o=o&&Object.prototype.hasOwnProperty.call(o,"default")?o.default:o;
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var h={properties:{arrowPlacement:{type:"string",enumValues:["adjacent","overlay"],value:"adjacent"},arrowVisibility:{type:"string",enumValues:["auto","hidden","hover","visible"],value:"auto"},currentItem:{type:"object",writeback:!0,value:{index:0},properties:{id:{type:"string"},index:{type:"number"}}},looping:{type:"string",enumValues:["off","page"],value:"off"},maxItemsPerPage:{type:"number",value:0},orientation:{type:"string",enumValues:["horizontal","vertical"],value:"horizontal"},translations:{type:"object",value:{},properties:{labelAccArrowNextPage:{type:"string"},labelAccArrowPreviousPage:{type:"string"},labelAccFilmStrip:{type:"string"},tipArrowNextPage:{type:"string"},tipArrowPreviousPage:{type:"string"}}}},methods:{getItemsPerPage:{},getPagingModel:{},getProperty:{},refresh:{},setProperties:{},setProperty:{},getNodeBySubId:{},getSubIdByNode:{}},extension:{}};h.extension._WIDGET_NAME="ojFilmStrip",h.extension._TRACK_CHILDREN="immediate",t.CustomElementBridge.register("oj-film-strip",{metadata:h});
/**
   * @license
   * Copyright (c) 2015 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
const u=function(){this.Init()};t._registerLegacyNamespaceProp("FilmStripPagingModel",u),t.Object.createSubclass(u,t.EventSource,"oj.FilmStripPagingModel"),u.prototype.Init=function(){u.superclass.Init.call(this),this._page=-1,this._totalSize=0,this._pageSize=-1},u.prototype.setTotalSize=function(e){this._totalSize=e},u.prototype.getPageSize=function(){return this._pageSize},u.prototype.getPage=function(){return this._page},u.prototype.setPage=function(e,t){e=parseInt(e,10);try{var i=this.getPageCount(),s=this._page,n=this._pageSize,a=n;if(t&&t.pageSize&&(a=t.pageSize),0===this._totalSize&&-1===a)return Promise.resolve();var r=Math.ceil(this._totalSize/a);if(e<0||e>r-1)throw new Error("JET FilmStrip: Invalid 'page' set: "+e);var o=!1;if(e!==s||a!==n){if(!1===this.handleEvent("beforePage",{page:e,previousPage:s}))return Promise.reject();o=!0}this._page=e,this._pageSize=a;var l=this.getPageCount(),h=this;return new Promise(function(n){if(i!==l&&h.handleEvent("pageCount",{pageCount:l,previousPageCount:i}),o){var a={page:e,previousPage:s};t&&t.loopDirection&&(a.loopDirection=t.loopDirection),h.handleEvent("page",a)}n(null)})}catch(e){return Promise.reject(e)}},u.prototype.getStartItemIndex=function(){return-1===this._page&&-1===this._pageSize?-1:this._page*this._pageSize},u.prototype.getEndItemIndex=function(){return Math.min(this.getStartItemIndex()+this._pageSize,this._totalSize)-1},u.prototype.getPageCount=function(){return Math.ceil(this._totalSize/this._pageSize)},u.prototype.totalSize=function(){return this._totalSize},u.prototype.totalSizeConfidence=function(){return"actual"},
/**
   * @license
   * Copyright (c) 2015 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
function(){function e(e,t){e.css("-webkit-transform",t).css("-ms-transform",t).css("transform",t)}function l(e){e.css("-webkit-transform","").css("-ms-transform","").css("transform","")}function h(e){var t=i("<div></div>");return t.text(e),t[0].innerHTML}t.__registerWidget("oj.ojFilmStrip",i.oj.baseComponent,{defaultElement:"<div>",widgetEventPrefix:"oj",options:{maxItemsPerPage:0,orientation:"horizontal",currentItem:{index:0},arrowPlacement:"adjacent",arrowVisibility:"auto",looping:"off"},_ComponentCreate:function(){this._super();var e=this.element;e.addClass("oj-filmstrip oj-component").attr("tabindex",0).attr("role","region"),e.uniqueId(),this._focusable({element:e,applyHighlight:!0});var t=this.options;if(t.disabled&&a.warn("JET FilmStrip: 'disabled' property not supported"),"horizontal"!==t.orientation&&"vertical"!==t.orientation)throw new Error("JET FilmStrip: Unsupported value set as 'orientation' property: "+t.orientation);if("adjacent"!==t.arrowPlacement&&"overlay"!==t.arrowPlacement)throw new Error("Unsupported value set as 'arrowPlacement' property: "+t.arrowPlacement);if("visible"!==t.arrowVisibility&&"hidden"!==t.arrowVisibility&&"hover"!==t.arrowVisibility&&"auto"!==t.arrowVisibility)throw new Error("Unsupported value set as 'arrowVisibility' property: "+t.arrowVisibility);if("off"!==t.looping&&"page"!==t.looping)throw new Error("Unsupported value set as 'looping' property: "+t.looping);this.touchEventNamespace=this.eventNamespace+"Touch",this.mouseEventNamespace=this.eventNamespace+"Mouse",this.keyEventNamespace=this.eventNamespace+"Key",this.navArrowHoverableEventNamespace=this.eventNamespace+"NavArrowHoverable",t.currentItem=this._convertItemToObj(t.currentItem),this._setup(!0),this._populateItemObj(t.currentItem),this.option("currentItem",t.currentItem,{_context:{internalSet:!0,writeback:!0}})},refresh:function(){this._super(),this._setup(!1)},getItemsPerPage:function(){return this._itemsPerPage},getPagingModel:function(){return this._pagingModel},_NotifyShown:function(){this._super(),this._needsSetup?this._setup(this._needsSetup[0]):this._handleResize()},_NotifyAttached:function(){this._super(),this._needsSetup?this._setup(this._needsSetup[0]):this._handleResize()},_setup:function(e){var t=this;if(e&&!this._pagingModel&&(this._pagingModel=new u),e&&!this._filterNestedFilmStripsFunc&&(this._filterNestedFilmStripsFunc=function(e,s){return i(s).closest(".oj-filmstrip")[0]===t.element[0]}),!this._canCalculateSizes()){var s=!1;return this._needsSetup&&(s=this._needsSetup[0]),void(this._needsSetup=[e||s])}this._needsSetup=null,this._bRTL="rtl"===this._GetReadingDirection(),this._bTouchSupported=r.isTouchSupported();var a=this.element;e?(this._itemsPerPage=0,this._handlePageFunc=function(e){t._handlePage(e)},this._componentSize=0,this._itemSize=-1,this._handleTransitionEndFunc=function(e){t._handleTransitionEnd()},this._handleResizeFunc=function(e,i){t._handleResize()},this._bTouchSupported&&(this._handleTouchStartFunc=function(e){t._handleTouchStart(e)},this._handleTouchMoveFunc=function(e){t._handleTouchMove(e)},this._handleTouchEndFunc=function(e){t._handleTouchEnd(e)},this._addTouchListeners()),this._handleMouseDownFunc=function(e){t._handleMouseDown(e)},this._handleMouseMoveFunc=function(e){t._handleMouseMove(e)},this._handleMouseUpFunc=function(e){t._handleMouseUp(e)},this._addMouseListeners(),this._handleKeyDownFunc=function(e){t._handleKeyDown(e)},this._addKeyListeners()):this._destroyInternal();var o,l=a.children();for(o=0;o<l.length;o++)n.subtreeDetached(l[o]);var h=this._pagingModel;if(e&&h.on("page",this._handlePageFunc),h.setTotalSize(l.length),this._wrapChildren(),l.length>0){for(this._adjustSizes(),o=0;o<l.length;o++)n.subtreeAttached(l[o]);r.addResizeListener(a[0],this._handleResizeFunc,25)}},_destroy:function(){this._bTouchSupported&&(this._removeTouchListeners(),this._handleTouchStartFunc=null,this._handleTouchMoveFunc=null,this._handleTouchEndFunc=null),this._removeMouseListeners(),this._handleMouseDownFunc=null,this._handleMouseMoveFunc=null,this._handleMouseUpFunc=null,this._removeKeyListeners(),this._handleKeyDownFunc=null,this._destroyInternal(),this._pagingModel.off("page",this._handlePageFunc),this._handlePageFunc=null,this._pagingModel=null,this._handleResizeFunc=null,this._handleTransitionEndFunc=null,this._filterNestedFilmStripsFunc=null;var e=this.element;e.removeClass("oj-filmstrip oj-component oj-filmstrip-hover").removeAttr("tabindex role").removeAttr("aria-labelledby"),e.removeUniqueId(),this._IsCustomElement()&&(e[0].removeEventListener("touchstart",this._delegatedHandleTouchStartFunc,{passive:!0}),e[0].removeEventListener("touchmove",this._delegatedHandleTouchMoveFunc,{passive:!1}),delete this._delegatedHandleTouchStartFunc,delete this._delegatedHandleTouchMoveFunc),this._super()},_destroyInternal:function(){this._deferredHandleResize=!1,this._resolveBusyState();var e=this.element;r.removeResizeListener(e[0],this._handleResizeFunc),this._itemSize=-1,this._queuedHandleResize&&(clearTimeout(this._queuedHandleResize),this._queuedHandleResize=null);var t,i=this._getItems();for(t=0;t<i.length;t++)n.subtreeDetached(i[t]);for(this._clearCalculatedSizes(),this._getItemContainers().unwrap(),this._unwrapChildren(),t=0;t<i.length;t++)n.subtreeAttached(i[t])},_setOption:function(e,t,i){var s=this.options,n=!1,r=-1,o=this._pagingModel,l=o.getPage();switch(e){case"disabled":a.warn("JET FilmStrip: 'disabled' property not supported");break;case"orientation":if("horizontal"!==t&&"vertical"!==t)throw new Error("JET FilmStrip: Unsupported value set as 'orientation' property: "+t);n=s.orientation!==t;break;case"maxItemsPerPage":n=s.maxItemsPerPage!==t;break;case"arrowPlacement":if("adjacent"!==t&&"overlay"!==t)throw new Error("Unsupported value set as 'arrowPlacement' property: "+t);n=s.arrowPlacement!==t;break;case"arrowVisibility":if("visible"!==t&&"hidden"!==t&&"hover"!==t&&"auto"!==t)throw new Error("Unsupported value set as 'arrowVisibility' property: "+t);n=s.arrowVisibility!==t;break;case"looping":if("off"!==t&&"page"!==t)throw new Error("Unsupported value set as 'looping' property: "+t);n=s.looping!==t;break;case"currentItem":t=this._convertItemToObj(t),this._populateItemObj(t);var h=s.currentItem;if(h&&t&&(h.id!==t.id||h.index!==t.index)&&((r=this._findPage(t))<0||r>=o.getPageCount()))throw new Error("JET FilmStrip: Value of 'currentItem' property not found: "+t)}switch(this._super(e,t,i),e){case"currentItem":r>-1&&r!==l&&o.setPage(r)}n&&this._setup(!1)},_handleResize:function(){if(this._busyStateResolveFunc)this._deferredHandleResize=!0;else if(this._bHandlingResize){if(!this._queuedHandleResize){var e=this;this._queuedHandleResize=setTimeout(function(){e._queuedHandleResize=null,e._handleResize()},0)}}else this._bHandlingResize=!0,this._adjustSizes(!0),this._bHandlingResize=!1},_isHorizontal:function(){return"vertical"!==this.options.orientation},_isLoopingPage:function(){return"page"===this.options.looping},_getCssPositionAttr:function(){return this._isHorizontal()?this._bRTL?"right":"left":"top"},_getCssSizeAttr:function(){return this._isHorizontal()?"width":"height"},_canCalculateSizes:function(){var e=document.createElement("div"),t=e.style;t.position="absolute",t.width="10px",t.height="10px";var i=this.element[0];i.appendChild(e);var s=!1;try{s=e.offsetWidth>0&&e.offsetHeight>0}catch(e){}return i.removeChild(e),s},_wrapChildren:function(){var e=this.element,t=this._isHorizontal(),i=e.children();i.addClass("oj-filmstrip-item").wrap("<div class='oj-filmstrip-container oj-filmstrip-item-container'></div>");var s=this._getCssPositionAttr(),n=e.children().wrapAll("<div class='oj-filmstrip-container oj-filmstrip-pages-container'></div>").parent().css(s,"0px");this._pagesWrapper=n;var a=this.options;"hidden"!==a.arrowVisibility&&"adjacent"===a.arrowPlacement&&(this._contentWrapper=n.wrap("<div class='oj-filmstrip-container oj-filmstrip-content-container'></div>").parent()),e.addClass("oj-filmstrip-container"),t||e.addClass("oj-filmstrip-vertical");var r=this._createPageInfoElem(),o=e.attr("id"),l=r.attr("id");e.append(r),e.attr("aria-labelledby",o+" "+l),this._pageInfoElem=r,"hidden"!==a.arrowVisibility&&i.length>0&&(this._prevButton=this._createPrevNavArrow(),this._nextButton=this._createNextNavArrow(),this._navArrowsShownOnHover()&&this._setupNavArrowsHoverable())},_unwrapChildren:function(){var e=this.element,t=this._getItems();this._tearDownNavArrowsHoverable(),this._prevButton&&(this._UnregisterChildNode(this._prevButton),this._prevButton=null),this._nextButton&&(this._UnregisterChildNode(this._nextButton),this._nextButton=null);var i=e.children(".oj-filmstrip-arrow-container");i&&i.remove(),this._pageInfoElem&&(this._UnregisterChildNode(this._pageInfoElem),this._pageInfoElem.remove(),this._pageInfoElem=null),t.removeClass("oj-filmstrip-item").unwrap().unwrap(),this._pagesWrapper=null,this._contentWrapper&&(t.unwrap(),this._contentWrapper=null),e.removeClass("oj-filmstrip-container oj-filmstrip-vertical")},_createPageInfoElem:function(){var e=i(document.createElement("div"));return e.uniqueId(),e.addClass("oj-helper-hidden-accessible oj-filmstrip-liveregion"),e.attr({"aria-live":"polite","aria-atomic":"true"}),e},_updatePageInfoElem:function(){var e=this._pagingModel,t=e.getPage(),i=e.getPageCount(),s=h(this.getTranslatedString("labelAccFilmStrip",{pageIndex:t+1,pageCount:i})),n=this._pageInfoElem;n&&n.text(s)},_setupNavArrowsHoverable:function(){this.element.on("mouseenter"+this.navArrowHoverableEventNamespace,function(e){i(e.currentTarget).hasClass("oj-disabled")||i(e.currentTarget).addClass("oj-filmstrip-hover")}).on("mouseleave"+this.navArrowHoverableEventNamespace,function(e){i(e.currentTarget).removeClass("oj-filmstrip-hover")})},_tearDownNavArrowsHoverable:function(){this.element.off(this.navArrowHoverableEventNamespace)},_navArrowsShownOnHover:function(){var e=this.options,t=e.arrowVisibility;return"hover"===t||"auto"===t&&"overlay"===e.arrowPlacement},_hasPrevPage:function(){return this._pagingModel.getPage()>0},_hasNextPage:function(){var e=this._pagingModel;return e.getPage()<e.getPageCount()-1},_prevPage:function(){var e=this._pagingModel;if(this._hasPrevPage())e.setPage(e.getPage()-1);else{var t=e.getPageCount();this._isLoopingPage()&&t>1&&e.setPage(t-1,{loopDirection:"prev"})}},_nextPage:function(){var e=this._pagingModel;if(this._hasNextPage())e.setPage(e.getPage()+1);else{var t=e.getPageCount();this._isLoopingPage()&&t>1&&e.setPage(0,{loopDirection:"next"})}},_displayNavigationArrow:function(e,t){"adjacent"===this.options.arrowPlacement?t.css("visibility",e?"":"hidden"):t.parent().css("display",e?"":"none")},_updateNavigationArrowsDisplay:function(){if("hidden"!==this.options.arrowVisibility){var e=this._pagingModel,t=e.getPage(),i=e.getPageCount(),s=this._isLoopingPage()&&i>1;this._displayNavigationArrow(s||0!==t,this._prevButton),this._displayNavigationArrow(s||t!==i-1,this._nextButton)}},_createPrevNavArrow:function(){var e=this.element,t=this._isHorizontal()?"oj-start":"oj-top",i=this._createNavigationArrowContainer(t);"overlay"===this.options.arrowPlacement?e.append(i):e.prepend(i);var s=h(this.getTranslatedString("labelAccArrowPreviousPage")),n=h(this.getTranslatedString("tipArrowPreviousPage")),a=this._createNavigationArrow(i,t,s,n),r=this;return a.on("click",function(){r._prevPage()}),a},_createNextNavArrow:function(){var e=this.element,t=this._isHorizontal()?"oj-end":"oj-bottom",i=this._createNavigationArrowContainer(t);e.append(i);var s=h(this.getTranslatedString("labelAccArrowNextPage")),n=h(this.getTranslatedString("tipArrowNextPage")),a=this._createNavigationArrow(i,t,s,n),r=this;return a.on("click",function(){r._nextPage()}),a},_createNavigationArrowContainer:function(e){var t=i(document.createElement("div"));return t.addClass("oj-filmstrip-arrow-container "+e),"overlay"===this.options.arrowPlacement&&(t.addClass("oj-filmstrip-arrow-container-overlay"),this._navArrowsShownOnHover()&&t.addClass("oj-filmstrip-arrow-transition")),t},_createNavigationArrow:function(e,t,i,s){var n="<div class='oj-filmstrip-arrow oj-default oj-enabled "+t+"' role='button' tabindex='-1'";n+="><span class='oj-filmstrip-arrow-icon "+t+" oj-component-icon'></span></div>",e.append(n);var a=e.children(".oj-filmstrip-arrow").eq(0);a.uniqueId();var r=a.attr("id");i&&a.attr("aria-label",i),s&&a.attr("title",s);var o=this._pageInfoElem.attr("id");return a.attr("aria-labelledby",o+" "+r),this._AddHoverable(a),this._AddActiveable(a),"adjacent"===this.options.arrowPlacement&&this._navArrowsShownOnHover()&&a.addClass("oj-filmstrip-arrow-transition"),a},_getItemContainers:function(){return this._pagesWrapper.find(".oj-filmstrip-item-container").filter(this._filterNestedFilmStripsFunc)},_getItems:function(){return this._pagesWrapper.find(".oj-filmstrip-item").filter(this._filterNestedFilmStripsFunc)},_getPages:function(){return this._pagesWrapper.children(".oj-filmstrip-page")},_clearCalculatedSizes:function(){var e=this._pagesWrapper;this._getPages().css("flex-basis","").css("-webkit-flex-basis",""),this._getItemContainers().css("flex-basis","").css("-webkit-flex-basis",""),e.css(this._getCssSizeAttr(),"")},_adjustSizes:function(e){this._clearCalculatedSizes();var t=this.options,s=this._isHorizontal(),a=t.maxItemsPerPage,r=a<1,o=this.element,l=this._getItemContainers();if(this._itemSize<0){var h=this._getItemIndex(t.currentItem),u=i(l[h]),p=u.children(".oj-filmstrip-item");p.css("display",""),n.subtreeShown(p[0]),this._itemSize=s?u.width():u.height()}var d=s?o.width():o.height();if("hidden"!==t.arrowVisibility&&"adjacent"===t.arrowPlacement){var c=o.children(".oj-filmstrip-arrow-container").eq(0);d-=2*(s?c.width():c.height())}if(this._componentSize=d,!r){var g=Math.max(Math.floor(d/this._itemSize),1);g<a&&(a=g)}var _=r?Math.max(Math.floor(d/this._itemSize),1):a,f=d/_;l.css("flex-basis",f+"px").css("-webkit-flex-basis",f+"px");var m=Math.ceil(l.length/_),v=this._getPages(),P=!1,b=this._pagingModel;if(b.getPageCount()!==m||this._itemsPerPage!==_||!v||v.length<1){var w;if(P=!0,e)for(w=0;w<l.length;w++)n.subtreeDetached(l[w]);for(v&&v.length>0&&l.unwrap(),w=0;w<l.length;w+=_){l.slice(w,w+_).wrapAll("<div class='oj-filmstrip-container oj-filmstrip-page' aria-hidden='true'></div>").parent().css("display","none")}if(e)for(w=0;w<l.length;w++)n.subtreeAttached(l[w])}(v=this._getPages()).css("flex-basis",d+"px").css("-webkit-flex-basis",d+"px");var S=this._pagesWrapper,y=this._contentWrapper;S.css(this._getCssSizeAttr(),d),y&&y.css(this._getCssSizeAttr(),d);var j=0;if(t.currentItem&&(j=this._findPage(t.currentItem,_)),b.getPageCount()!==m||this._itemsPerPage!==_||b.getPage()!==j)b.setPage(j,{pageSize:_});else if(P){var C=b.getPage();this._handlePage({previousPage:C,page:C})}},_handlePage:function(e){var t=e.page,s=e.loopDirection,n=e.previousPage,a=this._pagesWrapper,r=this._getPages(),o=this._pagingModel,l=o.getPageSize(),h=o.getPageCount(),u=n<0||n===t||this._itemsPerPage!==l,p=this._isLoopingPage();this._itemsPerPage=l;var d=null;u||(d=i(r[n]));var c=this._getCssPositionAttr(),g=i(r[t]),_=g.is(":hidden");_&&this._unhidePage(g);var f,m=this._bDragInit;if(n>-1&&!u){f=t>n,p&&s&&(f="next"===s);var v=p&&!f&&h>1&&0===n,P=p&&f&&h>1&&n===h-1;m=!0,a.css(this._getCssSizeAttr(),2*this._componentSize),f||_&&a.css(c,-this._componentSize+"px"),f?(d.addClass("oj-filmstrip-transition-next-oldpage-from"),g.addClass("oj-filmstrip-transition-next-newpage-from"),P&&g.addClass("oj-filmstrip-transition-display-as-lastpage")):(d.addClass("oj-filmstrip-transition-prev-oldpage-from"),g.addClass("oj-filmstrip-transition-prev-newpage-from"),v&&g.addClass("oj-filmstrip-transition-display-as-firstpage"))}if(this._busyStateResolveFunc=this._addBusyState("scrolling"),m){var b=this,w=this._bDragInit;if(w&&n<0)r.filter(":visible").addClass("oj-filmstrip-transition");setTimeout(function(){b._finishHandlePage(t,n,f,u,w)},25)}else this._finishHandlePage(t,n,f,u)},_finishHandlePage:function(t,s,n,a,r){var o=this._pagesWrapper;if(a||(this._bPageChangeTransition=!0,o.on("transitionend"+this.eventNamespace+" webkitTransitionEnd"+this.eventNamespace,this._handleTransitionEndFunc)),a)this._handleTransitionEnd();else{var h=this._getPages();if(r&&l(h),s>-1){var u=i(h[s]),p=i(h[t]);u.addClass("oj-filmstrip-transition"),p.addClass("oj-filmstrip-transition"),n?(u.removeClass("oj-filmstrip-transition-next-oldpage-from"),p.removeClass("oj-filmstrip-transition-next-newpage-from"),u.addClass("oj-filmstrip-transition-next-oldpage-to"),p.addClass("oj-filmstrip-transition-next-newpage-to")):(u.removeClass("oj-filmstrip-transition-prev-oldpage-from"),p.removeClass("oj-filmstrip-transition-prev-newpage-from"),u.addClass("oj-filmstrip-transition-prev-oldpage-to"),p.addClass("oj-filmstrip-transition-prev-newpage-to"))}else if(r){e(h.filter(":visible"),"translate3d(0, 0, 0)")}}},_handleTransitionEnd:function(){this._bPageChangeTransition=!1;var e=this._pagesWrapper,t=this._getCssPositionAttr();e.off(this.eventNamespace).css(this._getCssSizeAttr(),this._componentSize).css(t,"0px");var s=null;(o.containsFocus(e[0])||this._nextButton&&o.containsFocus(this._nextButton[0])||this._prevButton&&o.containsFocus(this._prevButton[0]))&&(s=document.activeElement);for(var n=this._pagingModel.getPage(),a=this._getPages(),r=0;r<a.length;r++)r!==n&&this._hidePage(i(a[r]));if(a.removeClass("oj-filmstrip-transition oj-filmstrip-transition-next-oldpage-to oj-filmstrip-transition-next-newpage-to oj-filmstrip-transition-prev-oldpage-to oj-filmstrip-transition-prev-newpage-to oj-filmstrip-transition-display-as-firstpage oj-filmstrip-transition-display-as-lastpage"),l(a),this._updateNavigationArrowsDisplay(),s&&i(s).is(":hidden")){var h=this.element,u=o.getFirstTabStop(a[n]);u?o.focusElement(u):o.focusElement(h[0])}var p=this.options;if(this._findPage(p.currentItem)!==n){var d=this._getFirstItemOnPage(n);d&&this.option("currentItem",d,{_context:{writeback:!0}})}this._deferredHandleResize&&(this._deferredHandleResize=!1,this._handleResize()),this._updatePageInfoElem(),this._resolveBusyState()},_getItemIndex:function(e){var t=-1;if(e){var i=this._getItems();if(e.id&&r.isValidIdentifier(e.id))for(var s=0;s<i.length;s++){var n=i[s].id;if(n&&n.length>0&&n===e.id){t=s;break}}else null!=e.index&&e.index>=0&&e.index<i.length&&(t=e.index)}return t},_convertItemToObj:function(e){var t=null;return"object"==typeof e?t=e:"number"==typeof e?t={index:e}:"string"==typeof e&&(t={id:e}),t},_populateItemObj:function(e){if(e&&this._pagingModel.getPage()>=0){var t=this._getItemIndex(e);if(e.index=t,null==e.id&&-1!==t){var i=this._getItems();e.id=i[t].id}}},_findPage:function(e,t){var i=this._getItemIndex(e),s=-1;return i>-1&&(void 0===t&&(t=this._itemsPerPage),s=Math.floor(i/t)),s},_getFirstItemOnPage:function(e,t,i){var s=this._pagingModel;if(void 0===t&&(t=s.getPageCount()),e>=0&&e<t){var n=this._getItems();void 0===i&&(i=this._itemsPerPage);var a=e*i;if(a<n.length)return{id:n[a].id,index:a}}return null},_hidePage:function(e){n.subtreeHidden(e[0]),e.css("display","none").attr("aria-hidden","true"),e.find(".oj-filmstrip-item").filter(this._filterNestedFilmStripsFunc).css("display","none")},_unhidePage:function(e){e.css("display","").removeAttr("aria-hidden"),e.find(".oj-filmstrip-item").filter(this._filterNestedFilmStripsFunc).css("display",""),n.subtreeShown(e[0])},_addKeyListeners:function(){this.element.on("keydown"+this.keyEventNamespace,this._handleKeyDownFunc)},_removeKeyListeners:function(){this.element.off(this.keyEventNamespace)},_addMouseListeners:function(){this.element.on("mousedown"+this.mouseEventNamespace,this._handleMouseDownFunc).on("mousemove"+this.mouseEventNamespace,this._handleMouseMoveFunc).on("mouseup"+this.mouseEventNamespace,this._handleMouseUpFunc)},_removeMouseListeners:function(){this.element.off(this.mouseEventNamespace)},_addTouchListeners:function(){var e=this.element;if(this._IsCustomElement()){var t=function(e){return function(t){e(i.Event(t))}};this._delegatedHandleTouchStartFunc=t(this._handleTouchStartFunc),this._delegatedHandleTouchMoveFunc=t(this._handleTouchMoveFunc),e[0].addEventListener("touchstart",this._delegatedHandleTouchStartFunc,{passive:!0}),e[0].addEventListener("touchmove",this._delegatedHandleTouchMoveFunc,{passive:!1}),e.on("touchend"+this.touchEventNamespace,this._handleTouchEndFunc).on("touchcancel"+this.touchEventNamespace,this._handleTouchEndFunc)}else e.on("touchstart"+this.touchEventNamespace,this._handleTouchStartFunc).on("touchmove"+this.touchEventNamespace,this._handleTouchMoveFunc).on("touchend"+this.touchEventNamespace,this._handleTouchEndFunc).on("touchcancel"+this.touchEventNamespace,this._handleTouchEndFunc)},_removeTouchListeners:function(){this.element.off(this.touchEventNamespace)},_handleKeyDown:function(e){var t=this._pagingModel,s=t.getPage(),n=t.getPageCount(),a=-2;switch(e.keyCode){case i.ui.keyCode.RIGHT:a=this._bRTL?s-1:s+1;break;case i.ui.keyCode.LEFT:a=this._bRTL?s+1:s-1;break;case i.ui.keyCode.DOWN:a=s+1;break;case i.ui.keyCode.UP:a=s-1;break;case i.ui.keyCode.HOME:a=0;break;case i.ui.keyCode.END:a=n-1;break;default:return}if(a>-1&&a<n)t.setPage(a);else if(this._isLoopingPage()&&n>1){var r={};a===n&&(a=0,r.loopDirection="next"),-1===a&&(a=n-1,r.loopDirection="prev"),t.setPage(a,r)}e.preventDefault()},_handleMouseDown:function(e){var t=e.originalEvent;this._dragScrollStart(t)},_handleMouseMove:function(e){var t=e.originalEvent;this._dragScrollMove(e,t)},_handleMouseUp:function(e){this._dragScrollEnd()},_handleTouchStart:function(e){var t=e.originalEvent.touches;if(1===t.length){var i=t[0];this._dragScrollStart(i)}},_handleTouchMove:function(e){var t=e.originalEvent.touches[0];this._dragScrollMove(e,t),(this._bTouch||this._scrolledForThisTouch)&&e.preventDefault()},_handleTouchEnd:function(e){this._dragScrollEnd()},_dragScrollStart:function(e){if(this._pagingModel.getPageCount()>1&&!this._bPageChangeTransition){this._bTouch=!0,this._bDragInit=!1,this._bFirstToLast=!1,this._bLastToFirst=!1;var t=this._isHorizontal();this._touchStartCoord=t?e.pageX:e.pageY,this._touchStartCoord2=t?e.pageY:e.pageX}},_initDragScroll:function(e,t,s){var n=this._isHorizontal();this._touchStartCoord=n?e.pageX:e.pageY,this._touchStartCoord2=n?e.pageY:e.pageX;var a=this._getCssPositionAttr(),r=this._pagesWrapper,o=this._pagingModel,l=o.getPage(),h=o.getPageCount(),u=this._getPages(),p=1;t||s?(t&&(this._unhidePage(i(u[h-1])),r.css(a,-this._componentSize+"px"),p+=1,i(u[h-1]).addClass("oj-filmstrip-transition-display-as-firstpage")),s&&(this._unhidePage(i(u[0])),p+=1,i(u[0]).addClass("oj-filmstrip-transition-display-as-lastpage"))):(l>0&&(this._unhidePage(i(u[l-1])),r.css(a,-this._componentSize+"px"),p+=1),l<h-1&&(this._unhidePage(i(u[l+1])),p+=1)),p>1&&r.css(this._getCssSizeAttr(),p*this._componentSize),this._touchStartScroll=parseInt(r.css(a),10)},_dragScrollMove:function(t,s){if(this._bTouch){var n=this._isHorizontal(),a=(n?s.pageX:s.pageY)-this._touchStartCoord,r=(n?s.pageY:s.pageX)-this._touchStartCoord2,o=n&&this._bRTL?a>0:a<0,l=this._pagingModel,h=l.getPage(),u=l.getPageCount(),p=this._isLoopingPage(),d=p&&!o&&u>1&&0===h,c=p&&o&&u>1&&h===u-1;if(!this._bDragInit)return Math.abs(r)>Math.abs(a)&&(this._bTouch=!1,this._scrolledForThisTouch=!1),Math.abs(a)>3&&(this._initDragScroll(s,d,c),this._bDragInit=!0),this._bFirstToLast=d,void(this._bLastToFirst=c);if(d===this._bFirstToLast&&c===this._bLastToFirst||(this._dragScrollResetPages(),this._initDragScroll(s,d,c),this._bFirstToLast=d,this._bLastToFirst=c),o&&h<l.getPageCount()-1||!o&&h>0||p){var g=this.element[0],_=Math.min(.33*(n?g.offsetWidth:g.offsetHeight),100),f=this._getCssPositionAttr(),m=this._pagesWrapper,v=this._getPages();if(Math.abs(a)>=_){var P,b,w={};if(d||c?(d?(P=u-1,b=u>2?1:-1):c&&(P=0,b=u>2?u-2:-1),w.loopDirection=o?"next":"prev"):(P=o?h+1:h-1,b=o?h-1:h+1),b>-1&&b<l.getPageCount()&&this._hidePage(i(v[b])),o&&b>-1&&!c){var S=parseInt(m.css(f),10);m.css(f,S+this._componentSize+"px")}m.css(this._getCssSizeAttr(),2*this._componentSize),this._bTouch=!1,l.setPage(P,w)}else{var y=n?"translate3d("+a+"px, 0, 0)":"translate3d(0, "+a+"px, 0)";e(v.filter(":visible"),y)}this._scrolledForThisTouch=!0}this._scrolledForThisTouch&&(t.preventDefault(),t.stopPropagation())}},_dragScrollEnd:function(){if(this._bTouch&&this._bDragInit){var e=this._pagingModel.getPage();this._handlePage({previousPage:e,page:e})}this._bTouch=!1,this._bDragInit=!1,this._bFirstToLast=!1,this._bLastToFirst=!1,this._scrolledForThisTouch=!1},_dragScrollResetPages:function(){for(var e=this._pagesWrapper,t=this._getCssPositionAttr(),s=this._pagingModel,n=s.getPage(),a=s.getPageCount(),r=this._getPages(),o=0;o<r.length;o++)o!==n&&this._hidePage(i(r[o]));e.css(t,"0px"),i(r[0]).removeClass("oj-filmstrip-transition-display-as-lastpage"),i(r[a-1]).removeClass("oj-filmstrip-transition-display-as-firstpage")},_addBusyState:function(e){var t=this.element,i=s.getContext(t[0]).getBusyContext(),n="FilmStrip";n+=" (id='"+t.attr("id")+"')";var a={description:n+=": "+e};return i.addBusyState(a)},_resolveBusyState:function(){this._busyStateResolveFunc&&(this._busyStateResolveFunc(),this._busyStateResolveFunc=null)},getNodeBySubId:function(e){if(null==e)return this.element?this.element[0]:null;var t=e.subId;return"oj-filmstrip-start-arrow"===t?this.widget().find(".oj-filmstrip-arrow.oj-start").filter(this._filterNestedFilmStripsFunc)[0]:"oj-filmstrip-end-arrow"===t?this.widget().find(".oj-filmstrip-arrow.oj-end").filter(this._filterNestedFilmStripsFunc)[0]:"oj-filmstrip-top-arrow"===t?this.widget().find(".oj-filmstrip-arrow.oj-top").filter(this._filterNestedFilmStripsFunc)[0]:"oj-filmstrip-bottom-arrow"===t?this.widget().find(".oj-filmstrip-arrow.oj-bottom").filter(this._filterNestedFilmStripsFunc)[0]:null},getSubIdByNode:function(e){for(var t=this.getNodeBySubId({subId:"oj-filmstrip-start-arrow"}),i=this.getNodeBySubId({subId:"oj-filmstrip-end-arrow"}),s=this.getNodeBySubId({subId:"oj-filmstrip-top-arrow"}),n=this.getNodeBySubId({subId:"oj-filmstrip-bottom-arrow"}),a=e,r=this.element[0];a&&a!==r;){if(a===t)return{subId:"oj-filmstrip-start-arrow"};if(a===i)return{subId:"oj-filmstrip-end-arrow"};if(a===s)return{subId:"oj-filmstrip-top-arrow"};if(a===n)return{subId:"oj-filmstrip-bottom-arrow"};a=a.parentElement}return null},_CompareOptionValues:function(e,i,s){return"currentItem"===e?t.Object.compareValues(i,s):this._super(e,i,s)}})}(),e.FilmStripPagingModel=u,Object.defineProperty(e,"__esModule",{value:!0})});
//# sourceMappingURL=ojfilmstrip.js.map