/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["ojs/ojcore-base","jquery","ojs/ojthemeutils","ojs/ojcomponentcore","ojs/ojlogger","ojs/ojcontext","ojs/ojconfig","ojs/ojdomutils","touchr"],function(t,e,o,n,i,r,s,l,a){"use strict";t=t&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t,e=e&&Object.prototype.hasOwnProperty.call(e,"default")?e.default:e,r=r&&Object.prototype.hasOwnProperty.call(r,"default")?r.default:r;
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var h={properties:{arrowVisibility:{type:"string",writeback:!0,enumValues:["auto","hidden","visible"]},contentParent:{type:"string",writeback:!0},orientation:{type:"string",writeback:!0,enumValues:["horizontal","vertical"],value:"horizontal"},translations:{type:"object",value:{},properties:{tipArrowNext:{type:"string"},tipArrowPrevious:{type:"string"}}}},methods:{getProperty:{},refresh:{},scrollElementIntoView:{},setProperties:{},setProperty:{},getNodeBySubId:{},getSubIdByNode:{}},extension:{}};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
function c(t,e,o,n,i,r,s,l){this._elem=t,this._orientation=e,this._contentParent=o,this._bRtl=n,this._arrowVisibility=i.arrowVisibility,this._prevButtonStyleClass=i.prevButtonStyleClass,this._nextButtonStyleClass=i.nextButtonStyleClass,this._prevButtonIcon=i.prevButtonIcon,this._nextButtonIcon=i.nextButtonIcon,this._scrollFunc=r.scrollFunc,this._addResizeListenerFunc=r.addResizeListener,this._removeResizeListenerFunc=r.removeResizeListener,this._addStyleClassNameFunc=r.addStyleClassName,this._removeStyleClassNameFunc=r.removeStyleClassName,this._hasStyleClassNameFunc=r.hasStyleClassName,this._filterContentElementsFunc=r.filterContentElements,this._subtreeDetachedFunc=r.subtreeDetached,this._subtreeAttachedFunc=r.subtreeAttached,this._addBusyStateFunc=r.addBusyState,this._overflowContainerStyleClass=s.overflowContainerStyleClass,this._contentContainerStyleClass=s.contentContainerStyleClass,this._itemStyleClass=s.itemStyleClass,this._hiddenStyleClass=s.hiddenStyleClass,this._bExternalScroll=!0,this._firstVisibleItemIndex=0,this._agentVersion=l.browserVersion,this._atStart=!0,this._atEnd=!1;var a=navigator.userAgent.toLowerCase();-1!==a.indexOf("gecko/")?this._bAgentGecko=!0:l&&"safari"===l.browser?this._bAgentSafari=!0:l&&"edge"===l.browser?this._bAgentEdge=!0:-1===a.indexOf("applewebkit")&&-1===a.indexOf("safari")||(this._bAgentWebkit=!0)}h.extension._WIDGET_NAME="ojConveyorBelt",t.CustomElementBridge.register("oj-conveyor-belt",{metadata:h}),c.prototype.setup=function(){var t=this,o=c;if(this._createInnerContainers(),"visible"===this._arrowVisibility){this._createPrevButton(this._prevButtonStyleClass,this._prevButtonIcon),this._createNextButton(this._nextButtonStyleClass,this._nextButtonIcon);var n=this._nextButton;this._buttonWidth=Math.round(e(n).outerWidth(!0)),this._buttonHeight=Math.round(e(n).outerHeight(!0))}else this._buttonWidth=0,this._buttonHeight=0;this._hidePrevButton(),this._hideNextButton(),this._mouseWheelListener=function(e){t._handleMouseWheel(e)},o._addBubbleEventListener(this._elem,"mousewheel",this._mouseWheelListener,!1),o._addBubbleEventListener(this._elem,"wheel",this._mouseWheelListener,!1),this._touchStartListener=function(e){t._handleTouchStart(e)},o._addBubbleEventListener(this._overflowContainer,"touchstart",this._touchStartListener,!0),this._touchMoveListener=function(e){t._handleTouchMove(e)},o._addBubbleEventListener(this._overflowContainer,"touchmove",this._touchMoveListener,!1),this._touchEndListener=function(e){t._handleTouchEnd(e)},o._addBubbleEventListener(this._overflowContainer,"touchend",this._touchEndListener),o._addBubbleEventListener(this._overflowContainer,"touchcancel",this._touchEndListener),this._handleKeyDownFunc=function(e){t._handleKeyDown(e)},o._addBubbleEventListener(this._elem,"keydown",this._handleKeyDownFunc),this._origScroll=0,this._clearCachedSizes(),this._adjustOverflowSize(!0),this._handleResize(!0),this._handleResizeFunc=function(e,o){t._handleResize(!1)},this._addResizeListenerFunc.call(null,this._elem,this._handleResizeFunc),this._addResizeListenerFunc.call(null,this._contentContainer,this._handleResizeFunc),this._subtreeAttachedFunc(this._contentContainer)},c.prototype._handleKeyDown=function(t){if(!t.defaultPrevented){var e=this._elem.getAttribute("tabindex");if(!(null==e||e<0)){var o=t.key||t.keyCode;if("horizontal"===this._orientation)switch(o){case c._KEYBOARD_KEYS._RIGHT:case c._KEYBOARD_KEYS._RIGHT_IE:case c._KEYBOARD_KEYS._RIGHT_CODE:this._bRtl?this._scrollPrevOnKeyDown(t):this._scrollNextOnKeyDown(t);break;case c._KEYBOARD_KEYS._LEFT:case c._KEYBOARD_KEYS._LEFT_IE:case c._KEYBOARD_KEYS._LEFT_CODE:this._bRtl?this._scrollNextOnKeyDown(t):this._scrollPrevOnKeyDown(t);break;default:return}if("vertical"===this._orientation)switch(o){case c._KEYBOARD_KEYS._DOWN:case c._KEYBOARD_KEYS._DOWN_IE:case c._KEYBOARD_KEYS._DOWN_CODE:this._scrollNextOnKeyDown(t);break;case c._KEYBOARD_KEYS._UP:case c._KEYBOARD_KEYS._UP_IE:case c._KEYBOARD_KEYS._UP_CODE:this._scrollPrevOnKeyDown(t)}}}},c.prototype._scrollNextOnKeyDown=function(t){this._constrainScroll(this._calcNextScroll())!==this._getCurrScroll()&&(this._scrollNext(),t.preventDefault())},c.prototype._scrollPrevOnKeyDown=function(t){this._constrainScroll(this._calcPrevScroll())!==this._getCurrScroll()&&(this._scrollPrev(),t.preventDefault())},c.prototype.destroy=function(){this._resolveBusyState();var t=this._elem,e=c;e._removeBubbleEventListener(t,"mousewheel",this._mouseWheelListener,!1),e._removeBubbleEventListener(t,"wheel",this._mouseWheelListener,!1),e._removeBubbleEventListener(this._overflowContainer,"touchstart",this._touchStartListener,!0),e._removeBubbleEventListener(this._overflowContainer,"touchmove",this._touchMoveListener,!1),e._removeBubbleEventListener(this._overflowContainer,"touchend",this._touchEndListener),e._removeBubbleEventListener(this._overflowContainer,"touchcancel",this._touchEndListener),e._removeBubbleEventListener(this._overflowContainer,"scroll",this._scrollListener),e._removeBubbleEventListener(this._elem,"keydown",this._handleKeyDownFunc),this._mouseWheelListener=null,this._touchStartListener=null,this._touchMoveListener=null,this._touchEndListener=null,this._scrollListener=null,this._removeResizeListenerFunc.call(null,t,this._handleResizeFunc),this._removeResizeListenerFunc.call(null,this._contentContainer,this._handleResizeFunc),this._handleResizeFunc=null,this._reparentChildrenFromContentContainer(this._contentContainer,t),t.removeChild(this._overflowContainer),this._overflowContainer=null,null!=this._nextButton&&null!=this._prevButton&&(t.removeChild(this._nextButton),t.removeChild(this._prevButton),this._nextButton=null,this._prevButton=null),this._contentContainer=null,this._clearCachedSizes(),this._elem=null,this._scrollFunc=null,this._addResizeListenerFunc=null,this._removeResizeListenerFunc=null,this._addStyleClassNameFunc=null,this._removeStyleClassNameFunc=null,this._hasStyleClassNameFunc=null,this._filterContentElementsFunc=null,this._subtreeDetachedFunc=null,this._subtreeAttachedFunc=null,this._addBusyStateFunc=null,this._contentParent=null},c.prototype.handleResize=function(){this._handleResize(!1)},c.prototype.setScroll=function(t,e){this._setCurrScroll(t,e)},c.prototype.getScroll=function(){return this._getCurrScroll()},c.prototype._reparentChildrenToContentContainer=function(t,e){for(var o=t.childNodes;o.length>0;){var n=o[0];this._subtreeDetachedFunc(n),e.appendChild(n),1===n.nodeType&&this._itemStyleClass&&this._addStyleClassNameFunc(n,this._itemStyleClass)}},c.prototype._reparentChildrenFromContentContainer=function(t,e){for(var o=t.childNodes;o.length>0;){var n=o[0];e.appendChild(n),1===n.nodeType&&this._itemStyleClass&&this._removeStyleClassNameFunc(n,this._itemStyleClass)}},c._getComputedStyle=function(t){return t.ownerDocument.defaultView.getComputedStyle(t,null)},c._getElemInnerWidth=function(t){var e=c,o=e._getComputedStyle(t);return e._getCSSLengthAsInt(o.width)},c._getElemInnerHeight=function(t){var e=c,o=e._getComputedStyle(t);return e._getCSSLengthAsInt(o.height)},c._getCSSLengthAsInt=function(t){if(t.length>0&&"auto"!==t){var e=Math.round(parseFloat(t));return isNaN(e)&&(e=0),e}return 0},c._addBubbleEventListener=function(t,e,o,n){t.addEventListener(e,o,{passive:n,capture:!1})},c._removeBubbleEventListener=function(t,e,o,n){t.removeEventListener(e,o,{passive:n,capture:!1})},c._getWheelDelta=function(t){return null!=t.wheelDelta?t.wheelDelta:null!=t.deltaY?-t.deltaY:-t.detail},c.prototype._isHorizontal=function(){return"horizontal"===this._orientation},c.prototype._isEmpty=function(){return!this._getContentParent().hasChildNodes()},c.prototype._reinitializeInnerDom=function(){this._origScroll=this._getCurrScroll(),this._setOverflowScroll(0),this._hidePrevButton(),this._hideNextButton()},c.prototype._clearCachedSizes=function(){this._totalSize=null,this._sizes=null},c.prototype._handleResize=function(t){t||this._reinitializeInnerDom(),this._clearCachedSizes(),this._totalSize=this._measureContents(),t||this._adjustOverflowSize(!1),"visible"===this._arrowVisibility&&this._alignButtons()},c.prototype._alignButtons=function(){var t=this._nextButton,e=this._prevButton,o=t.style,n=e.style,i=this._totalSize;this._isHorizontal()?(o.height=i.h+"px",n.height=i.h+"px"):(o.width=i.w+"px",n.width=i.w+"px")},c.prototype._adjustOverflowSize=function(t){var e=this._contentContainer,o=this._isHorizontal(),n=c,i=o?n._getElemInnerWidth(this._elem):n._getElemInnerHeight(this._elem);this._minScroll=0,this._maxScroll=o?e.offsetWidth-i+this._buttonWidth:e.offsetHeight-i+this._buttonHeight,this._maxScroll<0&&(this._maxScroll=0),this._hidePrevButton(),this._hideNextButton(),this._setCurrScroll(t?this._minScroll:this._origScroll,!0),this._origScroll=0},c.prototype._createInnerContainers=function(){var t=this,e=this._elem,o=c,n=document.createElement("div");this._overflowContainer=n,this._addStyleClassNameFunc(n,this._overflowContainerStyleClass);var i=document.createElement("div");this._contentContainer=i,this._addStyleClassNameFunc(i,this._contentContainerStyleClass),this._reparentChildrenToContentContainer(e,i),e.appendChild(n),n.appendChild(i),this._scrollListener=function(e){t._handleScroll(e)},o._addBubbleEventListener(n,"scroll",this._scrollListener)},c.prototype._getContentElements=function(){var t,e=[],o=this._contentParent?this._contentParent:this._contentContainer,n=o.children,i=n.length;for(t=0;t<i;t++){var r=n[t];1===r.nodeType&&"TEMPLATE"!==r.tagName&&0!==r.offsetWidth&&e.push(r)}if(e=(0,this._filterContentElementsFunc)(e),o===this._contentContainer&&this._itemStyleClass)for(t=0;t<e.length;t++){var s=e[t];this._hasStyleClassNameFunc(s,this._itemStyleClass)||this._addStyleClassNameFunc(s,this._itemStyleClass)}return e},c.prototype._createPrevButton=function(t,e){var o=this,n=document.createElement("div");this._prevButton=n,n.setAttribute("class",t),n.setAttribute("aria-hidden","true"),c._addBubbleEventListener(n,"click",function(){o._scrollPrev()}),n.appendChild(e),this._elem.insertBefore(n,this._overflowContainer)},c.prototype._createNextButton=function(t,e){var o=this,n=document.createElement("div");this._nextButton=n,n.setAttribute("class",t),n.setAttribute("aria-hidden","true"),c._addBubbleEventListener(n,"click",function(){o._scrollNext()}),n.appendChild(e),this._elem.appendChild(n)},c.prototype._getContentParent=function(){var t=this._contentParent;return t||(t=this._contentContainer),t},c.prototype._measureContents=function(){var t=this._getContentElements(),e={w:0,h:0},o=[];if(t.length>0){var n,i=t,r=this._isHorizontal();n=this._contentContainer.offsetWidth;for(var s=0,l=null,a=0;a<i.length;a++){var h=i[a];if(1===h.nodeType){var c=h.offsetWidth,_=h.offsetHeight,u={w:c,h:_,id:h.id};if(r){var d=h.offsetLeft;this._contentParent||0!==d||(d=h.parentNode.offsetLeft),this._bRtl?u.start=n-(d+c):u.start=d,0===a&&(s=u.start),u.start-=s,e.w=u.start+c,e.h=Math.max(e.h,_),u.end=e.w-1}else{var v=h.offsetTop;this._contentParent||0!==v||(v=h.parentNode.offsetTop),u.start=v,e.w=Math.max(e.w,c),e.h=u.start+_,u.end=e.h-1}if(l&&l.end>=u.start){var f=l.end-(u.start-1);l.end-=f,r?l.w-=f:l.h-=f}o.push(u),l=u}}}return this._sizes=o,e},c.prototype._getSizes=function(){return this._sizes},c.prototype._showNextButton=function(){this._removeStyleClassNameFunc(this._nextButton,this._hiddenStyleClass),this._atEnd=!1},c.prototype._showPrevButton=function(){this._removeStyleClassNameFunc(this._prevButton,this._hiddenStyleClass),this._atStart=!1},c.prototype._hideNextButton=function(){this._addStyleClassNameFunc(this._nextButton,this._hiddenStyleClass),this._atEnd=!0},c.prototype._hidePrevButton=function(){this._addStyleClassNameFunc(this._prevButton,this._hiddenStyleClass),this._atStart=!0},c.prototype._getButtonSize=function(){var t=0;return"visible"===this._arrowVisibility&&(t=this._isHorizontal()?this._buttonWidth:this._buttonHeight),t},c.prototype._updateButtonVisibility=function(t){var e=this._getButtonSize(),o=this._getCurrScroll(),n=this._needsScroll();t<=this._minScroll?(this._atStart||(o-=e),this._hidePrevButton()):n&&(this._atStart&&(o+=e),this._showPrevButton()),t>=this._maxScroll?this._hideNextButton():n&&this._showNextButton(),this._setOverflowScroll(o)},c.prototype._setOverflowScroll=function(t){var e=this._overflowContainer;this._isHorizontal()?e.scrollLeft=this._convertScrollLogicalToBrowser(t):e.scrollTop=t},c.prototype._getCurrViewportSize=function(){var t=this._overflowContainer;return this._isHorizontal()?t.offsetWidth:t.offsetHeight},c.prototype._setCurrScroll=function(t,e){this._bScrolling||(this._bExternalScroll=!1,this._setCurrScrollHelper(t,e))},c.prototype._setCurrScrollHelper=function(t,e){if(!this._isEmpty()){this._bScrolling=!0,t=this._constrainScroll(t),this._updateButtonVisibility(t);var o=this._scrollFunc;if(e||!o||t===this._getCurrScroll())this._onScrollAnimEnd(this._bExternalScroll?this._getCurrScroll():t);else{this._busyStateResolveFunc=this._addBusyStateFunc("scrolling");var n=c,i=Math.abs(this._getCurrScroll()-t)/n._SCROLL_SPEED,r=this;o.call(null,this._overflowContainer,this._convertScrollLogicalToBrowser(t),i,function(){r._onScrollAnimEnd(t),r._resolveBusyState()})}}},c.prototype._resolveBusyState=function(){this._busyStateResolveFunc&&(this._busyStateResolveFunc(),this._busyStateResolveFunc=null)},c.prototype._getCurrScroll=function(){var t=this._overflowContainer;return this._isHorizontal()?Math.round(this._convertScrollBrowserToLogical(t.scrollLeft)):Math.round(t.scrollTop)},c.prototype._needsScroll=function(){var t=this._contentContainer,e=this._overflowContainer;return this._isHorizontal()?t.offsetWidth>e.offsetWidth:t.offsetHeight>e.offsetHeight},c.prototype._constrainScroll=function(t){return!this._needsScroll()||t<this._minScroll?this._minScroll:t>this._maxScroll?this._maxScroll:t},c.prototype._handleMouseWheel=function(t){var e=this._bScrolling;if(this._needsScroll()&&!this._bScrolling){var o=c._getWheelDelta(t);o<0&&!this._atEnd?(e=!0,this._scrollNext()):o>0&&!this._atStart&&(e=!0,this._scrollPrev())}e&&(t.preventDefault(),t.stopPropagation())},c.prototype._handleTouchStart=function(t){var e=t.touches;if(this._needsScroll()&&!this._bScrolling&&1===e.length){this._bTouch=!0;var o=e[0];this._touchStartCoord=this._isHorizontal()?o.pageX:o.pageY,this._touchStartScroll=this._getCurrScroll(),this._touchStartNextScroll=this._calcNextScroll(),this._touchStartPrevScroll=this._calcPrevScroll(),this._touchInitialNotAtEnd=!this._atEnd,this._touchInitialNotAtStart=!this._atStart}},c.prototype._handleTouchMove=function(t){var e=this._isHorizontal(),o=t.touches[0],n=(e?o.pageX:o.pageY)-this._touchStartCoord,i=e&&this._bRtl?n>0:n<0,r=i&&this._touchInitialNotAtEnd||!i&&this._touchInitialNotAtStart;if(this._bTouch&&r){var s=c,l=this._overflowContainer,a=s._SWIPE_THRESHOLD*(e?l.offsetWidth:l.offsetHeight);Math.abs(n)<a?(this._setCurrScroll(this._touchStartScroll-n,!0),(this._touchInitialNotAtEnd&&this._atEnd||this._touchInitialNotAtStart&&this._atStart)&&(this._bTouch=!1)):(this._setCurrScroll(i?this._touchStartNextScroll:this._touchStartPrevScroll,!1),this._bTouch=!1),this._scrolledForThisTouch=!0}this._scrolledForThisTouch&&(t.preventDefault(),t.stopPropagation())},c.prototype._handleTouchEnd=function(t){this._bTouch&&this._setCurrScroll(this._touchStartScroll,!1),this._bTouch=!1,this._scrolledForThisTouch=!1},c.prototype._handleScroll=function(t){this._bExternalScroll&&!this._bScrolling&&this._setCurrScrollHelper(this._getCurrScroll(),!0)},c.prototype._onScrollAnimEnd=function(t){this._setOverflowScroll(t),this._bExternalScroll=!0,this._bScrolling=!1},c.prototype._scrollNext=function(){this._bScrolling||this._setCurrScroll(this._calcNextScroll(),!1)},c.prototype._scrollPrev=function(){this._bScrolling||this._setCurrScroll(this._calcPrevScroll(),!1)},c.prototype._calcNextScroll=function(){var t=this._calcNextVisibleItemIndex();return t===this._calcFirstVisibleItemIndex()?this._getCurrScroll()+this._getCurrViewportSize():this._calcStartScroll(t)},c.prototype._calcPrevScroll=function(){var t=this._calcPrevVisibleItemIndex(),e=0;return e=t===this._calcLastVisibleItemIndex()?this._getCurrScroll()-this._getCurrViewportSize():this._calcEndScroll(t),this._atEnd&&(e+=this._getButtonSize()),e<=this._getButtonSize()&&(e=this._minScroll),e},c.prototype._calcStartScroll=function(t){return this._getSizes()[t].start},c.prototype._calcEndScroll=function(t){return this._getSizes()[t].end-this._getCurrViewportSize()+1},c.prototype._calcFirstVisibleItemIndex=function(){var t=this._getCurrScroll(),e=this._calcItemIndex(t);return e<0?0:e},c.prototype._calcLastVisibleItemIndex=function(){var t=this._getCurrViewportSize(),e=this._getCurrScroll()+t-1,o=this._calcItemIndex(e),n=this._getSizes();return o<0?n.length-1:o},c.prototype._calcPrevVisibleItemIndex=function(){var t=this._getCurrScroll()-1,e=this._calcItemIndex(t);return e<0?0:e},c.prototype._calcNextVisibleItemIndex=function(){var t=this._getCurrViewportSize(),e=this._getCurrScroll()+t,o=this._calcItemIndex(e),n=this._getSizes();return o<0?n.length-1:o},c.prototype._calcItemIndex=function(t){for(var e=this._getSizes(),o=0;o<e.length;o++)if(t<=e[o].end)return o;return-1},c.prototype._convertScrollLogicalToBrowser=function(t){var e=t;return this._bRtl&&this._isHorizontal()&&(this._bAgentGecko||this._bAgentWebkit&&this._agentVersion>=85||this._bAgentSafari&&this._agentVersion>=10?e=-t:(this._bAgentWebkit&&this._agentVersion<85||this._bAgentSafari&&this._agentVersion<10)&&(e=this._contentContainer.offsetWidth-this._overflowContainer.offsetWidth-t)),e},c.prototype._convertScrollBrowserToLogical=function(t){return this._convertScrollLogicalToBrowser(t)},c._SCROLL_SPEED=1.1,c._SWIPE_THRESHOLD=.33,c._KEYBOARD_KEYS={_UP:"ArrowUp",_UP_IE:"Up",_UP_CODE:38,_DOWN:"ArrowDown",_DOWN_IE:"Down",_DOWN_CODE:40,_LEFT:"ArrowLeft",_LEFT_IE:"Left",_LEFT_CODE:37,_RIGHT:"ArrowRight",_RIGHT_IE:"Right",_RIGHT_CODE:39},
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
function(){function a(t){var o=e("<div></div>");return o.text(t),o[0].innerHTML}t.__registerWidget("oj.ojConveyorBelt",e.oj.baseComponent,{defaultElement:"<div>",widgetEventPrefix:"oj",options:{orientation:"horizontal",arrowVisibility:"auto",contentParent:null},_ComponentCreate:function(){this._super(),this.element.addClass("oj-conveyorbelt oj-component"),this.options.disabled&&i.warn("JET ConveyorBelt: 'disabled' property not supported"),this._setup()},refresh:function(){this._super();var t,e="rtl"===this._GetReadingDirection(),o=this._bRTL!==e;o||(t=this._cbCommon.getScroll()),this._destroyCBCommon(),this._setup(),o||this._cbCommon.setScroll(t,!0)},_NotifyShown:function(){this._super(),this._needsSetup?this._setup():this._cbCommon&&this._cbCommon.handleResize()},_NotifyAttached:function(){this._super(),this._needsSetup?this._setup():this._cbCommon&&this._cbCommon.handleResize()},_setup:function(){var o=this,i=this.element,r=this.options,h=r.orientation;if("vertical"===h?i.addClass("oj-conveyorbelt-vertical"):i.removeClass("oj-conveyorbelt-vertical"),this._canCalculateSizes()){if(this._needsSetup=null,this._bRTL="rtl"===this._GetReadingDirection(),!this._cbCommon){var _=null,u=null,d=null,v=null,f=null,S=a(this.getTranslatedString("tipArrowNext")),p=a(this.getTranslatedString("tipArrowPrevious"));"vertical"!==h?(_="oj-enabled oj-conveyorbelt-overflow-indicator oj-start oj-default",u="oj-enabled oj-conveyorbelt-overflow-indicator oj-end oj-default",d=this._createIcon("oj-conveyorbelt-overflow-icon oj-start",p),v=this._createIcon("oj-conveyorbelt-overflow-icon oj-end",S),f=this._animateScrollLeft):(_="oj-enabled oj-conveyorbelt-overflow-indicator oj-top oj-default",u="oj-enabled oj-conveyorbelt-overflow-indicator oj-bottom oj-default",d=this._createIcon("oj-conveyorbelt-overflow-icon oj-top",p),v=this._createIcon("oj-conveyorbelt-overflow-icon oj-bottom",S),f=this._animateScrollTop);var m={};"auto"===r.arrowVisibility?m.arrowVisibility="phone"===s.getDeviceRenderMode()?"hidden":"visible":m.arrowVisibility=r.arrowVisibility,m.prevButtonStyleClass=_,m.nextButtonStyleClass=u,m.prevButtonIcon=d,m.nextButtonIcon=v;var b={overflowContainerStyleClass:"oj-conveyorbelt-overflow-container",contentContainerStyleClass:"oj-conveyorbelt-content-container",itemStyleClass:"oj-conveyorbelt-item",hiddenStyleClass:"oj-helper-hidden"},C={addResizeListener:function(t,e){l.addResizeListener(t,e,25)}};C.removeResizeListener=l.removeResizeListener,C.addStyleClassName=this._addStyleClassName,C.removeStyleClassName=this._removeStyleClassName,C.hasStyleClassName=this._hasStyleClassName,C.filterContentElements=function(t){return o._filterContentElements(t)},C.subtreeDetached=n.subtreeDetached,C.subtreeAttached=n.subtreeAttached,C.addBusyState=function(t){return o._addBusyState(t)},"enabled"!==s.getAutomationMode()&&(C.scrollFunc=f);var y=null;r.contentParent&&(y=e(r.contentParent)[0]);var g=t.AgentUtils.getAgentInfo(navigator.userAgent);this._cbCommon=new c(i[0],h,y,this._bRTL,m,C,b,g)}this._cbCommon.setup();for(var w=i.find(".oj-conveyorbelt-overflow-indicator"),E=0;E<w.length;E++)this._setupButtonMouseStyles(e(w[E]))}else this._needsSetup=!0},_destroy:function(){this._destroyCBCommon(),this.element.removeClass("oj-conveyorbelt oj-component oj-conveyorbelt-vertical"),this._super()},_setOption:function(t,e,o){var n=!1,r=this.options;switch(t){case"containerParent":case"arrowVisibility":n=!0;break;case"orientation":n=r.orientation!==e;break;case"disabled":i.warn("JET ConveyorBelt: 'disabled' property not supported")}n&&this._destroyCBCommon(),this._super(t,e,o),n&&this._setup()},_destroyCBCommon:function(){var t=this._cbCommon;t&&(this.element.find(".oj-conveyorbelt-overflow-indicator").off(this.eventNamespace),t.destroy()),this._cbCommon=null},_canCalculateSizes:function(){var t=document.createElement("div"),e=t.style;e.width="10px",e.height="10px",e["-webkit-flex"]="0 0 auto",e.flex="0 0 auto";var o=this.element[0];o.appendChild(t);var n=!1;try{n=t.offsetWidth>0&&t.offsetHeight>0}catch(t){}return o.removeChild(t),n},_setupButtonMouseStyles:function(t){this._AddHoverable({element:t,afterToggle:function(e){"mouseenter"===e?t.removeClass("oj-default"):"mouseleave"===e&&t.addClass("oj-default")}}),this._AddActiveable({element:t,afterToggle:function(e){"mousedown"===e||"touchstart"===e||"mouseenter"===e?t.removeClass("oj-default"):"mouseup"!==e&&"touchend"!==e&&"touchcancel"!==e&&"mouseleave"!==e||t.addClass("oj-default")}})},_createIcon:function(t,e){var o=document.createElement("span");o.setAttribute("class","oj-component-icon "+t);var n=document.createElement("div");return n.setAttribute("class","oj-conveyorbelt-overflow-button"),n.setAttribute("role","button"),n.appendChild(o),n.setAttribute("title",e),n},_animateScrollLeft:function(t,o,n,i){var r={};r.scrollLeft=o,e(t).animate(r,n,"swing",i)},_animateScrollTop:function(t,o,n,i){var r={};r.scrollTop=o,e(t).animate(r,n,"swing",i)},_addStyleClassName:function(t,o){e(t).addClass(o)},_removeStyleClassName:function(t,o){e(t).removeClass(o)},_hasStyleClassName:function(t,o){return e(t).hasClass(o)},_filterContentElements:function(t){for(var e=[],o=0;o<t.length;o++){var n=t[o];this._hasStyleClassName(n,"oj-helper-detect-expansion")||this._hasStyleClassName(n,"oj-helper-detect-contraction")||e.push(n)}return e},_addBusyState:function(t){var e=this.element,o=r.getContext(e[0]).getBusyContext(),n="ConveyorBelt";n+=" (id='"+e.attr("id")+"')";var i={description:n+=": "+t};return o.addBusyState(i)},getNodeBySubId:function(t){if(null==t)return this.element[0];var e=t.subId;return"oj-conveyorbelt-start-overflow-indicator"===e?this.widget().find(".oj-conveyorbelt-overflow-indicator.oj-start")[0]:"oj-conveyorbelt-end-overflow-indicator"===e?this.widget().find(".oj-conveyorbelt-overflow-indicator.oj-end")[0]:"oj-conveyorbelt-top-overflow-indicator"===e?this.widget().find(".oj-conveyorbelt-overflow-indicator.oj-top")[0]:"oj-conveyorbelt-bottom-overflow-indicator"===e?this.widget().find(".oj-conveyorbelt-overflow-indicator.oj-bottom")[0]:null},getSubIdByNode:function(t){for(var e=this.getNodeBySubId({subId:"oj-conveyorbelt-start-overflow-indicator"}),o=this.getNodeBySubId({subId:"oj-conveyorbelt-end-overflow-indicator"}),n=this.getNodeBySubId({subId:"oj-conveyorbelt-top-overflow-indicator"}),i=this.getNodeBySubId({subId:"oj-conveyorbelt-bottom-overflow-indicator"}),r=t,s=this.element[0];r&&r!==s;){if(r===e)return{subId:"oj-conveyorbelt-start-overflow-indicator"};if(r===o)return{subId:"oj-conveyorbelt-end-overflow-indicator"};if(r===n)return{subId:"oj-conveyorbelt-top-overflow-indicator"};if(r===i)return{subId:"oj-conveyorbelt-bottom-overflow-indicator"};r=r.parentElement}return null},scrollElementIntoView:function(t){var e=this._cbCommon.getScroll(),o=this._cbCommon._getCurrViewportSize(),n=this._cbCommon._contentContainer.offsetWidth,i=t.offsetLeft;this._cbCommon._contentParent||0!==i||(i=t.parentNode.offsetLeft),this._cbCommon._bRtl&&(i=n-(i+t.offsetWidth));var r=t.offsetTop;if(this._cbCommon._contentParent||0!==r||(r=t.parentNode.offsetTop),this._cbCommon._isHorizontal()){if(i+t.offsetWidth<=e+o&&i>=e)return}else if(r+t.offsetHeight<=e+o&&r>=e)return;var s=this._cbCommon._contentContainer,l=c,a=this._cbCommon._isHorizontal()?l._getElemInnerWidth(this.element[0]):l._getElemInnerHeight(this.element[0]);this._cbCommon._minScroll=0,this._cbCommon._maxScroll=this._cbCommon._isHorizontal()?s.offsetWidth-a+this._cbCommon._buttonWidth:s.offsetHeight-a+this._cbCommon._buttonHeight,this._cbCommon._maxScroll<0&&(this._cbCommon._maxScroll=0),this._cbCommon._isHorizontal()?this._cbCommon._setCurrScroll(i,!0):this._cbCommon._setCurrScroll(r,!0)}}),n.setDefaultOptions({ojConveyorBelt:{arrowVisibility:n.createDynamicPropertyGetter(function(){return(o.parseJSONFromFontFamily("oj-conveyorbelt-option-defaults")||{}).arrowVisibility})}})}()});
//# sourceMappingURL=ojconveyorbelt.js.map