/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["ojs/ojcore","ojs/ojcomponentcore","ojs/ojlabel","ojs/ojcore-base","ojs/ojdomutils","ojs/ojcontext","ojs/ojlogger","ojs/ojthemeutils"],function(e,t,n,o,a,i,l,r){"use strict";o=o&&Object.prototype.hasOwnProperty.call(o,"default")?o.default:o,i=i&&Object.prototype.hasOwnProperty.call(i,"default")?i.default:i;
/**
   * @license
   * Copyright (c) 2017 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var s={properties:{colspanWrap:{type:"string",enumValues:["nowrap","wrap"]},columns:{type:"number",value:0},direction:{type:"string",enumValues:["column","row"]},labelEdge:{type:"string",enumValues:["inside","start","top"]},labelWidth:{type:"string",value:"33%"},labelWrapping:{type:"string",enumValues:["truncate","wrap"],value:"wrap"},maxColumns:{type:"number",value:1},readonly:{type:"boolean",value:!1},userAssistanceDensity:{type:"string",enumValues:["compact","efficient","reflow"],value:"efficient"}},methods:{getProperty:{},refresh:{},setProperties:{},setProperty:{},getNodeBySubId:{},getSubIdByNode:{}},extension:{}};Object.freeze(s);var d=0;function u(e){var t,n,o,s,u,c=this,f=e.element,m="data-oj-formlayout-bonus-dom",p=!0,y=!1;function h(e){f.columns<1&&"row"===f.direction&&a.addResizeListener(e,c._resizeHandler,25)}function b(){n&&(n(),n=null)}function v(){t&&(t(),t=null)}function g(e){return"inside"===f.labelEdge||"inside"===e.labelEdge||"none"===e.labelEdge}function j(e){var t=null;return g(e)||e instanceof Element&&"labelHint"in e&&""!==e.labelHint&&(_(e),t=function(e){var t=e.labelledBy;t&&document.getElementById(t)&&l.error("The oj-form-layout descendent component with id "+e.id+' has both label-hint and labelled-by. Remove labelled-by="'+t+'" since no matching element was found in the document, and a label will be created using the label-hint.');var n=document.createElement("oj-label");n.setAttribute(m,""),n.setAttribute("data-oj-internal",""),n.setAttribute("data-oj-binding-provider","none"),n.setAttribute("data-oj-context","");var o=document.createElement("span");return o.id=e.id+"|hint",o.textContent=e.labelHint,q(e)&&A(e,n),n.appendChild(o),function(e,t){var n=e,o=t;n.id=o.id+"-labelled-by",n.setAttribute("for",o.id)}(n,e),n}(e),e.parentElement.insertBefore(t,e),function(e){e.addEventListener("labelHintChanged",x),e.addEventListener("helpHintsChanged",C),e.addEventListener("requiredChanged",w),e.addEventListener("userAssistanceDensityChanged",L)}(e)),t}function x(e){var t=e.target,n=document.getElementById(t.id+"|hint");n&&(n.textContent=e.detail.value)}function C(e){var t=e.target,n=O(t),o=e.detail.value;n&&E(t)&&(n.help=o)}function w(e){var t,n=e.target,o=O(n);o&&(t=!!e.detail.value&&E(n),o.showRequired=t)}function L(e){var t=e.target,n=e.detail.value,o=e.detail.previousValue;if("compact"===n||"compact"===o){var a=O(t);if(q(t))A(t,a);else{t.required&&(a.showRequired=!1);var i=t.helpHints;i&&(i.definition||i.source)&&(a.help={definition:null,source:null})}}}function E(e){var t="use"===r.parseJSONFromFontFamily("oj-form-control-option-defaults").useUserAssistanceOptionDefault?e.userAssistanceDensity:"displayOptions";return"compact"===t||"displayOptions"===t}function O(e){return"labelledBy"in e?document.getElementById(e.labelledBy):f.querySelector('oj-label[for="'+e.id+'"]')}function A(e,t){var n,o=t,a=e.helpHints;a&&(a.definition||a.source)&&(o.help=a),n=!!e.required&&E(e),o.showRequired=n}function N(){return"column"===f.direction||1===u}function S(e,t){if(!N()){for(var n,o=t.previousSibling;o&&1!==o.nodeType;)n=o,o=o.previousSibling;for(;n&&n!==t;)o=n.nextSibling,e.appendChild(n),n=o}}function B(e){if(!N())for(;e.nextSibling;){var t=e.nextSibling;if(1===t.nodeType)break;if(8===t.nodeType&&0===t.textContent.trim().indexOf("oj-bind-"))break;e.appendChild(t)}}function W(e,t){e&&B(e);var n=k("oj-flex");return t.parentElement.insertBefore(n,t),S(n,n),n}function F(){var e=f.maxColumns,t=f.columns;if(t>0)e=t,f.classList.add("oj-form-layout-no-min-column-width");else if(f.classList.remove("oj-form-layout-no-min-column-width"),"row"===f.direction&&!I()){var n=parseFloat(window.getComputedStyle(o).columnWidth);if(!isNaN(n)){var a=parseFloat(window.getComputedStyle(f.parentElement).width),i=Math.max(Math.floor(a/n),1);i<e&&(e=i)}}return e}function D(e,t){var n=1;if("column"===f.direction)return"100%";e&&"colspan"in e&&e.colspan&&(n=Math.min(Math.floor(e.colspan),t));var o=r.parseJSONFromFontFamily("oj-form-layout-option-defaults").columnGap,a="calc(((100% / "+u+") - (("+o+" * ("+(u-1)+") / "+u+"))"+(I()?" - 0.1px":"")+")";return n>1&&(a+=" * "+n+" + ("+o+" * "+(n-1)+")"),a+=")"}function R(e,t){var n=k("oj-flex-item");return n.style.flexGrow="0",n.style.flexShrink="1",n.style.flexBasis=t,n.style.width=t,n.style.maxWidth=t,e.appendChild(n),n}function M(e,t){var n=t%u,o=D();if("column"!==f.direction&&e&&n>0)for(var a=n;a<u;a++)a!==n&&H(e),R(e,o)}function H(e){var t=k("oj-formlayout-column-gutter");e.appendChild(t)}function T(e,t,n,o){var a=D(e,o);S(n,e);var i=k("oj-flex-item");if(n.appendChild(i),i.appendChild(e),t)if(i.style.flexGrow="1",i.style.flexShrink="1",i.style.flexBasis=a,i.style.width=a,i.style.maxWidth=a,"OJ-FORM-LAYOUT"===t.tagName&&i.classList.add("oj-formlayout-nested-formlayout"),"start"===f.labelEdge){i.style.display="flex";var l=k("oj-formlayout-inline-label"),s=k("oj-formlayout-inline-value");l.style.flexGrow="0",l.style.flexShrink="0",l.style.flexBasis=f.labelWidth,l.style.width=f.labelWidth,l.style.maxWidth=f.labelWidth,l.appendChild(e),i.appendChild(l),s.style.flexGrow="1",s.style.flexShrink="1",s.style.flexBasis="calc(100% - "+f.labelWidth+")",s.style.width=s.style.flexBasis,s.style.maxWidth=s.style.flexBasis,s.appendChild(t),i.appendChild(s)}else i.appendChild(t);else if("labelHint"in e&&g(e))i.style.flexGrow="1",i.style.flexShrink="1",i.style.flexBasis=a,i.style.width=a,i.style.maxWidth=a,i.appendChild(e);else if(i.appendChild(e),i.style.flexGrow="1",i.style.flexShrink="1",i.style.flexBasis=a,i.style.width=a,i.style.maxWidth=a,i.classList.add("oj-formlayout-no-label-flex-item"),"OJ-LABEL-VALUE"===e.tagName){var d=r.parseJSONFromFontFamily("oj-form-layout-option-defaults").columnGap;i.classList.add("oj-formlayout-nested-labelvalue"),e.setAttribute("data-oj-colspan",o),e.setAttribute("data-oj-column-gap",d),e.refresh()}else"OJ-FORM-LAYOUT"===e.tagName&&i.classList.add("oj-formlayout-nested-formlayout");B(n)}function k(e){var t=document.createElement("div");return t.setAttribute(m,""),t.setAttribute("data-oj-internal",""),t.classList.add(e),t}function J(e){for(var t=e,n=!0;t!==f;){if("OJ-FORM-LAYOUT"===t.tagName){n=!1;break}if(null==(t=t.parentElement)){n=!1;break}}return n}function U(e){for(;e.firstChild;){var t=e.firstChild;e.parentNode.insertBefore(t,e)}e.parentNode.removeChild(e)}function _(e){var t=e;t.id||(t.id="oflId_"+d,d+=1)}function I(){var e=oj.AgentUtils.getAgentInfo();return"ie"===e.browser&&11===e.browserVersion}function q(e){var t=r.parseJSONFromFontFamily("oj-form-control-option-defaults"),n="displayOptions";return t&&(n="use"===t.useUserAssistanceOptionDefault?e.userAssistanceDensity:"displayOptions"),"compact"===n||"displayOptions"===n}function V(e){var t=r.parseJSONFromFontFamily("oj-form-layout-option-defaults")||{};e?(e.props.labelEdge||(f.labelEdge=t.labelEdge),e.props.colspanWrap||(f.colspanWrap=t.colspanWrap),e.props.direction||(f.direction=t.direction)):(f.labelEdge||(f.labelEdge=t.labelEdge),f.colspanWrap||(f.colspanWrap=t.colspanWrap),f.direction||(f.direction=t.direction))}V(e),c._rootElementMutationObserver=new MutationObserver(function(e){document.body.contains(f)?(function(e){for(var t=e.length,n=0;n<t;n++){var a=e[n];if("childList"===a.type)for(var i=a.addedNodes.length,l=0;l<i;l++){var r=a.addedNodes[l];r.parentNode===f&&o.appendChild(r)}}}(e),function(e){for(var t=!0,n=e.length,o=["colspan","label-hint"],a=0;a<n;a++){var i=e[a];if("childList"===i.type&&((l=i.target)===f||l&&"DIV"===l.tagName&&l.hasAttribute(m))&&J(i.target)){t=!1;break}if("attributes"===i.type&&o.includes(i.attributeName)){t=!1;break}}var l;return t}(e)||(function(e){for(var t=e.length,n=0;n<t;n++){var o=e[n];if("childList"===o.type)for(var a=o.removedNodes.length,i=0;i<a;i++){var l=o.removedNodes[i];1===l.nodeType&&(l.removeEventListener("labelHintChanged",x),l.removeEventListener("helpHintsChanged",C),l.removeEventListener("requiredChanged",w),l.removeEventListener("userAssistanceDensityChanged",L))}}}(e),f.refresh())):this.disconnect()}),c._resizeHandler=function(e,t){F()!==u&&f.refresh()},this.createDOM=function(){for(f.classList.add("oj-form-layout"),(o=document.createElement("div")).classList.add("oj-form"),o.setAttribute("data-oj-context",""),o.setAttribute("data-oj-internal",""),o.setAttribute(m,""),f.readonly?o.classList.remove("oj-enabled"):o.classList.add("oj-enabled"),"efficient"===f.userAssistanceDensity?o.classList.add("oj-efficient"):o.classList.remove("oj-efficient");f.firstChild;)o.appendChild(f.firstChild);f.appendChild(o)},c.handlePropertyChanged=function(e,t){switch(e){case"readonly":return f.readonly?o.classList.remove("oj-enabled"):o.classList.add("oj-enabled"),!0;case"userAssistanceDensity":return"efficient"===f.userAssistanceDensity?o.classList.add("oj-efficient"):o.classList.remove("oj-efficient"),!0;case"labelWrapping":return"truncate"===f.labelWrapping?o.classList.add("oj-formlayout-labels-nowrap"):o.classList.remove("oj-formlayout-labels-nowrap"),!0;default:return!1}},this.updateDOM=function(){function e(){!function(){if(!n){var e=i.getContext(f).getBusyContext(),t={description:"The oj-form-layout component with id = '"+f.id+"' is being rendered."};n=e.addBusyState(t)}}(),V(),s=[],i.getContext(o).getBusyContext().whenReady().then(function(){var e,n=document.activeElement,r=!1;!function(){if(!t){var e=i.getContext(o).getBusyContext(),n={description:"The oj-form div for oj-form-layout component with id = '"+f.id+"' is being rendered."};t=e.addBusyState(n)}}(),c._rootElementMutationObserver.disconnect(),(e=o)&&c._resizeHandler&&a.removeResizeListener(e,c._resizeHandler),function(){var e;if("start"===f.labelEdge){var t=parseInt(f.labelWidth,10);(isNaN(t)||t>0)&&o.classList.add("oj-form-cols-labels-inline"),f.classList.add("oj-formlayout-labels-inline"),o.classList.remove("oj-form-cols")}else o.classList.add("oj-form-cols"),o.classList.remove("oj-form-cols-labels-inline"),f.classList.remove("oj-formlayout-labels-inline");"truncate"===f.labelWrapping?o.classList.add("oj-formlayout-labels-nowrap"):o.classList.remove("oj-formlayout-labels-nowrap");var n=u;if((u=F())!==n){var a="oj-formlayout-max-cols-"+u,i=f.className;-1!==i.indexOf("oj-formlayout-max-cols-")?f.className=i.replace(/oj-formlayout-max-cols-[\d+]/,a):f.classList.add(a)}"row"===f.direction?(e=1,o.classList.add("oj-formlayout-form-across")):(e=u,o.classList.remove("oj-formlayout-form-across")),o.style.columnCount=e,o.style.webkitColumnCount=e,o.style.MozColumnCount=e}(),p||function(){for(var e=o.querySelectorAll("[data-oj-formlayout-bonus-dom]"),t=e.length,n=0;n<t;++n){var a=e[n];J(a)&&("OJ-LABEL"===a.tagName?(a.for="",a.parentElement.removeChild(a)):U(a))}}(),function(){for(var e=o.firstElementChild,t=0,n="column"===f.direction;e;){var a=e.tagName.toLowerCase();if(-1!==a.indexOf("-"))if("oj-label"===a){var i=e;if(!(e=e.nextElementSibling))throw _(f),_(i),v(),b(),new Error("oj-form-layout component with id='"+f.id+"' has an oj-label child element with id='"+i.id+"' but has no next sibling element that it is associated with.")}else"oj-label-value"===a?p||e.refresh():e.classList.contains("oj-complete")?j(e):((n||t%u==0)&&e.setAttribute("data-oj-needs-oj-flex-div",""),s.push(e));t+=1,e=e.nextElementSibling}}(),function(){var e,t=[],n=o.children.length,a="column"===f.direction,i=0,r=0;!function(e,t){for(var n=t,o=e.length-1;o>=0;o--)n[o]=e[o]}(o.children,t);for(var d,c=0,m=!1,p=!1;i<n;){var y=t[i];if(d=1,(a||r%u==0)&&(e=W(e,y)),-1===s.indexOf(y))if("oj-label"===y.tagName.toLowerCase())T(y,t[i+=1],e);else if("labelHint"in y&&g(y))T(y,null,e);else{if("colspan"in y&&y.getAttribute("colspan"))if(a)m||(l.error('Colspan attribute is ignored unless direction is set to "row"'),m=!0);else{var h=u-c;d=Math.floor(y.colspan),"wrap"===f.colspanWrap&&h<d&&c>0?(M(e,r),r+=h,c=0,d=Math.min(d,u),e=W(e,y)):d=Math.min(d,h),!p&&u>1&&(p=!0)}T(y,null,e,d)}r+=d,a||r%u==0||H(e),c=r%u,i+=1}p&&!a?o.classList.add("oj-form-control-full-width"):o.classList.remove("oj-form-control-full-width"),M(e,r)}(),n&&(r=a.isAncestorOrSelf(f,n)),!p&&r&&setTimeout(function(){n.focus()},0),h(o),c._rootElementMutationObserver.observe(f,{childList:!0,subtree:!0,attributes:!0}),p&&(p=!1),v(),b()})}var r;y||(p||!f.hasAttribute("data-oj-context")||(r=i.getContext(f).getBusyContext()).isReady()?e():(y=!0,r.whenReady().then(function(){y=!1,e()})))}}u.getDynamicDefaults=function(){var e=r.parseJSONFromFontFamily("oj-form-layout-option-defaults")||{};return{labelEdge:e.labelEdge,direction:e.direction}},s.extension._CONSTRUCTOR=u,s.extension._TRACK_CHILDREN="nearestCustomElement",o.CustomElementBridge.register("oj-form-layout",{metadata:o.CollectionUtils.mergeDeep(s,{properties:{readonly:{binding:{provide:[{name:"containerReadonly"},{name:"readonly"}],consume:{name:"containerReadonly"}}},userAssistanceDensity:{binding:{provide:[{name:"containerUserAssistanceDensity",default:"efficient"},{name:"userAssistanceDensity",default:"efficient"}],consume:{name:"containerUserAssistanceDensity"}}},labelEdge:{binding:{provide:[{name:"containerLabelEdge"},{name:"labelEdge",transform:{top:"provided",start:"provided"}}],consume:{name:"containerLabelEdge"}}}}})})});
//# sourceMappingURL=ojformlayout.js.map