/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["ojs/ojcore-base","jquery","ojs/ojlogger","ojs/ojcomponentcore"],function(e,t,i,s){"use strict";e=e&&Object.prototype.hasOwnProperty.call(e,"default")?e.default:e,t=t&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t,
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
e.__registerWidget("oj._ojRadioCheckbox",t.oj.baseComponent,{version:"1.0.0",defaultElement:"<input>",widgetEventPrefix:"oj",options:{disabled:null,checked:null,type:null},label:function(){return void 0===this.$label&&(this.$label=this._getLabelsForElement()),this.$label},refresh:function(){this._super(),this._setup()},refreshDisabled:function(){this._renderDisabled()},setSelectedClass:function(e){this.element.toggleClass("oj-selected",e),this.$label.toggleClass("oj-selected",e),this.$choiceItem.toggleClass("oj-selected",e)},widget:function(){return this.uiRadioCheckbox},_InitOptions:function(e,t){var i,s;if(this._super(e,t),"checked"in t||(this.initCheckedFromDom=!0,i=!!this.element.prop("checked"),this.option("checked",i,{_context:{internalSet:!0}})),"boolean"!=typeof this.options.checked)throw new Error("checked option must be a boolean");if("disabled"in t||(s=!!this.element.prop("disabled"),this.option("disabled",s,{_context:{internalSet:!0}})),"boolean"!=typeof this.options.disabled)throw new Error("disabled option must be a boolean");"type"in t||this.option("type",this.element.prop("type"),{_context:{internalSet:!0}})},_ComponentCreate:function(){this._super();var e=this.options.type;"checkbox"===e?(this.uiRadioCheckbox=this.element.addClass("oj-checkbox oj-component"),this.$label=this._getLabelsForElement(),this.$label.addClass("oj-checkbox-label")):"radio"===e&&(this.uiRadioCheckbox=this.element.addClass("oj-radio oj-component"),this.$label=this._getLabelsForElement(),this.$label.addClass("oj-radio-label")),this.$choiceItem=this._getChoiceItem();var i=document.createElement("span");i.setAttribute("class","oj-radiocheckbox-icon"),this.element.wrapAll(i),this._focusable(this.element),this._AddHoverable(this.$choiceItem),this._AddActiveable(this.$choiceItem),this._focusable({element:this.$choiceItem,applyHighlight:!0}),this._AddHoverable(this.$label),this._AddActiveable(this.$label),t.each(this.$label,function(){t(this.childNodes).wrapAll("<span class='oj-radiocheckbox-label-text'></span>")}),this._setup()},_SaveAttributes:function(e){this._savedClasses=e.attr("class")},_RestoreAttributes:function(){this._savedClasses?this.element.attr("class",this._savedClasses):this.element.removeAttr("class")},_setup:function(){this._renderDisabled(),this.initCheckedFromDom||this._setCheckedOnDom(this.options.checked),this.options.checked&&this.setSelectedClass(this.options.checked)},_setCheckedOnDom:function(e){e=!!e,this.element.prop("checked",e)},_renderDisabled:function(){this._IsEffectivelyDisabled()?(this.element.prop("disabled",!0).removeAttr("aria-disabled").removeClass("oj-enabled").addClass("oj-disabled"),this.$label.removeClass("oj-enabled").addClass("oj-disabled"),this.$choiceItem.removeClass("oj-enabled").addClass("oj-disabled")):(this.element.prop("disabled",!1).removeAttr("aria-disabled").removeClass("oj-disabled").addClass("oj-enabled"),this.$label.addClass("oj-enabled").removeClass("oj-disabled"),this.$choiceItem.addClass("oj-enabled").removeClass("oj-disabled"))},_setOption:function(e,t){this._superApply(arguments),"disabled"===e&&(t=!!t,this._renderDisabled(t)),"checked"===e&&(this._setCheckedOnDom(t),this.setSelectedClass(t))},_getLabelsForElement:function(){var e,s=this.element.closest("label"),o="label[for='"+this.element.prop("id")+"']",a=t(o);return 0!==s.length&&i.error("Found a label that is an input's ancestor. This is not supported in the ojCheckboxset or ojRadioset component and the component will\nnot work correctly. Use a label as a sibling to the input and use the label 'for' attribute to tie the two together."),0===(a=a.not(s)).length&&(e=this.element.siblings(o),a=a.add(e)),a},_getChoiceItem:function(){var e,t,s,o=null;return(e=this.element.parent())&&(e.hasClass("oj-choice-item")||e.hasClass("oj-choice-row")||e.hasClass("oj-choice-row-inline"))?o=e:(i.warn("The radioset/checkboxset's input and label dom should be wrapped in a dom node with class 'oj-choice-item'. JET is adding this missing dom to make the component work correctly."),t="label[for='"+this.element.attr("id")+"']",0!==(s=this.element.siblings().filter(t)).length?(this.element.add(s).wrapAll("<span class='oj-choice-item oj-choice-item-added'></span>"),o=this.element.parent()):(this.element.wrapAll("<span class='oj-choice-item oj-choice-item-added'></span>"),o=this.element.parent())),o},getNodeBySubId:function(e){var t=this._super(e);if(!t){var i=e.subId;"oj-radiocheckbox-input"===i&&(t=this.element[0]),"oj-radiocheckbox-label"===i&&(t=this.label()[0])}return t||null},_destroy:function(){var e=this._super();this._RemoveHoverable(this.$choiceItem),this._RemoveActiveable(this.$choiceItem),this._RemoveHoverable(this.$label),this._RemoveActiveable(this.$label);var i=this.options.type;return"checkbox"===i?this.$label.removeClass("oj-enabled oj-disabled oj-selected oj-checkbox-label"):"radio"===i&&this.$label.removeClass("oj-enabled oj-disabled oj-selected oj-radio-label"),this.$choiceItem.removeClass("oj-enabled oj-disabled oj-selected"),t.each(this.$label,function(){var e=this.getElementsByClassName("oj-radiocheckbox-label-text");void 0!==e&&t(e[0].childNodes[0]).unwrap()}),this.element.unwrap(),this.$choiceItem.hasClass("oj-choice-item-added")&&this.element.unwrap(),this.$choiceItem=null,this.$label=null,e}});
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var o={};e._registerLegacyNamespaceProp("RadioCheckboxUtils",o),o.renderOptions=function(){var e=this._optionsDataArray,t=this.element[0];if(e){for(var i="OJ-RADIOSET"===t.tagName?"oj-radioset-wrapper":"oj-checkboxset-wrapper",o=t.querySelector("."+i),a=o.querySelectorAll(".oj-choice-item"),n=0;n<a.length;n++){var l=a[n];l.parentNode.removeChild(l)}a=o.querySelectorAll("oj-option");for(var r=0;r<a.length;r++){var h=a[r];h.parentNode.removeChild(h)}var d=this.options.optionRenderer,c=this.options.optionsKeys,p=c&&c.value?c.value:"value";"function"!=typeof d&&(d=function(e){var t=c&&c.label?c.label:"label",i=document.createElement("oj-option");return i.value=e.data[p],i.textContent=e.data[t],i.disabled=e.data.disabled,i});for(var b=0;b<e.length;b++){var m={component:t,index:b,data:e[b]},u=d(m);u&&"OJ-OPTION"===u.tagName&&(u.hasAttribute("data-oj-binding-provider")||u.setAttribute("data-oj-binding-provider","none"),null!==u.value&&void 0!==u.value||(u.value=m.data[p]),o.appendChild(u),s.subtreeAttached(u))}this.refresh()}},o.generateOptionsFromData=function(){var t=this.options.options;if(o.removeDataListener.call(this),t&&e.DataProviderFeatureChecker.isDataProvider(t)){var i,s={description:'The component identified by "'+this.element[0].id+'" is fetching data'},a=e.Context.getContext(this.element[0]).getBusyContext().addBusyState(s);this._clientId=this._clientId||Symbol(),this._optionsDataArray=[];var n=t.fetchFirst({clientId:this._clientId})[Symbol.asyncIterator](),l=this;n.next().then(function e(t){var s;if(t&&t.value){var o=t.value;for(i=0;i<o.data.length;i++)l._optionsDataArray.push(o.data[i]);t.done||(s=n.next().then(e))}return s}).then(function(){o.renderOptions.call(l),o.addDataListener.call(l),a()},function(){a()})}},o.addDataListener=function(){o.removeDataListener.call(this),this.options.options&&e.DataProviderFeatureChecker.isDataProvider(this.options.options)&&(this._optionsDataProvider=this.options.options,this._optionsDataListener=o.generateOptionsFromData.bind(this),this._optionsDataProvider.addEventListener("refresh",this._optionsDataListener),this._optionsDataProvider.addEventListener("mutate",this._optionsDataListener))},o.removeDataListener=function(){this._optionsDataListener&&(this._optionsDataProvider.removeEventListener("refresh",this._optionsDataListener),this._optionsDataProvider.removeEventListener("mutate",this._optionsDataListener),this._optionsDataProvider=null,this._optionsDataListener=null)}});
//# sourceMappingURL=ojradiocheckbox.js.map