define(["./impl/logger","./impl/PersistenceStoreMetadata","./pouchDBPersistenceStoreFactory"],function(a,b,c){"use strict";var d=function(){Object.defineProperty(this,"_stores",{value:{},writable:!0}),Object.defineProperty(this,"_factories",{value:{},writable:!0}),Object.defineProperty(this,"_DEFAULT_STORE_FACTORY_NAME",{value:"_defaultFactory",writable:!1}),Object.defineProperty(this,"_METADATA_STORE_NAME",{value:"systemCache-metadataStore",writable:!1}),Object.defineProperty(this,"_storeNameMapping",{value:{},writable:!0})};return d.prototype.registerStoreFactory=function(a,b){if(!b)throw TypeError("A valid factory must be provided.");if(!a)throw TypeError("A valid name must be provided.");var c=this._mapStoreName(a),d=this._factories[c];if(d&&d!==b)throw TypeError("A factory with the same name has already been registered.");this._factories[c]=b},d.prototype.registerDefaultStoreFactory=function(a){this.registerStoreFactory(this._DEFAULT_STORE_FACTORY_NAME,a)},d.prototype.openStore=function(b,c){a.log("Offline Persistence Toolkit PersistenceStoreManager: openStore() for name: "+b);var d=this._mapStoreName(b),e=this._stores[d],f=c&&c.version||"0";if(e&&e[f])return Promise.resolve(e[f]);var g=this._factories[d];if(g||(g=this._factories[this._DEFAULT_STORE_FACTORY_NAME]),!g)return Promise.reject(new Error("no factory is registered to create the store."));var h=this;return a.log("Offline Persistence Toolkit PersistenceStoreManager: Calling createPersistenceStore on factory"),g.createPersistenceStore(d,c).then(function(b){return e=e||{},e[f]=b,h._stores[d]=e,c&&c.skipMetadata?b:h._updateStoreMetadata(d,f).then(function(){return b}).catch(function(c){return a.log("updating store metadata for store "+d+" failed"),b})})},d.prototype._updateStoreMetadata=function(a,b){var c=this;return c._getStoresMetadata(a).then(function(d){var e=null;if(d?d.versions.indexOf(b)<0&&(d.versions.push(b),e=d.versions):e=[b],e){var f=c._encodeString(a);return c._metadataStore.upsert(f,{},e)}})},d.prototype.hasStore=function(a,b){var c=this._mapStoreName(a),d=this._stores[c];return!(!d||0===Object.keys(d).length)&&(!b||!b.version||!!d[b.version])},d.prototype.deleteStore=function(b,c){a.log("Offline Persistence Toolkit PersistenceStoreManager: deleteStore() for name: "+b);var d=this,e=this._mapStoreName(b);return d._getStoresMetadata(e).then(function(f){if(f){var g=[],h=[],i=f.versions;if(c&&c.version){var j=i.indexOf(c.version);j<0?h=i:(i.splice(j,1),h=i,g.push(c.version))}else g=i;if(g.length){var k=g.map(function(a){var b=this;return b.openStore(e,{version:a,skipMetadata:!0}).then(function(c){return delete b._stores[e][a],c.delete()})},d);return Promise.all(k).then(function(){var a=d._encodeString(e);return h.length?d._metadataStore.upsert(a,{},h):d._metadataStore.removeByKey(a)}).then(function(){return!0}).catch(function(b){return a.log("failed deleting store "+e),!1})}return!1}var l=[];if(c&&c.version?d._stores[e]&&d._stores[e][c.version]&&(l.push(d._stores[e][c.version]),delete d._stores[e][c.version]):d._stores[e]&&(l=Object.values(d._stores[e]),d._stores[e]={}),l.length){var k=l.map(function(a){return a.delete()});return Promise.all(k).then(function(){return!0}).catch(function(c){return a.log("failed deleting store "+b),!1})}return!1})},d.prototype.getStoresMetadata=function(){var c=this,d=new Map;return this._getMetadataStore().then(function(a){return a.find({fields:["key","value"]})}).then(function(a){return a&&a.length>0&&a.forEach(function(a){var e=c._decodeString(a.key),f=c._factories[e];f||(f=c._factories[c._DEFAULT_STORE_FACTORY_NAME]),d.set(e,new b(e,f,a.value))}),d}).catch(function(b){return a.log("error occured getting store metadata."),d})},d.prototype._getStoresMetadata=function(c){var d=this;return d._getMetadataStore().then(function(a){var b=d._encodeString(c);return a.findByKey(b)}).then(function(a){if(a){var e=d._factories[c];return e||(e=d._factories[d._DEFAULT_STORE_FACTORY_NAME]),new b(c,e,a)}return null}).catch(function(b){return a.log("error getting store metadata for store "+c),null})},d.prototype._mapStoreName=function(a,b){var c=this._storeNameMapping[a];return c||(c=a.replace(/(.*):\/\/(.*)/gi,"$1$2"),this._storeNameMapping[a]=c,c)},d.prototype._getMetadataStore=function(){var a=this;if(!a._metadataStore){return this._factories[this._DEFAULT_STORE_FACTORY_NAME]||(this._factories[a._METADATA_STORE_NAME]=c),this.openStore(a._METADATA_STORE_NAME,{skipMetadata:!0}).then(function(b){return a._metadataStore=b,a._metadataStore})}return Promise.resolve(a._metadataStore)},d.prototype._encodeString=function(a){for(var b,c=[],b=0;b<a.length;b++){var d=Number(a.charCodeAt(b)).toString(16);c.push(d)}return c.join("")},d.prototype._decodeString=function(a){var b,c=a.toString(),d="";for(b=0;b<c.length;b+=2)d+=String.fromCharCode(parseInt(c.substr(b,2),16));return d},new d});